﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Text.RegularExpressions;
using cms.DB.IBasics;

/* Framework (fw) version 1.0 
 * 557c89c9-a3e1-46fd-942b-b3cfe58c8246
 * 
 * C# implementation 1.0
 * 
 * Copyright 2010, RISE to Bloome Software AB 
 */

namespace BasicFramework
{
    public class Basics
    {
		public returnConstants Constants()
		{
			returnConstants rv = new returnConstants();
            rv.EmptyString = string.Empty;
            rv.NullBool = null;
            rv.NullDateTime = null;
            rv.NullFloat = null;
            rv.NullInt = null;
            rv.NullString = null;
            rv.FalseBool = false;
            rv.TrueBool = true;
            rv.ZeroInt = 0;
            rv.OneInt = 1;
            rv.TwoInt = 2;
            rv.ThreeInt = 3;
            rv.FourInt = 4;
            rv.FiveInt = 5;
            rv.SixInt = 6;
            rv.SevenInt = 7;
            rv.EightInt = 8;
            rv.NineInt = 9;
            rv.TenInt = 10;
            return rv;
        }
		public returnIsEqualInt IsEqualInt(long i1, long i2)
		{
			returnIsEqualInt rv = new returnIsEqualInt();
            rv.isEqual = i1 == i2;
            return rv;
        }
		public returnIsEqualFloat IsEqualFloat(double f1, double f2)
		{
			returnIsEqualFloat rv = new returnIsEqualFloat();
            rv.isEqual = f1 == f2;
            return rv;
        }
		public returnIsEqualDateTime IsEqualDateTime(DateTime dt1, DateTime dt2)
		{
			returnIsEqualDateTime rv = new returnIsEqualDateTime();
            rv.isEqual = DateTime.Compare(dt1, dt2) == 0;
            return rv;
        }
		public returnIsEqualString IsEqualString(string s1, string s2)
		{
			returnIsEqualString rv = new returnIsEqualString();
            rv.isEqual = string.Compare(s1, s2) == 0;
            return rv;
        }
		public returnIsEqualBool IsEqualBool(bool b1, bool b2)
		{
			returnIsEqualBool rv = new returnIsEqualBool();
            rv.isEqual = b1 == b2;
            return rv;
        }
		public returnDefaultBool DefaultBool(bool? b, bool defaultValue)
		{
			returnDefaultBool rv = new returnDefaultBool();
            rv.b = b ?? defaultValue;
            return rv;
        }
		public returnDefaultInt DefaultInt(long? i, long defaultValue)
		{
			returnDefaultInt rv = new returnDefaultInt();
            rv.i = i ?? defaultValue;
            return rv;
        }
        public returnDefaultDateTime DefaultDateTime(DateTime? dt, DateTime defaultValue)
		{
			returnDefaultDateTime rv = new returnDefaultDateTime();
            rv.dt = dt ?? defaultValue;
            return rv;
        }
		public returnDefaultFloat DefaultFloat(double? f, double defaultValue)
		{
			returnDefaultFloat rv = new returnDefaultFloat();
            rv.f = f ?? defaultValue;
            return rv;
        }
		public returnDefaultString DefaultString(string s, string defaultValue)
		{
			returnDefaultString rv = new returnDefaultString();
            rv.s = s ?? defaultValue;
            return rv;
        }
		public returnIsGreaterThanDateTime IsGreaterThanDateTime(DateTime d1, DateTime d2)
		{
			returnIsGreaterThanDateTime rv = new returnIsGreaterThanDateTime();
            rv.isGT = DateTime.Compare(d1, d2) > 0;
            return rv;
        }
		public returnIsLessThanDateTime IsLessThanDateTime(DateTime d1, DateTime d2)
		{
			returnIsLessThanDateTime rv = new returnIsLessThanDateTime();
            rv.isLT = DateTime.Compare(d1, d2) < 0;
            return rv;
        }
		public returnIsGreaterThanOrEqualDateTime IsGreaterThanOrEqualDateTime(DateTime d1, DateTime d2)
		{
			returnIsGreaterThanOrEqualDateTime rv = new returnIsGreaterThanOrEqualDateTime();
            rv.isGTE = DateTime.Compare(d1, d2) >= 0;
            return rv;
        }
		public returnIsLessThanOrEqualDateTime IsLessThanOrEqualDateTime(DateTime d1, DateTime d2)
		{
			returnIsLessThanOrEqualDateTime rv = new returnIsLessThanOrEqualDateTime();
            rv.isLTE = DateTime.Compare(d1, d2) <= 0;
            return rv;
        }
		public returnIsGreaterThanFloat IsGreaterThanFloat(double f1, double f2)
		{
			returnIsGreaterThanFloat rv = new returnIsGreaterThanFloat();
            rv.isGT = f1 > f2;
            return rv;
        }
		public returnIsGreaterThanOrEqualFloat IsGreaterThanOrEqualFloat(double f1, double f2)
		{
			returnIsGreaterThanOrEqualFloat rv = new returnIsGreaterThanOrEqualFloat();
            rv.isGTE = f1 >= f2;
            return rv;
        }
		public returnIsLessThanFloat IsLessThanFloat(double f1, double f2)
		{
			returnIsLessThanFloat rv = new returnIsLessThanFloat();
            rv.isLT = f1 < f2;
            return rv;
        }
		public returnIsLessThanOrEqualFloat IsLessThanOrEqualFloat(double f1, double f2)
		{
			returnIsLessThanOrEqualFloat rv = new returnIsLessThanOrEqualFloat();
            rv.isLTE = f1 <= f2;
            return rv;
        }
		public returnIsGreaterThanInt IsGreaterThanInt(long i1, long i2)
		{
			returnIsGreaterThanInt rv = new returnIsGreaterThanInt();
            rv.isGT = i1 > i2;
            return rv;
        }
		public returnIsGreaterThanOrEqualInt IsGreaterThanOrEqualInt(long i1, long i2)
		{
			returnIsGreaterThanOrEqualInt rv = new returnIsGreaterThanOrEqualInt();
            rv.isGTE = i1 >= i2;
            return rv;
        }
		public returnIsLessThanInt IsLessThanInt(long i1, long i2)
		{
			returnIsLessThanInt rv = new returnIsLessThanInt();
            rv.isLT = i1 < i2;
            return rv;
        }
		public returnIsLessThanOrEqualInt IsLessThanOrEqualInt(long i1, long i2)
		{
			returnIsLessThanOrEqualInt rv = new returnIsLessThanOrEqualInt();
            rv.isLTE = i1 <= i2;
            return rv;
        }
		public returnIsGreaterThanString IsGreaterThanString(string s1, string s2)
		{
			returnIsGreaterThanString rv = new returnIsGreaterThanString();
            rv.isGT = string.Compare(s1, s2) > 0;
            return rv;
        }
		public returnIsGreaterThanOrEqualString IsGreaterThanOrEqualString(string s1, string s2)
		{
			returnIsGreaterThanOrEqualString rv = new returnIsGreaterThanOrEqualString();
            rv.isGTE = string.Compare(s1, s2) >= 0;
            return rv;
        }
		public returnIsLessThanString IsLessThanString(string s1, string s2)
		{
			returnIsLessThanString rv = new returnIsLessThanString();
            rv.isLT = string.Compare(s1, s2) < 0;
            return rv;
        }
		public returnIsLessThanOrEqualString IsLessThanOrEqualString(string s1, string s2)
		{
			returnIsLessThanOrEqualString rv = new returnIsLessThanOrEqualString();
            rv.isLTE = string.Compare(s1, s2) <= 0;
            return rv;
        }
		public returnIsBetweenDateTime IsBetweenDateTime(DateTime dtMin, DateTime dt, DateTime dtMax)
		{
			returnIsBetweenDateTime rv = new returnIsBetweenDateTime();
            rv.isBetween = DateTime.Compare(dtMin, dt) <= 0 && DateTime.Compare(dt, dtMax) <= 0;
            return rv;
        }
		public returnIsBetweenInt IsBetweenInt(long iMin, long i, long iMax)
		{
			returnIsBetweenInt rv = new returnIsBetweenInt();
            rv.isBetween = iMin <= i && i <= iMax;
            return rv;
        }
		public returnIsBetweenFloat IsBetweenFloat(double fMin, double f, double fMax)
		{
			returnIsBetweenFloat rv = new returnIsBetweenFloat();
            rv.isBetween = fMin <= f && f <= fMax;
            return rv;
        }
		public returnIsBetweenString IsBetweenString(string sMin, string s, string sMax)
		{
			returnIsBetweenString rv = new returnIsBetweenString();
            rv.isBetween = string.Compare(sMin, s) <= 0 && string.Compare(s, sMax) <= 0;
            return rv;
        }
		public returnLogicalAnd LogicalAnd(bool b1, bool b2)
		{
            returnLogicalAnd rv = new returnLogicalAnd();
            rv.b = b1 && b2;
            return rv;
        }
		public returnLogicalOr LogicalOr(bool b1, bool b2)
		{
            returnLogicalOr rv = new returnLogicalOr();
            rv.b = b1 || b2;
            return rv;
        }
		public returnLogicalXor LogicalXor(bool b1, bool b2)
		{
            returnLogicalXor rv = new returnLogicalXor();
            rv.b = b1 && !b2 || b2 && !b1;
            return rv;
        }
		public returnLogicalNot LogicalNot(bool b)
		{
            returnLogicalNot rv = new returnLogicalNot();
            rv.notB = !b;
            return rv;
        }
		public returnMultiplyInt MultiplyInt(long i1, long i2)
		{
			returnMultiplyInt rv = new returnMultiplyInt();
            rv.equals = i1 * i2;
            return rv;
        }
		public returnMultiplyFloat MultiplyFloat(double f1, double f2)
		{
			returnMultiplyFloat rv = new returnMultiplyFloat();
            rv.equals = f1 * f2;
            return rv;
        }
		public returnDivideInt DivideInt(long iDividend, long iDivisor)
		{
			returnDivideInt rv = new returnDivideInt();
            rv.equals = iDividend / iDivisor;
            return rv;
        }
		public returnDivideFloat DivideFloat(double fDividend, double fDivisor)
		{
			returnDivideFloat rv = new returnDivideFloat();
            rv.equals = fDividend / fDivisor;
            return rv;
        }
		public returnAddInt AddInt(long i1, long i2)
		{
			returnAddInt rv = new returnAddInt();
            rv.sum = i1 + i2;
            return rv;
        }
		public returnAddFloat AddFloat(double f1, double f2)
		{
			returnAddFloat rv = new returnAddFloat();
            rv.sum = f1 + f2;
            return rv;
        }
		public returnSubtractInt SubtractInt(long i1, long i2)
		{
			returnSubtractInt rv = new returnSubtractInt();
            rv.difference = i1 - i2;
            return rv;
        }
		public returnSubtractFloat SubtractFloat(double f1, double f2)
		{
			returnSubtractFloat rv = new returnSubtractFloat();
            rv.difference = f1 - f2;
            return rv;
        }
		public returnModulo Modulo(long iDividend, long iDivisor)
		{
			returnModulo rv = new returnModulo();
            rv.modulo = iDividend % iDivisor;
            return rv;
        }
		public returnNegateInt NegateInt(long i)
		{
			returnNegateInt rv = new returnNegateInt();
            rv.negI = -i;
            return rv;
        }
		public returnNegateFloat NegateFloat(double f)
		{
			returnNegateFloat rv = new returnNegateFloat();
            rv.negF = -f;
            return rv;
        }
		public returnAbortIf AbortIf(bool b)
		{
			returnAbortIf rv = new returnAbortIf();
            if (b) throw new Exception("Execution stopped!");
            return rv;
        }
		public returnAbortIfNot AbortIfNot(bool b)
		{
			returnAbortIfNot rv = new returnAbortIfNot();
            if (!b) throw new Exception("Execution stopped!");
            return rv;
        }
        public returnServerDateTime ServerDateTime(long? timems)
        {
            returnServerDateTime rv = new returnServerDateTime();
            rv.dateTime = (timems.HasValue ? new DateTime(1970, 1, 1).AddTicks(timems.Value * 10000).ToLocalTime() : DateTime.Now);
            rv.timems = Convert.ToInt64(rv.dateTime.ToUniversalTime().Subtract(new DateTime(1970, 1, 1)).TotalMilliseconds);
            rv.timezoneOffset = Convert.ToInt64(rv.dateTime.ToUniversalTime().Subtract(rv.dateTime).TotalMinutes);
            return rv;
        }
        public returnUniversalDateTime UniversalDateTime(long? timems)
        {
            returnUniversalDateTime rv = new returnUniversalDateTime();
            rv.dateTime = (timems.HasValue ? new DateTime(1970, 1, 1).AddTicks(timems.Value * 10000) : DateTime.Now.ToUniversalTime());
            rv.timems = Convert.ToInt64(rv.dateTime.Subtract(new DateTime(1970, 1, 1)).TotalMilliseconds);
            return rv;
        }

    }
}
