﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;
using System.IO;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.DB.IAdmin
{
	/// <summary>
	/// Return value from method SaveSite
	/// </summary>
	public struct returnSaveSite
	{
		public long ID;
	}
	/// <summary>
	/// Return value from method DeleteSite
	/// </summary>
	public struct returnDeleteSite
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method ListSites
	/// </summary>
	public struct returnListSites
	{
		public long ID;
		public string Name;
		public bool MembersOnly;
		public bool RecycleBin;
	}
	/// <summary>
	/// Return value from method ListUsers
	/// </summary>
	public struct returnListUsers
	{
		public long ID;
		public string GUID;
		public string Login;
		public string Name;
		public bool Administrator;
	}
	/// <summary>
	/// Return value from method ListUserSessions
	/// </summary>
	public struct returnListUserSessions
	{
		public long ID;
		public DateTime StartDate;
		public DateTime EndDate;
	}
	/// <summary>
	/// Return value from method ListUserSites
	/// </summary>
	public struct returnListUserSites
	{
		public long ID;
		public string Name;
		public bool MembersOnly;
		public bool RecycleBin;
		public bool IsEditor;
	}
	/// <summary>
	/// Return value from method DeleteArticleHint
	/// </summary>
	public struct returnDeleteArticleHint
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method ListSiteArticleHints
	/// </summary>
	public struct returnListSiteArticleHints
	{
		public long ID;
		public string Name;
		public long SiteID;
	}
	/// <summary>
	/// Return value from method SaveSiteArticleHint
	/// </summary>
	public struct returnSaveSiteArticleHint
	{
		public long ID;
	}
	/// <summary>
	/// Return value from method CopySiteArticleHints
	/// </summary>
	public struct returnCopySiteArticleHints
	{
		public long AddedArticleHintID;
	}
	/// <summary>
	/// Return value from method GetSite
	/// </summary>
	public struct returnGetSite
	{
		public long ID;
		public string Name;
		public bool MembersOnly;
		public bool RecycleBin;
	}
	/// <summary>
	/// Return value from method ListSiteUsers
	/// </summary>
	public struct returnListSiteUsers
	{
		public long ID;
		public string Login;
		public bool Administrator;
		public string Name;
		public string GUID;
		public bool IsEditor;
	}
	/// <summary>
	/// Return value from method SaveUser
	/// </summary>
	public struct returnSaveUser
	{
		public long ID;
	}
	/// <summary>
	/// Return value from method DeleteUser
	/// </summary>
	public struct returnDeleteUser
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method GetUser
	/// </summary>
	public struct returnGetUser
	{
		public long ID;
		public string Login;
		public bool Administrator;
		public string Name;
		public string GUID;
	}
	/// <summary>
	/// Return value from method SaveMembership
	/// </summary>
	public struct returnSaveMembership
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method RevokeMembership
	/// </summary>
	public struct returnRevokeMembership
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Class implementing operations on:
	///     Custom object
	/// </summary>
	public class IAdmin
	{
		private string _tempDir = ".";
		private bool _odbcCloseAfterUse;
		private OdbcConnection _dbConnection = null;
		private OdbcTransaction _dbTransaction = null;
		public string TempDir
		{
			get { return _tempDir; }
			set { _tempDir = value; }
		}
		public OdbcConnection DbConnection
		{
			get { return _dbConnection; }
			set { _dbConnection = value; }
		}
		public OdbcTransaction DbTransaction
		{
			get { return _dbTransaction; }
			set { _dbTransaction = value; }
		}
		public IAdmin() : this((OdbcConnection)null) { }
		public IAdmin(string connectionString) : this(new OdbcConnection(connectionString)) { }
		public IAdmin(OdbcConnection dbConnection)
		{
			_dbConnection = dbConnection;
		}
		public IAdmin(OdbcConnection dbConnection, OdbcTransaction dbTransaction)
			: this(dbConnection)
		{
			_dbTransaction = dbTransaction;
		}
		protected void DBConnect()
		{
			if (_odbcCloseAfterUse = (_dbConnection.State != ConnectionState.Open))
			{
				_dbConnection.Open();
				if (_dbConnection.Driver.ToLower().StartsWith("myodbc"))
				{
					OdbcCommand cmd = _dbConnection.CreateCommand();
					if (_dbTransaction != null) cmd.Transaction = _dbTransaction;
					cmd.CommandText = "SET sql_mode = 'ANSI'";
					cmd.ExecuteNonQuery();
				}
			}
		}
		protected void DBClose() { if (_odbcCloseAfterUse) _dbConnection.Close(); }
		protected OdbcCommand DBCreateCommand()
		{
			OdbcCommand cmd = _dbConnection.CreateCommand();
			if(_dbTransaction != null) cmd.Transaction = _dbTransaction;
			return cmd;
		}
		/// <summary>
		/// Creates or updates site info
		/// runs a sequence of connected methods: AbortIfNotAdministrator, IsRecycleBin, Constants, SaveSite.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <param name="MembersOnly"></param>
		/// <param name="Name"></param>
		/// <returns>returnSaveSite</returns>
		public returnSaveSite SaveSite(string ticket, long? ID, bool MembersOnly, string Name)
		{
			returnSaveSite rv = new returnSaveSite();
			List<returnSaveSite> rvl = new List<returnSaveSite>();
			returnSaveSite crv = new returnSaveSite();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnIsRecycleBin prvIsRecycleBin = PDatabaseObj.IsRecycleBin(ID);
			if (prvIsRecycleBin.isRecycleBin != true)
			{
				cms.DB.IBasics.returnConstants prvConstants = IBasicsObj.Constants();
				cms.DB.PDatabase.returnSaveSite prvSaveSite = PDatabaseObj.SaveSite(ID, Name, MembersOnly, prvConstants.FalseBool);
				crv.ID = prvSaveSite.SiteID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveSite());
			return rv;
		}
		/// <summary>
		/// Delete a site
		/// runs a sequence of connected methods: AbortIfNotAdministrator, IsRecycleBin, DeleteSiteEx.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnDeleteSite</returns>
		public returnDeleteSite DeleteSite(string ticket, long ID)
		{
			returnDeleteSite rv = new returnDeleteSite();
			List<returnDeleteSite> rvl = new List<returnDeleteSite>();
			returnDeleteSite crv = new returnDeleteSite();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnIsRecycleBin prvIsRecycleBin = PDatabaseObj.IsRecycleBin(ID);
			if (prvIsRecycleBin.isRecycleBin != true)
			{
				cms.DB.PDatabase.returnDeleteSiteEx prvDeleteSiteEx = PDatabaseObj.DeleteSiteEx(ID);
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnDeleteSite());
			return rv;
		}
		/// <summary>
		/// List all sites
		/// runs a sequence of connected methods: AbortIfNotAdministrator, ListSiteByNameLike.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="NameLike"></param>
		/// <returns>returnListSites[]</returns>
		public returnListSites[] ListSites(int? maxRowsToReturn, string ticket, string NameLike)
		{
			returnListSites[] rv = null;
			List<returnListSites> rvl = new List<returnListSites>();
			returnListSites crv = new returnListSites();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnListSiteByNameLike[] prvListSiteByNameLike = PDatabaseObj.ListSiteByNameLike(maxRowsToReturn, NameLike);
			for(int idxListSiteByNameLike = 0; idxListSiteByNameLike < prvListSiteByNameLike.Length; idxListSiteByNameLike++)
			{
				if (idxListSiteByNameLike > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnListSites();
					}
				}
				crv.ID = prvListSiteByNameLike[idxListSiteByNameLike].ID;
				crv.Name = prvListSiteByNameLike[idxListSiteByNameLike].Name;
				crv.MembersOnly = prvListSiteByNameLike[idxListSiteByNameLike].MembersOnly;
				crv.RecycleBin = prvListSiteByNameLike[idxListSiteByNameLike].RecycleBin;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Lists all users
		/// runs a sequence of connected methods: AbortIfNotAdministrator, ListUserByNameLike.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="NameLike"></param>
		/// <returns>returnListUsers[]</returns>
		public returnListUsers[] ListUsers(int? maxRowsToReturn, string ticket, string NameLike)
		{
			returnListUsers[] rv = null;
			List<returnListUsers> rvl = new List<returnListUsers>();
			returnListUsers crv = new returnListUsers();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnListUserByNameLike[] prvListUserByNameLike = PDatabaseObj.ListUserByNameLike(maxRowsToReturn, NameLike);
			for(int idxListUserByNameLike = 0; idxListUserByNameLike < prvListUserByNameLike.Length; idxListUserByNameLike++)
			{
				if (idxListUserByNameLike > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnListUsers();
					}
				}
				crv.ID = prvListUserByNameLike[idxListUserByNameLike].ID;
				crv.GUID = prvListUserByNameLike[idxListUserByNameLike].GUID;
				crv.Login = prvListUserByNameLike[idxListUserByNameLike].Login;
				crv.Name = prvListUserByNameLike[idxListUserByNameLike].Name;
				crv.Administrator = prvListUserByNameLike[idxListUserByNameLike].Administrator;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Lists all sessions for a specific user
		/// runs a sequence of connected methods: AbortIfNotAdministrator, ListSessionByUser.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="UserID"></param>
		/// <returns>returnListUserSessions[]</returns>
		public returnListUserSessions[] ListUserSessions(int? maxRowsToReturn, string ticket, long UserID)
		{
			returnListUserSessions[] rv = null;
			List<returnListUserSessions> rvl = new List<returnListUserSessions>();
			returnListUserSessions crv = new returnListUserSessions();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnListSessionByUser[] prvListSessionByUser = PDatabaseObj.ListSessionByUser(maxRowsToReturn, UserID);
			for(int idxListSessionByUser = 0; idxListSessionByUser < prvListSessionByUser.Length; idxListSessionByUser++)
			{
				if (idxListSessionByUser > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnListUserSessions();
					}
				}
				crv.ID = prvListSessionByUser[idxListSessionByUser].ID;
				crv.StartDate = prvListSessionByUser[idxListSessionByUser].StartDate;
				crv.EndDate = prvListSessionByUser[idxListSessionByUser].EndDate;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Lists a all membership sites for a user
		/// runs a sequence of connected methods: AbortIfNotAdministrator, ListMemberByUser, GetSite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="UserID"></param>
		/// <returns>returnListUserSites[]</returns>
		public returnListUserSites[] ListUserSites(int? maxRowsToReturn, string ticket, long UserID)
		{
			returnListUserSites[] rv = null;
			List<returnListUserSites> rvl = new List<returnListUserSites>();
			returnListUserSites crv = new returnListUserSites();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnListMemberByUser[] prvListMemberByUser = PDatabaseObj.ListMemberByUser(maxRowsToReturn, UserID);
			for(int idxListMemberByUser = 0; idxListMemberByUser < prvListMemberByUser.Length; idxListMemberByUser++)
			{
				if (idxListMemberByUser > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnListUserSites();
					}
				}
				crv.IsEditor = prvListMemberByUser[idxListMemberByUser].Edit;
				crvUsed = true;
				cms.DB.PDatabase.returnGetSite prvGetSite = PDatabaseObj.GetSite(prvListMemberByUser[idxListMemberByUser].SiteID);
				crv.ID = prvGetSite.ID;
				crv.Name = prvGetSite.Name;
				crv.MembersOnly = prvGetSite.MembersOnly;
				crv.RecycleBin = prvGetSite.RecycleBin;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Delete a hint from the site hint list
		/// runs a sequence of connected methods: AbortIfNotAdministrator, DeleteArticleHint.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnDeleteArticleHint</returns>
		public returnDeleteArticleHint DeleteArticleHint(string ticket, long ID)
		{
			returnDeleteArticleHint rv = new returnDeleteArticleHint();
			List<returnDeleteArticleHint> rvl = new List<returnDeleteArticleHint>();
			returnDeleteArticleHint crv = new returnDeleteArticleHint();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			int prvDeleteArticleHint = PDatabaseObj.DeleteArticleHint(ID);
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnDeleteArticleHint());
			return rv;
		}
		/// <summary>
		/// Lists all display hints for a site
		/// runs a sequence of connected methods: AbortIfNotAdministrator, ListArticleHintBySite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListSiteArticleHints[]</returns>
		public returnListSiteArticleHints[] ListSiteArticleHints(int? maxRowsToReturn, string ticket, long SiteID)
		{
			returnListSiteArticleHints[] rv = null;
			List<returnListSiteArticleHints> rvl = new List<returnListSiteArticleHints>();
			returnListSiteArticleHints crv = new returnListSiteArticleHints();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnListArticleHintBySite[] prvListArticleHintBySite = PDatabaseObj.ListArticleHintBySite(maxRowsToReturn, SiteID);
			for(int idxListArticleHintBySite = 0; idxListArticleHintBySite < prvListArticleHintBySite.Length; idxListArticleHintBySite++)
			{
				if (idxListArticleHintBySite > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnListSiteArticleHints();
					}
				}
				crv.ID = prvListArticleHintBySite[idxListArticleHintBySite].ID;
				crv.Name = prvListArticleHintBySite[idxListArticleHintBySite].Name;
				crv.SiteID = prvListArticleHintBySite[idxListArticleHintBySite].SiteID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Creates or updates a hint in the site hint list
		/// runs a sequence of connected methods: AbortIfNotAdministrator, SaveArticleHint.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <param name="Name"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnSaveSiteArticleHint</returns>
		public returnSaveSiteArticleHint SaveSiteArticleHint(string ticket, long? ID, string Name, long SiteID)
		{
			returnSaveSiteArticleHint rv = new returnSaveSiteArticleHint();
			List<returnSaveSiteArticleHint> rvl = new List<returnSaveSiteArticleHint>();
			returnSaveSiteArticleHint crv = new returnSaveSiteArticleHint();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			if (Name == null) throw new Exception("Name must not be null!");
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnSaveArticleHint prvSaveArticleHint = PDatabaseObj.SaveArticleHint(ID, Name, SiteID);
			crv.ID = prvSaveArticleHint.ArticleHintID;
			crvUsed = true;
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveSiteArticleHint());
			return rv;
		}
		/// <summary>
		/// Copy the hint list from one site to another
		/// runs a sequence of connected methods: AbortIfNotAdministrator, ListArticleHintBySite, ListArticleHintByName, NewArticleHint.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="fromSiteID"></param>
		/// <param name="toSiteID"></param>
		/// <returns>returnCopySiteArticleHints[]</returns>
		public returnCopySiteArticleHints[] CopySiteArticleHints(int? maxRowsToReturn, string ticket, long fromSiteID, long toSiteID)
		{
			returnCopySiteArticleHints[] rv = null;
			List<returnCopySiteArticleHints> rvl = new List<returnCopySiteArticleHints>();
			returnCopySiteArticleHints crv = new returnCopySiteArticleHints();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnListArticleHintBySite[] prvListArticleHintBySite = PDatabaseObj.ListArticleHintBySite(maxRowsToReturn, fromSiteID);
			for(int idxListArticleHintBySite = 0; idxListArticleHintBySite < prvListArticleHintBySite.Length; idxListArticleHintBySite++)
			{
				if (idxListArticleHintBySite > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnCopySiteArticleHints();
					}
				}
				cms.DB.PDatabase.returnListArticleHintByName[] prvListArticleHintByName = PDatabaseObj.ListArticleHintByName(1, toSiteID, prvListArticleHintBySite[idxListArticleHintBySite].Name);
				bool prvListArticleHintByNamehasResults = prvListArticleHintByName.Length > 0;
				if (prvListArticleHintByNamehasResults != true)
				{
					long prvNewArticleHint = PDatabaseObj.NewArticleHint(prvListArticleHintBySite[idxListArticleHintBySite].Name, toSiteID);
					crv.AddedArticleHintID = prvNewArticleHint;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: AbortIfNotAdministrator, GetSite.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnGetSite</returns>
		public returnGetSite GetSite(string ticket, long ID)
		{
			returnGetSite rv = new returnGetSite();
			List<returnGetSite> rvl = new List<returnGetSite>();
			returnGetSite crv = new returnGetSite();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnGetSite prvGetSite = PDatabaseObj.GetSite(ID);
			crv.ID = prvGetSite.ID;
			crv.Name = prvGetSite.Name;
			crv.MembersOnly = prvGetSite.MembersOnly;
			crv.RecycleBin = prvGetSite.RecycleBin;
			crvUsed = true;
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnGetSite());
			return rv;
		}
		/// <summary>
		/// Lists all users that are members of the site
		/// runs a sequence of connected methods: AbortIfNotAdministrator, ListMemberBySite, GetUser.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListSiteUsers[]</returns>
		public returnListSiteUsers[] ListSiteUsers(int? maxRowsToReturn, string ticket, long SiteID)
		{
			returnListSiteUsers[] rv = null;
			List<returnListSiteUsers> rvl = new List<returnListSiteUsers>();
			returnListSiteUsers crv = new returnListSiteUsers();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnListMemberBySite[] prvListMemberBySite = PDatabaseObj.ListMemberBySite(maxRowsToReturn, SiteID);
			for(int idxListMemberBySite = 0; idxListMemberBySite < prvListMemberBySite.Length; idxListMemberBySite++)
			{
				if (idxListMemberBySite > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnListSiteUsers();
					}
				}
				crv.IsEditor = prvListMemberBySite[idxListMemberBySite].Edit;
				crvUsed = true;
				cms.DB.PDatabase.returnGetUser prvGetUser = PDatabaseObj.GetUser(prvListMemberBySite[idxListMemberBySite].UserID);
				crv.ID = prvGetUser.ID;
				crv.Login = prvGetUser.Login;
				crv.Administrator = prvGetUser.Administrator;
				crv.Name = prvGetUser.Name;
				crv.GUID = prvGetUser.GUID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Creates or update a user. If password is null the current password is kept.
		/// runs a sequence of connected methods: AbortIfNotAdministrator, SaveUser.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <param name="Login"></param>
		/// <param name="Name"></param>
		/// <param name="Administrator"></param>
		/// <param name="Password"></param>
		/// <returns>returnSaveUser</returns>
		public returnSaveUser SaveUser(string ticket, long? ID, string Login, string Name, bool Administrator, string Password)
		{
			returnSaveUser rv = new returnSaveUser();
			List<returnSaveUser> rvl = new List<returnSaveUser>();
			returnSaveUser crv = new returnSaveUser();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			if (Login == null) throw new Exception("Login must not be null!");
			if (Name == null) throw new Exception("Name must not be null!");
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnSaveUser prvSaveUser = PDatabaseObj.SaveUser(ID, Login, Name, Administrator, Password);
			crv.ID = prvSaveUser.UserID;
			crvUsed = true;
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveUser());
			return rv;
		}
		/// <summary>
		/// Deletes a user account (incl sessions and memberships)
		/// runs a sequence of connected methods: AbortIfNotAdministrator, DeleteUserEx.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnDeleteUser</returns>
		public returnDeleteUser DeleteUser(string ticket, long ID)
		{
			returnDeleteUser rv = new returnDeleteUser();
			List<returnDeleteUser> rvl = new List<returnDeleteUser>();
			returnDeleteUser crv = new returnDeleteUser();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnDeleteUserEx prvDeleteUserEx = PDatabaseObj.DeleteUserEx(ID);
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnDeleteUser());
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: AbortIfNotAdministrator, GetUser.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnGetUser</returns>
		public returnGetUser GetUser(string ticket, long ID)
		{
			returnGetUser rv = new returnGetUser();
			List<returnGetUser> rvl = new List<returnGetUser>();
			returnGetUser crv = new returnGetUser();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnGetUser prvGetUser = PDatabaseObj.GetUser(ID);
			crv.ID = prvGetUser.ID;
			crv.Login = prvGetUser.Login;
			crv.Administrator = prvGetUser.Administrator;
			crv.Name = prvGetUser.Name;
			crv.GUID = prvGetUser.GUID;
			crvUsed = true;
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnGetUser());
			return rv;
		}
		/// <summary>
		/// Creates or changes a user site membership.
		/// runs a sequence of connected methods: AbortIfNotAdministrator, SaveMembership.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="UserID"></param>
		/// <param name="SiteID"></param>
		/// <param name="IsEditor"></param>
		/// <returns>returnSaveMembership</returns>
		public returnSaveMembership SaveMembership(string ticket, long UserID, long SiteID, bool IsEditor)
		{
			returnSaveMembership rv = new returnSaveMembership();
			List<returnSaveMembership> rvl = new List<returnSaveMembership>();
			returnSaveMembership crv = new returnSaveMembership();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnSaveMembership prvSaveMembership = PDatabaseObj.SaveMembership(UserID, SiteID, IsEditor);
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveMembership());
			return rv;
		}
		/// <summary>
		/// Revokes a user site membership
		/// runs a sequence of connected methods: AbortIfNotAdministrator, RevokeMembership.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="UserID"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnRevokeMembership</returns>
		public returnRevokeMembership RevokeMembership(string ticket, long UserID, long SiteID)
		{
			returnRevokeMembership rv = new returnRevokeMembership();
			List<returnRevokeMembership> rvl = new List<returnRevokeMembership>();
			returnRevokeMembership crv = new returnRevokeMembership();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnAbortIfNotAdministrator prvAbortIfNotAdministrator = ICredentialsObj.AbortIfNotAdministrator(ticket);
			cms.DB.PDatabase.returnRevokeMembership prvRevokeMembership = PDatabaseObj.RevokeMembership(UserID, SiteID);
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnRevokeMembership());
			return rv;
		}
	}
}
