﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;
using System.IO;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.DB.ICredentials
{
	/// <summary>
	/// Return value from method MayViewSite
	/// </summary>
	public struct returnMayViewSite
	{
		public bool UserMayViewSite;
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
		public bool SiteIsPublic;
		public bool UserIsAuthenticated;
	}
	/// <summary>
	/// Return value from method MayEditSite
	/// </summary>
	public struct returnMayEditSite
	{
		public bool UserMayEditSite;
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
	}
	/// <summary>
	/// Return value from method MayViewContent
	/// </summary>
	public struct returnMayViewContent
	{
		public bool UserMayViewContent;
		public bool UserMayViewSite;
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
		public string ContentType;
		public bool ContentPublished;
		public bool UserIsAuthenticated;
	}
	/// <summary>
	/// Return value from method MayEditContent
	/// </summary>
	public struct returnMayEditContent
	{
		public bool UserMayEditSite;
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
		public string ContentType;
	}
	/// <summary>
	/// Return value from method AbortIfNotAdministrator
	/// </summary>
	public struct returnAbortIfNotAdministrator
	{
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
	}
	/// <summary>
	/// Return value from method AbortIfSiteIsChanged
	/// </summary>
	public struct returnAbortIfSiteIsChanged
	{
		public bool UserMayEditSite;
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
	}
	/// <summary>
	/// Return value from method AbortIfContentNotInSite
	/// </summary>
	public struct returnAbortIfContentNotInSite
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method ViewableSites
	/// </summary>
	public struct returnViewableSites
	{
		public bool UserMayViewSite;
		public long SiteID;
		public string SiteName;
		public bool SiteRecycleBin;
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
		public bool SiteIsPublic;
	}
	/// <summary>
	/// Return value from method EditableSites
	/// </summary>
	public struct returnEditableSites
	{
		public bool UserMayEditSite;
		public long SiteID;
		public string SiteName;
		public bool SiteRecycleBin;
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
	}
	/// <summary>
	/// Return value from method SearchSites
	/// </summary>
	public struct returnSearchSites
	{
		public bool UserMayEditSite;
		public long SiteID;
		public string SiteName;
		public bool SiteRecycleBin;
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
		public bool ShouldSearchSite;
		public string EmptyString;
	}
	/// <summary>
	/// Class implementing operations on:
	///     Custom object
	/// </summary>
	public class ICredentials
	{
		private string _tempDir = ".";
		private bool _odbcCloseAfterUse;
		private OdbcConnection _dbConnection = null;
		private OdbcTransaction _dbTransaction = null;
		public string TempDir
		{
			get { return _tempDir; }
			set { _tempDir = value; }
		}
		public OdbcConnection DbConnection
		{
			get { return _dbConnection; }
			set { _dbConnection = value; }
		}
		public OdbcTransaction DbTransaction
		{
			get { return _dbTransaction; }
			set { _dbTransaction = value; }
		}
		public ICredentials() : this((OdbcConnection)null) { }
		public ICredentials(string connectionString) : this(new OdbcConnection(connectionString)) { }
		public ICredentials(OdbcConnection dbConnection)
		{
			_dbConnection = dbConnection;
		}
		public ICredentials(OdbcConnection dbConnection, OdbcTransaction dbTransaction)
			: this(dbConnection)
		{
			_dbTransaction = dbTransaction;
		}
		protected void DBConnect()
		{
			if (_odbcCloseAfterUse = (_dbConnection.State != ConnectionState.Open))
			{
				_dbConnection.Open();
				if (_dbConnection.Driver.ToLower().StartsWith("myodbc"))
				{
					OdbcCommand cmd = _dbConnection.CreateCommand();
					if (_dbTransaction != null) cmd.Transaction = _dbTransaction;
					cmd.CommandText = "SET sql_mode = 'ANSI'";
					cmd.ExecuteNonQuery();
				}
			}
		}
		protected void DBClose() { if (_odbcCloseAfterUse) _dbConnection.Close(); }
		protected OdbcCommand DBCreateCommand()
		{
			OdbcCommand cmd = _dbConnection.CreateCommand();
			if(_dbTransaction != null) cmd.Transaction = _dbTransaction;
			return cmd;
		}
		/// <summary>
		/// runs a sequence of connected methods: CurrentUser, GetSite, IsMemberOf, LogicalNot, LogicalOr, LogicalOr.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnMayViewSite</returns>
		public returnMayViewSite MayViewSite(string ticket, long SiteID)
		{
			returnMayViewSite rv = new returnMayViewSite();
			List<returnMayViewSite> rvl = new List<returnMayViewSite>();
			returnMayViewSite crv = new returnMayViewSite();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnCurrentUser prvCurrentUser = PPlatformObj.CurrentUser(ticket);
			crv.UserIsAuthenticated = prvCurrentUser.IsAuthenticated;
			crv.UserID = prvCurrentUser.UserID;
			crv.UserLogin = prvCurrentUser.UserLogin;
			crv.UserAdministrator = prvCurrentUser.UserAdministrator;
			crvUsed = true;
			cms.DB.PDatabase.returnGetSite prvGetSite = PDatabaseObj.GetSite(SiteID);
			cms.DB.PDatabase.returnIsMemberOf prvIsMemberOf = PDatabaseObj.IsMemberOf(prvGetSite.ID, prvCurrentUser.UserID);
			cms.DB.IBasics.returnLogicalNot prvLogicalNot = IBasicsObj.LogicalNot(prvGetSite.MembersOnly);
			crv.SiteIsPublic = prvLogicalNot.notB;
			crvUsed = true;
			cms.DB.IBasics.returnLogicalOr prvIBasicsLogicalOr = IBasicsObj.LogicalOr(prvLogicalNot.notB, prvIsMemberOf.hasResults);
			cms.DB.IBasics.returnLogicalOr prvLogicalOr = IBasicsObj.LogicalOr(prvCurrentUser.UserAdministrator, prvIBasicsLogicalOr.b);
			crv.UserMayViewSite = prvLogicalOr.b;
			crvUsed = true;
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnMayViewSite());
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: CurrentUser, IsEditMemberOf, LogicalOr.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <returns>returnMayEditSite</returns>
		public returnMayEditSite MayEditSite(string ticket, long siteID)
		{
			returnMayEditSite rv = new returnMayEditSite();
			List<returnMayEditSite> rvl = new List<returnMayEditSite>();
			returnMayEditSite crv = new returnMayEditSite();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnCurrentUser prvCurrentUser = PPlatformObj.CurrentUser(ticket);
			crv.UserID = prvCurrentUser.UserID;
			crv.UserLogin = prvCurrentUser.UserLogin;
			crv.UserAdministrator = prvCurrentUser.UserAdministrator;
			crvUsed = true;
			if (prvCurrentUser.IsAuthenticated == true)
			{
				cms.DB.PDatabase.returnIsEditMemberOf prvIsEditMemberOf = PDatabaseObj.IsEditMemberOf(siteID, prvCurrentUser.UserID);
				cms.DB.IBasics.returnLogicalOr prvLogicalOr = IBasicsObj.LogicalOr(prvCurrentUser.UserAdministrator, prvIsEditMemberOf.MemberEdit);
				crv.UserMayEditSite = prvLogicalOr.b;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnMayEditSite());
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: GetContent, MayViewSite, LogicalAnd, LogicalOr, LogicalAnd.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnMayViewContent</returns>
		public returnMayViewContent MayViewContent(string ticket, long ContentID)
		{
			returnMayViewContent rv = new returnMayViewContent();
			List<returnMayViewContent> rvl = new List<returnMayViewContent>();
			returnMayViewContent crv = new returnMayViewContent();
			bool crvUsed = false;
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PDatabase.returnGetContent prvGetContent = PDatabaseObj.GetContent(ContentID);
			crv.ContentPublished = prvGetContent.Published;
			crv.ContentType = prvGetContent.Type;
			crvUsed = true;
			returnMayViewSite prvMayViewSite = this.MayViewSite(ticket, prvGetContent.SiteID);
			crv.UserMayViewSite = prvMayViewSite.UserMayViewSite;
			crv.UserID = prvMayViewSite.UserID;
			crv.UserLogin = prvMayViewSite.UserLogin;
			crv.UserAdministrator = prvMayViewSite.UserAdministrator;
			crv.UserIsAuthenticated = prvMayViewSite.UserIsAuthenticated;
			crvUsed = true;
			cms.DB.IBasics.returnLogicalAnd prvLogicalAnd = IBasicsObj.LogicalAnd(prvMayViewSite.SiteIsPublic, prvGetContent.Published);
			cms.DB.IBasics.returnLogicalOr prvLogicalOr = IBasicsObj.LogicalOr(prvMayViewSite.UserIsAuthenticated, prvLogicalAnd.b);
			cms.DB.IBasics.returnLogicalAnd prvIBasicsLogicalAnd = IBasicsObj.LogicalAnd(prvMayViewSite.UserMayViewSite, prvLogicalOr.b);
			crv.UserMayViewContent = prvIBasicsLogicalAnd.b;
			crvUsed = true;
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnMayViewContent());
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: GetContent, MayEditSite.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnMayEditContent</returns>
		public returnMayEditContent MayEditContent(string ticket, long ContentID)
		{
			returnMayEditContent rv = new returnMayEditContent();
			List<returnMayEditContent> rvl = new List<returnMayEditContent>();
			returnMayEditContent crv = new returnMayEditContent();
			bool crvUsed = false;
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.PDatabase.returnGetContent prvGetContent = PDatabaseObj.GetContent(ContentID);
			crv.ContentType = prvGetContent.Type;
			crvUsed = true;
			returnMayEditSite prvMayEditSite = this.MayEditSite(ticket, prvGetContent.SiteID);
			crv.UserMayEditSite = prvMayEditSite.UserMayEditSite;
			crv.UserID = prvMayEditSite.UserID;
			crv.UserLogin = prvMayEditSite.UserLogin;
			crv.UserAdministrator = prvMayEditSite.UserAdministrator;
			crvUsed = true;
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnMayEditContent());
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: CurrentUser, AbortIfNot.
		/// </summary>
		/// <param name="ticket"></param>
		/// <returns>returnAbortIfNotAdministrator</returns>
		public returnAbortIfNotAdministrator AbortIfNotAdministrator(string ticket)
		{
			returnAbortIfNotAdministrator rv = new returnAbortIfNotAdministrator();
			List<returnAbortIfNotAdministrator> rvl = new List<returnAbortIfNotAdministrator>();
			returnAbortIfNotAdministrator crv = new returnAbortIfNotAdministrator();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnCurrentUser prvCurrentUser = PPlatformObj.CurrentUser(ticket);
			crv.UserID = prvCurrentUser.UserID;
			crv.UserLogin = prvCurrentUser.UserLogin;
			crv.UserAdministrator = prvCurrentUser.UserAdministrator;
			crvUsed = true;
			cms.DB.IBasics.returnAbortIfNot prvAbortIfNot = IBasicsObj.AbortIfNot(prvCurrentUser.UserAdministrator);
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnAbortIfNotAdministrator());
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: MayEditSite, IdIsNull, MayEditContent, LogicalAnd, AbortIfNot.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <param name="contentID"></param>
		/// <returns>returnAbortIfSiteIsChanged</returns>
		public returnAbortIfSiteIsChanged AbortIfSiteIsChanged(string ticket, long siteID, long? contentID)
		{
			returnAbortIfSiteIsChanged rv = new returnAbortIfSiteIsChanged();
			List<returnAbortIfSiteIsChanged> rvl = new List<returnAbortIfSiteIsChanged>();
			returnAbortIfSiteIsChanged crv = new returnAbortIfSiteIsChanged();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			returnMayEditSite prvMayEditSite = this.MayEditSite(ticket, siteID);
			crv.UserMayEditSite = prvMayEditSite.UserMayEditSite;
			crv.UserID = prvMayEditSite.UserID;
			crv.UserLogin = prvMayEditSite.UserLogin;
			crv.UserAdministrator = prvMayEditSite.UserAdministrator;
			crvUsed = true;
			cms.DB.PPlatform.returnIdIsNull prvIdIsNull = PPlatformObj.IdIsNull(contentID);
			if (contentID != null)
			{
				returnMayEditContent prvMayEditContent = this.MayEditContent(ticket, contentID.Value);
				cms.DB.IBasics.returnLogicalAnd prvLogicalAnd = IBasicsObj.LogicalAnd(prvMayEditSite.UserMayEditSite, prvMayEditContent.UserMayEditSite);
				cms.DB.IBasics.returnAbortIfNot prvAbortIfNot = IBasicsObj.AbortIfNot(prvLogicalAnd.b);
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnAbortIfSiteIsChanged());
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: IdIsNull, GetContent, IsEqualInt, AbortIfNot.
		/// </summary>
		/// <param name="contentID"></param>
		/// <param name="siteID"></param>
		/// <returns>returnAbortIfContentNotInSite</returns>
		public returnAbortIfContentNotInSite AbortIfContentNotInSite(long? contentID, long siteID)
		{
			returnAbortIfContentNotInSite rv = new returnAbortIfContentNotInSite();
			List<returnAbortIfContentNotInSite> rvl = new List<returnAbortIfContentNotInSite>();
			returnAbortIfContentNotInSite crv = new returnAbortIfContentNotInSite();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnIdIsNull prvIdIsNull = PPlatformObj.IdIsNull(contentID);
			if (contentID != null && prvIdIsNull.isNull != true)
			{
				cms.DB.PDatabase.returnGetContent prvGetContent = PDatabaseObj.GetContent(contentID.Value);
				cms.DB.IBasics.returnIsEqualInt prvIsEqualInt = IBasicsObj.IsEqualInt(prvGetContent.SiteID, siteID);
				cms.DB.IBasics.returnAbortIfNot prvAbortIfNot = IBasicsObj.AbortIfNot(prvIsEqualInt.isEqual);
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnAbortIfContentNotInSite());
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: CurrentUser, ListSite, LogicalNot, IsMemberOf, LogicalOr, LogicalOr.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <returns>returnViewableSites[]</returns>
		public returnViewableSites[] ViewableSites(int? maxRowsToReturn, string ticket)
		{
			returnViewableSites[] rv = null;
			List<returnViewableSites> rvl = new List<returnViewableSites>();
			returnViewableSites crv = new returnViewableSites();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnCurrentUser prvCurrentUser = PPlatformObj.CurrentUser(ticket);
			crv.UserID = prvCurrentUser.UserID;
			crv.UserLogin = prvCurrentUser.UserLogin;
			crv.UserAdministrator = prvCurrentUser.UserAdministrator;
			crvUsed = true;
			cms.DB.PDatabase.returnListSite[] prvListSite = PDatabaseObj.ListSite(maxRowsToReturn);
			for(int idxListSite = 0; idxListSite < prvListSite.Length; idxListSite++)
			{
				if (idxListSite > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnViewableSites();
						crv.UserID = rvl[rvl.Count-1].UserID;
						crv.UserLogin = rvl[rvl.Count-1].UserLogin;
						crv.UserAdministrator = rvl[rvl.Count-1].UserAdministrator;
					}
				}
				crv.SiteID = prvListSite[idxListSite].ID;
				crv.SiteName = prvListSite[idxListSite].Name;
				crv.SiteRecycleBin = prvListSite[idxListSite].RecycleBin;
				crvUsed = true;
				cms.DB.IBasics.returnLogicalNot prvLogicalNot = IBasicsObj.LogicalNot(prvListSite[idxListSite].MembersOnly);
				crv.SiteIsPublic = prvLogicalNot.notB;
				crvUsed = true;
				cms.DB.PDatabase.returnIsMemberOf prvIsMemberOf = PDatabaseObj.IsMemberOf(prvListSite[idxListSite].ID, prvCurrentUser.UserID);
				cms.DB.IBasics.returnLogicalOr prvLogicalOr = IBasicsObj.LogicalOr(prvIsMemberOf.hasResults, prvLogicalNot.notB);
				cms.DB.IBasics.returnLogicalOr prvIBasicsLogicalOr = IBasicsObj.LogicalOr(prvLogicalOr.b, prvCurrentUser.UserAdministrator);
				crv.UserMayViewSite = prvIBasicsLogicalOr.b;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: CurrentUser, ListSite, IsEditMemberOf, LogicalOr.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <returns>returnEditableSites[]</returns>
		public returnEditableSites[] EditableSites(int? maxRowsToReturn, string ticket)
		{
			returnEditableSites[] rv = null;
			List<returnEditableSites> rvl = new List<returnEditableSites>();
			returnEditableSites crv = new returnEditableSites();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnCurrentUser prvCurrentUser = PPlatformObj.CurrentUser(ticket);
			crv.UserID = prvCurrentUser.UserID;
			crv.UserLogin = prvCurrentUser.UserLogin;
			crv.UserAdministrator = prvCurrentUser.UserAdministrator;
			crvUsed = true;
			if (prvCurrentUser.IsAuthenticated == true)
			{
				cms.DB.PDatabase.returnListSite[] prvListSite = PDatabaseObj.ListSite(maxRowsToReturn);
				for(int idxListSite = 0; idxListSite < prvListSite.Length; idxListSite++)
				{
					if (idxListSite > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnEditableSites();
							crv.UserID = rvl[rvl.Count-1].UserID;
							crv.UserLogin = rvl[rvl.Count-1].UserLogin;
							crv.UserAdministrator = rvl[rvl.Count-1].UserAdministrator;
						}
					}
					crv.SiteID = prvListSite[idxListSite].ID;
					crv.SiteName = prvListSite[idxListSite].Name;
					crv.SiteRecycleBin = prvListSite[idxListSite].RecycleBin;
					crvUsed = true;
					cms.DB.PDatabase.returnIsEditMemberOf prvIsEditMemberOf = PDatabaseObj.IsEditMemberOf(prvListSite[idxListSite].ID, prvCurrentUser.UserID);
					cms.DB.IBasics.returnLogicalOr prvLogicalOr = IBasicsObj.LogicalOr(prvCurrentUser.UserAdministrator, prvIsEditMemberOf.MemberEdit);
					crv.UserMayEditSite = prvLogicalOr.b;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: Constants, DefaultInt, IsEqualInt, EditableSites, IsEqualInt, LogicalOr.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <returns>returnSearchSites[]</returns>
		public returnSearchSites[] SearchSites(int? maxRowsToReturn, string ticket, long? siteID)
		{
			returnSearchSites[] rv = null;
			List<returnSearchSites> rvl = new List<returnSearchSites>();
			returnSearchSites crv = new returnSearchSites();
			bool crvUsed = false;
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.IBasics.returnConstants prvConstants = IBasicsObj.Constants();
			crv.EmptyString = prvConstants.EmptyString;
			crvUsed = true;
			cms.DB.IBasics.returnDefaultInt prvDefaultInt = IBasicsObj.DefaultInt(siteID, prvConstants.ZeroInt);
			cms.DB.IBasics.returnIsEqualInt prvIsEqualInt = IBasicsObj.IsEqualInt(prvDefaultInt.i, prvConstants.ZeroInt);
			returnEditableSites[] prvEditableSites = this.EditableSites(maxRowsToReturn, ticket);
			for(int idxEditableSites = 0; idxEditableSites < prvEditableSites.Length; idxEditableSites++)
			{
				if (idxEditableSites > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnSearchSites();
						crv.EmptyString = rvl[rvl.Count-1].EmptyString;
					}
				}
				crv.UserMayEditSite = prvEditableSites[idxEditableSites].UserMayEditSite;
				crv.SiteID = prvEditableSites[idxEditableSites].SiteID;
				crv.SiteName = prvEditableSites[idxEditableSites].SiteName;
				crv.SiteRecycleBin = prvEditableSites[idxEditableSites].SiteRecycleBin;
				crv.UserID = prvEditableSites[idxEditableSites].UserID;
				crv.UserLogin = prvEditableSites[idxEditableSites].UserLogin;
				crv.UserAdministrator = prvEditableSites[idxEditableSites].UserAdministrator;
				crvUsed = true;
				cms.DB.IBasics.returnIsEqualInt prvIBasicsIsEqualInt = IBasicsObj.IsEqualInt(prvEditableSites[idxEditableSites].SiteID, prvDefaultInt.i);
				cms.DB.IBasics.returnLogicalOr prvLogicalOr = IBasicsObj.LogicalOr(prvIsEqualInt.isEqual, prvIBasicsIsEqualInt.isEqual);
				crv.ShouldSearchSite = prvLogicalOr.b;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
	}
}
