﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;
using System.IO;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.DB.IEdit
{
	/// <summary>
	/// Return value from method ListSiteContent
	/// </summary>
	public struct returnListSiteContent
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentType;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public long? ParentID;
		public string friendlyName;
	}
	/// <summary>
	/// Return value from method GetContentDetails
	/// </summary>
	public struct returnGetContentDetails
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentType;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public DateTime EditedDate;
		public string EditedBy;
		public long SiteID;
		public string SiteName;
		public long? ParentID;
		public string friendlyName;
		public bool hasArticle;
		public long ArticleID;
		public string ArticleEditor;
		public string ArticleData;
		public string ArticleHint;
		public bool hasDocument;
		public long DocumentID;
		public string DocumentMimeType;
		public bool hasImage;
		public long ImageID;
		public string ImageMimeType;
		public long ImageWidth;
		public long ImageHeight;
		public string ImageAlternative;
		public bool hasLink;
		public long LinkID;
		public string LinkTargetURI;
		public string LinkTargetURL;
		public bool hasMessage;
		public long MessageID;
		public string MessageSource;
		public string MessageData;
	}
	/// <summary>
	/// Return value from method SaveLink
	/// </summary>
	public struct returnSaveLink
	{
		public long LinkID;
		public long ContentID;
	}
	/// <summary>
	/// Return value from method SaveDocument
	/// </summary>
	public struct returnSaveDocument
	{
		public long DocumentID;
		public long ContentID;
	}
	/// <summary>
	/// Return value from method SaveImage
	/// </summary>
	public struct returnSaveImage
	{
		public long ImageID;
		public long ContentID;
	}
	/// <summary>
	/// Return value from method SaveArticle
	/// </summary>
	public struct returnSaveArticle
	{
		public long ArticleID;
		public long ContentID;
	}
	/// <summary>
	/// Return value from method SaveMessage
	/// </summary>
	public struct returnSaveMessage
	{
		public long MessageID;
		public long ContentID;
	}
	/// <summary>
	/// Return value from method DeleteContent
	/// </summary>
	public struct returnDeleteContent
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method ListSites
	/// </summary>
	public struct returnListSites
	{
		public long SiteID;
		public string SiteName;
		public bool SiteMembersOnly;
		public bool SiteRecycleBin;
	}
	/// <summary>
	/// Return value from method MoveContent
	/// </summary>
	public struct returnMoveContent
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method SaveArticleText
	/// </summary>
	public struct returnSaveArticleText
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method SaveNone
	/// </summary>
	public struct returnSaveNone
	{
		public long ContentID;
	}
	/// <summary>
	/// Return value from method ListChildContent
	/// </summary>
	public struct returnListChildContent
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public long? ParentID;
		public string ContentType;
		public string friendlyName;
	}
	/// <summary>
	/// Return value from method ListRootContent
	/// </summary>
	public struct returnListRootContent
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentType;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public long? ParentID;
		public string friendlyName;
	}
	/// <summary>
	/// Return value from method SearchByTitleType
	/// </summary>
	public struct returnSearchByTitleType
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentType;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public string SiteName;
		public bool SiteRecycleBin;
		public long? ParentID;
	}
	/// <summary>
	/// Return value from method SearchByArticleText
	/// </summary>
	public struct returnSearchByArticleText
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public string SiteName;
		public bool SiteRecycleBin;
		public long? ParentID;
		public string ContentType;
	}
	/// <summary>
	/// Return value from method SearchByLinkTargetURI
	/// </summary>
	public struct returnSearchByLinkTargetURI
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public string SiteName;
		public bool SiteRecycleBin;
		public long? ParentID;
		public string ContentType;
	}
	/// <summary>
	/// Return value from method Download
	/// </summary>
	public struct returnDownload
	{
		public string Title;
		public string MimeType;
		public byte[] bytes;
	}
	/// <summary>
	/// Return value from method DownloadThumbnail
	/// </summary>
	public struct returnDownloadThumbnail
	{
		public string MimeType;
		public byte[] imageBytes;
	}
	/// <summary>
	/// Return value from method Upload
	/// </summary>
	public struct returnUpload
	{
		public long? imageID;
		public long? documentID;
	}
	/// <summary>
	/// Return value from method ListSiteArticleHints
	/// </summary>
	public struct returnListSiteArticleHints
	{
		public long ArticleHintID;
		public string ArticleHintName;
		public long SiteID;
	}
	/// <summary>
	/// Return value from method SearchImageByTitle
	/// </summary>
	public struct returnSearchImageByTitle
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentType;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public long SiteID;
		public string SiteName;
		public bool SiteRecycleBin;
		public long? ParentID;
		public string ContentAbstract;
		public long ImageID;
		public string ImageMimeType;
		public long ImageWidth;
		public long ImageHeight;
		public string ImageAlternative;
	}
	/// <summary>
	/// Return value from method LookupIDFromFriendlyName
	/// </summary>
	public struct returnLookupIDFromFriendlyName
	{
		public long ContentID;
	}
	/// <summary>
	/// Class implementing operations on:
	///     Custom object
	/// </summary>
	public class IEdit
	{
		private string _tempDir = ".";
		private bool _odbcCloseAfterUse;
		private OdbcConnection _dbConnection = null;
		private OdbcTransaction _dbTransaction = null;
		public string TempDir
		{
			get { return _tempDir; }
			set { _tempDir = value; }
		}
		public OdbcConnection DbConnection
		{
			get { return _dbConnection; }
			set { _dbConnection = value; }
		}
		public OdbcTransaction DbTransaction
		{
			get { return _dbTransaction; }
			set { _dbTransaction = value; }
		}
		public IEdit() : this((OdbcConnection)null) { }
		public IEdit(string connectionString) : this(new OdbcConnection(connectionString)) { }
		public IEdit(OdbcConnection dbConnection)
		{
			_dbConnection = dbConnection;
		}
		public IEdit(OdbcConnection dbConnection, OdbcTransaction dbTransaction)
			: this(dbConnection)
		{
			_dbTransaction = dbTransaction;
		}
		protected void DBConnect()
		{
			if (_odbcCloseAfterUse = (_dbConnection.State != ConnectionState.Open))
			{
				_dbConnection.Open();
				if (_dbConnection.Driver.ToLower().StartsWith("myodbc"))
				{
					OdbcCommand cmd = _dbConnection.CreateCommand();
					if (_dbTransaction != null) cmd.Transaction = _dbTransaction;
					cmd.CommandText = "SET sql_mode = 'ANSI'";
					cmd.ExecuteNonQuery();
				}
			}
		}
		protected void DBClose() { if (_odbcCloseAfterUse) _dbConnection.Close(); }
		protected OdbcCommand DBCreateCommand()
		{
			OdbcCommand cmd = _dbConnection.CreateCommand();
			if(_dbTransaction != null) cmd.Transaction = _dbTransaction;
			return cmd;
		}
		/// <summary>
		/// Lists all content in a site.
		/// runs a sequence of connected methods: MayEditSite, ListContentBySite, ComposeFriendlyName.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListSiteContent[]</returns>
		public returnListSiteContent[] ListSiteContent(int? maxRowsToReturn, string ticket, long SiteID)
		{
			returnListSiteContent[] rv = null;
			List<returnListSiteContent> rvl = new List<returnListSiteContent>();
			returnListSiteContent crv = new returnListSiteContent();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayEditSite prvMayEditSite = ICredentialsObj.MayEditSite(ticket, SiteID);
			if (prvMayEditSite.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnListContentBySite[] prvListContentBySite = PDatabaseObj.ListContentBySite(maxRowsToReturn, SiteID);
				for(int idxListContentBySite = 0; idxListContentBySite < prvListContentBySite.Length; idxListContentBySite++)
				{
					if (idxListContentBySite > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnListSiteContent();
						}
					}
					crv.ContentID = prvListContentBySite[idxListContentBySite].ID;
					crv.ContentTitle = prvListContentBySite[idxListContentBySite].Title;
					crv.ContentPublished = prvListContentBySite[idxListContentBySite].Published;
					crv.ContentSortOrder = prvListContentBySite[idxListContentBySite].SortOrder;
					crv.ContentKeywords = prvListContentBySite[idxListContentBySite].Keywords;
					crv.ContentDescription = prvListContentBySite[idxListContentBySite].Description;
					crv.ContentRobots = prvListContentBySite[idxListContentBySite].Robots;
					crv.ContentLanguage = prvListContentBySite[idxListContentBySite].Language;
					crv.ContentCustom = prvListContentBySite[idxListContentBySite].Custom;
					crv.ContentAllowMessages = prvListContentBySite[idxListContentBySite].AllowMessages;
					crv.SiteID = prvListContentBySite[idxListContentBySite].SiteID;
					crv.ParentID = prvListContentBySite[idxListContentBySite].ParentID;
					crv.ContentType = prvListContentBySite[idxListContentBySite].Type;
					crv.ContentAbstract = prvListContentBySite[idxListContentBySite].Abstract;
					crv.ContentSUID = prvListContentBySite[idxListContentBySite].SUID;
					crvUsed = true;
					cms.DB.PPlatform.returnComposeFriendlyName prvComposeFriendlyName = PPlatformObj.ComposeFriendlyName(prvListContentBySite[idxListContentBySite].ID, prvListContentBySite[idxListContentBySite].Title);
					crv.friendlyName = prvComposeFriendlyName.friendlyName;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Get content details for any kind of content
		/// runs a sequence of connected methods: MayEditContent, GetContent, GetSite, ComposeFriendlyName, LatestLog, GetContentArticle, GetContentDocument, GetContentImage, GetContentLink, GetContentMessage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnGetContentDetails</returns>
		public returnGetContentDetails GetContentDetails(string ticket, long ContentID)
		{
			returnGetContentDetails rv = new returnGetContentDetails();
			List<returnGetContentDetails> rvl = new List<returnGetContentDetails>();
			returnGetContentDetails crv = new returnGetContentDetails();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, ContentID);
			if (prvMayEditContent.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnGetContent prvGetContent = PDatabaseObj.GetContent(ContentID);
				crv.ContentID = prvGetContent.ID;
				crv.ContentTitle = prvGetContent.Title;
				crv.ContentPublished = prvGetContent.Published;
				crv.ContentSortOrder = prvGetContent.SortOrder;
				crv.ContentKeywords = prvGetContent.Keywords;
				crv.ContentDescription = prvGetContent.Description;
				crv.ContentRobots = prvGetContent.Robots;
				crv.ContentLanguage = prvGetContent.Language;
				crv.ContentCustom = prvGetContent.Custom;
				crv.ContentAllowMessages = prvGetContent.AllowMessages;
				crv.SiteID = prvGetContent.SiteID;
				crv.ParentID = prvGetContent.ParentID;
				crv.ContentType = prvGetContent.Type;
				crv.ContentAbstract = prvGetContent.Abstract;
				crv.ContentSUID = prvGetContent.SUID;
				crvUsed = true;
				cms.DB.PDatabase.returnGetSite prvGetSite = PDatabaseObj.GetSite(prvGetContent.SiteID);
				crv.SiteName = prvGetSite.Name;
				crvUsed = true;
				cms.DB.PPlatform.returnComposeFriendlyName prvComposeFriendlyName = PPlatformObj.ComposeFriendlyName(prvGetContent.ID, prvGetContent.Title);
				crv.friendlyName = prvComposeFriendlyName.friendlyName;
				crvUsed = true;
				cms.DB.PPlatform.returnLatestLog prvLatestLog = PPlatformObj.LatestLog(ContentID);
				crv.EditedDate = prvLatestLog.EditedDate;
				crv.EditedBy = prvLatestLog.EditedBy;
				crvUsed = true;
				cms.DB.PDatabase.returnGetContentArticle prvGetContentArticle = PDatabaseObj.GetContentArticle(prvGetContent.Type, ContentID);
				crv.hasArticle = prvGetContentArticle.hasArticle;
				crv.ArticleID = prvGetContentArticle.ArticleID;
				crv.ArticleEditor = prvGetContentArticle.ArticleEditor;
				crv.ArticleData = prvGetContentArticle.ArticleData;
				crv.ArticleHint = prvGetContentArticle.ArticleHint;
				crvUsed = true;
				if (prvGetContentArticle.hasArticle != true)
				{
					cms.DB.PDatabase.returnGetContentDocument prvGetContentDocument = PDatabaseObj.GetContentDocument(prvGetContent.Type, prvGetContent.ID);
					crv.hasDocument = prvGetContentDocument.hasDocument;
					crv.DocumentID = prvGetContentDocument.DocumentID;
					crv.DocumentMimeType = prvGetContentDocument.DocumentMimeType;
					crvUsed = true;
					if (prvGetContentDocument.hasDocument != true)
					{
						cms.DB.PDatabase.returnGetContentImage prvGetContentImage = PDatabaseObj.GetContentImage(prvGetContent.Type, prvGetContent.ID);
						crv.hasImage = prvGetContentImage.hasImage;
						crv.ImageID = prvGetContentImage.ImageID;
						crv.ImageMimeType = prvGetContentImage.ImageMimeType;
						crv.ImageWidth = prvGetContentImage.ImageWidth;
						crv.ImageHeight = prvGetContentImage.ImageHeight;
						crv.ImageAlternative = prvGetContentImage.ImageAlternative;
						crvUsed = true;
						if (prvGetContentImage.hasImage != true)
						{
							cms.DB.PDatabase.returnGetContentLink prvGetContentLink = PDatabaseObj.GetContentLink(prvGetContent.Type, prvGetContent.ID);
							crv.hasLink = prvGetContentLink.hasLink;
							crv.LinkID = prvGetContentLink.LinkID;
							crv.LinkTargetURI = prvGetContentLink.LinkTargetURI;
							crv.LinkTargetURL = prvGetContentLink.LinkTargetURL;
							crvUsed = true;
							if (prvGetContentLink.hasLink != true)
							{
								cms.DB.PDatabase.returnGetContentMessage prvGetContentMessage = PDatabaseObj.GetContentMessage(prvGetContent.Type, prvGetContent.ID);
								crv.hasMessage = prvGetContentMessage.hasMessage;
								crv.MessageID = prvGetContentMessage.MessageID;
								crv.MessageSource = prvGetContentMessage.MessageSource;
								crv.MessageData = prvGetContentMessage.MessageData;
								crvUsed = true;
							}
						}
					}
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnGetContentDetails());
			return rv;
		}
		/// <summary>
		/// Creates or update link content.
		/// runs a sequence of connected methods: AbortIfSiteIsChanged, SaveLink.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="LinkID"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <param name="LinkTargetURI"></param>
		/// <param name="LinkTargetURL"></param>
		/// <returns>returnSaveLink</returns>
		public returnSaveLink SaveLink(string ticket, long? LinkID, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID, string LinkTargetURI, string LinkTargetURL)
		{
			returnSaveLink rv = new returnSaveLink();
			List<returnSaveLink> rvl = new List<returnSaveLink>();
			returnSaveLink crv = new returnSaveLink();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			if (ContentTitle == null) throw new Exception("ContentTitle must not be null!");
			cms.DB.ICredentials.returnAbortIfSiteIsChanged prvAbortIfSiteIsChanged = ICredentialsObj.AbortIfSiteIsChanged(ticket, SiteID, ContentID);
			if (prvAbortIfSiteIsChanged.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnSaveLink prvSaveLink = PDatabaseObj.SaveLink(LinkID, ContentID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID, LinkTargetURI, LinkTargetURL, prvAbortIfSiteIsChanged.UserLogin, ContentSUID);
				crv.LinkID = prvSaveLink.LinkID;
				crv.ContentID = prvSaveLink.ContentID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveLink());
			return rv;
		}
		/// <summary>
		/// Creates or updates document content excl the document file
		/// runs a sequence of connected methods: AbortIfSiteIsChanged, SaveDocument.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="DocumentID"></param>
		/// <param name="DocumentMimeType"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <returns>returnSaveDocument</returns>
		public returnSaveDocument SaveDocument(string ticket, long? DocumentID, string DocumentMimeType, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID)
		{
			returnSaveDocument rv = new returnSaveDocument();
			List<returnSaveDocument> rvl = new List<returnSaveDocument>();
			returnSaveDocument crv = new returnSaveDocument();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			if (DocumentMimeType == null) throw new Exception("DocumentMimeType must not be null!");
			if (ContentTitle == null) throw new Exception("ContentTitle must not be null!");
			cms.DB.ICredentials.returnAbortIfSiteIsChanged prvAbortIfSiteIsChanged = ICredentialsObj.AbortIfSiteIsChanged(ticket, SiteID, ContentID);
			if (prvAbortIfSiteIsChanged.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnSaveDocument prvSaveDocument = PDatabaseObj.SaveDocument(DocumentID, DocumentMimeType, ContentID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID, prvAbortIfSiteIsChanged.UserLogin, ContentSUID);
				crv.DocumentID = prvSaveDocument.DocumentID;
				crv.ContentID = prvSaveDocument.ContentID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveDocument());
			return rv;
		}
		/// <summary>
		/// Creates or updates image content excl the image file
		/// runs a sequence of connected methods: AbortIfSiteIsChanged, SaveImage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ImageID"></param>
		/// <param name="ImageMimeType"></param>
		/// <param name="ImageWidth"></param>
		/// <param name="ImageHeight"></param>
		/// <param name="ImageAlternative"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <returns>returnSaveImage</returns>
		public returnSaveImage SaveImage(string ticket, long? ImageID, string ImageMimeType, long ImageWidth, long ImageHeight, string ImageAlternative, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID)
		{
			returnSaveImage rv = new returnSaveImage();
			List<returnSaveImage> rvl = new List<returnSaveImage>();
			returnSaveImage crv = new returnSaveImage();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			if (ImageMimeType == null) throw new Exception("ImageMimeType must not be null!");
			if (ContentTitle == null) throw new Exception("ContentTitle must not be null!");
			cms.DB.ICredentials.returnAbortIfSiteIsChanged prvAbortIfSiteIsChanged = ICredentialsObj.AbortIfSiteIsChanged(ticket, SiteID, ContentID);
			if (prvAbortIfSiteIsChanged.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnSaveImage prvSaveImage = PDatabaseObj.SaveImage(ImageID, ImageMimeType, ImageWidth, ImageHeight, ImageAlternative, ContentID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID, prvAbortIfSiteIsChanged.UserLogin, ContentSUID);
				crv.ImageID = prvSaveImage.ImageID;
				crv.ContentID = prvSaveImage.ContentID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveImage());
			return rv;
		}
		/// <summary>
		/// Creates or updates article content
		/// runs a sequence of connected methods: AbortIfSiteIsChanged, SaveArticle.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ArticleID"></param>
		/// <param name="ArticleEditor"></param>
		/// <param name="ArticleData"></param>
		/// <param name="ArticleHint"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <param name="ContentSUID"></param>
		/// <returns>returnSaveArticle</returns>
		public returnSaveArticle SaveArticle(string ticket, long? ArticleID, string ArticleEditor, string ArticleData, string ArticleHint, long? ContentID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID, string ContentSUID)
		{
			returnSaveArticle rv = new returnSaveArticle();
			List<returnSaveArticle> rvl = new List<returnSaveArticle>();
			returnSaveArticle crv = new returnSaveArticle();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			if (ContentTitle == null) throw new Exception("ContentTitle must not be null!");
			cms.DB.ICredentials.returnAbortIfSiteIsChanged prvAbortIfSiteIsChanged = ICredentialsObj.AbortIfSiteIsChanged(ticket, SiteID, ContentID);
			if (prvAbortIfSiteIsChanged.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnSaveArticle prvSaveArticle = PDatabaseObj.SaveArticle(ArticleID, ArticleEditor, ArticleData, ContentID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ParentID, prvAbortIfSiteIsChanged.UserLogin, ArticleHint, ContentAbstract, ContentSUID);
				crv.ArticleID = prvSaveArticle.ArticleID;
				crv.ContentID = prvSaveArticle.ContentID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveArticle());
			return rv;
		}
		/// <summary>
		/// Creates or update message content
		/// runs a sequence of connected methods: AbortIfSiteIsChanged, SaveMessage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="MessageID"></param>
		/// <param name="MessageSource"></param>
		/// <param name="MessageData"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <returns>returnSaveMessage</returns>
		public returnSaveMessage SaveMessage(string ticket, long? MessageID, string MessageSource, string MessageData, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID)
		{
			returnSaveMessage rv = new returnSaveMessage();
			List<returnSaveMessage> rvl = new List<returnSaveMessage>();
			returnSaveMessage crv = new returnSaveMessage();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			if (ContentTitle == null) throw new Exception("ContentTitle must not be null!");
			cms.DB.ICredentials.returnAbortIfSiteIsChanged prvAbortIfSiteIsChanged = ICredentialsObj.AbortIfSiteIsChanged(ticket, SiteID, ContentID);
			if (prvAbortIfSiteIsChanged.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnSaveMessage prvSaveMessage = PDatabaseObj.SaveMessage(MessageID, MessageSource, ContentID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID, prvAbortIfSiteIsChanged.UserLogin, MessageData, ContentSUID);
				crv.MessageID = prvSaveMessage.MessageID;
				crv.ContentID = prvSaveMessage.ContentID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveMessage());
			return rv;
		}
		/// <summary>
		/// Delete content, e.g. an article, a document.
		/// runs a sequence of connected methods: MayEditContent, DeleteIfRecycleBinContent, GetRecycleBin, Constants, MoveContent.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnDeleteContent</returns>
		public returnDeleteContent DeleteContent(string ticket, long ContentID)
		{
			returnDeleteContent rv = new returnDeleteContent();
			List<returnDeleteContent> rvl = new List<returnDeleteContent>();
			returnDeleteContent crv = new returnDeleteContent();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, ContentID);
			if (prvMayEditContent.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnDeleteIfRecycleBinContent prvDeleteIfRecycleBinContent = PDatabaseObj.DeleteIfRecycleBinContent(ContentID);
				if (prvDeleteIfRecycleBinContent.isRecycleBin != true)
				{
					cms.DB.PDatabase.returnGetRecycleBin prvGetRecycleBin = PDatabaseObj.GetRecycleBin();
					cms.DB.IBasics.returnConstants prvConstants = IBasicsObj.Constants();
					cms.DB.PDatabase.returnMoveContent prvMoveContent = PDatabaseObj.MoveContent(ContentID, prvConstants.NullInt, prvGetRecycleBin.SiteID, prvConstants.NullString, prvMayEditContent.UserLogin);
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnDeleteContent());
			return rv;
		}
		/// <summary>
		/// Lists all sites you're allowed to edit.
		/// runs a sequence of connected methods: CurrentUser, ListSite, IsEditMemberOf, LogicalOr, GetSite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <returns>returnListSites[]</returns>
		public returnListSites[] ListSites(int? maxRowsToReturn, string ticket)
		{
			returnListSites[] rv = null;
			List<returnListSites> rvl = new List<returnListSites>();
			returnListSites crv = new returnListSites();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnCurrentUser prvCurrentUser = PPlatformObj.CurrentUser(ticket);
			if (prvCurrentUser.IsAuthenticated == true)
			{
				cms.DB.PDatabase.returnListSite[] prvListSite = PDatabaseObj.ListSite(maxRowsToReturn);
				for(int idxListSite = 0; idxListSite < prvListSite.Length; idxListSite++)
				{
					if (idxListSite > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnListSites();
						}
					}
					cms.DB.PDatabase.returnIsEditMemberOf prvIsEditMemberOf = PDatabaseObj.IsEditMemberOf(prvListSite[idxListSite].ID, prvCurrentUser.UserID);
					cms.DB.IBasics.returnLogicalOr prvLogicalOr = IBasicsObj.LogicalOr(prvCurrentUser.UserAdministrator, prvIsEditMemberOf.MemberEdit);
					if (prvLogicalOr.b == true)
					{
						cms.DB.PDatabase.returnGetSite prvGetSite = PDatabaseObj.GetSite(prvListSite[idxListSite].ID);
						crv.SiteID = prvGetSite.ID;
						crv.SiteName = prvGetSite.Name;
						crv.SiteMembersOnly = prvGetSite.MembersOnly;
						crv.SiteRecycleBin = prvGetSite.RecycleBin;
						crvUsed = true;
					}
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Move content in the content structure.
		/// runs a sequence of connected methods: MayEditContent, MayEditSite, AbortIfContentNotInSite, MoveContent.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <param name="newParentID"></param>
		/// <param name="newSiteID"></param>
		/// <param name="newSortOrder"></param>
		/// <returns>returnMoveContent</returns>
		public returnMoveContent MoveContent(string ticket, long ContentID, long? newParentID, long newSiteID, string newSortOrder)
		{
			returnMoveContent rv = new returnMoveContent();
			List<returnMoveContent> rvl = new List<returnMoveContent>();
			returnMoveContent crv = new returnMoveContent();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, ContentID);
			if (prvMayEditContent.UserMayEditSite == true)
			{
				cms.DB.ICredentials.returnMayEditSite prvMayEditSite = ICredentialsObj.MayEditSite(ticket, newSiteID);
				if (prvMayEditSite.UserMayEditSite == true)
				{
					cms.DB.ICredentials.returnAbortIfContentNotInSite prvAbortIfContentNotInSite = ICredentialsObj.AbortIfContentNotInSite(newParentID, newSiteID);
					cms.DB.PDatabase.returnMoveContent prvMoveContent = PDatabaseObj.MoveContent(ContentID, newParentID, newSiteID, newSortOrder, prvMayEditContent.UserLogin);
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnMoveContent());
			return rv;
		}
		/// <summary>
		/// Updates the article text body.
		/// runs a sequence of connected methods: MayEditContent, ContentTypes, GetContentArticle, GetContent, SaveArticle.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <param name="ArticleData"></param>
		/// <param name="ContentSUID"></param>
		/// <returns>returnSaveArticleText</returns>
		public returnSaveArticleText SaveArticleText(string ticket, long ContentID, string ArticleData, string ContentSUID)
		{
			returnSaveArticleText rv = new returnSaveArticleText();
			List<returnSaveArticleText> rvl = new List<returnSaveArticleText>();
			returnSaveArticleText crv = new returnSaveArticleText();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, ContentID);
			if (prvMayEditContent.UserMayEditSite == true)
			{
				cms.DB.PPlatform.returnContentTypes prvContentTypes = PPlatformObj.ContentTypes();
				cms.DB.PDatabase.returnGetContentArticle prvGetContentArticle = PDatabaseObj.GetContentArticle(prvContentTypes.Article, ContentID);
				cms.DB.PDatabase.returnGetContent prvGetContent = PDatabaseObj.GetContent(ContentID);
				cms.DB.PDatabase.returnSaveArticle prvSaveArticle = PDatabaseObj.SaveArticle(prvGetContentArticle.ArticleID, prvGetContentArticle.ArticleEditor, ArticleData, prvGetContent.ID, prvGetContent.Title, prvGetContent.SortOrder, prvGetContent.SiteID, prvGetContent.Published, prvGetContent.Keywords, prvGetContent.Description, prvGetContent.Robots, prvGetContent.Language, prvGetContent.Custom, prvGetContent.AllowMessages, prvGetContent.ParentID, prvMayEditContent.UserLogin, prvGetContentArticle.ArticleHint, prvGetContent.Abstract, ContentSUID);
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveArticleText());
			return rv;
		}
		/// <summary>
		/// Creates or updates unspecified content, i.e. a folder.
		/// runs a sequence of connected methods: AbortIfSiteIsChanged, ContentTypes, SaveContent.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <returns>returnSaveNone</returns>
		public returnSaveNone SaveNone(string ticket, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID)
		{
			returnSaveNone rv = new returnSaveNone();
			List<returnSaveNone> rvl = new List<returnSaveNone>();
			returnSaveNone crv = new returnSaveNone();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			if (ContentTitle == null) throw new Exception("ContentTitle must not be null!");
			cms.DB.ICredentials.returnAbortIfSiteIsChanged prvAbortIfSiteIsChanged = ICredentialsObj.AbortIfSiteIsChanged(ticket, SiteID, ContentID);
			if (prvAbortIfSiteIsChanged.UserMayEditSite == true)
			{
				cms.DB.PPlatform.returnContentTypes prvContentTypes = PPlatformObj.ContentTypes();
				cms.DB.PDatabase.returnSaveContent prvSaveContent = PDatabaseObj.SaveContent(prvAbortIfSiteIsChanged.UserLogin, ContentID, ContentSUID, ContentTitle, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ParentID, prvContentTypes.None, ContentSortOrder, ContentAbstract);
				crv.ContentID = prvSaveContent.ContentID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnSaveNone());
			return rv;
		}
		/// <summary>
		/// Lists all sub-content of specified content.
		/// runs a sequence of connected methods: MayEditContent, ListContentByParent, ComposeFriendlyName.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnListChildContent[]</returns>
		public returnListChildContent[] ListChildContent(int? maxRowsToReturn, string ticket, long? ContentID)
		{
			returnListChildContent[] rv = null;
			List<returnListChildContent> rvl = new List<returnListChildContent>();
			returnListChildContent crv = new returnListChildContent();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			if (ContentID != null)
			{
				cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, ContentID.Value);
				if (prvMayEditContent.UserMayEditSite == true)
				{
					cms.DB.PDatabase.returnListContentByParent[] prvListContentByParent = PDatabaseObj.ListContentByParent(maxRowsToReturn, ContentID);
					for(int idxListContentByParent = 0; idxListContentByParent < prvListContentByParent.Length; idxListContentByParent++)
					{
						if (idxListContentByParent > 0)
						{
							if(crvUsed)
							{
								rvl.Add(crv);
								crvUsed = false;
								crv = new returnListChildContent();
							}
						}
						crv.ContentID = prvListContentByParent[idxListContentByParent].ID;
						crv.ContentTitle = prvListContentByParent[idxListContentByParent].Title;
						crv.ContentPublished = prvListContentByParent[idxListContentByParent].Published;
						crv.ContentSortOrder = prvListContentByParent[idxListContentByParent].SortOrder;
						crv.ContentKeywords = prvListContentByParent[idxListContentByParent].Keywords;
						crv.ContentDescription = prvListContentByParent[idxListContentByParent].Description;
						crv.ContentRobots = prvListContentByParent[idxListContentByParent].Robots;
						crv.ContentLanguage = prvListContentByParent[idxListContentByParent].Language;
						crv.ContentCustom = prvListContentByParent[idxListContentByParent].Custom;
						crv.ContentAllowMessages = prvListContentByParent[idxListContentByParent].AllowMessages;
						crv.SiteID = prvListContentByParent[idxListContentByParent].SiteID;
						crv.ParentID = prvListContentByParent[idxListContentByParent].ParentID;
						crv.ContentType = prvListContentByParent[idxListContentByParent].Type;
						crv.ContentAbstract = prvListContentByParent[idxListContentByParent].Abstract;
						crv.ContentSUID = prvListContentByParent[idxListContentByParent].SUID;
						crvUsed = true;
						cms.DB.PPlatform.returnComposeFriendlyName prvComposeFriendlyName = PPlatformObj.ComposeFriendlyName(prvListContentByParent[idxListContentByParent].ID, prvListContentByParent[idxListContentByParent].Title);
						crv.friendlyName = prvComposeFriendlyName.friendlyName;
						crvUsed = true;
					}
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Lists all root-level content in a site
		/// runs a sequence of connected methods: MayEditSite, ListContentRoots, ComposeFriendlyName.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <returns>returnListRootContent[]</returns>
		public returnListRootContent[] ListRootContent(int? maxRowsToReturn, string ticket, long siteID)
		{
			returnListRootContent[] rv = null;
			List<returnListRootContent> rvl = new List<returnListRootContent>();
			returnListRootContent crv = new returnListRootContent();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayEditSite prvMayEditSite = ICredentialsObj.MayEditSite(ticket, siteID);
			if (prvMayEditSite.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnListContentRoots[] prvListContentRoots = PDatabaseObj.ListContentRoots(maxRowsToReturn, siteID);
				for(int idxListContentRoots = 0; idxListContentRoots < prvListContentRoots.Length; idxListContentRoots++)
				{
					if (idxListContentRoots > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnListRootContent();
						}
					}
					crv.ContentID = prvListContentRoots[idxListContentRoots].ID;
					crv.ContentType = prvListContentRoots[idxListContentRoots].Type;
					crv.ContentTitle = prvListContentRoots[idxListContentRoots].Title;
					crv.ContentPublished = prvListContentRoots[idxListContentRoots].Published;
					crv.ContentSortOrder = prvListContentRoots[idxListContentRoots].SortOrder;
					crv.ContentKeywords = prvListContentRoots[idxListContentRoots].Keywords;
					crv.ContentDescription = prvListContentRoots[idxListContentRoots].Description;
					crv.ContentRobots = prvListContentRoots[idxListContentRoots].Robots;
					crv.ContentLanguage = prvListContentRoots[idxListContentRoots].Language;
					crv.ContentCustom = prvListContentRoots[idxListContentRoots].Custom;
					crv.ContentAllowMessages = prvListContentRoots[idxListContentRoots].AllowMessages;
					crv.SiteID = prvListContentRoots[idxListContentRoots].SiteID;
					crv.ParentID = prvListContentRoots[idxListContentRoots].ParentID;
					crv.ContentAbstract = prvListContentRoots[idxListContentRoots].Abstract;
					crv.ContentSUID = prvListContentRoots[idxListContentRoots].SUID;
					crvUsed = true;
					cms.DB.PPlatform.returnComposeFriendlyName prvComposeFriendlyName = PPlatformObj.ComposeFriendlyName(prvListContentRoots[idxListContentRoots].ID, prvListContentRoots[idxListContentRoots].Title);
					crv.friendlyName = prvComposeFriendlyName.friendlyName;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Lists all content with a title matching the criteria.
		/// runs a sequence of connected methods: SearchSites, ListContentBySiteAndTitle, DefaultString, DefaultBool.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <param name="titleLike"></param>
		/// <param name="typeLike"></param>
		/// <returns>returnSearchByTitleType[]</returns>
		public returnSearchByTitleType[] SearchByTitleType(int? maxRowsToReturn, string ticket, long? siteID, string titleLike, string typeLike)
		{
			returnSearchByTitleType[] rv = null;
			List<returnSearchByTitleType> rvl = new List<returnSearchByTitleType>();
			returnSearchByTitleType crv = new returnSearchByTitleType();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			if (titleLike == null) throw new Exception("titleLike must not be null!");
			if (typeLike == null) throw new Exception("typeLike must not be null!");
			cms.DB.ICredentials.returnSearchSites[] prvSearchSites = ICredentialsObj.SearchSites(maxRowsToReturn, ticket, siteID);
			for(int idxSearchSites = 0; idxSearchSites < prvSearchSites.Length; idxSearchSites++)
			{
				if (idxSearchSites > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnSearchByTitleType();
					}
				}
				if (prvSearchSites[idxSearchSites].ShouldSearchSite == true)
				{
					cms.DB.PDatabase.returnListContentBySiteAndTitle[] prvListContentBySiteAndTitle = PDatabaseObj.ListContentBySiteAndTitle(maxRowsToReturn, prvSearchSites[idxSearchSites].SiteID, titleLike, typeLike);
					for(int idxListContentBySiteAndTitle = 0; idxListContentBySiteAndTitle < prvListContentBySiteAndTitle.Length; idxListContentBySiteAndTitle++)
					{
						if (idxListContentBySiteAndTitle > 0)
						{
							if(crvUsed)
							{
								rvl.Add(crv);
								crvUsed = false;
								crv = new returnSearchByTitleType();
							}
						}
						crv.ContentID = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].ID;
						crv.ContentType = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Type;
						crv.ContentTitle = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Title;
						crv.ContentPublished = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Published;
						crv.ContentSortOrder = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].SortOrder;
						crv.ContentKeywords = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Keywords;
						crv.ContentDescription = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Description;
						crv.ContentRobots = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Robots;
						crv.ContentLanguage = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Language;
						crv.ContentCustom = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Custom;
						crv.ContentAllowMessages = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].AllowMessages;
						crv.SiteID = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].SiteID;
						crv.ParentID = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].ParentID;
						crv.ContentAbstract = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Abstract;
						crv.ContentSUID = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].SUID;
						crvUsed = true;
						cms.DB.IBasics.returnDefaultString prvDefaultString = IBasicsObj.DefaultString(prvSearchSites[idxSearchSites].SiteName, prvSearchSites[idxSearchSites].EmptyString);
						crv.SiteName = prvDefaultString.s;
						crvUsed = true;
						cms.DB.IBasics.returnDefaultBool prvDefaultBool = IBasicsObj.DefaultBool(prvSearchSites[idxSearchSites].SiteRecycleBin, prvSearchSites[idxSearchSites].SiteRecycleBin);
						crv.SiteRecycleBin = prvDefaultBool.b;
						crvUsed = true;
					}
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Lists all articles matching the specified criteria.
		/// runs a sequence of connected methods: CurrentUser, ListArticleByData, MayEditContent, GetContent, GetSite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="dataLike"></param>
		/// <returns>returnSearchByArticleText[]</returns>
		public returnSearchByArticleText[] SearchByArticleText(int? maxRowsToReturn, string ticket, string dataLike)
		{
			returnSearchByArticleText[] rv = null;
			List<returnSearchByArticleText> rvl = new List<returnSearchByArticleText>();
			returnSearchByArticleText crv = new returnSearchByArticleText();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			if (dataLike == null) throw new Exception("dataLike must not be null!");
			cms.DB.PPlatform.returnCurrentUser prvCurrentUser = PPlatformObj.CurrentUser(ticket);
			if (prvCurrentUser.IsAuthenticated == true)
			{
				cms.DB.PDatabase.returnListArticleByData[] prvListArticleByData = PDatabaseObj.ListArticleByData(maxRowsToReturn, dataLike);
				for(int idxListArticleByData = 0; idxListArticleByData < prvListArticleByData.Length; idxListArticleByData++)
				{
					if (idxListArticleByData > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnSearchByArticleText();
						}
					}
					cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, prvListArticleByData[idxListArticleByData].ContentID);
					if (prvMayEditContent.UserMayEditSite == true)
					{
						cms.DB.PDatabase.returnGetContent prvGetContent = PDatabaseObj.GetContent(prvListArticleByData[idxListArticleByData].ContentID);
						crv.ContentID = prvGetContent.ID;
						crv.ContentTitle = prvGetContent.Title;
						crv.ContentPublished = prvGetContent.Published;
						crv.ContentSortOrder = prvGetContent.SortOrder;
						crv.ContentKeywords = prvGetContent.Keywords;
						crv.ContentDescription = prvGetContent.Description;
						crv.ContentRobots = prvGetContent.Robots;
						crv.ContentLanguage = prvGetContent.Language;
						crv.ContentCustom = prvGetContent.Custom;
						crv.ContentAllowMessages = prvGetContent.AllowMessages;
						crv.SiteID = prvGetContent.SiteID;
						crv.ParentID = prvGetContent.ParentID;
						crv.ContentType = prvGetContent.Type;
						crv.ContentAbstract = prvGetContent.Abstract;
						crv.ContentSUID = prvGetContent.SUID;
						crvUsed = true;
						cms.DB.PDatabase.returnGetSite prvGetSite = PDatabaseObj.GetSite(prvGetContent.SiteID);
						crv.SiteName = prvGetSite.Name;
						crv.SiteRecycleBin = prvGetSite.RecycleBin;
						crvUsed = true;
					}
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Lists all links referring to the specified target.
		/// runs a sequence of connected methods: CurrentUser, ListLinkByTargetURI, MayEditContent, GetContent, GetSite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="targetURI"></param>
		/// <returns>returnSearchByLinkTargetURI[]</returns>
		public returnSearchByLinkTargetURI[] SearchByLinkTargetURI(int? maxRowsToReturn, string ticket, string targetURI)
		{
			returnSearchByLinkTargetURI[] rv = null;
			List<returnSearchByLinkTargetURI> rvl = new List<returnSearchByLinkTargetURI>();
			returnSearchByLinkTargetURI crv = new returnSearchByLinkTargetURI();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			if (targetURI == null) throw new Exception("targetURI must not be null!");
			cms.DB.PPlatform.returnCurrentUser prvCurrentUser = PPlatformObj.CurrentUser(ticket);
			if (prvCurrentUser.IsAuthenticated == true)
			{
				cms.DB.PDatabase.returnListLinkByTargetURI[] prvListLinkByTargetURI = PDatabaseObj.ListLinkByTargetURI(maxRowsToReturn, targetURI);
				for(int idxListLinkByTargetURI = 0; idxListLinkByTargetURI < prvListLinkByTargetURI.Length; idxListLinkByTargetURI++)
				{
					if (idxListLinkByTargetURI > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnSearchByLinkTargetURI();
						}
					}
					cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, prvListLinkByTargetURI[idxListLinkByTargetURI].ContentID);
					if (prvMayEditContent.UserMayEditSite == true)
					{
						cms.DB.PDatabase.returnGetContent prvGetContent = PDatabaseObj.GetContent(prvListLinkByTargetURI[idxListLinkByTargetURI].ContentID);
						crv.ContentID = prvGetContent.ID;
						crv.ContentTitle = prvGetContent.Title;
						crv.ContentPublished = prvGetContent.Published;
						crv.ContentSortOrder = prvGetContent.SortOrder;
						crv.ContentKeywords = prvGetContent.Keywords;
						crv.ContentDescription = prvGetContent.Description;
						crv.ContentRobots = prvGetContent.Robots;
						crv.ContentLanguage = prvGetContent.Language;
						crv.ContentCustom = prvGetContent.Custom;
						crv.ContentAllowMessages = prvGetContent.AllowMessages;
						crv.SiteID = prvGetContent.SiteID;
						crv.ParentID = prvGetContent.ParentID;
						crv.ContentType = prvGetContent.Type;
						crv.ContentAbstract = prvGetContent.Abstract;
						crv.ContentSUID = prvGetContent.SUID;
						crvUsed = true;
						cms.DB.PDatabase.returnGetSite prvGetSite = PDatabaseObj.GetSite(prvGetContent.SiteID);
						crv.SiteName = prvGetSite.Name;
						crv.SiteRecycleBin = prvGetSite.RecycleBin;
						crvUsed = true;
					}
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Download image or document file content
		/// runs a sequence of connected methods: MayEditContent, Download.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="contentID"></param>
		/// <returns>returnDownload</returns>
		public returnDownload Download(string ticket, long? contentID)
		{
			returnDownload rv = new returnDownload();
			List<returnDownload> rvl = new List<returnDownload>();
			returnDownload crv = new returnDownload();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.IFiles.IFiles IFilesObj = new cms.DB.IFiles.IFiles(DbConnection, DbTransaction);
			if (contentID != null)
			{
				cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, contentID.Value);
				if (prvMayEditContent.UserMayEditSite == true)
				{
					cms.DB.IFiles.returnDownload prvDownload = IFilesObj.Download(ticket, contentID);
					crv.Title = prvDownload.Title;
					crv.MimeType = prvDownload.MimeType;
					crv.bytes = prvDownload.bytes;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnDownload());
			return rv;
		}
		/// <summary>
		/// Download image thumbnail file content
		/// runs a sequence of connected methods: MayEditContent, DownloadThumbnail.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="contentID"></param>
		/// <returns>returnDownloadThumbnail</returns>
		public returnDownloadThumbnail DownloadThumbnail(string ticket, long? contentID)
		{
			returnDownloadThumbnail rv = new returnDownloadThumbnail();
			List<returnDownloadThumbnail> rvl = new List<returnDownloadThumbnail>();
			returnDownloadThumbnail crv = new returnDownloadThumbnail();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.IFiles.IFiles IFilesObj = new cms.DB.IFiles.IFiles(DbConnection, DbTransaction);
			if (contentID != null)
			{
				cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, contentID.Value);
				if (prvMayEditContent.UserMayEditSite == true)
				{
					cms.DB.IFiles.returnDownloadThumbnail prvDownloadThumbnail = IFilesObj.DownloadThumbnail(ticket, contentID);
					crv.MimeType = prvDownloadThumbnail.MimeType;
					crv.imageBytes = prvDownloadThumbnail.imageBytes;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnDownloadThumbnail());
			return rv;
		}
		/// <summary>
		/// Uploads document or image file. For images, a thumbnail file is automatically generated.
		/// runs a sequence of connected methods: MayEditSite, Upload.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <param name="contentID"></param>
		/// <param name="parentID"></param>
		/// <param name="type"></param>
		/// <param name="fileName"></param>
		/// <param name="mimeType"></param>
		/// <param name="bytes"></param>
		/// <returns>returnUpload</returns>
		public returnUpload Upload(string ticket, long siteID, long? contentID, long? parentID, string type, string fileName, string mimeType, byte[] bytes)
		{
			returnUpload rv = new returnUpload();
			List<returnUpload> rvl = new List<returnUpload>();
			returnUpload crv = new returnUpload();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.IFiles.IFiles IFilesObj = new cms.DB.IFiles.IFiles(DbConnection, DbTransaction);
			if (fileName == null) throw new Exception("fileName must not be null!");
			if (mimeType == null) throw new Exception("mimeType must not be null!");
			if (bytes == null) throw new Exception("bytes must not be null!");
			cms.DB.ICredentials.returnMayEditSite prvMayEditSite = ICredentialsObj.MayEditSite(ticket, siteID);
			if (prvMayEditSite.UserMayEditSite == true)
			{
				cms.DB.IFiles.returnUpload prvUpload = IFilesObj.Upload(ticket, siteID, contentID, parentID, type, fileName, mimeType, bytes);
				crv.imageID = prvUpload.imageID;
				crv.documentID = prvUpload.documentID;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnUpload());
			return rv;
		}
		/// <summary>
		/// Lists the site hint list.
		/// runs a sequence of connected methods: MayEditSite, ListArticleHintBySite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <returns>returnListSiteArticleHints[]</returns>
		public returnListSiteArticleHints[] ListSiteArticleHints(int? maxRowsToReturn, string ticket, long siteID)
		{
			returnListSiteArticleHints[] rv = null;
			List<returnListSiteArticleHints> rvl = new List<returnListSiteArticleHints>();
			returnListSiteArticleHints crv = new returnListSiteArticleHints();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayEditSite prvMayEditSite = ICredentialsObj.MayEditSite(ticket, siteID);
			if (prvMayEditSite.UserMayEditSite == true)
			{
				cms.DB.PDatabase.returnListArticleHintBySite[] prvListArticleHintBySite = PDatabaseObj.ListArticleHintBySite(maxRowsToReturn, siteID);
				for(int idxListArticleHintBySite = 0; idxListArticleHintBySite < prvListArticleHintBySite.Length; idxListArticleHintBySite++)
				{
					if (idxListArticleHintBySite > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnListSiteArticleHints();
						}
					}
					crv.ArticleHintID = prvListArticleHintBySite[idxListArticleHintBySite].ID;
					crv.ArticleHintName = prvListArticleHintBySite[idxListArticleHintBySite].Name;
					crv.SiteID = prvListArticleHintBySite[idxListArticleHintBySite].SiteID;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: ContentTypes, SearchSites, ListContentBySiteAndTitle, DefaultString, DefaultBool, GetImageByContent.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <param name="titleLike"></param>
		/// <returns>returnSearchImageByTitle[]</returns>
		public returnSearchImageByTitle[] SearchImageByTitle(int? maxRowsToReturn, string ticket, long? siteID, string titleLike)
		{
			returnSearchImageByTitle[] rv = null;
			List<returnSearchImageByTitle> rvl = new List<returnSearchImageByTitle>();
			returnSearchImageByTitle crv = new returnSearchImageByTitle();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			if (titleLike == null) throw new Exception("titleLike must not be null!");
			cms.DB.PPlatform.returnContentTypes prvContentTypes = PPlatformObj.ContentTypes();
			cms.DB.ICredentials.returnSearchSites[] prvSearchSites = ICredentialsObj.SearchSites(maxRowsToReturn, ticket, siteID);
			for(int idxSearchSites = 0; idxSearchSites < prvSearchSites.Length; idxSearchSites++)
			{
				if (idxSearchSites > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnSearchImageByTitle();
					}
				}
				if (prvSearchSites[idxSearchSites].ShouldSearchSite == true)
				{
					cms.DB.PDatabase.returnListContentBySiteAndTitle[] prvListContentBySiteAndTitle = PDatabaseObj.ListContentBySiteAndTitle(maxRowsToReturn, prvSearchSites[idxSearchSites].SiteID, titleLike, prvContentTypes.Image);
					for(int idxListContentBySiteAndTitle = 0; idxListContentBySiteAndTitle < prvListContentBySiteAndTitle.Length; idxListContentBySiteAndTitle++)
					{
						if (idxListContentBySiteAndTitle > 0)
						{
							if(crvUsed)
							{
								rvl.Add(crv);
								crvUsed = false;
								crv = new returnSearchImageByTitle();
							}
						}
						crv.ContentID = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].ID;
						crv.ContentType = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Type;
						crv.ContentTitle = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Title;
						crv.ContentPublished = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Published;
						crv.ContentSortOrder = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].SortOrder;
						crv.ContentKeywords = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Keywords;
						crv.ContentDescription = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Description;
						crv.ContentRobots = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Robots;
						crv.ContentLanguage = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Language;
						crv.ContentCustom = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Custom;
						crv.ContentAllowMessages = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].AllowMessages;
						crv.SiteID = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].SiteID;
						crv.ParentID = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].ParentID;
						crv.ContentAbstract = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].Abstract;
						crv.ContentSUID = prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].SUID;
						crvUsed = true;
						cms.DB.IBasics.returnDefaultString prvDefaultString = IBasicsObj.DefaultString(prvSearchSites[idxSearchSites].SiteName, prvSearchSites[idxSearchSites].EmptyString);
						crv.SiteName = prvDefaultString.s;
						crvUsed = true;
						cms.DB.IBasics.returnDefaultBool prvDefaultBool = IBasicsObj.DefaultBool(prvSearchSites[idxSearchSites].SiteRecycleBin, prvSearchSites[idxSearchSites].SiteRecycleBin);
						crv.SiteRecycleBin = prvDefaultBool.b;
						crvUsed = true;
						cms.DB.PDatabase.returnGetImageByContent prvGetImageByContent = PDatabaseObj.GetImageByContent(prvListContentBySiteAndTitle[idxListContentBySiteAndTitle].ID);
						crv.ImageID = prvGetImageByContent.ImageID;
						crv.ImageMimeType = prvGetImageByContent.ImageMimeType;
						crv.ImageWidth = prvGetImageByContent.ImageWidth;
						crv.ImageHeight = prvGetImageByContent.ImageHeight;
						crv.ImageAlternative = prvGetImageByContent.ImageAlternative;
						crvUsed = true;
					}
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: FindIDByFriendlyName, MayEditContent, Constants, DefaultInt.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="friendlyName"></param>
		/// <returns>returnLookupIDFromFriendlyName</returns>
		public returnLookupIDFromFriendlyName LookupIDFromFriendlyName(string ticket, string friendlyName)
		{
			returnLookupIDFromFriendlyName rv = new returnLookupIDFromFriendlyName();
			List<returnLookupIDFromFriendlyName> rvl = new List<returnLookupIDFromFriendlyName>();
			returnLookupIDFromFriendlyName crv = new returnLookupIDFromFriendlyName();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnFindIDByFriendlyName prvFindIDByFriendlyName = PPlatformObj.FindIDByFriendlyName(friendlyName);
			cms.DB.ICredentials.returnMayEditContent prvMayEditContent = ICredentialsObj.MayEditContent(ticket, prvFindIDByFriendlyName.ContentID);
			if (prvMayEditContent.UserMayEditSite == true)
			{
				cms.DB.IBasics.returnConstants prvConstants = IBasicsObj.Constants();
				cms.DB.IBasics.returnDefaultInt prvDefaultInt = IBasicsObj.DefaultInt(prvFindIDByFriendlyName.ContentID, prvConstants.ZeroInt);
				crv.ContentID = prvDefaultInt.i;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnLookupIDFromFriendlyName());
			return rv;
		}
	}
}
