﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;
using System.IO;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.DB.IPublished
{
	/// <summary>
	/// Return value from method ListSiteContent
	/// </summary>
	public struct returnListSiteContent
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentType;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public long? ParentID;
		public string friendlyName;
	}
	/// <summary>
	/// Return value from method ListRootContent
	/// </summary>
	public struct returnListRootContent
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentType;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public long? ParentID;
		public string friendlyName;
		public bool hasLink;
		public long LinkID;
		public string LinkTargetURI;
		public string LinkTargetURL;
	}
	/// <summary>
	/// Return value from method ListChildContent
	/// </summary>
	public struct returnListChildContent
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentType;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public long? ParentID;
		public string friendlyName;
		public bool hasLink;
		public long LinkID;
		public string LinkTargetURI;
		public string LinkTargetURL;
	}
	/// <summary>
	/// Return value from method GetContentDetails
	/// </summary>
	public struct returnGetContentDetails
	{
		public long ContentID;
		public string ContentSUID;
		public string ContentType;
		public string ContentTitle;
		public bool ContentPublished;
		public string ContentSortOrder;
		public string ContentKeywords;
		public string ContentDescription;
		public string ContentRobots;
		public string ContentLanguage;
		public string ContentCustom;
		public bool ContentAllowMessages;
		public string ContentAbstract;
		public long SiteID;
		public string SiteName;
		public long? ParentID;
		public string friendlyName;
		public bool hasArticle;
		public long ArticleID;
		public string ArticleEditor;
		public string ArticleData;
		public string ArticleHint;
		public bool hasDocument;
		public long DocumentID;
		public string DocumentMimeType;
		public bool hasImage;
		public long ImageID;
		public string ImageMimeType;
		public long ImageWidth;
		public long ImageHeight;
		public string ImageAlternative;
		public bool hasLink;
		public long LinkID;
		public string LinkTargetURI;
		public string LinkTargetURL;
		public bool hasMessage;
		public long MessageID;
		public string MessageSource;
		public string MessageData;
	}
	/// <summary>
	/// Return value from method GetSiteID
	/// </summary>
	public struct returnGetSiteID
	{
		public long SiteID;
	}
	/// <summary>
	/// Return value from method AddMessage
	/// </summary>
	public struct returnAddMessage
	{
		public long MessageID;
	}
	/// <summary>
	/// Return value from method LookupIDFromSUID
	/// </summary>
	public struct returnLookupIDFromSUID
	{
		public long ContentID;
	}
	/// <summary>
	/// Return value from method Download
	/// </summary>
	public struct returnDownload
	{
		public string Title;
		public string MimeType;
		public byte[] bytes;
	}
	/// <summary>
	/// Return value from method DownloadThumbnail
	/// </summary>
	public struct returnDownloadThumbnail
	{
		public string MimeType;
		public byte[] imageBytes;
	}
	/// <summary>
	/// Return value from method ListSites
	/// </summary>
	public struct returnListSites
	{
		public long SiteID;
		public string SiteName;
		public bool SiteIsPublic;
		public bool SiteRecycleBin;
	}
	/// <summary>
	/// Return value from method LookupIDFromFriendlyName
	/// </summary>
	public struct returnLookupIDFromFriendlyName
	{
		public long ContentID;
	}
	/// <summary>
	/// Class implementing operations on:
	///     Custom object
	/// </summary>
	public class IPublished
	{
		private string _tempDir = ".";
		private bool _odbcCloseAfterUse;
		private OdbcConnection _dbConnection = null;
		private OdbcTransaction _dbTransaction = null;
		public string TempDir
		{
			get { return _tempDir; }
			set { _tempDir = value; }
		}
		public OdbcConnection DbConnection
		{
			get { return _dbConnection; }
			set { _dbConnection = value; }
		}
		public OdbcTransaction DbTransaction
		{
			get { return _dbTransaction; }
			set { _dbTransaction = value; }
		}
		public IPublished() : this((OdbcConnection)null) { }
		public IPublished(string connectionString) : this(new OdbcConnection(connectionString)) { }
		public IPublished(OdbcConnection dbConnection)
		{
			_dbConnection = dbConnection;
		}
		public IPublished(OdbcConnection dbConnection, OdbcTransaction dbTransaction)
			: this(dbConnection)
		{
			_dbTransaction = dbTransaction;
		}
		protected void DBConnect()
		{
			if (_odbcCloseAfterUse = (_dbConnection.State != ConnectionState.Open))
			{
				_dbConnection.Open();
				if (_dbConnection.Driver.ToLower().StartsWith("myodbc"))
				{
					OdbcCommand cmd = _dbConnection.CreateCommand();
					if (_dbTransaction != null) cmd.Transaction = _dbTransaction;
					cmd.CommandText = "SET sql_mode = 'ANSI'";
					cmd.ExecuteNonQuery();
				}
			}
		}
		protected void DBClose() { if (_odbcCloseAfterUse) _dbConnection.Close(); }
		protected OdbcCommand DBCreateCommand()
		{
			OdbcCommand cmd = _dbConnection.CreateCommand();
			if(_dbTransaction != null) cmd.Transaction = _dbTransaction;
			return cmd;
		}
		/// <summary>
		/// Lists all site content
		/// runs a sequence of connected methods: MayViewSite, ListPublishedContentAll, ComposeFriendlyName.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListSiteContent[]</returns>
		public returnListSiteContent[] ListSiteContent(int? maxRowsToReturn, string ticket, long SiteID)
		{
			returnListSiteContent[] rv = null;
			List<returnListSiteContent> rvl = new List<returnListSiteContent>();
			returnListSiteContent crv = new returnListSiteContent();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayViewSite prvMayViewSite = ICredentialsObj.MayViewSite(ticket, SiteID);
			if (prvMayViewSite.UserMayViewSite == true)
			{
				cms.DB.PDatabase.returnListPublishedContentAll[] prvListPublishedContentAll = PDatabaseObj.ListPublishedContentAll(maxRowsToReturn, SiteID);
				for(int idxListPublishedContentAll = 0; idxListPublishedContentAll < prvListPublishedContentAll.Length; idxListPublishedContentAll++)
				{
					if (idxListPublishedContentAll > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnListSiteContent();
						}
					}
					crv.ContentID = prvListPublishedContentAll[idxListPublishedContentAll].ID;
					crv.ContentType = prvListPublishedContentAll[idxListPublishedContentAll].Type;
					crv.ContentTitle = prvListPublishedContentAll[idxListPublishedContentAll].Title;
					crv.ContentPublished = prvListPublishedContentAll[idxListPublishedContentAll].Published;
					crv.ContentSortOrder = prvListPublishedContentAll[idxListPublishedContentAll].SortOrder;
					crv.ContentKeywords = prvListPublishedContentAll[idxListPublishedContentAll].Keywords;
					crv.ContentDescription = prvListPublishedContentAll[idxListPublishedContentAll].Description;
					crv.ContentRobots = prvListPublishedContentAll[idxListPublishedContentAll].Robots;
					crv.ContentLanguage = prvListPublishedContentAll[idxListPublishedContentAll].Language;
					crv.ContentCustom = prvListPublishedContentAll[idxListPublishedContentAll].Custom;
					crv.ContentAllowMessages = prvListPublishedContentAll[idxListPublishedContentAll].AllowMessages;
					crv.SiteID = prvListPublishedContentAll[idxListPublishedContentAll].SiteID;
					crv.ParentID = prvListPublishedContentAll[idxListPublishedContentAll].ParentID;
					crv.ContentAbstract = prvListPublishedContentAll[idxListPublishedContentAll].Abstract;
					crv.ContentSUID = prvListPublishedContentAll[idxListPublishedContentAll].SUID;
					crvUsed = true;
					cms.DB.PPlatform.returnComposeFriendlyName prvComposeFriendlyName = PPlatformObj.ComposeFriendlyName(prvListPublishedContentAll[idxListPublishedContentAll].ID, prvListPublishedContentAll[idxListPublishedContentAll].Title);
					crv.friendlyName = prvComposeFriendlyName.friendlyName;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// List all root-level content of a site
		/// runs a sequence of connected methods: MayViewSite, ListPublishedContentRoots, ComposeFriendlyName, GetContentLink.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListRootContent[]</returns>
		public returnListRootContent[] ListRootContent(int? maxRowsToReturn, string ticket, long SiteID)
		{
			returnListRootContent[] rv = null;
			List<returnListRootContent> rvl = new List<returnListRootContent>();
			returnListRootContent crv = new returnListRootContent();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayViewSite prvMayViewSite = ICredentialsObj.MayViewSite(ticket, SiteID);
			if (prvMayViewSite.UserMayViewSite == true)
			{
				cms.DB.PDatabase.returnListPublishedContentRoots[] prvListPublishedContentRoots = PDatabaseObj.ListPublishedContentRoots(maxRowsToReturn, SiteID);
				for(int idxListPublishedContentRoots = 0; idxListPublishedContentRoots < prvListPublishedContentRoots.Length; idxListPublishedContentRoots++)
				{
					if (idxListPublishedContentRoots > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnListRootContent();
						}
					}
					crv.ContentID = prvListPublishedContentRoots[idxListPublishedContentRoots].ID;
					crv.ContentType = prvListPublishedContentRoots[idxListPublishedContentRoots].Type;
					crv.ContentTitle = prvListPublishedContentRoots[idxListPublishedContentRoots].Title;
					crv.ContentPublished = prvListPublishedContentRoots[idxListPublishedContentRoots].Published;
					crv.ContentSortOrder = prvListPublishedContentRoots[idxListPublishedContentRoots].SortOrder;
					crv.ContentKeywords = prvListPublishedContentRoots[idxListPublishedContentRoots].Keywords;
					crv.ContentDescription = prvListPublishedContentRoots[idxListPublishedContentRoots].Description;
					crv.ContentRobots = prvListPublishedContentRoots[idxListPublishedContentRoots].Robots;
					crv.ContentLanguage = prvListPublishedContentRoots[idxListPublishedContentRoots].Language;
					crv.ContentCustom = prvListPublishedContentRoots[idxListPublishedContentRoots].Custom;
					crv.ContentAllowMessages = prvListPublishedContentRoots[idxListPublishedContentRoots].AllowMessages;
					crv.SiteID = prvListPublishedContentRoots[idxListPublishedContentRoots].SiteID;
					crv.ParentID = prvListPublishedContentRoots[idxListPublishedContentRoots].ParentID;
					crv.ContentAbstract = prvListPublishedContentRoots[idxListPublishedContentRoots].Abstract;
					crv.ContentSUID = prvListPublishedContentRoots[idxListPublishedContentRoots].SUID;
					crvUsed = true;
					cms.DB.PPlatform.returnComposeFriendlyName prvComposeFriendlyName = PPlatformObj.ComposeFriendlyName(prvListPublishedContentRoots[idxListPublishedContentRoots].ID, prvListPublishedContentRoots[idxListPublishedContentRoots].Title);
					crv.friendlyName = prvComposeFriendlyName.friendlyName;
					crvUsed = true;
					cms.DB.PDatabase.returnGetContentLink prvGetContentLink = PDatabaseObj.GetContentLink(prvListPublishedContentRoots[idxListPublishedContentRoots].Type, prvListPublishedContentRoots[idxListPublishedContentRoots].ID);
					crv.hasLink = prvGetContentLink.hasLink;
					crv.LinkID = prvGetContentLink.LinkID;
					crv.LinkTargetURI = prvGetContentLink.LinkTargetURI;
					crv.LinkTargetURL = prvGetContentLink.LinkTargetURL;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Lists all sub-content of a content node.
		/// runs a sequence of connected methods: MayViewContent, ListPublishedContentChildren, ComposeFriendlyName, GetContentLink.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnListChildContent[]</returns>
		public returnListChildContent[] ListChildContent(int? maxRowsToReturn, string ticket, long ContentID)
		{
			returnListChildContent[] rv = null;
			List<returnListChildContent> rvl = new List<returnListChildContent>();
			returnListChildContent crv = new returnListChildContent();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayViewContent prvMayViewContent = ICredentialsObj.MayViewContent(ticket, ContentID);
			if (prvMayViewContent.UserMayViewContent == true)
			{
				cms.DB.PDatabase.returnListPublishedContentChildren[] prvListPublishedContentChildren = PDatabaseObj.ListPublishedContentChildren(maxRowsToReturn, ContentID);
				for(int idxListPublishedContentChildren = 0; idxListPublishedContentChildren < prvListPublishedContentChildren.Length; idxListPublishedContentChildren++)
				{
					if (idxListPublishedContentChildren > 0)
					{
						if(crvUsed)
						{
							rvl.Add(crv);
							crvUsed = false;
							crv = new returnListChildContent();
						}
					}
					crv.ContentID = prvListPublishedContentChildren[idxListPublishedContentChildren].ID;
					crv.ContentType = prvListPublishedContentChildren[idxListPublishedContentChildren].Type;
					crv.ContentTitle = prvListPublishedContentChildren[idxListPublishedContentChildren].Title;
					crv.ContentPublished = prvListPublishedContentChildren[idxListPublishedContentChildren].Published;
					crv.ContentSortOrder = prvListPublishedContentChildren[idxListPublishedContentChildren].SortOrder;
					crv.ContentKeywords = prvListPublishedContentChildren[idxListPublishedContentChildren].Keywords;
					crv.ContentDescription = prvListPublishedContentChildren[idxListPublishedContentChildren].Description;
					crv.ContentRobots = prvListPublishedContentChildren[idxListPublishedContentChildren].Robots;
					crv.ContentLanguage = prvListPublishedContentChildren[idxListPublishedContentChildren].Language;
					crv.ContentCustom = prvListPublishedContentChildren[idxListPublishedContentChildren].Custom;
					crv.ContentAllowMessages = prvListPublishedContentChildren[idxListPublishedContentChildren].AllowMessages;
					crv.SiteID = prvListPublishedContentChildren[idxListPublishedContentChildren].SiteID;
					crv.ParentID = prvListPublishedContentChildren[idxListPublishedContentChildren].ParentID;
					crv.ContentAbstract = prvListPublishedContentChildren[idxListPublishedContentChildren].Abstract;
					crv.ContentSUID = prvListPublishedContentChildren[idxListPublishedContentChildren].SUID;
					crvUsed = true;
					cms.DB.PPlatform.returnComposeFriendlyName prvComposeFriendlyName = PPlatformObj.ComposeFriendlyName(prvListPublishedContentChildren[idxListPublishedContentChildren].ID, prvListPublishedContentChildren[idxListPublishedContentChildren].Title);
					crv.friendlyName = prvComposeFriendlyName.friendlyName;
					crvUsed = true;
					cms.DB.PDatabase.returnGetContentLink prvGetContentLink = PDatabaseObj.GetContentLink(prvListPublishedContentChildren[idxListPublishedContentChildren].Type, prvListPublishedContentChildren[idxListPublishedContentChildren].ID);
					crv.hasLink = prvGetContentLink.hasLink;
					crv.LinkID = prvGetContentLink.LinkID;
					crv.LinkTargetURI = prvGetContentLink.LinkTargetURI;
					crv.LinkTargetURL = prvGetContentLink.LinkTargetURL;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// Returns content details for all types of content.
		/// runs a sequence of connected methods: MayViewContent, GetContent, GetSite, ComposeFriendlyName, GetContentArticle, GetContentDocument, GetContentImage, GetContentLink, GetContentMessage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnGetContentDetails</returns>
		public returnGetContentDetails GetContentDetails(string ticket, long ContentID)
		{
			returnGetContentDetails rv = new returnGetContentDetails();
			List<returnGetContentDetails> rvl = new List<returnGetContentDetails>();
			returnGetContentDetails crv = new returnGetContentDetails();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.returnMayViewContent prvMayViewContent = ICredentialsObj.MayViewContent(ticket, ContentID);
			if (prvMayViewContent.UserMayViewContent == true)
			{
				cms.DB.PDatabase.returnGetContent prvGetContent = PDatabaseObj.GetContent(ContentID);
				crv.ContentID = prvGetContent.ID;
				crv.ContentTitle = prvGetContent.Title;
				crv.ContentPublished = prvGetContent.Published;
				crv.ContentSortOrder = prvGetContent.SortOrder;
				crv.ContentKeywords = prvGetContent.Keywords;
				crv.ContentDescription = prvGetContent.Description;
				crv.ContentRobots = prvGetContent.Robots;
				crv.ContentLanguage = prvGetContent.Language;
				crv.ContentCustom = prvGetContent.Custom;
				crv.ContentAllowMessages = prvGetContent.AllowMessages;
				crv.SiteID = prvGetContent.SiteID;
				crv.ParentID = prvGetContent.ParentID;
				crv.ContentType = prvGetContent.Type;
				crv.ContentAbstract = prvGetContent.Abstract;
				crv.ContentSUID = prvGetContent.SUID;
				crvUsed = true;
				cms.DB.PDatabase.returnGetSite prvGetSite = PDatabaseObj.GetSite(prvGetContent.SiteID);
				crv.SiteName = prvGetSite.Name;
				crvUsed = true;
				cms.DB.PPlatform.returnComposeFriendlyName prvComposeFriendlyName = PPlatformObj.ComposeFriendlyName(prvGetContent.ID, prvGetContent.Title);
				crv.friendlyName = prvComposeFriendlyName.friendlyName;
				crvUsed = true;
				cms.DB.PDatabase.returnGetContentArticle prvGetContentArticle = PDatabaseObj.GetContentArticle(prvGetContent.Type, prvGetContent.ID);
				crv.hasArticle = prvGetContentArticle.hasArticle;
				crv.ArticleID = prvGetContentArticle.ArticleID;
				crv.ArticleEditor = prvGetContentArticle.ArticleEditor;
				crv.ArticleData = prvGetContentArticle.ArticleData;
				crv.ArticleHint = prvGetContentArticle.ArticleHint;
				crvUsed = true;
				if (prvGetContentArticle.hasArticle != true)
				{
					cms.DB.PDatabase.returnGetContentDocument prvGetContentDocument = PDatabaseObj.GetContentDocument(prvGetContent.Type, prvGetContent.ID);
					crv.hasDocument = prvGetContentDocument.hasDocument;
					crv.DocumentID = prvGetContentDocument.DocumentID;
					crv.DocumentMimeType = prvGetContentDocument.DocumentMimeType;
					crvUsed = true;
					if (prvGetContentDocument.hasDocument != true)
					{
						cms.DB.PDatabase.returnGetContentImage prvGetContentImage = PDatabaseObj.GetContentImage(prvGetContent.Type, prvGetContent.ID);
						crv.hasImage = prvGetContentImage.hasImage;
						crv.ImageID = prvGetContentImage.ImageID;
						crv.ImageMimeType = prvGetContentImage.ImageMimeType;
						crv.ImageWidth = prvGetContentImage.ImageWidth;
						crv.ImageHeight = prvGetContentImage.ImageHeight;
						crv.ImageAlternative = prvGetContentImage.ImageAlternative;
						crvUsed = true;
						if (prvGetContentImage.hasImage != true)
						{
							cms.DB.PDatabase.returnGetContentLink prvGetContentLink = PDatabaseObj.GetContentLink(prvGetContent.Type, prvGetContent.ID);
							crv.hasLink = prvGetContentLink.hasLink;
							crv.LinkID = prvGetContentLink.LinkID;
							crv.LinkTargetURI = prvGetContentLink.LinkTargetURI;
							crv.LinkTargetURL = prvGetContentLink.LinkTargetURL;
							crvUsed = true;
							if (prvGetContentLink.hasLink != true)
							{
								cms.DB.PDatabase.returnGetContentMessage prvGetContentMessage = PDatabaseObj.GetContentMessage(prvGetContent.Type, prvGetContent.ID);
								crv.hasMessage = prvGetContentMessage.hasMessage;
								crv.MessageID = prvGetContentMessage.MessageID;
								crv.MessageSource = prvGetContentMessage.MessageSource;
								crv.MessageData = prvGetContentMessage.MessageData;
								crvUsed = true;
							}
						}
					}
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnGetContentDetails());
			return rv;
		}
		/// <summary>
		/// Maps a site name to a site ID.
		/// runs a sequence of connected methods: GetSiteByName.
		/// </summary>
		/// <param name="name"></param>
		/// <returns>returnGetSiteID</returns>
		public returnGetSiteID GetSiteID(string name)
		{
			returnGetSiteID rv = new returnGetSiteID();
			List<returnGetSiteID> rvl = new List<returnGetSiteID>();
			returnGetSiteID crv = new returnGetSiteID();
			bool crvUsed = false;
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			if (name == null) throw new Exception("name must not be null!");
			cms.DB.PDatabase.returnGetSiteByName prvGetSiteByName = PDatabaseObj.GetSiteByName(name);
			crv.SiteID = prvGetSiteByName.SiteID;
			crvUsed = true;
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnGetSiteID());
			return rv;
		}
		/// <summary>
		/// Creates a new message if allowed for the specified parent.
		/// runs a sequence of connected methods: MayViewContent, GetContent, Constants, ContentTypes, SaveMessage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ParentID"></param>
		/// <param name="MessageSource"></param>
		/// <param name="LogEditedBy"></param>
		/// <param name="MessageData"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="ContentSUID"></param>
		/// <returns>returnAddMessage</returns>
		public returnAddMessage AddMessage(string ticket, long ParentID, string MessageSource, string LogEditedBy, string MessageData, string ContentTitle, string ContentSortOrder, string ContentSUID)
		{
			returnAddMessage rv = new returnAddMessage();
			List<returnAddMessage> rvl = new List<returnAddMessage>();
			returnAddMessage crv = new returnAddMessage();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.PDatabase.PDatabase PDatabaseObj = new cms.DB.PDatabase.PDatabase(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			if (LogEditedBy == null) throw new Exception("LogEditedBy must not be null!");
			if (ContentTitle == null) throw new Exception("ContentTitle must not be null!");
			cms.DB.ICredentials.returnMayViewContent prvMayViewContent = ICredentialsObj.MayViewContent(ticket, ParentID);
			if (prvMayViewContent.UserMayViewContent == true)
			{
				cms.DB.PDatabase.returnGetContent prvGetContent = PDatabaseObj.GetContent(ParentID);
				if (prvGetContent.AllowMessages == true)
				{
					cms.DB.IBasics.returnConstants prvConstants = IBasicsObj.Constants();
					cms.DB.PPlatform.returnContentTypes prvContentTypes = PPlatformObj.ContentTypes();
					cms.DB.PDatabase.returnSaveMessage prvSaveMessage = PDatabaseObj.SaveMessage(prvConstants.NullInt, MessageSource, prvConstants.NullInt, ContentTitle, ContentSortOrder, prvGetContent.SiteID, prvConstants.TrueBool, prvConstants.NullString, prvConstants.NullString, prvConstants.NullString, prvConstants.NullString, prvConstants.NullString, prvConstants.TrueBool, prvGetContent.Abstract, ParentID, LogEditedBy, MessageData, ContentSUID);
					crv.MessageID = prvSaveMessage.MessageID;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnAddMessage());
			return rv;
		}
		/// <summary>
		/// Returns content details, for all types of content, based on the SUID or friendly name
		/// runs a sequence of connected methods: FindIDBySUID, MayViewContent, Constants, DefaultInt.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="SUID"></param>
		/// <returns>returnLookupIDFromSUID</returns>
		public returnLookupIDFromSUID LookupIDFromSUID(string ticket, string SUID)
		{
			returnLookupIDFromSUID rv = new returnLookupIDFromSUID();
			List<returnLookupIDFromSUID> rvl = new List<returnLookupIDFromSUID>();
			returnLookupIDFromSUID crv = new returnLookupIDFromSUID();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnFindIDBySUID prvFindIDBySUID = PPlatformObj.FindIDBySUID(SUID);
			cms.DB.ICredentials.returnMayViewContent prvMayViewContent = ICredentialsObj.MayViewContent(ticket, prvFindIDBySUID.ContentID);
			if (prvMayViewContent.UserMayViewContent == true)
			{
				cms.DB.IBasics.returnConstants prvConstants = IBasicsObj.Constants();
				cms.DB.IBasics.returnDefaultInt prvDefaultInt = IBasicsObj.DefaultInt(prvFindIDBySUID.ContentID, prvConstants.ZeroInt);
				crv.ContentID = prvDefaultInt.i;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnLookupIDFromSUID());
			return rv;
		}
		/// <summary>
		/// Download image or document file content
		/// runs a sequence of connected methods: MayViewContent, Download.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="contentID"></param>
		/// <returns>returnDownload</returns>
		public returnDownload Download(string ticket, long? contentID)
		{
			returnDownload rv = new returnDownload();
			List<returnDownload> rvl = new List<returnDownload>();
			returnDownload crv = new returnDownload();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.IFiles.IFiles IFilesObj = new cms.DB.IFiles.IFiles(DbConnection, DbTransaction);
			if (contentID != null)
			{
				cms.DB.ICredentials.returnMayViewContent prvMayViewContent = ICredentialsObj.MayViewContent(ticket, contentID.Value);
				if (prvMayViewContent.UserMayViewContent == true)
				{
					cms.DB.IFiles.returnDownload prvDownload = IFilesObj.Download(ticket, contentID);
					crv.Title = prvDownload.Title;
					crv.MimeType = prvDownload.MimeType;
					crv.bytes = prvDownload.bytes;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnDownload());
			return rv;
		}
		/// <summary>
		/// Download image thumbnail file content.
		/// runs a sequence of connected methods: MayViewContent, DownloadThumbnail.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="contentID"></param>
		/// <returns>returnDownloadThumbnail</returns>
		public returnDownloadThumbnail DownloadThumbnail(string ticket, long? contentID)
		{
			returnDownloadThumbnail rv = new returnDownloadThumbnail();
			List<returnDownloadThumbnail> rvl = new List<returnDownloadThumbnail>();
			returnDownloadThumbnail crv = new returnDownloadThumbnail();
			bool crvUsed = false;
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.IFiles.IFiles IFilesObj = new cms.DB.IFiles.IFiles(DbConnection, DbTransaction);
			if (contentID != null)
			{
				cms.DB.ICredentials.returnMayViewContent prvMayViewContent = ICredentialsObj.MayViewContent(ticket, contentID.Value);
				if (prvMayViewContent.UserMayViewContent == true)
				{
					cms.DB.IFiles.returnDownloadThumbnail prvDownloadThumbnail = IFilesObj.DownloadThumbnail(ticket, contentID);
					crv.MimeType = prvDownloadThumbnail.MimeType;
					crv.imageBytes = prvDownloadThumbnail.imageBytes;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnDownloadThumbnail());
			return rv;
		}
		/// <summary>
		/// Lists all sites
		/// runs a sequence of connected methods: Constants, ViewableSites, DefaultInt, DefaultString, DefaultBool, DefaultBool.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <returns>returnListSites[]</returns>
		public returnListSites[] ListSites(int? maxRowsToReturn, string ticket)
		{
			returnListSites[] rv = null;
			List<returnListSites> rvl = new List<returnListSites>();
			returnListSites crv = new returnListSites();
			bool crvUsed = false;
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.IBasics.returnConstants prvConstants = IBasicsObj.Constants();
			cms.DB.ICredentials.returnViewableSites[] prvViewableSites = ICredentialsObj.ViewableSites(maxRowsToReturn, ticket);
			for(int idxViewableSites = 0; idxViewableSites < prvViewableSites.Length; idxViewableSites++)
			{
				if (idxViewableSites > 0)
				{
					if(crvUsed)
					{
						rvl.Add(crv);
						crvUsed = false;
						crv = new returnListSites();
					}
				}
				if (prvViewableSites[idxViewableSites].UserMayViewSite == true)
				{
					cms.DB.IBasics.returnDefaultInt prvDefaultInt = IBasicsObj.DefaultInt(prvViewableSites[idxViewableSites].SiteID, prvConstants.ZeroInt);
					crv.SiteID = prvDefaultInt.i;
					crvUsed = true;
					cms.DB.IBasics.returnDefaultString prvDefaultString = IBasicsObj.DefaultString(prvViewableSites[idxViewableSites].SiteName, prvConstants.EmptyString);
					crv.SiteName = prvDefaultString.s;
					crvUsed = true;
					cms.DB.IBasics.returnDefaultBool prvDefaultBool = IBasicsObj.DefaultBool(prvViewableSites[idxViewableSites].SiteIsPublic, prvConstants.FalseBool);
					crv.SiteIsPublic = prvDefaultBool.b;
					crvUsed = true;
					cms.DB.IBasics.returnDefaultBool prvIBasicsDefaultBool = IBasicsObj.DefaultBool(prvViewableSites[idxViewableSites].SiteRecycleBin, prvConstants.FalseBool);
					crv.SiteRecycleBin = prvIBasicsDefaultBool.b;
					crvUsed = true;
				}
			}
			if(crvUsed) rvl.Add(crv);
			rv = rvl.ToArray();
			return rv;
		}
		/// <summary>
		/// runs a sequence of connected methods: FindIDByFriendlyName, MayViewContent, Constants, DefaultInt.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="friendlyName"></param>
		/// <returns>returnLookupIDFromFriendlyName</returns>
		public returnLookupIDFromFriendlyName LookupIDFromFriendlyName(string ticket, string friendlyName)
		{
			returnLookupIDFromFriendlyName rv = new returnLookupIDFromFriendlyName();
			List<returnLookupIDFromFriendlyName> rvl = new List<returnLookupIDFromFriendlyName>();
			returnLookupIDFromFriendlyName crv = new returnLookupIDFromFriendlyName();
			bool crvUsed = false;
			cms.DB.PPlatform.PPlatform PPlatformObj = new cms.DB.PPlatform.PPlatform(DbConnection, DbTransaction);
			cms.DB.ICredentials.ICredentials ICredentialsObj = new cms.DB.ICredentials.ICredentials(DbConnection, DbTransaction);
			cms.DB.IBasics.IBasics IBasicsObj = new cms.DB.IBasics.IBasics(DbConnection, DbTransaction);
			cms.DB.PPlatform.returnFindIDByFriendlyName prvFindIDByFriendlyName = PPlatformObj.FindIDByFriendlyName(friendlyName);
			cms.DB.ICredentials.returnMayViewContent prvMayViewContent = ICredentialsObj.MayViewContent(ticket, prvFindIDByFriendlyName.ContentID);
			if (prvMayViewContent.UserMayViewContent == true)
			{
				cms.DB.IBasics.returnConstants prvConstants = IBasicsObj.Constants();
				cms.DB.IBasics.returnDefaultInt prvDefaultInt = IBasicsObj.DefaultInt(prvFindIDByFriendlyName.ContentID, prvConstants.ZeroInt);
				crv.ContentID = prvDefaultInt.i;
				crvUsed = true;
			}
			if(crvUsed) rvl.Add(crv);
			rv = (rvl.Count>0 ? rvl[0] : new returnLookupIDFromFriendlyName());
			return rv;
		}
	}
}
