﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.Odbc;
using System.IO;
using PlatformFramework;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.DB.PPlatform
{
	/// <summary>
	/// Return value from method ContentTypes
	/// </summary>
	public struct returnContentTypes
	{
		public string None;
		public string Link;
		public string Article;
		public string Image;
		public string Document;
		public string Message;
	}
	/// <summary>
	/// Return value from method LoginPwd
	/// </summary>
	public struct returnLoginPwd
	{
		public string ticket;
	}
	/// <summary>
	/// Return value from method ImageMimeType
	/// </summary>
	public struct returnImageMimeType
	{
		public bool isImage;
		public string mimeType;
		public string extension;
	}
	/// <summary>
	/// Return value from method CreateThumnail
	/// </summary>
	public struct returnCreateThumnail
	{
		public byte[] thumbnail;
		public string thumbnailExtension;
		public string thumbnailMimeType;
		public long originalWidth;
		public long originalHeight;
		public long thumbWidth;
		public long thumbHeight;
		public bool autoGenerate;
	}
	/// <summary>
	/// Return value from method DeleteContentChildren
	/// </summary>
	public struct returnDeleteContentChildren
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method IdVariable
	/// </summary>
	public struct returnIdVariable
	{
		public long? getID;
	}
	/// <summary>
	/// Return value from method CurrentUser
	/// </summary>
	public struct returnCurrentUser
	{
		public bool IsAuthenticated;
		public long UserID;
		public string UserLogin;
		public bool UserAdministrator;
		public long SessionID;
		public string UserName;
		public string Ticket;
		public string UserGUID;
	}
	/// <summary>
	/// Return value from method IdIsNull
	/// </summary>
	public struct returnIdIsNull
	{
		public bool isNull;
	}
	/// <summary>
	/// Return value from method ContentSortOrder
	/// </summary>
	public struct returnContentSortOrder
	{
		public string sortOrder;
	}
	/// <summary>
	/// Return value from method ComposeFriendlyName
	/// </summary>
	public struct returnComposeFriendlyName
	{
		public string friendlyName;
	}
	/// <summary>
	/// Return value from method FindIDBySUID
	/// </summary>
	public struct returnFindIDBySUID
	{
		public long ContentID;
	}
	/// <summary>
	/// Return value from method Thumbnails
	/// </summary>
	public struct returnThumbnails
	{
		public bool autoGenerate;
		public string extension;
		public string mimeType;
		public long width;
		public long height;
	}
	/// <summary>
	/// Return value from method LatestLog
	/// </summary>
	public struct returnLatestLog
	{
		public long ID;
		public DateTime EditedDate;
		public string EditedBy;
	}
	/// <summary>
	/// Return value from method SetContentChildrenSite
	/// </summary>
	public struct returnSetContentChildrenSite
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method UniqueSiteName
	/// </summary>
	public struct returnUniqueSiteName
	{
		public string SiteName;
	}
	/// <summary>
	/// Return value from method NewSUID
	/// </summary>
	public struct returnNewSUID
	{
		public string SUID;
	}
	/// <summary>
	/// Return value from method FindIDByFriendlyName
	/// </summary>
	public struct returnFindIDByFriendlyName
	{
		public long ContentID;
	}
	/// <summary>
	/// Return value from method Logout
	/// </summary>
	public struct returnLogout
	{
		public int methodReturnsNothing;
	}
	/// <summary>
	/// Return value from method MakePassword
	/// </summary>
	public struct returnMakePassword
	{
		public string passwordMD5;
	}
	/// <summary>
	/// Return value from method PasswordEncode
	/// </summary>
	public struct returnPasswordEncode
	{
		public string MD5encoded;
	}
	/// <summary>
	/// Return value from method UniqueUserLogin
	/// </summary>
	public struct returnUniqueUserLogin
	{
		public string UserLogin;
	}
	/// <summary>
	/// Class implementing operations on:
	///     Custom object
	/// </summary>
	public class PPlatform
	{
		private string _tempDir = ".";
		private bool _odbcCloseAfterUse;
		private OdbcConnection _dbConnection = null;
		private OdbcTransaction _dbTransaction = null;
		public string TempDir
		{
			get { return _tempDir; }
			set { _tempDir = value; }
		}
		public OdbcConnection DbConnection
		{
			get { return _dbConnection; }
			set { _dbConnection = value; }
		}
		public OdbcTransaction DbTransaction
		{
			get { return _dbTransaction; }
			set { _dbTransaction = value; }
		}
		public PPlatform() : this((OdbcConnection)null) { }
		public PPlatform(string connectionString) : this(new OdbcConnection(connectionString)) { }
		public PPlatform(OdbcConnection dbConnection)
		{
			_dbConnection = dbConnection;
		}
		public PPlatform(OdbcConnection dbConnection, OdbcTransaction dbTransaction)
			: this(dbConnection)
		{
			_dbTransaction = dbTransaction;
		}
		protected void DBConnect()
		{
			if (_odbcCloseAfterUse = (_dbConnection.State != ConnectionState.Open))
			{
				_dbConnection.Open();
				if (_dbConnection.Driver.ToLower().StartsWith("myodbc"))
				{
					OdbcCommand cmd = _dbConnection.CreateCommand();
					if (_dbTransaction != null) cmd.Transaction = _dbTransaction;
					cmd.CommandText = "SET sql_mode = 'ANSI'";
					cmd.ExecuteNonQuery();
				}
			}
		}
		protected void DBClose() { if (_odbcCloseAfterUse) _dbConnection.Close(); }
		protected OdbcCommand DBCreateCommand()
		{
			OdbcCommand cmd = _dbConnection.CreateCommand();
			if(_dbTransaction != null) cmd.Transaction = _dbTransaction;
			return cmd;
		}
		/// <summary>
		/// Returns a set of strings
		/// perform custom defined operations.
		/// </summary>
		/// <returns>returnContentTypes</returns>
		public returnContentTypes ContentTypes()
		{
			returnContentTypes rv = new returnContentTypes();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.ContentTypes();
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Start a user session based on login and password
		/// perform custom defined operations.
		/// </summary>
		/// <param name="login"></param>
		/// <param name="password"></param>
		/// <param name="persistent"></param>
		/// <returns>returnLoginPwd</returns>
		public returnLoginPwd LoginPwd(string login, string password, bool persistent)
		{
			returnLoginPwd rv = new returnLoginPwd();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Security customObject = new PlatformFramework.Security(cmd);
			if (login == null) throw new Exception("login must not be null!");
			if (password == null) throw new Exception("password must not be null!");
			rv = customObject.LoginPwd(login, password, persistent);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Detects images by mimetype or extension
		/// perform custom defined operations.
		/// </summary>
		/// <param name="fileName"></param>
		/// <param name="mimeType"></param>
		/// <returns>returnImageMimeType</returns>
		public returnImageMimeType ImageMimeType(string fileName, string mimeType)
		{
			returnImageMimeType rv = new returnImageMimeType();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Imaging customObject = new PlatformFramework.Imaging(cmd);
			if (fileName == null) throw new Exception("fileName must not be null!");
			rv = customObject.ImageMimeType(fileName, mimeType);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Creates a thumbnail image
		/// perform custom defined operations.
		/// </summary>
		/// <param name="original"></param>
		/// <param name="mimeType"></param>
		/// <returns>returnCreateThumnail</returns>
		public returnCreateThumnail CreateThumnail(byte[] original, string mimeType)
		{
			returnCreateThumnail rv = new returnCreateThumnail();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Imaging customObject = new PlatformFramework.Imaging(cmd);
			if (original == null) throw new Exception("original must not be null!");
			rv = customObject.CreateThumnail(original, mimeType);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Recursion point, calls PDatabase.DeleteContentChildren
		/// perform custom defined operations.
		/// </summary>
		/// <param name="contentID"></param>
		/// <returns>returnDeleteContentChildren</returns>
		public returnDeleteContentChildren DeleteContentChildren(long contentID)
		{
			returnDeleteContentChildren rv = new returnDeleteContentChildren();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.DeleteContentChildren(contentID);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Just pass through
		/// perform custom defined operations.
		/// </summary>
		/// <param name="setID"></param>
		/// <returns>returnIdVariable</returns>
		public returnIdVariable IdVariable(long? setID)
		{
			returnIdVariable rv = new returnIdVariable();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.IdVariable(setID);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Returns current user
		/// perform custom defined operations.
		/// </summary>
		/// <param name="ticket"></param>
		/// <returns>returnCurrentUser</returns>
		public returnCurrentUser CurrentUser(string ticket)
		{
			returnCurrentUser rv = new returnCurrentUser();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Security customObject = new PlatformFramework.Security(cmd);
			rv = customObject.CurrentUser(ticket);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// perform custom defined operations.
		/// </summary>
		/// <param name="id"></param>
		/// <returns>returnIdIsNull</returns>
		public returnIdIsNull IdIsNull(long? id)
		{
			returnIdIsNull rv = new returnIdIsNull();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.IdIsNull(id);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// perform custom defined operations.
		/// </summary>
		/// <param name="siteID"></param>
		/// <param name="parentID"></param>
		/// <returns>returnContentSortOrder</returns>
		public returnContentSortOrder ContentSortOrder(long siteID, long? parentID)
		{
			returnContentSortOrder rv = new returnContentSortOrder();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.ContentSortOrder(siteID, parentID);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Creates a URL valid name.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="contentID"></param>
		/// <param name="title"></param>
		/// <returns>returnComposeFriendlyName</returns>
		public returnComposeFriendlyName ComposeFriendlyName(long contentID, string title)
		{
			returnComposeFriendlyName rv = new returnComposeFriendlyName();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			if (title == null) throw new Exception("title must not be null!");
			rv = customObject.ComposeFriendlyName(contentID, title);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Finds the ID using SUID or friendly name
		/// perform custom defined operations.
		/// </summary>
		/// <param name="SUID"></param>
		/// <returns>returnFindIDBySUID</returns>
		public returnFindIDBySUID FindIDBySUID(string SUID)
		{
			returnFindIDBySUID rv = new returnFindIDBySUID();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.FindIDBySUID(SUID);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// perform custom defined operations.
		/// </summary>
		/// <returns>returnThumbnails</returns>
		public returnThumbnails Thumbnails()
		{
			returnThumbnails rv = new returnThumbnails();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Imaging customObject = new PlatformFramework.Imaging(cmd);
			rv = customObject.Thumbnails();
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// perform custom defined operations.
		/// </summary>
		/// <param name="contentID"></param>
		/// <returns>returnLatestLog</returns>
		public returnLatestLog LatestLog(long contentID)
		{
			returnLatestLog rv = new returnLatestLog();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.LatestLog(contentID);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Recursion point, calls PDatabase.SetChildrenSite
		/// perform custom defined operations.
		/// </summary>
		/// <param name="contentID"></param>
		/// <param name="editedBy"></param>
		/// <returns>returnSetContentChildrenSite</returns>
		public returnSetContentChildrenSite SetContentChildrenSite(long contentID, string editedBy)
		{
			returnSetContentChildrenSite rv = new returnSetContentChildrenSite();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			if (editedBy == null) throw new Exception("editedBy must not be null!");
			rv = customObject.SetContentChildrenSite(contentID, editedBy);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Make sure the site name becomes unique
		/// perform custom defined operations.
		/// </summary>
		/// <param name="newSiteName"></param>
		/// <returns>returnUniqueSiteName</returns>
		public returnUniqueSiteName UniqueSiteName(string newSiteName)
		{
			returnUniqueSiteName rv = new returnUniqueSiteName();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.UniqueSiteName(newSiteName);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// perform custom defined operations.
		/// </summary>
		/// <returns>returnNewSUID</returns>
		public returnNewSUID NewSUID()
		{
			returnNewSUID rv = new returnNewSUID();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.NewSUID();
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Finds an ID, note 0 means not found
		/// perform custom defined operations.
		/// </summary>
		/// <param name="friendlyName"></param>
		/// <returns>returnFindIDByFriendlyName</returns>
		public returnFindIDByFriendlyName FindIDByFriendlyName(string friendlyName)
		{
			returnFindIDByFriendlyName rv = new returnFindIDByFriendlyName();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			rv = customObject.FindIDByFriendlyName(friendlyName);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// perform custom defined operations.
		/// </summary>
		/// <param name="ticket"></param>
		/// <returns>returnLogout</returns>
		public returnLogout Logout(string ticket)
		{
			returnLogout rv = new returnLogout();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Security customObject = new PlatformFramework.Security(cmd);
			rv = customObject.Logout(ticket);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Returns the current or new password MD5
		/// perform custom defined operations.
		/// </summary>
		/// <param name="newPassword"></param>
		/// <param name="currentPasswordMD5"></param>
		/// <returns>returnMakePassword</returns>
		public returnMakePassword MakePassword(string newPassword, string currentPasswordMD5)
		{
			returnMakePassword rv = new returnMakePassword();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Security customObject = new PlatformFramework.Security(cmd);
			rv = customObject.MakePassword(newPassword, currentPasswordMD5);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Password encoder. Returns null if input is null.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="unencoded"></param>
		/// <returns>returnPasswordEncode</returns>
		public returnPasswordEncode PasswordEncode(string unencoded)
		{
			returnPasswordEncode rv = new returnPasswordEncode();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Security customObject = new PlatformFramework.Security(cmd);
			if (unencoded == null) throw new Exception("unencoded must not be null!");
			rv = customObject.PasswordEncode(unencoded);
			cmd.Dispose();
			DBClose();
			return rv;
		}
		/// <summary>
		/// Makes sure the user login becomes unique.
		/// perform custom defined operations.
		/// </summary>
		/// <param name="newUserLogin"></param>
		/// <returns>returnUniqueUserLogin</returns>
		public returnUniqueUserLogin UniqueUserLogin(string newUserLogin)
		{
			returnUniqueUserLogin rv = new returnUniqueUserLogin();
			DBConnect();
			OdbcCommand cmd = DBCreateCommand();
			PlatformFramework.Utilities customObject = new PlatformFramework.Utilities(cmd);
			if (newUserLogin == null) throw new Exception("newUserLogin must not be null!");
			rv = customObject.UniqueUserLogin(newUserLogin);
			cmd.Dispose();
			DBClose();
			return rv;
		}
	}
}
