﻿using System;
using System.Data.Odbc;
using System.Web;
using System.IO;
using System.Drawing;
using System.Collections.Generic;
using db.Utility;
using cms.DB.PPlatform;

namespace PlatformFramework
{
    public class Imaging
    {
        private OdbcCommand _cmd = null;
        public Imaging(OdbcCommand cmd)
        {
            _cmd = cmd;
        }
        public returnImageMimeType ImageMimeType(string fileName, string mimeType)
        {
            returnImageMimeType rv = new returnImageMimeType();
            MimeTypeMap mtm = (!string.IsNullOrEmpty(fileName) ? MimeTypeMap.GetByExtension(new FileInfo(fileName).Extension) : MimeTypeMap.GetByMimeType(mimeType));
            rv.isImage = mtm.IsImage;
            rv.mimeType = mtm.MimeType;
            rv.extension = mtm.Extension;
            return rv;
        }
        public returnCreateThumnail CreateThumnail(byte[] original, string mimeType)
        {
            returnCreateThumnail rv = new returnCreateThumnail();
            ImageUtility img = new ImageUtility();
            try
            {
                returnThumbnails thumbs = Thumbnails();
                rv.thumbnail = ImageUtility.GetBytes(img.GetImage(original, new Size((int)thumbs.width, (int)thumbs.height), EFitImage.Fit, Brushes.White));
                rv.originalWidth = img.OriginalSize.Width;
                rv.originalHeight = img.OriginalSize.Height;
                rv.thumbWidth = thumbs.width;
                rv.thumbHeight = thumbs.height;
                rv.thumbnailExtension = thumbs.extension;
                rv.thumbnailMimeType = thumbs.mimeType;
                rv.autoGenerate = thumbs.autoGenerate;
            }
            catch (Exception)
            {   // Just ignore this
            }
            return rv;
        }
        public returnThumbnails Thumbnails()
        {
            returnThumbnails rv = new returnThumbnails();
            rv.autoGenerate = true;
            rv.extension = ".png";
            rv.mimeType = MimeTypeMap.GetByExtension(rv.extension).MimeType;
            rv.width = 64;
            rv.height = 64;
            return rv;
        }
    }
}