﻿if not exists(select * from sysobjects where name=N't_rise_u_model' and xtype='U')
begin
  create table [t_rise_u_model]
  (
    [c_id] int identity(1,1) primary key clustered not null,
    [c_u_name] nvarchar(50),
    [c_u_prefix] nvarchar(10),
    [c_u_guid] nvarchar(50),
    [c_u_version] int not null,
    [c_u_versionSequenceNumber] int not null
  )
  alter table [t_rise_u_model] add
    constraint [ix_rise_u_model_u_guid] unique nonclustered ([c_u_guid]),
    constraint [ix_rise_u_model_u_prefix] unique nonclustered ([c_u_prefix]),
    constraint [ix_rise_u_model_u_name] unique nonclustered ([c_u_name])
end
if not exists(select * from sysobjects where name=N't_rise_u_log' and xtype='U')
begin
  create table [t_rise_u_log]
  (
    [c_id] int identity(1,1) primary key clustered not null,
    [c_r_model] int not null,
    [c_u_sequenceNumber] int not null,
    [c_u_timeStamp] datetime not null,
    [c_u_xml] ntext null
  )
  alter table [t_rise_u_log] add
    constraint [fk_rise_u_log_r_model] foreign key ( [c_r_model] ) references [t_rise_u_model] ( [c_id] ),
    constraint [ix_rise_u_log_i_modelSN] unique nonclustered ([c_r_model],[c_u_sequenceNumber])
end
if not exists(select * from sysobjects where name=N't_rise_u_object' and xtype='U')
begin
  create table [t_rise_u_object]
  (
    [c_id] int identity(1,1) primary key clustered not null,
    [c_u_tableName] nvarchar(50) not null,
    [c_u_riseID] nvarchar(50) not null,
    [c_u_dbID] int not null,
    [c_u_state] nvarchar(1) not null
  )
  alter table [t_rise_u_object] add
    constraint [ix_rise_u_object_u_tableNameriseID] unique nonclustered ([c_u_tableName],[c_u_riseID]),
    constraint [ix_rise_u_object_u_tableNamedbID] unique nonclustered ([c_u_tableName],[c_u_dbID])
end
if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_rise_u_object') where sc.name='c_u_state')
  alter table [t_rise_u_object] add [c_u_state] nvarchar(1) null
if not exists(select * from sysobjects where name = 'f_rise_u_dbID' and xtype='FN')
  execute(N'create function f_rise_u_dbID (@p_tableName nvarchar(50), @p_riseID nvarchar(50)) returns int
    as
    begin
      declare @v_dbID int
      select @v_dbID = c_u_dbID from t_rise_u_object where c_u_tableName = @p_tableName and c_u_riseID = @p_riseID
      return @v_dbID
    end')
if not exists(select * from sysobjects where name=N'v_rise_nextSNinner' and xtype='V')
  execute(N'create view [v_rise_nextSNinner] ([SN],[c_r_model]) as
    select max([c_u_sequenceNumber])+1,[c_r_model]
    from [t_rise_u_log]
    group by [c_r_model]')
if not exists(select * from sysobjects where name=N'v_rise_nextSN' and xtype='V')
  execute(N'create view [v_rise_nextSN] ([SN],[prefix],[guid]) as
    select isnull([l].[SN],1),[m].[c_u_prefix],[m].[c_u_guid]
    from [t_rise_u_model] [m]
    left outer join [v_rise_nextSNinner] [l] on ([l].[c_r_model]=[m].[c_id])')
GO -- 'end-of-command

if not exists(select * from [t_rise_u_model] where [c_u_prefix]=N'cms' and [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88') insert into [t_rise_u_model] ([c_u_name],[c_u_prefix],[c_u_guid],[c_u_version],[c_u_versionSequenceNumber]) values (N'CMS',N'cms',N'da6e583d-ae07-4955-956b-5fe205448f88',0,0)
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=1)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],1,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>1</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Content</rise:name><rise:attribute><rise:name>SUID</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>True</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>System Unique IDentifier, auto-generated or well-known name</rise:description></rise:attribute><rise:attribute><rise:name>Type</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>Type of content, determines what extension to load</rise:description></rise:attribute><rise:attribute><rise:name>Title</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>Title/name of this content</rise:description></rise:attribute><rise:attribute><rise:name>Published</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:default>''0''</rise:default><rise:description>True if content is published</rise:description></rise:attribute><rise:attribute><rise:name>SortOrder</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Sort order used when sorting siblings</rise:description></rise:attribute><rise:attribute><rise:name>Keywords</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Meta tag</rise:description></rise:attribute><rise:attribute><rise:name>Description</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Short description of content (meta tag)</rise:description></rise:attribute><rise:attribute><rise:name>Robots</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Meta tag</rise:description></rise:attribute><rise:attribute><rise:name>Language</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Meta tag</rise:description></rise:attribute><rise:attribute><rise:name>Custom</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Used to pass custom data with content</rise:description></rise:attribute><rise:attribute><rise:name>AllowMessages</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:default>''0''</rise:default><rise:description>If set the content allows sub-content messages</rise:description></rise:attribute><rise:attribute><rise:name>Abstract</rise:name><rise:dataTypeAlias /><rise:dataType>text</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Preamble describing the content</rise:description></rise:attribute><rise:maxID>2</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Content') 
    create table [t_cms_u_Content]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_SUID] nvarchar(50) not null,
      [c_u_Type] nvarchar(50) not null,
      [c_u_Title] nvarchar(255) not null,
      [c_u_Published] bit not null,
      [c_u_SortOrder] nvarchar(50) null,
      [c_u_Keywords] nvarchar(255) null,
      [c_u_Description] nvarchar(255) null,
      [c_u_Robots] nvarchar(50) null,
      [c_u_Language] nvarchar(50) null,
      [c_u_Custom] nvarchar(255) null,
      [c_u_AllowMessages] bit not null,
      [c_u_Abstract] ntext null
    )
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_Content_u_SUID') 
    alter table [t_cms_u_Content] add constraint [ix_cms_u_Content_u_SUID] unique nonclustered ([c_u_SUID])
  if not exists(select id from sysobjects where xtype='D' and name='df_cms_u_Content_u_Published') 
  begin
    execute('alter table [t_cms_u_Content] add constraint [df_cms_u_Content_u_Published] default (''0'') for [c_u_Published] with values')
    if(@@error <> 0) print 'default value ignored!'
    else
    begin
      if exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Content') where sc.isnullable=1 and sc.name='c_u_Published') 
      begin
        execute('declare @v_default bit set @v_default = ''0'' update [t_cms_u_Content] set [c_u_Published]=@v_default where [c_u_Published] is null')
        alter table [t_cms_u_Content] alter column [c_u_Published] bit not null
      end
    end
  end
  if not exists(select id from sysobjects where xtype='D' and name='df_cms_u_Content_u_AllowMessages') 
  begin
    execute('alter table [t_cms_u_Content] add constraint [df_cms_u_Content_u_AllowMessages] default (''0'') for [c_u_AllowMessages] with values')
    if(@@error <> 0) print 'default value ignored!'
    else
    begin
      if exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Content') where sc.isnullable=1 and sc.name='c_u_AllowMessages') 
      begin
        execute('declare @v_default bit set @v_default = ''0'' update [t_cms_u_Content] set [c_u_AllowMessages]=@v_default where [c_u_AllowMessages] is null')
        alter table [t_cms_u_Content] alter column [c_u_AllowMessages] bit not null
      end
    end
  end
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=2)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],2,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>2</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Article</rise:name><rise:attribute><rise:name>Editor</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Editor to use when editing the article</rise:description></rise:attribute><rise:attribute><rise:name>Data</rise:name><rise:dataTypeAlias /><rise:dataType>text</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>The article text</rise:description></rise:attribute><rise:attribute><rise:name>Hint</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Selected from the list of article hints</rise:description></rise:attribute><rise:maxID>1</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Article') 
    create table [t_cms_u_Article]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_Editor] nvarchar(50) null,
      [c_u_Data] ntext null,
      [c_u_Hint] nvarchar(50) null
    )
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=3)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],3,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>3</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Site</rise:name><rise:attribute><rise:name>Name</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>True</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description /></rise:attribute><rise:attribute><rise:name>MembersOnly</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:default>''0''</rise:default><rise:description>Published site content is available to members only.</rise:description></rise:attribute><rise:attribute><rise:name>RecycleBin</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:default>''0''</rise:default><rise:description>If true, this is the system recycle bin.</rise:description></rise:attribute><rise:maxID>3</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Site') 
    create table [t_cms_u_Site]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_Name] nvarchar(255) not null,
      [c_u_MembersOnly] bit not null,
      [c_u_RecycleBin] bit not null
    )
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_Site_u_Name') 
    alter table [t_cms_u_Site] add constraint [ix_cms_u_Site_u_Name] unique nonclustered ([c_u_Name])
  if not exists(select id from sysobjects where xtype='D' and name='df_cms_u_Site_u_MembersOnly') 
  begin
    execute('alter table [t_cms_u_Site] add constraint [df_cms_u_Site_u_MembersOnly] default (''0'') for [c_u_MembersOnly] with values')
    if(@@error <> 0) print 'default value ignored!'
    else
    begin
      if exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Site') where sc.isnullable=1 and sc.name='c_u_MembersOnly') 
      begin
        execute('declare @v_default bit set @v_default = ''0'' update [t_cms_u_Site] set [c_u_MembersOnly]=@v_default where [c_u_MembersOnly] is null')
        alter table [t_cms_u_Site] alter column [c_u_MembersOnly] bit not null
      end
    end
  end
  if not exists(select id from sysobjects where xtype='D' and name='df_cms_u_Site_u_RecycleBin') 
  begin
    execute('alter table [t_cms_u_Site] add constraint [df_cms_u_Site_u_RecycleBin] default (''0'') for [c_u_RecycleBin] with values')
    if(@@error <> 0) print 'default value ignored!'
    else
    begin
      if exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Site') where sc.isnullable=1 and sc.name='c_u_RecycleBin') 
      begin
        execute('declare @v_default bit set @v_default = ''0'' update [t_cms_u_Site] set [c_u_RecycleBin]=@v_default where [c_u_RecycleBin] is null')
        alter table [t_cms_u_Site] alter column [c_u_RecycleBin] bit not null
      end
    end
  end
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=4)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],4,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>4</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>User</rise:name><rise:attribute><rise:name>GUID</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>True</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>GUID, persistent over time</rise:description></rise:attribute><rise:attribute><rise:name>Login</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>100</rise:dataSize><rise:mustBeUnique>True</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>User ID, used when signing on</rise:description></rise:attribute><rise:attribute><rise:name>Name</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>100</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>User presentation name</rise:description></rise:attribute><rise:attribute><rise:name>Administrator</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>Set if uer is a system administrator</rise:description></rise:attribute><rise:attribute><rise:name>PasswordMD5</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>User password MD5</rise:description></rise:attribute><rise:maxID>2</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_User') 
    create table [t_cms_u_User]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_GUID] nvarchar(50) not null,
      [c_u_Login] nvarchar(100) not null,
      [c_u_Name] nvarchar(100) not null,
      [c_u_Administrator] bit not null,
      [c_u_PasswordMD5] nvarchar(50) null
    )
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_User_u_GUID') 
    alter table [t_cms_u_User] add constraint [ix_cms_u_User_u_GUID] unique nonclustered ([c_u_GUID])
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_User_u_Login') 
    alter table [t_cms_u_User] add constraint [ix_cms_u_User_u_Login] unique nonclustered ([c_u_Login])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=5)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],5,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>5</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Member</rise:name><rise:attribute><rise:name>Edit</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>Set if the related user is allowed to edit content in the related site.</rise:description></rise:attribute><rise:maxID>0</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Member') 
    create table [t_cms_u_Member]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_Edit] bit not null
    )
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=6)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],6,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>6</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Document</rise:name><rise:attribute><rise:name>MimeType</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>100</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>Mime type of document</rise:description></rise:attribute><rise:attribute><rise:name>Data</rise:name><rise:dataTypeAlias /><rise:dataType>blob</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>File content</rise:description></rise:attribute><rise:maxID>2</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Document') 
    create table [t_cms_u_Document]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_MimeType] nvarchar(100) not null,
      [c_u_Data] image null
    )
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=7)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],7,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>7</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Image</rise:name><rise:attribute><rise:name>MimeType</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>100</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist></rise:attribute><rise:attribute><rise:name>Data</rise:name><rise:dataTypeAlias /><rise:dataType>blob</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description /></rise:attribute><rise:attribute><rise:name>Width</rise:name><rise:dataTypeAlias /><rise:dataType>int</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description /></rise:attribute><rise:attribute><rise:name>Height</rise:name><rise:dataTypeAlias /><rise:dataType>int</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description /></rise:attribute><rise:attribute><rise:name>Thumbnail</rise:name><rise:dataTypeAlias /><rise:dataType>blob</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description /></rise:attribute><rise:attribute><rise:name>Alternative</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>AltText</rise:description></rise:attribute><rise:maxID>0</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Image') 
    create table [t_cms_u_Image]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_MimeType] nvarchar(100) not null,
      [c_u_Data] image null,
      [c_u_Width] bigint not null,
      [c_u_Height] bigint not null,
      [c_u_Thumbnail] image null,
      [c_u_Alternative] nvarchar(255) null
    )
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=8)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],8,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>8</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Link</rise:name><rise:attribute><rise:name>TargetURI</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>URI identifying the target content</rise:description></rise:attribute><rise:attribute><rise:name>TargetURL</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>URL indentifying the target, if TargetURI not specified.</rise:description></rise:attribute><rise:maxID>0</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Link') 
    create table [t_cms_u_Link]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_TargetURI] nvarchar(255) null,
      [c_u_TargetURL] nvarchar(255) null
    )
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=9)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],9,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>9</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Message</rise:name><rise:attribute><rise:name>Source</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Used to identify the source (form/application) that generated the message.</rise:description></rise:attribute><rise:attribute><rise:name>Data</rise:name><rise:dataTypeAlias /><rise:dataType>text</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Message text (or html)</rise:description></rise:attribute><rise:maxID>0</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Message') 
    create table [t_cms_u_Message]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_Source] nvarchar(50) null,
      [c_u_Data] ntext null
    )
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=10)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],10,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>10</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Session</rise:name><rise:attribute><rise:name>StartDate</rise:name><rise:dataTypeAlias /><rise:dataType>datetime</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>DateTime when the session was started</rise:description></rise:attribute><rise:attribute><rise:name>Ticket</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>True</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>The session identifier</rise:description></rise:attribute><rise:attribute><rise:name>EndDate</rise:name><rise:dataTypeAlias /><rise:dataType>datetime</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>DateTime after which the session is not valid.</rise:description></rise:attribute><rise:maxID>0</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Session') 
    create table [t_cms_u_Session]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_StartDate] datetime not null,
      [c_u_Ticket] nvarchar(50) not null,
      [c_u_EndDate] datetime not null
    )
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_Session_u_Ticket') 
    alter table [t_cms_u_Session] add constraint [ix_cms_u_Session_u_Ticket] unique nonclustered ([c_u_Ticket])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=11)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],11,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>11</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Log</rise:name><rise:attribute><rise:name>EditedDate</rise:name><rise:dataTypeAlias /><rise:dataType>datetime</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description /></rise:attribute><rise:attribute><rise:name>EditedBy</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>100</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description /></rise:attribute><rise:maxID>0</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_Log') 
    create table [t_cms_u_Log]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_EditedDate] datetime not null,
      [c_u_EditedBy] nvarchar(100) not null
    )
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=12)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],12,getdate(),N'<rise:newEntity xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>12</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>ArticleHint</rise:name><rise:attribute><rise:name>Name</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description /></rise:attribute><rise:maxID>0</rise:maxID></rise:entity></rise:newEntity>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysobjects where xtype='U' and name='t_cms_u_ArticleHint') 
    create table [t_cms_u_ArticleHint]
    (
      [c_id] bigint identity(1,1) primary key clustered not null,
      [c_u_Name] nvarchar(50) not null
    )
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=13)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],13,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>13</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>ContentArticle</rise:name><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Article</rise:name><rise:entityName>Article</rise:entityName><rise:cardinality>0or1</rise:cardinality></rise:node><rise:maxID>1</rise:maxID><rise:relationHint><rise:direction>Uni_2to1</rise:direction><rise:aggregation>Inheritance</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Article') where sc.name='c_r_Content') 
    alter table [t_cms_u_Article] add [c_r_Content] bigint null
  execute('if(not exists(select * from [t_cms_u_Article] where [c_r_Content] is null)) alter table [t_cms_u_Article] alter column [c_r_Content] bigint not null else alter table [t_cms_u_Article] alter column [c_r_Content] bigint null')
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_Article_r_Content') 
    alter table [t_cms_u_Article] add constraint [ix_cms_u_Article_r_Content] unique nonclustered ([c_r_Content])
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Article_r_Content') 
    alter table [t_cms_u_Article] add constraint [fk_cms_u_Article_r_Content] foreign key ([c_r_Content]) references [t_cms_u_Content]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=14)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],14,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>14</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>SiteContent</rise:name><rise:node><rise:name>Site</rise:name><rise:entityName>Site</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>0toN</rise:cardinality></rise:node><rise:maxID>1</rise:maxID><rise:relationHint><rise:direction>Uni_1to2</rise:direction><rise:aggregation>Composite</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Content') where sc.name='c_r_Site') 
    alter table [t_cms_u_Content] add [c_r_Site] bigint null
  execute('if(not exists(select * from [t_cms_u_Content] where [c_r_Site] is null)) alter table [t_cms_u_Content] alter column [c_r_Site] bigint not null else alter table [t_cms_u_Content] alter column [c_r_Site] bigint null')
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Content_r_Site') 
    alter table [t_cms_u_Content] add constraint [fk_cms_u_Content_r_Site] foreign key ([c_r_Site]) references [t_cms_u_Site]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=15)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],15,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>15</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>ParentContent</rise:name><rise:node><rise:name>Parent</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>0or1</rise:cardinality></rise:node><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>0toN</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_2to1</rise:direction><rise:aggregation>Basic</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Content') where sc.name='c_r_Parent') 
    alter table [t_cms_u_Content] add [c_r_Parent] bigint null
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Content_r_Parent') 
    alter table [t_cms_u_Content] add constraint [fk_cms_u_Content_r_Parent] foreign key ([c_r_Parent]) references [t_cms_u_Content]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=16)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],16,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>16</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>UserMember</rise:name><rise:node><rise:name>User</rise:name><rise:entityName>User</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Member</rise:name><rise:entityName>Member</rise:entityName><rise:cardinality>0toN</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_2to1</rise:direction><rise:aggregation>Basic</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Member') where sc.name='c_r_User') 
    alter table [t_cms_u_Member] add [c_r_User] bigint null
  execute('if(not exists(select * from [t_cms_u_Member] where [c_r_User] is null)) alter table [t_cms_u_Member] alter column [c_r_User] bigint not null else alter table [t_cms_u_Member] alter column [c_r_User] bigint null')
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Member_r_User') 
    alter table [t_cms_u_Member] add constraint [fk_cms_u_Member_r_User] foreign key ([c_r_User]) references [t_cms_u_User]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=17)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],17,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>17</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>SiteMember</rise:name><rise:node><rise:name>Site</rise:name><rise:entityName>Site</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Member</rise:name><rise:entityName>Member</rise:entityName><rise:cardinality>0toN</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_2to1</rise:direction><rise:aggregation>Basic</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Member') where sc.name='c_r_Site') 
    alter table [t_cms_u_Member] add [c_r_Site] bigint null
  execute('if(not exists(select * from [t_cms_u_Member] where [c_r_Site] is null)) alter table [t_cms_u_Member] alter column [c_r_Site] bigint not null else alter table [t_cms_u_Member] alter column [c_r_Site] bigint null')
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Member_r_Site') 
    alter table [t_cms_u_Member] add constraint [fk_cms_u_Member_r_Site] foreign key ([c_r_Site]) references [t_cms_u_Site]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=18)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],18,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>18</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>ContentDocument</rise:name><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Document</rise:name><rise:entityName>Document</rise:entityName><rise:cardinality>0or1</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_2to1</rise:direction><rise:aggregation>Inheritance</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Document') where sc.name='c_r_Content') 
    alter table [t_cms_u_Document] add [c_r_Content] bigint null
  execute('if(not exists(select * from [t_cms_u_Document] where [c_r_Content] is null)) alter table [t_cms_u_Document] alter column [c_r_Content] bigint not null else alter table [t_cms_u_Document] alter column [c_r_Content] bigint null')
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_Document_r_Content') 
    alter table [t_cms_u_Document] add constraint [ix_cms_u_Document_r_Content] unique nonclustered ([c_r_Content])
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Document_r_Content') 
    alter table [t_cms_u_Document] add constraint [fk_cms_u_Document_r_Content] foreign key ([c_r_Content]) references [t_cms_u_Content]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=19)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],19,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>19</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>ContentImage</rise:name><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Image</rise:name><rise:entityName>Image</rise:entityName><rise:cardinality>0or1</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_2to1</rise:direction><rise:aggregation>Inheritance</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Image') where sc.name='c_r_Content') 
    alter table [t_cms_u_Image] add [c_r_Content] bigint null
  execute('if(not exists(select * from [t_cms_u_Image] where [c_r_Content] is null)) alter table [t_cms_u_Image] alter column [c_r_Content] bigint not null else alter table [t_cms_u_Image] alter column [c_r_Content] bigint null')
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_Image_r_Content') 
    alter table [t_cms_u_Image] add constraint [ix_cms_u_Image_r_Content] unique nonclustered ([c_r_Content])
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Image_r_Content') 
    alter table [t_cms_u_Image] add constraint [fk_cms_u_Image_r_Content] foreign key ([c_r_Content]) references [t_cms_u_Content]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=20)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],20,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>20</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>ContentLink</rise:name><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Link</rise:name><rise:entityName>Link</rise:entityName><rise:cardinality>0or1</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_2to1</rise:direction><rise:aggregation>Inheritance</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Link') where sc.name='c_r_Content') 
    alter table [t_cms_u_Link] add [c_r_Content] bigint null
  execute('if(not exists(select * from [t_cms_u_Link] where [c_r_Content] is null)) alter table [t_cms_u_Link] alter column [c_r_Content] bigint not null else alter table [t_cms_u_Link] alter column [c_r_Content] bigint null')
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_Link_r_Content') 
    alter table [t_cms_u_Link] add constraint [ix_cms_u_Link_r_Content] unique nonclustered ([c_r_Content])
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Link_r_Content') 
    alter table [t_cms_u_Link] add constraint [fk_cms_u_Link_r_Content] foreign key ([c_r_Content]) references [t_cms_u_Content]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=21)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],21,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>21</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>ContentMessage</rise:name><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Message</rise:name><rise:entityName>Message</rise:entityName><rise:cardinality>0or1</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_2to1</rise:direction><rise:aggregation>Inheritance</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Message') where sc.name='c_r_Content') 
    alter table [t_cms_u_Message] add [c_r_Content] bigint null
  execute('if(not exists(select * from [t_cms_u_Message] where [c_r_Content] is null)) alter table [t_cms_u_Message] alter column [c_r_Content] bigint not null else alter table [t_cms_u_Message] alter column [c_r_Content] bigint null')
  if not exists(select id from sysobjects where xtype='UQ' and name='ix_cms_u_Message_r_Content') 
    alter table [t_cms_u_Message] add constraint [ix_cms_u_Message_r_Content] unique nonclustered ([c_r_Content])
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Message_r_Content') 
    alter table [t_cms_u_Message] add constraint [fk_cms_u_Message_r_Content] foreign key ([c_r_Content]) references [t_cms_u_Content]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=22)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],22,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>22</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>UserSession</rise:name><rise:node><rise:name>User</rise:name><rise:entityName>User</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Session</rise:name><rise:entityName>Session</rise:entityName><rise:cardinality>0toN</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_1to2</rise:direction><rise:aggregation>Composite</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Session') where sc.name='c_r_User') 
    alter table [t_cms_u_Session] add [c_r_User] bigint null
  execute('if(not exists(select * from [t_cms_u_Session] where [c_r_User] is null)) alter table [t_cms_u_Session] alter column [c_r_User] bigint not null else alter table [t_cms_u_Session] alter column [c_r_User] bigint null')
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Session_r_User') 
    alter table [t_cms_u_Session] add constraint [fk_cms_u_Session_r_User] foreign key ([c_r_User]) references [t_cms_u_User]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=23)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],23,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>23</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>ContentLog</rise:name><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>Log</rise:name><rise:entityName>Log</rise:entityName><rise:cardinality>0toN</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_1to2</rise:direction><rise:aggregation>Composite</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_Log') where sc.name='c_r_Content') 
    alter table [t_cms_u_Log] add [c_r_Content] bigint null
  execute('if(not exists(select * from [t_cms_u_Log] where [c_r_Content] is null)) alter table [t_cms_u_Log] alter column [c_r_Content] bigint not null else alter table [t_cms_u_Log] alter column [c_r_Content] bigint null')
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_Log_r_Content') 
    alter table [t_cms_u_Log] add constraint [fk_cms_u_Log_r_Content] foreign key ([c_r_Content]) references [t_cms_u_Content]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=24)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],24,getdate(),N'<rise:newRelation xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>24</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>SiteArticleHint</rise:name><rise:node><rise:name>Site</rise:name><rise:entityName>Site</rise:entityName><rise:cardinality>1</rise:cardinality></rise:node><rise:node><rise:name>ArticleHint</rise:name><rise:entityName>ArticleHint</rise:entityName><rise:cardinality>0toN</rise:cardinality></rise:node><rise:maxID>0</rise:maxID><rise:relationHint><rise:direction>Uni_1to2</rise:direction><rise:aggregation>Composite</rise:aggregation></rise:relationHint></rise:relation></rise:newRelation>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select sc.id from syscolumns sc join sysobjects so on (so.id =sc.id and so.xtype ='U' and so.name='t_cms_u_ArticleHint') where sc.name='c_r_Site') 
    alter table [t_cms_u_ArticleHint] add [c_r_Site] bigint null
  execute('if(not exists(select * from [t_cms_u_ArticleHint] where [c_r_Site] is null)) alter table [t_cms_u_ArticleHint] alter column [c_r_Site] bigint not null else alter table [t_cms_u_ArticleHint] alter column [c_r_Site] bigint null')
  if not exists(select id from sysobjects where xtype='F' and name='fk_cms_u_ArticleHint_r_Site') 
    alter table [t_cms_u_ArticleHint] add constraint [fk_cms_u_ArticleHint_r_Site] foreign key ([c_r_Site]) references [t_cms_u_Site]([c_id])
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=25)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],25,getdate(),N'<rise:newIndex xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>25</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Member</rise:name><rise:index><rise:name>UserSite</rise:name><rise:mustBeUnique>True</rise:mustBeUnique><rise:indexColumn><rise:relationName>UserMember</rise:relationName><rise:fkName>User</rise:fkName><rise:orderBy>ASC</rise:orderBy></rise:indexColumn><rise:indexColumn><rise:relationName>SiteMember</rise:relationName><rise:fkName>Site</rise:fkName><rise:orderBy>ASC</rise:orderBy></rise:indexColumn></rise:index><rise:maxID>0</rise:maxID></rise:entity></rise:newIndex>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysindexes where name='idx_cms_u_Member_UserSite') 
    create unique index [idx_cms_u_Member_UserSite] on [t_cms_u_Member] ([c_r_User] ASC,[c_r_Site] ASC)
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=26)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],26,getdate(),N'<rise:newIndex xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>26</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>ArticleHint</rise:name><rise:index><rise:name>SiteName</rise:name><rise:mustBeUnique>True</rise:mustBeUnique><rise:indexColumn><rise:relationName>SiteArticleHint</rise:relationName><rise:fkName>Site</rise:fkName><rise:orderBy>ASC</rise:orderBy></rise:indexColumn><rise:indexColumn><rise:attributeName>Name</rise:attributeName><rise:orderBy>ASC</rise:orderBy></rise:indexColumn></rise:index><rise:maxID>0</rise:maxID></rise:entity></rise:newIndex>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  if not exists(select id from sysindexes where name='idx_cms_u_ArticleHint_SiteName') 
    create unique index [idx_cms_u_ArticleHint_SiteName] on [t_cms_u_ArticleHint] ([c_r_Site] ASC,[c_u_Name] ASC)
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=27)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],27,getdate(),N'<rise:newInstance xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>27</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Content</rise:name><rise:attribute><rise:name>SUID</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>True</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>System Unique IDentifier, auto-generated or well-known name</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>HOME</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Type</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>Type of content, determines what extension to load</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>Article</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Title</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>Title/name of this content</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>Welcome to RISE.CMS</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Published</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:default>''0''</rise:default><rise:description>True if content is published</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>1</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>SortOrder</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Sort order used when sorting siblings</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>0010</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Keywords</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Meta tag</rise:description><rise:instance><rise:ID>2</rise:ID></rise:instance></rise:attribute><rise:attribute><rise:name>Description</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Short description of content (meta tag)</rise:description><rise:instance><rise:ID>2</rise:ID></rise:instance></rise:attribute><rise:attribute><rise:name>Robots</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Meta tag</rise:description><rise:instance><rise:ID>2</rise:ID></rise:instance></rise:attribute><rise:attribute><rise:name>Language</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Meta tag</rise:description><rise:instance><rise:ID>2</rise:ID></rise:instance></rise:attribute><rise:attribute><rise:name>Custom</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Used to pass custom data with content</rise:description><rise:instance><rise:ID>2</rise:ID></rise:instance></rise:attribute><rise:attribute><rise:name>AllowMessages</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:default>''0''</rise:default><rise:description>If set the content allows sub-content messages</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>0</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Abstract</rise:name><rise:dataTypeAlias /><rise:dataType>text</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Preamble describing the content</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>RISE.CMS installation homepage</rise:data></rise:instance></rise:attribute><rise:maxID>2</rise:maxID><rise:ID>2</rise:ID></rise:entity></rise:newInstance>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  print 'New instance operation enqueued!'
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=28)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],28,getdate(),N'<rise:newInstance xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>28</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Article</rise:name><rise:attribute><rise:name>Editor</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Editor to use when editing the article</rise:description><rise:instance><rise:ID>1</rise:ID><rise:data>Xinha</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Data</rise:name><rise:dataTypeAlias /><rise:dataType>text</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>The article text</rise:description><rise:instance><rise:ID>1</rise:ID><rise:data>&lt;h1&gt;Welcome to RISE.CMS&lt;/h1&gt;&lt;p&gt;If you are able to see this page your installation is up and running.&lt;/p&gt;&lt;p&gt;Now you may proceed, for instance, with:&lt;/p&gt;&lt;ul&gt;&lt;li&gt;Content authoring in the RISE.CMS editor.&lt;/li&gt;&lt;li&gt;Adjusting or fixing a better site template.&lt;/li&gt;&lt;li&gt;Integrating and modifying RISE.CMS itself.&lt;/li&gt;&lt;/ul&gt;&lt;p&gt;&amp;nbsp;&lt;/p&gt;&lt;p&gt;Good luck!&lt;/p&gt;</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Hint</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>Selected from the list of article hints</rise:description><rise:instance><rise:ID>1</rise:ID></rise:instance></rise:attribute><rise:maxID>1</rise:maxID><rise:ID>1</rise:ID></rise:entity></rise:newInstance>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  print 'New instance operation enqueued!'
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=29)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],29,getdate(),N'<rise:newInstance xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>29</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>Site</rise:name><rise:attribute><rise:name>Name</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>255</rise:dataSize><rise:mustBeUnique>True</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description /><rise:instance><rise:ID>1</rise:ID><rise:data>__RECYCLE_BIN__</rise:data></rise:instance><rise:instance><rise:ID>2</rise:ID><rise:data>Test site</rise:data></rise:instance><rise:instance><rise:ID>3</rise:ID><rise:data>Resources</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>MembersOnly</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:default>''0''</rise:default><rise:description>Published site content is available to members only.</rise:description><rise:instance><rise:ID>1</rise:ID><rise:data>0</rise:data></rise:instance><rise:instance><rise:ID>2</rise:ID><rise:data>0</rise:data></rise:instance><rise:instance><rise:ID>3</rise:ID><rise:data>0</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>RecycleBin</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:default>''0''</rise:default><rise:description>If true, this is the system recycle bin.</rise:description><rise:instance><rise:ID>1</rise:ID><rise:data>1</rise:data></rise:instance><rise:instance><rise:ID>2</rise:ID><rise:data>0</rise:data></rise:instance><rise:instance><rise:ID>3</rise:ID><rise:data>0</rise:data></rise:instance></rise:attribute><rise:maxID>3</rise:maxID><rise:ID>1</rise:ID><rise:ID>2</rise:ID><rise:ID>3</rise:ID></rise:entity></rise:newInstance>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  print 'New instance operation enqueued!'
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=30)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],30,getdate(),N'<rise:newInstance xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>30</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:entity><rise:name>User</rise:name><rise:attribute><rise:name>GUID</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>True</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>GUID, persistent over time</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>6520D69B-D4BA-4251-BFAD-840DA2ABAC4D</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Login</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>100</rise:dataSize><rise:mustBeUnique>True</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>User ID, used when signing on</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>admin</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Name</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>100</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>User presentation name</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>Built-in Administrator</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>Administrator</rise:name><rise:dataTypeAlias /><rise:dataType>bool</rise:dataType><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>True</rise:mustExist><rise:description>Set if uer is a system administrator</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>1</rise:data></rise:instance></rise:attribute><rise:attribute><rise:name>PasswordMD5</rise:name><rise:dataTypeAlias /><rise:dataType>string</rise:dataType><rise:dataSize>50</rise:dataSize><rise:mustBeUnique>False</rise:mustBeUnique><rise:mustExist>False</rise:mustExist><rise:description>User password MD5</rise:description><rise:instance><rise:ID>2</rise:ID><rise:data>5DB841236C2A297CAD1D48791FAB9C2E</rise:data></rise:instance></rise:attribute><rise:maxID>2</rise:maxID><rise:ID>2</rise:ID></rise:entity></rise:newInstance>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  print 'New instance operation enqueued!'
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=31)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],31,getdate(),N'<rise:newInstance xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>31</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>ContentArticle</rise:name><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>1</rise:cardinality><rise:reference><rise:ID>1</rise:ID><rise:refID>2</rise:refID></rise:reference></rise:node><rise:node><rise:name>Article</rise:name><rise:entityName>Article</rise:entityName><rise:cardinality>0or1</rise:cardinality><rise:reference><rise:ID>1</rise:ID><rise:refID>1</rise:refID></rise:reference></rise:node><rise:maxID>1</rise:maxID><rise:ID>1</rise:ID><rise:relationHint><rise:direction>Uni_2to1</rise:direction><rise:aggregation>Inheritance</rise:aggregation></rise:relationHint></rise:relation></rise:newInstance>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  print 'New instance operation enqueued!'
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=32)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],32,getdate(),N'<rise:newInstance xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>32</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:relation><rise:name>SiteContent</rise:name><rise:node><rise:name>Site</rise:name><rise:entityName>Site</rise:entityName><rise:cardinality>1</rise:cardinality><rise:reference><rise:ID>1</rise:ID><rise:refID>2</rise:refID></rise:reference></rise:node><rise:node><rise:name>Content</rise:name><rise:entityName>Content</rise:entityName><rise:cardinality>0toN</rise:cardinality><rise:reference><rise:ID>1</rise:ID><rise:refID>2</rise:refID></rise:reference></rise:node><rise:maxID>1</rise:maxID><rise:ID>1</rise:ID><rise:relationHint><rise:direction>Uni_1to2</rise:direction><rise:aggregation>Composite</rise:aggregation></rise:relationHint></rise:relation></rise:newInstance>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  print 'New instance operation enqueued!'
end
GO -- 'end-of-command

if exists(select * from [v_rise_nextSN] where [prefix]=N'cms' and [guid]=N'da6e583d-ae07-4955-956b-5fe205448f88' and [SN]=33)
begin
  insert into [t_rise_u_log]([c_r_model],[c_u_sequenceNumber],[c_u_timeStamp],[c_u_xml]) select [c_id],33,getdate(),N'<rise:release xmlns:rise="http://www.r2bsoftware/ns/rise/"><rise:sequenceNumber>33</rise:sequenceNumber><rise:timeStamp>2011-05-12T13:11:49</rise:timeStamp><rise:comment>Created from snapshot of model CMS (cms,f3e574e9-efe6-47ea-89da-66251a03f33d) at evolution #38</rise:comment></rise:release>' from [t_rise_u_model] where [c_u_guid]=N'da6e583d-ae07-4955-956b-5fe205448f88'
  update t_rise_u_model set c_u_version=1,c_u_versionSequenceNumber=33 where c_u_prefix='cms' and c_u_guid='da6e583d-ae07-4955-956b-5fe205448f88'
end
GO -- 'end-of-command

if not exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Site' and [c_u_riseID] = '1') 
begin
  insert into [t_cms_u_Site] ([c_u_Name]) values (N'__RECYCLE_BIN__')
  if (@@error = 0) insert into [t_rise_u_object] ([c_u_tableName],[c_u_riseID],[c_u_dbID],[c_u_state]) select N't_cms_u_Site','1',convert(int,SCOPE_IDENTITY()),'i'
end
if not exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Site' and [c_u_riseID] = '2') 
begin
  insert into [t_cms_u_Site] ([c_u_Name]) values (N'Test site')
  if (@@error = 0) insert into [t_rise_u_object] ([c_u_tableName],[c_u_riseID],[c_u_dbID],[c_u_state]) select N't_cms_u_Site','2',convert(int,SCOPE_IDENTITY()),'i'
end
if not exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Site' and [c_u_riseID] = '3') 
begin
  insert into [t_cms_u_Site] ([c_u_Name]) values (N'Resources')
  if (@@error = 0) insert into [t_rise_u_object] ([c_u_tableName],[c_u_riseID],[c_u_dbID],[c_u_state]) select N't_cms_u_Site','3',convert(int,SCOPE_IDENTITY()),'i'
end

GO -- 'end-of-command

if not exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_User' and [c_u_riseID] = '2') 
begin
  insert into [t_cms_u_User] ([c_u_GUID], [c_u_Login], [c_u_Name], [c_u_Administrator]) values (N'6520D69B-D4BA-4251-BFAD-840DA2ABAC4D', N'admin', N'Built-in Administrator', '1')
  if (@@error = 0) insert into [t_rise_u_object] ([c_u_tableName],[c_u_riseID],[c_u_dbID],[c_u_state]) select N't_cms_u_User','2',convert(int,SCOPE_IDENTITY()),'i'
end

GO -- 'end-of-command

if not exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Content' and [c_u_riseID] = '2') 
begin
  insert into [t_cms_u_Content] ([c_u_SUID], [c_u_Type], [c_u_Title], [c_r_Site]) values (N'HOME', N'Article', N'Welcome to RISE.CMS', dbo.f_rise_u_dbID(N't_cms_u_Site','2'))
  if (@@error = 0) insert into [t_rise_u_object] ([c_u_tableName],[c_u_riseID],[c_u_dbID],[c_u_state]) select N't_cms_u_Content','2',convert(int,SCOPE_IDENTITY()),'i'
end

GO -- 'end-of-command

if not exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Article' and [c_u_riseID] = '1') 
begin
  insert into [t_cms_u_Article] ([c_r_Content]) values (dbo.f_rise_u_dbID(N't_cms_u_Content','2'))
  if (@@error = 0) insert into [t_rise_u_object] ([c_u_tableName],[c_u_riseID],[c_u_dbID],[c_u_state]) select N't_cms_u_Article','1',convert(int,SCOPE_IDENTITY()),'i'
end

GO -- 'end-of-command

if exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Site' and [c_u_riseID] = '1' and [c_u_state] = 'i') 
begin
  update [t_cms_u_Site] set [c_u_Name]=N'__RECYCLE_BIN__' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Site','1')
  update [t_cms_u_Site] set [c_u_MembersOnly]='0' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Site','1')
  update [t_cms_u_Site] set [c_u_RecycleBin]='1' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Site','1')
  update [t_rise_u_object] set [c_u_state]='u' where [c_u_tableName]=N't_cms_u_Site' and [c_u_riseID]='1'
end
if exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Site' and [c_u_riseID] = '2' and [c_u_state] = 'i') 
begin
  update [t_cms_u_Site] set [c_u_Name]=N'Test site' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Site','2')
  update [t_cms_u_Site] set [c_u_MembersOnly]='0' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Site','2')
  update [t_cms_u_Site] set [c_u_RecycleBin]='0' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Site','2')
  update [t_rise_u_object] set [c_u_state]='u' where [c_u_tableName]=N't_cms_u_Site' and [c_u_riseID]='2'
end
if exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Site' and [c_u_riseID] = '3' and [c_u_state] = 'i') 
begin
  update [t_cms_u_Site] set [c_u_Name]=N'Resources' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Site','3')
  update [t_cms_u_Site] set [c_u_MembersOnly]='0' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Site','3')
  update [t_cms_u_Site] set [c_u_RecycleBin]='0' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Site','3')
  update [t_rise_u_object] set [c_u_state]='u' where [c_u_tableName]=N't_cms_u_Site' and [c_u_riseID]='3'
end

GO -- 'end-of-command

if exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_User' and [c_u_riseID] = '2' and [c_u_state] = 'i') 
begin
  update [t_cms_u_User] set [c_u_GUID]=N'6520D69B-D4BA-4251-BFAD-840DA2ABAC4D' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_User','2')
  update [t_cms_u_User] set [c_u_Login]=N'admin' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_User','2')
  update [t_cms_u_User] set [c_u_Name]=N'Built-in Administrator' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_User','2')
  update [t_cms_u_User] set [c_u_Administrator]='1' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_User','2')
  update [t_cms_u_User] set [c_u_PasswordMD5]=N'5DB841236C2A297CAD1D48791FAB9C2E' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_User','2')
  update [t_rise_u_object] set [c_u_state]='u' where [c_u_tableName]=N't_cms_u_User' and [c_u_riseID]='2'
end

GO -- 'end-of-command

if exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Content' and [c_u_riseID] = '2' and [c_u_state] = 'i') 
begin
  update [t_cms_u_Content] set [c_u_SUID]=N'HOME' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Content','2')
  update [t_cms_u_Content] set [c_u_Type]=N'Article' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Content','2')
  update [t_cms_u_Content] set [c_u_Title]=N'Welcome to RISE.CMS' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Content','2')
  update [t_cms_u_Content] set [c_u_Published]='1' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Content','2')
  update [t_cms_u_Content] set [c_u_SortOrder]=N'0010' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Content','2')
  update [t_cms_u_Content] set [c_u_AllowMessages]='0' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Content','2')
  update [t_cms_u_Content] set [c_u_Abstract]=N'RISE.CMS installation homepage' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Content','2')
  update [t_cms_u_Content] set [c_r_Site]=dbo.f_rise_u_dbID(N't_cms_u_Site','2') where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Content','2')
  update [t_rise_u_object] set [c_u_state]='u' where [c_u_tableName]=N't_cms_u_Content' and [c_u_riseID]='2'
end

GO -- 'end-of-command

if exists(select [c_u_dbID] from [t_rise_u_object] where [c_u_tableName] = N't_cms_u_Article' and [c_u_riseID] = '1' and [c_u_state] = 'i') 
begin
  update [t_cms_u_Article] set [c_u_Editor]=N'Xinha' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Article','1')
  update [t_cms_u_Article] set [c_u_Data]=N'<h1>Welcome to RISE.CMS</h1><p>If you are able to see this page your installation is up and running.</p><p>Now you may proceed, for instance, with:</p><ul><li>Content authoring in the RISE.CMS editor.</li><li>Adjusting or fixing a better site template.</li><li>Integrating and modifying RISE.CMS itself.</li></ul><p>&nbsp;</p><p>Good luck!</p>' where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Article','1')
  update [t_cms_u_Article] set [c_r_Content]=dbo.f_rise_u_dbID(N't_cms_u_Content','2') where [c_id] = dbo.f_rise_u_dbID(N't_cms_u_Article','1')
  update [t_rise_u_object] set [c_u_state]='u' where [c_u_tableName]=N't_cms_u_Article' and [c_u_riseID]='1'
end

GO -- 'end-of-command

