﻿var RISE = {
	idx: 1, 
	prefix: "RISE", 
	newIdx: function() {
		RISE.idx++;
		return RISE.idx;
	}, 
	newMarkupId: function(markupBase) {
		return ((markupBase) ? markupBase : (RISE.prefix || "")) + RISE.newIdx().toString();
	}, 
	evtSwitch: {
		_id: 1, 
		_newID: function() {
			return ("cb_" + RISE.evtSwitch._id++);
		}, 
		get: function(id) {
			return RISE.evtSwitch[id] || null;
		}, 
		set: function(callback, context) {
			if(callback) {
				var idx = RISE.evtSwitch._newID();
				RISE.evtSwitch[idx] = { 
					"callback": callback,
					"context": (context || null)
				}
				return idx;
			}
			return null;
		}, 
		remove: function(evtSwitchID) {
			if(evtSwitchID && RISE.evtSwitch[evtSwitchID]) {
				RISE.evtSwitch[evtSwitchID]["callback"] = null;
				RISE.evtSwitch[evtSwitchID]["context"] = null;
				delete RISE.evtSwitch[evtSwitchID];
			}
		}, 
		execute: function() {
			for(var i=0; i<arguments.length; i++){
				if(arguments[i]["evtSwitchID"]){
					var cb = RISE.evtSwitch.get(arguments[i]["evtSwitchID"]);
					if(cb && cb["callback"]){
						cb["callback"].apply(cb["context"]||null, arguments);
						return;
					}
				}
			}
			alert("RISE.evtSwitch: callback not found");
		}
	}, 
	today: function(){
		var now = new Date();
		return new Date(now.getFullYear(), now.getMonth(), now.getDate());
	}, 
	getQuerystring: function(key, dflt){
		try {
			key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
			var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
			var qs = regex.exec(window.location.href);
			if(qs == null) return dflt;
			else return qs[1];
		} catch(ex){ }
		return dflt;
	}, 
	dateToString: function(date){
		if(date) {
			var pad = function (val) {
				val = val.toString();
				while (val.length < 2) val = "0" + val;
				return val;
			};
			return (date ? date.getFullYear() + '-' + pad((date.getMonth()+1)) + '-' + pad(date.getDate()) + ((date.getHours() != 0 || date.getMinutes() != 0 || date.getSeconds() != 0) ? ' ' + pad(date.getHours()) + ':' + pad(date.getMinutes()) + ':' + pad(date.getSeconds()) : "") : null);
		}
		return null;
	},
	stringToDate: function(datestring){
		if(datestring) {
			var num = function(val, fb) {
				return (val && val!='' ? parseInt(val,10) : (fb ? fb : 0));
			};
			var m = datestring.match(/^\s*((\d\d\d\d)-(\d\d)-(\d\d))((\s|T)(\d\d)(:(\d\d)(:(\d\d))?)?)?\s*$/i);
			return new Date(num(m[2]), num(m[3])-1, num(m[4]), num(m[7]), num(m[9]), num(m[11]));
		}
		return null;
	}, 
	stringToDateEndOfDay: function(datestring){
		if(datestring) {
			var num = function(val, fb) {
				return (val && val!='' ? parseInt(val,10) : (fb ? fb : 0));
			};
			var m = datestring.match(/^\s*((\d\d\d\d)-(\d\d)-(\d\d))((\s|T)(\d\d)(:(\d\d)(:(\d\d))?)?)?\s*$/i);
			return new Date(num(m[2]), num(m[3])-1, num(m[4]), num(m[7], 23), num(m[9], 59), num(m[11], 59));
		}
		return null;
	}, 
	dateCompare: function(d1, d2) {
		try {
			if(d1 && !d2) return 1;
			if(!d1 && d2) return -1;
			if(!d1 && !d2) return 0;
			if(d1.getTime() > d2.getTime()) return 1;
			if(d1.getTime() < d2.getTime()) return -1;
			return 0;
		} catch (ex) {
		}
		return -2;
	}, 	
	isVisible: function(obj) {
		if (obj == document) return true;
		if (!obj || !obj.parentNode) return false;
		if (obj.style && (obj.style.display == 'none' || obj.style.visibility == 'hidden')) return false;
		if (window.getComputedStyle) {
			var style = window.getComputedStyle(obj, "");
			if (style.display == 'none' || style.visibility == 'hidden') return false;
		}
		if (obj.currentStyle && (obj.currentStyle['display'] == 'none' || obj.currentStyle['visibility'] == 'hidden')) return false;
		return this.isVisible(obj.parentNode);
	}, 
    htmlEncode: function(s){
		if (s && typeof(s) == "string") {
			return s.replace(/\"/g, "&quot;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
		} 
		return s;
	}, 	
	stringify: function (obj, depth) {  
		depth = (depth || 0) + 1;
		var t = typeof (obj); 
		if (t == 'undefined') {
			return 'undefined';
		} else if (t == 'object' && obj != null) {
			if (depth > 3)  return 'overflow';
			var arr = (obj.constructor == Array);
			var json = [];
			for (n in obj) {  
				json.push('"' + n + '":' + RISE.stringify(obj[n],depth));
			}
			return (arr ? '[' : '{') + json.join(',') + (arr ? ']' : '}');
		} else if (t == 'string'){
			return '"' + String(obj) +'"';
		} else if (t == 'function') {
			return 'function';
		} else {
			return String(obj);
		}
	}, 
    isUnsignedInteger: function (s) {
        return (s.toString().search(/^[0-9]+$/) == 0);
    }, 
    isInteger: function (s) {
        return (s.toString().search(/^-?[0-9]+$/) == 0);
    }
};