﻿var RISE = RISE || {};

RISE.idx = (RISE.idx || 1);
RISE.newIdx = (RISE.newIdx || function(){
	RISE.idx++;
	return RISE.idx;
});

RISE.ComboText = function(containerEl, config) {
	this.prefix = "RST";
	this.idx = RISE.newIdx();
	this.containerEl = ((containerEl) ? ((typeof(containerEl) == "string") ? document.getElementById(containerEl) : containerEl) : null);
	this.data = ((config && config["data"]) ? config["data"] : []);
	this.onChange = ((config && config["onChange"]) ? config["onChange"] : null);
	this.onChangeContext = ((config && config["onChangeContext"]) ? config["onChangeContext"] : null);
	this.onBlur = ((config && config["onBlur"]) ? config["onBlur"] : null);
	this.onBlurContext = ((config && config["onBlurContext"]) ? config["onBlurContext"] : null);
	this.onKeyEvt = ((config && config["onKeyEvt"]) ? config["onKeyEvt"] : null);
	this.onKeyEvtContext = ((config && config["onKeyEvtContext"]) ? config["onKeyEvtContext"] : null);
	this.onSelectImageClick = ((config && config["onSelectImageClick"]) ? config["onSelectImageClick"] : null);
	this.onSelectImageClickContext = ((config && config["onSelectImageClickContext"]) ? config["onSelectImageClickContext"] : null);
	this.custArgs = ((config && config["custArgs"]) ? config["custArgs"] : null);
	this.context = ((config && config["context"]) ? config["context"] : null);
	this.setFocus = ((config && config["focus"]) ? config["focus"] : false);
	
	this.textBoxValue = ((config && config["textBoxValue"]) ? config["textBoxValue"] : "");
	this.textBoxStyle = ((config && config["textBoxStyle"]) ? config["textBoxStyle"] : "");
	this.selectImage = ((config && config["selectImage"]) ? config["selectImage"] : null);
	this.selectSize = ((config && config["selectSize"]) ? config["selectSize"] : 5);
	this.useTextArea = ((config && config["useTextArea"]) ? config["useTextArea"] : false);	
	this.selectOnTab = true;
	
	this.popUp = ((config && config["popUp"]) ? config["popUp"] : { maxRows: 5 });	
	
	this.markupIds = {
		textBox: this.fldToID("textBox"), 
		selectDropDown: this.fldToID("selectDropDown"), 
		selectImage: this.fldToID("selectImage"), 
		popUp: this.fldToID("popUp")
	};
	this.popUp.lastVal = this.textBoxValue;
};

RISE.ComboText.prototype = {
	pos: function (obj) {
		try {
			if (obj && obj.offsetParent) {
				var curleft = curtop = 0;
				do {
					curleft += obj.offsetLeft;
					curtop += obj.offsetTop;
				} while (obj = obj.offsetParent);
				return { x: curleft, y: curtop };
			}
		} catch (ex) {}
		return  null;
	}, 
	fldToID: function(fld) {
		var s = [];
		s[s.length] = this.prefix;
		s[s.length] = this.idx.toString();
		s[s.length] = '_';
		s[s.length] = fld;
		return s.join('');
	}, 
	idToFld: function(id) {
		var s = id.split('_');
		return ((s.length == 2) ? s[1] : null);
	}, 
	htmlEncode: function(s){
		if (s && typeof(s) == "string") {
			return s.replace(/\"/g, "&quot;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
		} 
		return s;
	}, 
	setData: function(data){
		this.data = data;
	}, 
	findData: function(value) {
		var rc = [];
		try{
			for(var i=0; i < this.data.length; i++) {
				if(this.data[i].toLowerCase().indexOf(value) == 0) {
					rc[rc.length] = this.data[i];
				}
			}
		} catch (ex) {}
		return rc;
	}, 
	handleKeyEvt: function(evt, tbEl, puEl) {
		var self = this;
		if(evt && self.data && self.data.length) {
			if(tbEl.value) {
				if(evt.keyCode && evt.type) {
					if(evt.type == "onkeydown" && (self.selectOnTab && evt.keyCode == 9 || evt.keyCode == 13)) { // Tab && Return
						if(self.popUp.selIndex >= 0 && self.popUp.data && self.popUp.data.length > self.popUp.selIndex) {
							tbEl.value = self.popUp.data[self.popUp.selIndex];
							self.popUp.lastVal = self.popUp.data[self.popUp.selIndex];
							puEl.style.display = "none";
						}
					} else if (evt.type == "onkeydown" && evt.keyCode == 40) { // Down
						if(self.popUp.data && self.popUp.data.length > 0){
							var newIndex = (self.popUp.selIndex + 1) % Math.min(self.popUp.data.length, self.popUp["maxRows"]);
							var newEl = document.getElementById(self.fldToID(newIndex.toString()));
							var oldEl = document.getElementById(self.fldToID(self.popUp.selIndex.toString()));
							if(newEl) {
								newEl.className = "rstPopupDataHL";
								self.popUp.selIndex = newIndex;
							}
							if(oldEl) {
								oldEl.className = "rstPopupData";
							}
						}
					} else if (evt.type == "onkeydown" && evt.keyCode == 38) { // Up
						if(self.popUp.data && self.popUp.data.length > 0){
							var newIndex = ((self.popUp.selIndex - 1 >= 0) ? self.popUp.selIndex - 1 : Math.min(self.popUp.data.length, self.popUp["maxRows"]) - 1);
							var newEl = document.getElementById(self.fldToID(newIndex.toString()));
							var oldEl = document.getElementById(self.fldToID(self.popUp.selIndex.toString()));
							if(newEl) {
								newEl.className = "rstPopupDataHL";
								self.popUp.selIndex = newIndex;
							}
							if(oldEl) {
								oldEl.className = "rstPopupData";
							}										
						}
					} else if (evt.type == "onkeydown" && evt.keyCode == 27) { // Esc
						self.popUp.data = [];
						self.popUp.selIndex = -1;
						puEl.style.display = "none";
					} else if (evt.type == "onkeyup") {
						if(self.popUp.lastVal != tbEl.value) {
							self.popUp.lastVal = tbEl.value;
							self.popUp.data = self.findData(tbEl.value.toLowerCase());
							self.popUp.selIndex = -1;
							if(self.popUp.data.length > 0) {
								self.popUp.selIndex = 0;
								var s = [];
								s[s.length] = '<table class="rstPopupTable">';
								for(var i=0; i < self.popUp.data.length && i < self.popUp["maxRows"]; i++){
									s[s.length] = '<tr class="rstPopupRow">';
									s[s.length] = '<td class="' + ((i%2 == 0) ? "rstPopupCellEven":"rstPopupCellOdd") + '">';
									s[s.length] = '<div style="width: ' + ((tbEl.clientWidth) + "px") + '" id="' + self.fldToID(i.toString()) + '" class="' + ((i==0) ? "rstPopupDataHL":"rstPopupData") + '">';
									s[s.length] = self.htmlEncode(self.popUp.data[i]);
									s[s.length] = '</div></td></tr>';
								}
								s[s.length] = '</table>';
								puEl.style.width = (tbEl.clientWidth) + "px";
								puEl.innerHTML = s.join("");
								puEl.style.display = "block";
								for(var i=0; i < self.popUp.data.length && i < self.popUp["maxRows"]; i++){
									var el = document.getElementById(self.fldToID(i.toString()));
									if(el) {
										el.onmouseover = function(){
											var oldEl = document.getElementById(self.fldToID(self.popUp.selIndex.toString()));
											if(oldEl) oldEl.className = "rstPopupData";
											self.popUp.selIndex = parseInt(self.idToFld(this.id), 10);
											this.className = "rstPopupDataHL";
											tbEl.value = this.innerHTML;
										};
										el.onmouseout = function() {
											this.className = "rstPopupData";
										}
									}
								}
							} else {
								puEl.style.display = "none";
							}
						}
					}
				}
			} else {
				if(!tbEl.value) self.popUp.lastVal = "";
				puEl.style.display = "none";
				self.popUp.data = [];
				self.popUp.selIndex = -1;
			}
		} else {
			self.popUp.lastVal = tbEl.value;
			puEl.style.display = "none";
		}
	}, 
	trim: function (str) {
		str = str.replace(/^\s+/, '');
		for (var i = str.length - 1; i >= 0; i--) {
			if (/\S/.test(str.charAt(i))) {
				str = str.substring(0, i + 1);
				break;
			}
		}
		return str;
	}, 	
	render: function () {
		if(this.containerEl) {
			var self = this;
			var s = [];
			s[s.length] = '<div class="rstContainer">';
			s[s.length] = '    <table cellpadding="0" cellspacing="0" class="rstTable">';
			s[s.length] = '        <tr class="rstTextboxRow">';
			s[s.length] = '            <td class="rstTextboxCell">';
			if(this.useTextArea) {
				s[s.length] = '                <textarea id="' + this.markupIds["textBox"] + '" class="rstTextbox" style="' + (this.textBoxStyle || "") + '" rows="3" cols="30" >' + ((this.textBoxValue || this.textBoxValue == 0) ? this.htmlEncode(this.textBoxValue) : "") + '</textarea>';
			} else {
				s[s.length] = '                <input id="' + this.markupIds["textBox"] + '" type="text" class="rstTextbox" style="' + (this.textBoxStyle || "") + '" value="' + ((this.textBoxValue || this.textBoxValue == 0) ? this.htmlEncode(this.textBoxValue) : "") + '" />';
			}
			s[s.length] = '            </td>';
			if(this.selectImage && this.selectImage["src"] && (this.data && this.data.length || this.onSelectImageClick)){
				s[s.length] = '            <td>';
				s[s.length] = '                &nbsp;';
				s[s.length] = '            </td>';
				s[s.length] = '            <td>';
				s[s.length] = '                <img id="' + this.markupIds["selectImage"] + '" class="rstSelectImage" src="' + this.selectImage["src"] + '" alt="' + this.selectImage["alt"] + '" title="' + this.selectImage["title"] + '" style="' + this.selectImage["style"] + '" />';
				s[s.length] = '            </td>';
			}
			s[s.length] = '        </tr>';
			s[s.length] = '    </table>';
			s[s.length] = '    <div id="' + this.markupIds["popUp"] + '" class="rstPopup"></div>';
			s[s.length] = '</div>';
			this.containerEl.innerHTML = s.join("");
			
			var tbEl = document.getElementById(this.markupIds["textBox"]);
			var puEl = document.getElementById(this.markupIds["popUp"]);			
			var seEl = document.getElementById(this.markupIds["selectImage"]);

			if(tbEl && self.setFocus){
				try{ tbEl.focus(); } catch(ex){alert(ex);}
			}
			
			if(puEl && seEl && tbEl) {
				seEl.onclick = function(ev) {
					var evt = ev || window.event;
					var proceed = true;
					if(self.popUp){
					    self.popUp.data = [];
					    self.popUp.selIndex = -1;
					    puEl.style.display = "none";
					}
					if(self.onSelectImageClick) {
						if(self.onSelectImageClickContext) proceed = self.onSelectImageClick.call(self.onSelectImageClickContext, evt, seEl, tbEl, puEl, self.custArgs);
						else proceed = self.onSelectImageClick(evt, seEl, tbEl, puEl, self.custArgs);
					}
					if(proceed && self.data && self.data.length) {
						var dd = [];
						dd[dd.length] = '<select size="' + self.selectSize + ' " id="' + self.markupIds["selectDropDown"] + '" class="rstSelectDropDown">';
						for(var i=0; i<self.data.length; i++){
							var val = self.htmlEncode(self.data[i]);
							dd[dd.length] = '<option value="' + val + '"'+ ((val == tbEl.value) ? " SELECTED=TRUE":"") +' title="' + val + '">' + val + '</option>';
						}
						dd[dd.length] = '</select>';
						puEl.innerHTML = dd.join("");;
						var ddEl = document.getElementById(self.markupIds["selectDropDown"]);
						if(ddEl) {
							ddEl.onblur = function() {
								puEl.innerHTML = "";
								puEl.style.display = "none";
							};
							ddEl.onchange = function() {
								tbEl.value = ddEl.value;
								tbEl.focus();
								puEl.innerHTML = "";
								puEl.style.display = "none";
							};
							var pos = self.pos(tbEl);
							var sePos = self.pos(seEl);
							puEl.style.width = (sePos["x"] - pos["x"] + seEl.clientWidth) + "px";							
							puEl.style.display = "block";
							ddEl.focus();
						}
					}
				};
			}
			
			if(tbEl && puEl) {
				tbEl.onkeydown = function(ev) {
					var evt = ev || window.event;
					try {
						if(self.selectOnTab && evt && evt.keyCode && evt.keyCode == 27) {
							evt.cancelBubble = true;
							evt.returnValue = false;
						}
						var proceed = true;
						if(self.onKeyEvt) {
							if(self.onKeyEvtContext) proceed = self.onKeyEvt.call(self.onKeyEvtContext, { keyCode: evt.keyCode }, seEl, tbEl, puEl, self.custArgs);
							else proceed = self.onKeyEvt({ keyCode: evt.keyCode, type: "onkeydown" }, seEl, tbEl, puEl, self.custArgs);
						}
						if(proceed) 
							self.handleKeyEvt({ keyCode: evt.keyCode, type: "onkeydown" }, tbEl, puEl);
					} catch (ex) {}
				};
				tbEl.onkeypress = function(ev) {
					var evt = ev || window.event;
					try {
						var proceed = true;
						if(self.onKeyEvt) {
							if(self.onKeyEvtContext) proceed = self.onKeyEvt.call(self.onKeyEvtContext, { keyCode: evt.keyCode }, seEl, tbEl, puEl, self.custArgs);
							else proceed = self.onKeyEvt({ keyCode: (evt.charCode || evt.keyCode), type: "onkeypress" }, seEl, tbEl, puEl, self.custArgs);
						}
						if(proceed) 
							self.handleKeyEvt({ keyCode: evt.keyCode, type: "onkeypress" }, tbEl, puEl);
					} catch (ex) {}
				};
				tbEl.onkeyup = function(ev) {
					var evt = ev || window.event;
					try {
						var proceed = true;
						if(self.onKeyEvt) {
							if(self.onKeyEvtContext) proceed = self.onKeyEvt.call(self.onKeyEvtContext, { keyCode: evt.keyCode }, seEl, tbEl, puEl, self.custArgs);
							else proceed = self.onKeyEvt({ keyCode: evt.keyCode, type: "onkeyup" }, seEl, tbEl, puEl, self.custArgs);
						}
						if(proceed) 
							self.handleKeyEvt({ keyCode: evt.keyCode, type: "onkeyup" }, tbEl, puEl);
					} catch (ex) {}
				};
				tbEl.onblur = function() {
					puEl.innerHTML = "";
					puEl.style.display = "none";
					if(tbEl.value != self.textBoxValue && self.onChange) {
						if(self.onChangeContext) self.onChange.call(self.onChangeContext, tbEl, self.custArgs);
						else self.onChange(tbEl, self.custArgs);
					}
					if(self.onBlur) {
						if(self.onBlurContext) self.onBlur.call(self.onBlurContext, tbEl, self.custArgs);
						else self.onBlur(tbEl, self.custArgs);
					}
				    self.textBoxValue = tbEl.value || "";
				};
			}
		}
	}
};
