﻿/*
	DataTable
	column : {
		name: null, 
		label: null, 
		sortCallback: null, 
		opCallback: null,
		eventType: null,
		columnType: DataTable.prototype.columnType, 
		style: null
	}
	
	Copyright © RISE to Bloome Software 2010 - 2011
*/

var RISE = RISE || {};
RISE.idx = (RISE.idx || 1);
RISE.newIdx = (RISE.newIdx || function(){
	RISE.idx++;
	return RISE.idx;
});

RISE.DataTable = function(config) {
	this.rowID = ((config && config.rowID) ? config.rowID : "ID");
	this.columns = ((config && config.columns) ? config.columns : []);
	this.idx = RISE.newIdx();
};
RISE.DataTableSorter = function(columnMarkupID, sortCallback){
	if(columnMarkupID && sortCallback){
	}
}

RISE.DataTable.prototype = {
	prefix: "riseDT", 
	idx: 1, 
	addColumn: function(column){
		this.columns[this.columns.length] = column;
	}, 
	columnType: {
		label: 0, 
		textBox: 1, 
		textArea: 2, 
		checkBox: 3, 
		link: 4, 
		custom: 5, 
		image: 6, 
		dropdown: 7, 
		password: 8
	},
	htmlEncode: function(s){
		if (s && typeof(s) == "string") {
			return s.replace(/\"/g, "&quot;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
		} 
		return s;
	}, 
	span: function(rows, origDataName){
		var rc = {
			_span: []
		};
		if(this.rowID){
			for(var r=0; r<rows.length; r++) {
				if(typeof(rows[r][this.rowID]) !== "undefined") {
					rc[rows[r][this.rowID]] = {};
					rc._span[rc._span.length] = rows[r][this.rowID];
					if(origDataName) rc[rows[r][this.rowID]][origDataName] = rows[r];
					for(var c=0; c<this.columns.length; c++) {
						switch(this.columns[c].columnType) {
							case this.columnType.textBox:
								rc[rows[r][this.rowID]][this.columns[c]["name"]] = { value: ((typeof(rows[r][this.columns[c]["name"]]) !== "undefined") ? rows[r][this.columns[c]["name"]] : null), readonly: this._columnProp(this.columns[c], "readonly"), callbackArgs: this._columnProp(this.columns[c], "callbackArgs"), style: this._columnProp(this.columns[c], "style"), title: this._columnProp(this.columns[c], "title"), rowMarkupID: this._getRowMarkupID(rows[r][this.rowID]), markupID: this._getCellMarkupID(rows[r][this.rowID], this.columns[c]["name"]) };
							break;

							case this.columnType.textArea:
								rc[rows[r][this.rowID]][this.columns[c]["name"]] = { value: ((typeof(rows[r][this.columns[c]["name"]]) !== "undefined") ? rows[r][this.columns[c]["name"]] : null), readonly: this._columnProp(this.columns[c], "readonly"), callbackArgs: this._columnProp(this.columns[c], "callbackArgs"), style: this._columnProp(this.columns[c], "style"), title: this._columnProp(this.columns[c], "title"), rowMarkupID: this._getRowMarkupID(rows[r][this.rowID]), markupID: this._getCellMarkupID(rows[r][this.rowID], this.columns[c]["name"]) };
							break;

							case this.columnType.checkBox:
								rc[rows[r][this.rowID]][this.columns[c]["name"]] = { value: ((typeof(rows[r][this.columns[c]["name"]]) !== "undefined") ? rows[r][this.columns[c]["name"]] : null), readonly: this._columnProp(this.columns[c], "readonly"), callbackArgs: this._columnProp(this.columns[c], "callbackArgs"), style: this._columnProp(this.columns[c], "style"), title: this._columnProp(this.columns[c], "title"), rowMarkupID: this._getRowMarkupID(rows[r][this.rowID]), markupID: this._getCellMarkupID(rows[r][this.rowID], this.columns[c]["name"]) };
							break;

							case this.columnType.link:
								rc[rows[r][this.rowID]][this.columns[c]["name"]] = { value: ((typeof(rows[r][this.columns[c]["name"]]) !== "undefined") ? rows[r][this.columns[c]["name"]] : null), href: this._columnProp(this.columns[c], "href"), target: this._columnProp(this.columns[c], "target"), callbackArgs: this._columnProp(this.columns[c], "callbackArgs"), style: this._columnProp(this.columns[c], "style"), title: this._columnProp(this.columns[c], "title"), rowMarkupID: this._getRowMarkupID(rows[r][this.rowID]), markupID: this._getCellMarkupID(rows[r][this.rowID], this.columns[c]["name"]) };
							break;

							case this.columnType.custom:
								rc[rows[r][this.rowID]][this.columns[c]["name"]] = { value: ((typeof(rows[r][this.columns[c]["name"]]) !== "undefined") ? rows[r][this.columns[c]["name"]] : null), style: this._columnProp(this.columns[c], "style"), title: this._columnProp(this.columns[c], "title"), rowMarkupID: this._getRowMarkupID(rows[r][this.rowID]), markupID: this._getCellMarkupID(rows[r][this.rowID], this.columns[c]["name"]) };
							break;

							case this.columnType.image:
								rc[rows[r][this.rowID]][this.columns[c]["name"]] = { value: ((typeof(rows[r][this.columns[c]["name"]]) !== "undefined") ? rows[r][this.columns[c]["name"]] : null), src: this._columnProp(this.columns[c], "src"), alt: this._columnProp(this.columns[c], "alt"), title: this._columnProp(this.columns[c], "title"), width: this._columnProp(this.columns[c], "width"), height: this._columnProp(this.columns[c], "height"), style: this._columnProp(this.columns[c], "style"), callbackargs: this._columnProp(this.columns[c], "callbackArgs"), rowMarkupID: this._getRowMarkupID(rows[r][this.rowID]), markupID: this._getCellMarkupID(rows[r][this.rowID], this.columns[c]["name"]) };
							break;

							case this.columnType.dropdown:
								rc[rows[r][this.rowID]][this.columns[c]["name"]] = { value: ((typeof(rows[r][this.columns[c]["name"]]) !== "undefined") ? rows[r][this.columns[c]["name"]] : null), readonly: this._columnProp(this.columns[c], "readonly"), callbackArgs: this._columnProp(this.columns[c], "callbackArgs"), style: this._columnProp(this.columns[c], "style"), title: this._columnProp(this.columns[c], "title"), options: [], rowMarkupID: this._getRowMarkupID(rows[r][this.rowID]), markupID: this._getCellMarkupID(rows[r][this.rowID], this.columns[c]["name"]) };
							break;

							case this.columnType.password:
								rc[rows[r][this.rowID]][this.columns[c]["name"]] = { value: ((typeof(rows[r][this.columns[c]["name"]]) !== "undefined") ? rows[r][this.columns[c]["name"]] : null), readonly: this._columnProp(this.columns[c], "readonly"), callbackArgs: this._columnProp(this.columns[c], "callbackArgs"), style: this._columnProp(this.columns[c], "style"), title: this._columnProp(this.columns[c], "title"), rowMarkupID: this._getRowMarkupID(rows[r][this.rowID]), markupID: this._getCellMarkupID(rows[r][this.rowID], this.columns[c]["name"]) };
							break;
							
							default:
								rc[rows[r][this.rowID]][this.columns[c]["name"]] = { value: ((typeof(rows[r][this.columns[c]["name"]]) !== "undefined") ? rows[r][this.columns[c]["name"]] : null), style: this._columnProp(this.columns[c], "style"), title: this._columnProp(this.columns[c], "title"), callbackArgs: this._columnProp(this.columns[c], "callbackArgs"), rowMarkupID: this._getRowMarkupID(rows[r][this.rowID]), markupID: this._getCellMarkupID(rows[r][this.rowID], this.columns[c]["name"]) };
							break;
						}
					}
				}
			}
		}
		return rc;
	}, 
	render: function(rows, config){
		var html = [];
		html[html.length] = "<table cellpadding=\"0\"  cellspacing=\"0\" class=\"riseDataTable\">";
		if(this.rowID){
			if(!rows._span){
				rows = this.span(rows);
			}
			html[html.length] = "<tr class=\"riseDTHeader\">";
			for(var c=0; c<this.columns.length; c++){
				html[html.length] = "<td class=\""; 
				html[html.length] = ((c == this.columns.length-1) ? "riseDTColumnLast" : "riseDTColumn");
				html[html.length] = "\" id=\"";
				html[html.length] = this._getColumnMarkupID(this.columns[c]["name"]);
				html[html.length] = "\"";
				if(this.columns[c]["style"]){
					html[html.length] = " style=\"";
					html[html.length] = this.columns[c]["style"];
					html[html.length] = "\"";
				}
				html[html.length] = ">";
				html[html.length] = "<div style=\"float: left;\">";
				html[html.length] = this.columns[c]["label"];
				html[html.length] = "</div><div class=\"riseDTSortColumn\" id=\"";
				html[html.length] = this._getSortDivMarkupID(this.columns[c]["name"]);
				html[html.length] = "\"></div>";
				html[html.length] = "</td>";
			}
			html[html.length] = "</tr>";
			var index = 1;
			for(var i=0; i<rows._span.length; i++){
				var r = rows._span[i];
				
				html[html.length] = "<tr";
				if(!config){
				    html[html.length] = " valign=\"top\"";
				} else if(config.rowAlign) {
				    html[html.length] = " valign=\"" + config.rowAlign + "\"";
				}
				html[html.length] = " class=\"";
				html[html.length] = ((index % 2 ==  0) ? "riseDTTREven" : "riseDTTROdd");
				html[html.length] = "\" id=\"";
				html[html.length] = this._getRowMarkupID(r);
				html[html.length] = "\">";
				for(var c=0; c<this.columns.length; c++){
					html[html.length] = this._renderCell(r, this.columns[c], rows[r][this.columns[c]["name"]]);
				}
				html[html.length] = "</tr>";
				index++;
			}
		}
		html[html.length] = "</table>";
		return html.join("");
	}, 
	columnMarkupIDToSortMarkupID: function(markupID){
		var s = markupID.split('_');
		if(s.length == 4 && s[1] == "Column"){
			s[1] = "Sort";
			return s.join("_");
		}
		return null;
	}, 
	columnMarkupIDToColumnName: function(markupID){
		var s = markupID.split('_');
		if(s.length == 4 && s[1] == "Column"){
			return s[3];
		}
		return null;
	}, 
	cellMarkupIDToRowID: function(markupID){
		var s = markupID.split('_');
		if(s.length == 5 && s[1] == "Cell"){
			return s[3];
		}
		return null;
	}, 
	cellMarkupIDToColumnName: function(markupID){
		var s = markupID.split('_');
		if(s.length == 5 && s[1] == "Cell"){
			return s[4];
		}
		return null;
	}, 
	rowMarkupIDToRowID: function(markupID){
		var s = markupID.split('_');
		if(s.length == 4 && s[1] == "Row"){
			return s[3];
		}
		return null;
	}, 
	_columnProp: function(column, propName) {
		return ((column && column["columnProp"] && column["columnProp"][propName]) ? column["columnProp"][propName] : null);
	}, 
	_getSortDivMarkupID: function(columnName){
		var s = [];
		s[s.length] = this.prefix;
		s[s.length] = "_Sort_";
		s[s.length] = this.idx.toString();
		s[s.length] = "_";
		s[s.length] = columnName;
		return s.join("");	
	}, 	
	_getColumnMarkupID: function(columnName){
		var s = [];
		s[s.length] = this.prefix;
		s[s.length] = "_Column_";
		s[s.length] = this.idx.toString();
		s[s.length] = "_";
		s[s.length] = columnName;
		return s.join("");	
	}, 	
	_getCellMarkupID: function(rowID, columnName){
		var s = [];
		s[s.length] = this.prefix;
		s[s.length] = "_Cell_";
		s[s.length] = this.idx.toString();
		s[s.length] = "_";
		s[s.length] = rowID.toString();
		s[s.length] = "_";
		s[s.length] = columnName;
		return s.join("");	
	}, 
	_getRowMarkupID: function(rowID){
		var s = [];
		s[s.length] = this.prefix;
		s[s.length] = "_Row_";
		s[s.length] = this.idx.toString();
		s[s.length] = "_";
		s[s.length] = rowID.toString();
		return s.join("");	
	}, 
	_renderTextBoxCell: function(rowID, column, cell){
		var s = [];
		s[s.length] = "<td class=\"riseDTTextBoxCell\">";
		s[s.length] = "<input type=\"text\" class=\"riseDTTextBox\" value=\"";
		s[s.length] = ((cell["value"] || cell["value"] == 0) ? this.htmlEncode(cell["value"]): "");
		s[s.length] = "\"";
		s[s.length] = ((cell["readonly"] || !column["opCallback"]) ? " disabled=\"true\" " : "");
		if(column["opCallback"]){
			s[s.length] = " id=\"";
			s[s.length] = this._getCellMarkupID(rowID, column["name"]);
			s[s.length] = "\" ";
			s[s.length] = ((column["eventType"]) ? column["eventType"]:"onblur");
			s[s.length] = "=\"";
			s[s.length] = column["opCallback"];
			s[s.length] = "(this";
			if(cell["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(cell["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(cell["style"]){
			s[s.length] = " style=\"";
			s[s.length] = cell["style"];
			s[s.length] = "\"";
		}		
		if(cell["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(cell["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = " />";
		s[s.length] = "</td>";
		return s.join("");	
	}, 
	_renderTextAreaCell: function(rowID, column, cell){
		var s = [];
		s[s.length] = "<td class=\"riseDTTextAreaCell\">";
		s[s.length] = "<textarea cols=\"20\" rows=\"2\" class=\"riseDTTextArea\"";
		s[s.length] = ((cell["readonly"] || !column["opCallback"]) ? " disabled=\"true\" " : "");
		if(column["opCallback"]){
			s[s.length] = " id=\"";
			s[s.length] = this._getCellMarkupID(rowID, column["name"]);
			s[s.length] = "\" ";
			s[s.length] = ((column["eventType"]) ? column["eventType"]:"onblur");
			s[s.length] = "=\"";
			s[s.length] = column["opCallback"];
			s[s.length] = "(this";
			if(cell["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(cell["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(cell["style"]){
			s[s.length] = " style=\"";
			s[s.length] = cell["style"];
			s[s.length] = "\"";
		}		
		if(cell["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(cell["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = ">";
		s[s.length] = ((cell["value"] || cell["value"] == 0) ? this.htmlEncode(cell["value"]): "");
		s[s.length] = "</textarea>";
		s[s.length] = "</td>";
		return s.join("");
	}, 
	_renderCheckboxCell: function(rowID, column, cell){
		var s = [];
		s[s.length] = "<td class=\"riseDTCheckBoxCell\">";
		s[s.length] = "<input type=\"checkbox\" class=\"riseDTCheckBox\"";
		s[s.length] = ((cell["value"]) ? " checked=\"true\" ": "");
		s[s.length] = ((cell["readonly"] || !column["opCallback"]) ? " disabled=\"true\" " : "");
		if(column["opCallback"]){
			s[s.length] = " id=\"";
			s[s.length] = this._getCellMarkupID(rowID, column["name"]);
			s[s.length] = "\" ";
			s[s.length] = ((column["eventType"]) ? column["eventType"]:"onclick");
			s[s.length] = "=\"";
			s[s.length] = column["opCallback"];
			s[s.length] = "(this";
			if(cell["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(cell["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(cell["style"]){
			s[s.length] = " style=\"";
			s[s.length] = cell["style"];
			s[s.length] = "\"";
		}		
		if(cell["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(cell["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = " />";
		s[s.length] = "</td>";
		return s.join("");
	}, 
	_renderLinkCell: function(rowID, column, cell){
		var s = [];
		s[s.length] = "<td class=\"riseDTLinkCell\">";
		s[s.length] = "<a href=\"";
		s[s.length] = ((cell["href"]) ? cell["href"] : "");
		s[s.length] = "\" class=\"riseDTLink\"";
		if(cell["target"]){
			s[s.length] = " target=\"";
			s[s.length] = this.htmlEncode(cell["target"]);
			s[s.length] = "\"";
		}
		if(column["opCallback"]){
			s[s.length] = " id=\"";
			s[s.length] = this._getCellMarkupID(rowID, column["name"]);
			s[s.length] = "\" ";
			s[s.length] = ((column["eventType"]) ? column["eventType"]:"onclick");
			s[s.length] = "=\"return ";
			s[s.length] = column["opCallback"];
			s[s.length] = "(this";
			if(cell["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(cell["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(cell["style"]){
			s[s.length] = " style=\"";
			s[s.length] = cell["style"];
			s[s.length] = "\"";
		}		
		if(cell["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(cell["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = ">";
		s[s.length] = ((cell["value"] || cell["value"] == 0) ? this.htmlEncode(cell["value"]): "");
		s[s.length] = "</a>";
		s[s.length] = "</td>";
		return s.join("");
	}, 	
	_renderImageCell: function(rowID, column, cell){
		var s = [];
		s[s.length] = "<td class=\"riseDTImageCell\">";
		s[s.length] = "<img class=\"riseDTImage\" src=\"";
		s[s.length] = ((cell["src"]) ? cell["src"]: "");
		s[s.length] = "\"";
		if(cell["alt"]){
			s[s.length] = " alt=\"";
			s[s.length] = this.htmlEncode(cell["alt"]);
			s[s.length] = "\"";
		}
		if(cell["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(cell["title"]);
			s[s.length] = "\"";
		}
		if(cell["width"]){
			s[s.length] = " width=\"";
			s[s.length] = cell["width"];
			s[s.length] = "\"";
		}
		if(cell["height"]){
			s[s.length] = " height=\"";
			s[s.length] = cell["height"];
			s[s.length] = "\"";
		}
		if(cell["style"]){
			s[s.length] = " style=\"";
			s[s.length] = cell["style"];
			s[s.length] = "\"";
		}
		if(column["opCallback"]){
			s[s.length] = " id=\"";
			s[s.length] = this._getCellMarkupID(rowID, column["name"]);
			s[s.length] = "\" ";
			s[s.length] = ((column["eventType"]) ? column["eventType"]:"onclick");
			s[s.length] = "=\"";
			s[s.length] = column["opCallback"];
			s[s.length] = "(this";
			if(cell["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(cell["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}		
		s[s.length] = " />";
		s[s.length] = "</td>";
		return s.join("");
	}, 	
	_renderDropdownCell: function(rowID, column, cell){
		var s = [];
		s[s.length] = "<td class=\"riseDTDropdownCell\">";
		s[s.length] = "<select class=\"riseDTDropdown\"";
		s[s.length] = ((cell["readonly"] || !column["opCallback"]) ? " disabled=\"true\" " : "");
		if(column["opCallback"]){
			s[s.length] = " id=\"";
			s[s.length] = this._getCellMarkupID(rowID, column["name"]);
			s[s.length] = "\" ";
			s[s.length] = ((column["eventType"]) ? column["eventType"]:"onchange");
			s[s.length] = "=\"";
			s[s.length] = column["opCallback"];
			s[s.length] = "(this";
			if(cell["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(cell["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(cell["style"]){
			s[s.length] = " style=\"";
			s[s.length] = cell["style"];
			s[s.length] = "\"";
		}		
		if(cell["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(cell["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = ">";
		if(cell.options && cell.options.length){
			for(var i=0; i<cell.options.length; i++){
				if(typeof(cell.options[i].value) !== "undefined" && typeof(cell.options[i].name) !== "undefined" ){
					s[s.length] = "<option value=\"";
					s[s.length] = this.htmlEncode(cell.options[i].value);
					s[s.length] = "\"";
					if(cell["value"] == cell.options[i].value){
						s[s.length] = " SELECTED=\"TRUE\"";
					}
					s[s.length] = ">";
					s[s.length] = this.htmlEncode(cell.options[i].name);
					s[s.length] = "</option>";
				}
			}
		}
		s[s.length] = "</select>";
		s[s.length] = "</td>";
		return s.join("");
	}, 	
	_renderPasswordCell: function(rowID, column, cell){
		var s = [];
		s[s.length] = "<td class=\"riseDTPasswordCell\">";
		s[s.length] = "<input type=\"password\" class=\"riseDTPassword\" value=\"";
		s[s.length] = ((cell["value"] || cell["value"] == 0) ? this.htmlEncode(cell["value"]): "");
		s[s.length] = "\"";
		s[s.length] = ((cell["readonly"] || !column["opCallback"]) ? " disabled=\"true\" " : "");
		if(column["opCallback"]){
			s[s.length] = " id=\"";
			s[s.length] = this._getCellMarkupID(rowID, column["name"]);
			s[s.length] = "\" ";
			s[s.length] = ((column["eventType"]) ? column["eventType"]:"onblur");
			s[s.length] = "=\"";
			s[s.length] = column["opCallback"];
			s[s.length] = "(this";
			if(cell["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(cell["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(cell["style"]){
			s[s.length] = " style=\"";
			s[s.length] = cell["style"];
			s[s.length] = "\"";
		}		
		if(cell["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(cell["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = " />";
		s[s.length] = "</td>";
		return s.join("");	
	}, 
	_renderLabelCell: function(rowID, column, cell){
		var s = [];
		s[s.length] = ((column["opCallback"]) ? "<td class=\"riseDTLabelCBCell\">" : "<td class=\"riseDTLabelCell\">");
		s[s.length] = ((column["opCallback"]) ? "<div class=\"riseDTCBLabel\"" : "<div class=\"riseDTLabel\"");
		if(cell["style"]){
			s[s.length] = " style=\"";
			s[s.length] = cell["style"];
			s[s.length] = "\"";
		}
		if(cell["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(cell["title"]);
			s[s.length] = "\"";
		}
		if(column["opCallback"]){
			s[s.length] = " id=\"";
			s[s.length] = this._getCellMarkupID(rowID, column["name"]);
			s[s.length] = "\" ";
			s[s.length] = ((column["eventType"]) ? column["eventType"]:"onclick");
			s[s.length] = "=\"";
			s[s.length] = column["opCallback"];
			s[s.length] = "(this";
			if(cell["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(cell["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}		
		s[s.length] = ">";
		s[s.length] = ((cell["value"] || cell["value"] == 0) ? this.htmlEncode(cell["value"]): "");
		s[s.length] = "</div>";
		s[s.length] = "</td>";
		return s.join("");
	}, 	
	_renderCustomCell: function(rowID, column, cell){
		var s = [];
		s[s.length] = ((column["opCallback"]) ? "<td class=\"riseDTCustomCBCell\">" : "<td class=\"riseDTCustomCell\">");
		s[s.length] = ((column["opCallback"]) ? "<div class=\"riseDTCBCustom\"" : "<div class=\"riseDTCustom\"");
		if(cell["style"]){
			s[s.length] = " style=\"";
			s[s.length] = cell["style"];
			s[s.length] = "\"";
		}
		if(cell["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(cell["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = ">";
		s[s.length] = cell["value"] || "";
		s[s.length] = "</div>";
		s[s.length] = "</td>";
		return s.join("");
	}, 
	_renderCell: function(rowID, column, cell){
		var s = [];
		if(rowID && column && cell){
			switch(column.columnType){
				case this.columnType.textBox:
					s[s.length] = this._renderTextBoxCell(rowID, column, cell);
				break;

				case this.columnType.textArea:
					s[s.length] = this._renderTextAreaCell(rowID, column, cell);
				break;

				case this.columnType.checkBox:
					s[s.length] = this._renderCheckboxCell(rowID, column, cell);
				break;

				case this.columnType.link:
					s[s.length] = this._renderLinkCell(rowID, column, cell);
				break;

				case this.columnType.custom:
					s[s.length] = this._renderCustomCell(rowID, column, cell);
				break;

				case this.columnType.image:
					s[s.length] = this._renderImageCell(rowID, column, cell);
				break;

				case this.columnType.dropdown:
					s[s.length] = this._renderDropdownCell(rowID, column, cell);
				break;

				case this.columnType.password:
					s[s.length] = this._renderPasswordCell(rowID, column, cell);
				break;
				
				default:
					s[s.length] = this._renderLabelCell(rowID, column, cell);
				break;
			}
		}
		return s.join("");	
	}, 
	_renderOptionalArgsAsJsonString: function (args){
		var s = [];
		try {
			if(typeof(args) != "undefined" && args){
				for (var arg in args) {
					switch(typeof(args[arg])){
						case "string":
							s[s.length] = arg + ":'" + args[arg] + "'";
						break;

						case "boolean":
							s[s.length] = arg + ":" + args[arg].toString();
						break;

						case "number":
							s[s.length] = arg + ":" + args[arg].toString();
						break;
					}
				}
			}
		} catch(ex){}
		return "{" + s.join(", ") + "}";
	}
};