﻿var RISE = RISE || {};

RISE.idx = (RISE.idx || 1);
RISE.newIdx = (RISE.newIdx || function(){
	RISE.idx++;
	return RISE.idx;
});

RISE.DatePicker = function(domEl, config) {
	this.idx = RISE.newIdx();
	this.domEl = ((typeof(domEl) == "string") ? document.getElementById(domEl) : domEl);
	this._months = ((config && config["months"]) ? config["months"] : ["Janaury","February","March","April","May","June","July","August","September","October","November","December"]);
	this._days = ((config && config["days"]) ? config["days"] : ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]);
	this._firstDayInWeek = ((config && config["firstDayInWeek"]) ? config["firstDayInWeek"] : 0); // 0 == Sunday, 1== Monday, 2 == Tuesday ...
	this._shortMonthChars = ((config && config["shortMonthChars"]) ? config["shortMonthChars"] : 3);
	this._shortDayChars = ((config && config["shortDayChars"]) ? config["shortDayChars"] : 2);
	this._date = new Date(((config && config["date"]) ? config["date"] : new Date()));
	this._startDate = new Date(this._date.getTime());
	this._dayTitleCSSClasses = ((config && config["dayCSSClasses"]) ? config["dayCSSClasses"] : ["dpSuTitle","dpMoTitle","dpTuTitle","dpWeTitle","dpThTitle","dpFrTitle","dpSaTitle"]);
	this._dayCSSClasses = ((config && config["dayCSSClasses"]) ? config["dayCSSClasses"] : ["dpSu","dpMo","dpTu","dpWe","dpTh","dpFr","dpSa"]);
	this._selectCallback = ((config && config["selectCallback"]) ? config["selectCallback"] : null);
	this._selectCallbackContext = ((config && config["selectCallbackContext"]) ? config["selectCallbackContext"] : null);
	this._closeHTML = ((config && config["closeHTML"]) ? config["closeHTML"] : "Close");
	this._closeCallback = ((config && config["closeCallback"]) ? config["closeCallback"] : null);
	this._closeCallbackContext = ((config && config["closeCallbackContext"]) ? config["closeCallbackContext"] : null);
	this._prevYearTitle = ((config && config["prevYearTitle"]) ? config["prevYearTitle"] : "Previous Year");
	this._prevMonthTitle = ((config && config["prevMonthTitle"]) ? config["prevMonthTitle"] : "Previous Month");
	this._nextMonthTitle = ((config && config["nextMonthTitle"]) ? config["nextMonthTitle"] : "Next Month");
	this._nextYearTitle = ((config && config["nextYearTitle"]) ? config["nextYearTitle"] : "Next Year");
	this._prevYearHTML = ((config && config["prevYearHTML"]) ? config["prevYearHTML"] : "&lt;&lt;");
	this._prevMonthHTML = ((config && config["prevMonthHTML"]) ? config["prevMonthHTML"] : "&lt;");
	this._nextMonthHTML = ((config && config["nextMonthHTML"]) ? config["nextMonthHTML"] : "&gt;");
	this._nextYearHTML = ((config && config["nextYearHTML"]) ? config["nextYearHTML"] : "&gt;&gt;");
	this._highLightDates = ((config && config["highLightDates"]) ? config["highLightDates"] : []);
};

RISE.DatePicker.prototype = {
	prefix: "riseDatePicker", 
	fldToID: function(fld) {
		var s = [];
		s[s.length] = this.prefix;
		s[s.length] = this.idx.toString();
		s[s.length] = '_';
		s[s.length] = fld;
		return s.join('');
	}, 
	idToFld: function(id) {
		var s = id.split('_');
		return ((s.length == 2) ? s[1] : null);
	}, 
	htmlEncode: function(s) {
		if (s && typeof(s) == "string") {
			return s.replace(/\"/g, "&quot;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
		} 
		return s;
	}, 
	isSameDate: function(d1, d2) {
		try {
			return (d1.getFullYear() == d2.getFullYear() && d1.getMonth() == d2.getMonth() && d1.getDate() == d2.getDate());
		} catch(ex) {}
		return false;
	}, 
	highLightDate: function(date) {
		try {
			for(var i=0; i<this._highLightDates.length; i++) {
				if(this.isSameDate(date, this._highLightDates[i]))
					return true;
			}
		} catch(ex) {}
		return false;
	}, 
	render: function() {
		if(this.domEl && this._date) {
			var self = this;
			var html = [];
			html[html.length] = '<table cellpadding="0" cellspacing="0" class="datePicker">';
			html[html.length] = '    <tr>';
			html[html.length] = '        <td>';
			html[html.length] = '            <table cellpadding="0" cellspacing="0" class="dpNavH">';
			html[html.length] = '                <tr>';
			html[html.length] = '                    <td id="'+this.fldToID("NavPrevYear")+'" class="dpNavPrevYear" title="' + this._prevYearTitle + '">' + this._prevYearHTML + '</td>';
			html[html.length] = '                    <td id="'+this.fldToID("NavPrevMonth")+'" class="dpNavPrevMonth" title="' + this._prevMonthTitle + '">' + this._prevMonthHTML + '</td>';
			html[html.length] = '                    <td id="'+this.fldToID("NavInfo")+'" class="dpNavInfo">' + this._months[this._date.getMonth()].substring(0, this._shortMonthChars) + '&nbsp;' + this._date.getFullYear().toString() + '</td>';
			html[html.length] = '                    <td id="'+this.fldToID("NavNextMonth")+'" class="dpNavNextMonth" title="' + this._nextMonthTitle + '">' + this._nextMonthHTML + '</td>';
			html[html.length] = '                    <td id="'+this.fldToID("NavNextYear")+'" class="dpNavNextYear" title="' + this._nextYearTitle + '">' + this._nextYearHTML + '</td>';
			html[html.length] = '                </tr>';
			html[html.length] = '            </table>';
			html[html.length] = '        </td>';
			html[html.length] = '    </tr>';
			html[html.length] = '    <tr>';
			html[html.length] = '        <td>';
			html[html.length] = '            <table cellpadding="0" cellspacing="0" class="dpMonth">';
			html[html.length] = '                <tr class="dpTitle">';
			for(var day=0; day<7; day++) {
				html[html.length] = '                    <td class="' + this._dayTitleCSSClasses[(day + this._firstDayInWeek) % 7] + '">' + this._days[(day + this._firstDayInWeek) % 7].substring(0, this._shortDayChars)  + '</td>';
			}
			html[html.length] = '                </tr>';
			var cursor = new Date(this._date.getFullYear(), this._date.getMonth(), 1);
			cursor.setTime(cursor.getTime() + ((this._firstDayInWeek - (cursor.getDay() || 7))*24*3600*1000));
			for(var week=0; week<6; week++) {
				html[html.length] = '                <tr>';
				for(var day=0; day<7; day++) {
					var curMonth = (cursor.getMonth() == this._date.getMonth());
					var today = curMonth && this.isSameDate(cursor, new Date());
					var isStartDate = curMonth && this.isSameDate(cursor, this._startDate);
					var highLight = curMonth && this.highLightDate(cursor);
					var cssClass = ((curMonth) ? this._dayCSSClasses[(day + this._firstDayInWeek) % 7] : "dpEm") + ((today) ? " dpToday":"") + ((isStartDate) ? " dpStartDate":"") + ((highLight) ? " dpHighLight":"");
					html[html.length] = '<td  class="' + cssClass + '"' + ((curMonth) ? " id=\"" + this.fldToID(cursor.getDate().toString()) + "\"":"") + '>';
					if(curMonth)
						html[html.length] = cursor.getDate().toString();
					html[html.length] = '</td>';
					cursor.setTime(cursor.getTime() + (24*3600*1000));
				}
				html[html.length] = '                </tr>';
			}
			html[html.length] = '            </table>';
			html[html.length] = '        </td>';
			html[html.length] = '    </tr>';
			if(this._closeCallback) {
			html[html.length] = '    <tr>';
			html[html.length] = '        <td class="dpNavClose" id="'+this.fldToID("CloseEvt")+'">' + this._closeHTML + '</td>';
			html[html.length] = '    </tr>';
			}
			html[html.length] = '</table>';
			this.domEl.innerHTML = html.join("");
			
			for(var i=1; i<=31; i++) {
				var el = document.getElementById(this.fldToID(i.toString()));
				if(el) {
					el.datePickerSelDay = i;
					el.onclick = function() {
						var selDate = new Date(self._date.getFullYear(), self._date.getMonth(), this.datePickerSelDay);
						if(self._selectCallback){
							if (self._selectCallbackContext) self._selectCallback.call(self._selectCallbackContext, selDate);
							else self._selectCallback(selDate);
						}						
					};
				} else break;
			}
			var closeEl = document.getElementById(this.fldToID("CloseEvt"));
			if(closeEl) {
				closeEl.onclick = function() {
					if(self._closeCallback) {
						if (self._closeCallbackContext) self._closeCallback.call(self._closeCallbackContext);
						else self._closeCallback();
					}	
				};
			}
			document.getElementById(self.fldToID("NavPrevYear")).onclick = function() { 
				self._date.setFullYear(self._date.getFullYear()-1); 
				self.render();
			};
			
			document.getElementById(self.fldToID("NavPrevMonth")).onclick = function() { 
				if(self._date.getMonth() == 0) {
					self._date.setFullYear(self._date.getFullYear()-1);
					self._date.setMonth(11);
				} else {
					self._date.setMonth(self._date.getMonth() - 1);
				}
				self.render();
			};
			
			document.getElementById(self.fldToID("NavNextMonth")).onclick = function() { 
				if(self._date.getMonth() == 11) {
					self._date.setFullYear(self._date.getFullYear()+1);
					self._date.setMonth(0);
				} else {
					self._date.setMonth(self._date.getMonth() + 1);
				}
				self.render();
			};
			
			document.getElementById(self.fldToID("NavNextYear")).onclick = function() { 
				self._date.setFullYear(self._date.getFullYear()+1);
				self.render();
			};
		}
	}
};
