﻿var RISE = RISE || {};

RISE.idx = (RISE.idx || 1);
RISE.newIdx = (RISE.newIdx || function(){
	RISE.idx++;
	return RISE.idx;
});

RISE.PropertyGrid = function() {
	this.groups = {};
	this.idx = RISE.newIdx();
};

RISE.PropertyGrid.prototype = {
	prefix: "pg", 
	idx: 1, 
	init: function() {
		this.groups = {};
	}, 
	addProperty: function(groupName, property){
		if(!this.groups[groupName]){
			this.groups[groupName] = { "name": groupName, "props": {} };
		}
		if (property.name) {
			this.groups[groupName].props[property.name] = property;
		}
	}, 
	htmlEncode: function(s){
		if (s && typeof(s) == "string") {
			return s.replace(/\"/g, "&quot;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
		} 
		return s;
	}, 
	el: function(propName){
	    return document.getElementById(this._makePropertyID(propName));
	}, 
	_renderOptionalArgs: function (args){
		var s = [];
		try {
			if(typeof(args) != "undefined" && args){
				for (var arg in args) {
					var c = [];
					switch(typeof(args[arg])){
						case "string":
							c[c.length] = "'";
							c[c.length] = args[arg];
							c[c.length] = "'";
						break;

						case "boolean":
							c[c.length] = args[arg].toString();
						break;

						case "number":
							c[c.length] = args[arg].toString();
						break;

						default:
							c[c.length] = "''";
						break;
					}
					s[s.length] = c.join("");
				}
			}
		} catch(ex){}
		return s.join(", ");
	}, 
	_renderOptionalArgsAsJsonString: function (args){
		var s = [];
		try {
			if(typeof(args) != "undefined" && args){
				for (var arg in args) {
					switch(typeof(args[arg])){
						case "string":
							s[s.length] = arg + ":'" + args[arg] + "'";
						break;

						case "boolean":
							s[s.length] = arg + ":" + args[arg].toString();
						break;

						case "number":
							s[s.length] = arg + ":" + args[arg].toString();
						break;
					}
				}
			}
		} catch(ex){}
		return "{" + s.join(", ") + "}";
	}, 
	_renderLabelInner: function (property){
		var s = [];
		s[s.length] = "<div";
		if(property["style"]){
			s[s.length] = " style=\"";
			s[s.length] = property["style"];
			s[s.length] = "\"";
		}
		if(property["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = " id=\"";
		s[s.length] = this._makePropertyID(property["name"]);
		s[s.length] = "\"";		
		s[s.length] = ">";
		s[s.length] = ((property["value"] || property["value"] == 0) ? this.htmlEncode(property["value"]): "");
		s[s.length] = "</div>";
		return s.join("");
	}, 
	_renderCustomInner: function (property){
		var s = [];
		s[s.length] = "<div";
		if(property["style"]){
			s[s.length] = " style=\"";
			s[s.length] = property["style"];
			s[s.length] = "\"";
		}
		if(property["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = " id=\"";
		s[s.length] = this._makePropertyID(property["name"]);
		s[s.length] = "\"";
		s[s.length] = ">";
		s[s.length] = ((property["value"]) ? property["value"]: "");
		s[s.length] = "</div>";
		return s.join("");
	}, 
	_renderTextboxInner: function(property){
		var s = [];
		s[s.length] = "<input type=\"text\" class=\"propTextBoxValue\" value=\"";
		s[s.length] = ((property["value"] || property["value"] == 0) ? this.htmlEncode(property["value"]): "");
		s[s.length] = "\"";
		s[s.length] = ((property["readonly"]) ? " DISABLED=TRUE " : "");
		s[s.length] = " id=\"";
		s[s.length] = this._makePropertyID(property["name"]);
		s[s.length] = "\"";
		if(property["callback"]){
			s[s.length] = " " + ((property["event"]) ? property["event"] : "onchange") + "=\"";
			s[s.length] = property["callback"];
			s[s.length] = "(this";
			if(property["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(property["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(property["style"]){
			s[s.length] = " style=\"";
			s[s.length] = property["style"];
			s[s.length] = "\"";
		}		
		if(property["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = " />";
		return s.join("");
	}, 
	_renderPasswordInner: function(property){
		var s = [];
		s[s.length] = "<input type=\"password\" class=\"propTextBoxValue\" value=\"";
		s[s.length] = ((property["value"] || property["value"] == 0) ? this.htmlEncode(property["value"]): "");
		s[s.length] = "\"";
		s[s.length] = ((property["readonly"]) ? " DISABLED=TRUE " : "");
		s[s.length] = " id=\"";
		s[s.length] = this._makePropertyID(property["name"]);
		s[s.length] = "\"";
		if(property["callback"]){
			s[s.length] = " " + ((property["event"]) ? property["event"] : "onchange") + "=\"";
			s[s.length] = property["callback"];
			s[s.length] = "(this";
			if(property["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(property["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(property["style"]){
			s[s.length] = " style=\"";
			s[s.length] = property["style"];
			s[s.length] = "\"";
		}		
		if(property["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = " />";
		return s.join("");
	}, 
	_renderTextareaInner: function(property){
		var s = [];
		s[s.length] = "<textarea cols=\"20\" rows=\"2\" class=\"propTextAreaValue\"";
		s[s.length] = ((property["readonly"]) ? " DISABLED=TRUE " : "");
		s[s.length] = " id=\"";
		s[s.length] = this._makePropertyID(property["name"]);
		s[s.length] = "\"";
		if(property["callback"]){
			s[s.length] = " " + ((property["event"]) ? property["event"] : "onchange") + "=\"";
			s[s.length] = property["callback"];
			s[s.length] = "(this";
			if(property["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(property["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(property["style"]){
			s[s.length] = " style=\"";
			s[s.length] = property["style"];
			s[s.length] = "\"";
		}		
		if(property["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = ">";
		s[s.length] = ((property["value"] || property["value"] == 0) ? this.htmlEncode(property["value"]): "");
		s[s.length] = "</textarea>";
		return s.join("");
	}, 
	_renderCheckboxInner: function(property){
		var s = [];
		s[s.length] = "<input type=\"checkbox\" class=\"propCheckBoxValue\"";
		s[s.length] = ((property["value"]) ? " CHECKED=TRUE ": "");
		s[s.length] = ((property["readonly"]) ? " DISABLED=TRUE " : "");
		s[s.length] = " id=\"";
		s[s.length] = this._makePropertyID(property["name"]);
		s[s.length] = "\"";
		if(property["callback"]){
			s[s.length] = " " + ((property["event"]) ? property["event"] : "onclick") + "=\"";
			s[s.length] = property["callback"];
			s[s.length] = "(this";
			if(property["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(property["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(property["style"]){
			s[s.length] = " style=\"";
			s[s.length] = property["style"];
			s[s.length] = "\"";
		}		
		if(property["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = " />";
		return s.join("");
	}, 
	_renderLinkInner: function(property){
		var s = [];
		s[s.length] = "<a href=\"#\" class=\"propLinkValue\"";
		if(property["target"]){
			s[s.length] = " target=\"";
			s[s.length] = this.htmlEncode(property["target"]);
			s[s.length] = "\"";
		}
		s[s.length] = " id=\"";
		s[s.length] = this._makePropertyID(property["name"]);
		s[s.length] = "\"";
		if(property["callback"]){
			s[s.length] = " " + ((property["event"]) ? property["event"] : "onclick") + "=\"return ";
			s[s.length] = property["callback"];
			s[s.length] = "(this";
			if(property["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(property["callbackArgs"]);
			}
			s[s.length] = ") || false\"";
		}
		if(property["style"]){
			s[s.length] = " style=\"";
			s[s.length] = property["style"];
			s[s.length] = "\"";
		}		
		if(property["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = ">";
		s[s.length] = ((property["value"] || property["value"] == 0) ? this.htmlEncode(property["value"]): "");
		s[s.length] = "</a>";
		return s.join("");
	}, 
	_renderFileUploadInner: function(property){
		var s = [];
		if(property["name"] && property["action"] && property["target"] && property["uploadTicket"] && property["uploadContentID"] && property["uploadCallback"]){
			s[s.length] = "<form name=\"";
			s[s.length] = this._makePropertyFormID(property["name"]);
			s[s.length] = "\" id=\"";
			s[s.length] = this._makePropertyFormID(property["name"]);			
			s[s.length] = "\" action=\"";
			s[s.length] = property["action"];
			s[s.length] = "\" method=\"post\" target=\"";
			s[s.length] = property["target"];
			s[s.length] = "\" enctype=\"multipart/form-data\">";
			s[s.length] = "<input type=\"hidden\" name=\"ticket\" value=\"";
			s[s.length] = property["uploadTicket"];
			s[s.length] = "\" />";
			s[s.length] = "<input type=\"hidden\" name=\"content\" value=\"";
			s[s.length] = property["uploadContentID"];
			s[s.length] = "\" />";
			s[s.length] = "<input type=\"hidden\" name=\"callback\" value=\"";
			s[s.length] = property["uploadCallback"];
			s[s.length] = "\" />";
			s[s.length] = "<input type=\"hidden\" name=\"callbackArgs\" value=\"'";
			s[s.length] = this._makeUploadProgressID(property["name"]);
			s[s.length] = "'\" />";
			s[s.length] = "<input type=\"file\" class=\"propFileUploadValue\"";
			s[s.length] = " id=\"";
			s[s.length] = this._makePropertyID(property["name"]);
			s[s.length] = "\" name=\"";
			s[s.length] = this._makePropertyID(property["name"]);
			s[s.length] = "\"";
			if(property["callback"]){
				s[s.length] = " " + ((property["event"]) ? property["event"] : "onchange") + "=\"";
				s[s.length] = property["callback"];
				s[s.length] = "(this, '";
				s[s.length] = this._makePropertyFormID(property["name"]);
				s[s.length] = "', '";
				s[s.length] = this._makeUploadProgressID(property["name"]);
				s[s.length] = "'";
				if(property["callbackArgs"]){
					s[s.length] = ", ";
					s[s.length] = this._renderOptionalArgsAsJsonString(property["callbackArgs"]);
				}
				s[s.length] = ")\"";
			}
			if(property["style"]){
				s[s.length] = " style=\"";
				s[s.length] = property["style"];
				s[s.length] = "\"";
			}
			if(property["title"]){
				s[s.length] = " title=\"";
				s[s.length] = this.htmlEncode(property["title"]);
				s[s.length] = "\"";
			}
			s[s.length] = " /><div id=\"";
			s[s.length] = this._makeUploadProgressID(property["name"]);
			s[s.length] = "\"></div></form>";
		}
		return s.join("");
	}, 
	_renderImageInner: function (property){
		var s = [];
		s[s.length] = "<img src=\"";
		s[s.length] = ((property["src"]) ? property["src"]: "");
		s[s.length] = "\"";
		if(property["alt"]){
			s[s.length] = " alt=\"";
			s[s.length] = this.htmlEncode(property["alt"]);
			s[s.length] = "\"";
		}
		if(property["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["title"]);
			s[s.length] = "\"";
		}
		if(property["width"]){
			s[s.length] = " width=\"";
			s[s.length] = property["width"];
			s[s.length] = "\"";
		}
		if(property["height"]){
			s[s.length] = " height=\"";
			s[s.length] = property["height"];
			s[s.length] = "\"";
		}
		if(property["style"]){
			s[s.length] = " style=\"";
			s[s.length] = property["style"];
			s[s.length] = "\"";
		}
		s[s.length] = " id=\"";
		s[s.length] = this._makePropertyID(property["name"]);
		s[s.length] = "\"";
		if(property["callback"]){
			s[s.length] = " " + ((property["event"]) ? property["event"] : "onblur") + "=\"";
			s[s.length] = property["callback"];
			s[s.length] = "(this";
			if(property["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(property["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}		
		s[s.length] = " />";
		return s.join("");
	}, 
	_renderDropdownInner: function(property){
		var s = [];
		s[s.length] = "<select class=\"propDropdownValue\"";
		s[s.length] = " id=\"";
		s[s.length] = this._makePropertyID(property["name"]);
		s[s.length] = "\"";
		s[s.length] = ((property["readonly"]) ? " DISABLED=TRUE " : "");
		if(property["callback"]){
			s[s.length] = " " + ((property["event"]) ? property["event"] : "onchange") + "=\"";
			s[s.length] = property["callback"];
			s[s.length] = "(this";
			if(property["callbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(property["callbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		if(property["style"]){
			s[s.length] = " style=\"";
			s[s.length] = property["style"];
			s[s.length] = "\"";
		}		
		if(property["title"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["title"]);
			s[s.length] = "\"";
		}
		s[s.length] = ">";
		if(property.options && property.options.length){
			for(var i=0; i<property.options.length; i++){
				if(typeof(property.options[i].value) !== "undefined" && typeof(property.options[i].name) !== "undefined" ){
					s[s.length] = "<option value=\"";
					s[s.length] = this.htmlEncode(property.options[i].value);
					s[s.length] = "\"";
					if(property["value"] == property.options[i].value){
						s[s.length] = " SELECTED=\"TRUE\"";
					}
					s[s.length] = ">";
					s[s.length] = this.htmlEncode(property.options[i].name);
					s[s.length] = "</option>";
				}
			}
		}
		s[s.length] = "</select>";
		return s.join("");
	}, 
	_renderProperty: function(index, property){
		var s = [];
		s[s.length] = "<tr class=\"";
		s[s.length] = ((index % 2 ==  0) ? "propEven":"propOdd");
		s[s.length] = "\"";
		if(property["rowStyle"]){
			s[s.length] = " style=\"";
			s[s.length] = property["rowStyle"];
			s[s.length] = "\"";
		}
		s[s.length] = "><td class=\"propName\"";
		if(property["labelStyle"]){
			s[s.length] = " style=\"";
			s[s.length] = property["labelStyle"];
			s[s.length] = "\"";
		}
		if(property["labelTitle"]){
			s[s.length] = " title=\"";
			s[s.length] = this.htmlEncode(property["labelTitle"]);
			s[s.length] = "\"";
		}
		if(property["labelCallback"]){
			s[s.length] = " " + ((property["labelEvent"]) ? property["labelEvent"] : "onclick") + "=\"";
			s[s.length] = property["labelCallback"];
			s[s.length] = "(this";
			if(property["labelCallbackArgs"]){
				s[s.length] = ", ";
				s[s.length] = this._renderOptionalArgsAsJsonString(property["labelCallbackArgs"]);
			}
			s[s.length] = ")\"";
		}
		s[s.length] = " id=\"";
		s[s.length] = this._makeLabelID(property["name"]);
		s[s.length] = "\">";
		s[s.length] = ((property["label"] || property["label"] == 0) ? ((property["labelRaw"]) ? property["label"] : this.htmlEncode(property["label"])): "");
		s[s.length] = "</td><td class=\"propValue\">";
		switch(property.type){
			case "label":
				s[s.length] = this._renderLabelInner(property);
			break;
			
			case "custom":
				s[s.length] = this._renderCustomInner(property);
			break;

			case "textBox":
				s[s.length] = this._renderTextboxInner(property);
			break;
			
			case "textArea":
				s[s.length] = this._renderTextareaInner(property);
			break;
			
			case "checkBox":
				s[s.length] = this._renderCheckboxInner(property);
			break;

			case "link":
				s[s.length] = this._renderLinkInner(property);
			break;

			case "fileUpload":
				s[s.length] = this._renderFileUploadInner(property);
			break;

			case "image":
				s[s.length] = this._renderImageInner(property);
			break;
			
			case "dropdown":
				s[s.length] = this._renderDropdownInner(property);
			break;

			case "password":
				s[s.length] = this._renderPasswordInner(property);
			break;
		}
		s[s.length] = "</td><td class=\"propPadding\">&nbsp;</td></tr>";
		return s.join("");	
	}, 
	_renderGroup: function(groupName){
		var s = [];
		s[s.length] = "<tr class=\"propGroup\"><td class=\"propGroupCell\" colspan=\"3\">";
		s[s.length] = (groupName ? this.htmlEncode(groupName): "");
		s[s.length] = "</td></tr>";
		return s.join("");
	}, 
	_makeID: function(propertyName, type){
		var s = [];
		s[s.length] = this.prefix;
		s[s.length] = this.idx.toString();
		s[s.length] = "_";
		s[s.length] = (type || "property");
		s[s.length] = "_";
		s[s.length] = propertyName;
		return s.join("");
	}, 
	_makeLabelID: function(propertyName){
		return this._makeID(propertyName, "label");
	}, 
	_makePropertyID: function(propertyName){
		return this._makeID(propertyName, "property");
	}, 
	_makePropertyFormID: function(propertyName){
		return this._makeID(propertyName, "form");
	}, 
	_makeUploadProgressID: function(propertyName){
		return this._makeID(propertyName, "uploadProgress");
	}, 
	MarkupIDToPropertyName: function(markupID){
		var s = markupID.split('_');
		if(s.length == 3){
			return s[2];
		}
		return null;
	}, 
	render: function(config){
		var html = [];
		html[html.length] = "<table class=\"propGrid\" cellpadding=\"0\" cellspacing=\"0\"";
		if(config && config["style"]) {
			html[html.length] = " style=\"";
			html[html.length] = config["style"];
			html[html.length] = "\"";
		}
		html[html.length] = ">";
		for (var groupName in this.groups) {
			html[html.length] = this._renderGroup(groupName);
			var propIndex = 0;
			for (var propName in this.groups[groupName].props) {
				if(this.groups[groupName].props[propName].type){
					switch(this.groups[groupName].props[propName].type){
						case "label":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;
						
						case "custom":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;

						case "textBox":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;
						
						case "textArea":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;
						
						case "checkBox":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;

						case "link":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;

						case "fileUpload":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;

						case "image":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;
						
						case "dropdown":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;

						case "password":
							html[html.length] = this._renderProperty(propIndex++, this.groups[groupName].props[propName]);
						break;
					}
				}
			}
		}
		html[html.length] = "</table>";
		return html.join("");
	}
};
