﻿var RISE = RISE || {};

RISE.idx = (RISE.idx || 1);
RISE.newIdx = (RISE.newIdx || function(){
	RISE.idx++;
	return RISE.idx;
});

RISE.Toolbar = function(domEl, config) {
	this.idx = RISE.newIdx();
	this.domEl = ((typeof(domEl) == "string") ? document.getElementById(domEl) : domEl);
	this.imageWidth = ((config && config["imageWidth"]) ? config["imageWidth"] : 16);
	this.imageHeight = ((config && config["imageHeight"]) ? config["imageHeight"] : 16);
	this.imageBlocks = ((config && config["imageBlocks"]) ? config["imageBlocks"] : []); // [[{src:"", alt:"", title: "", style: "", onclick: null, cbContext: null}]]
	this.rightBlocks = ((config && config["rightBlocks"]) ? config["rightBlocks"] : []); // [[{src:"", alt:"", title: "", style: "", onclick: null, cbContext: null}]]
};

RISE.Toolbar.prototype = {
	prefix: "riseToolbar", 
	fldToID: function(fld) {
		var s = [];
		s[s.length] = this.prefix;
		s[s.length] = this.idx.toString();
		s[s.length] = '_';
		s[s.length] = fld;
		return s.join('');
	}, 
	idToFld: function(id) {
		var s = id.split('_');
		return ((s.length == 2) ? s[1] : null);
	}, 
	htmlEncode: function(s) {
		if (s && typeof(s) == "string") {
			return s.replace(/\"/g, "&quot;").replace(/</g, "&lt;").replace(/>/g, "&gt;");
		} 
		return s;
	}, 
	render: function() {
		if(this.domEl && this.imageBlocks && this.imageBlocks.length) {
			var self = this;
			var html = [];
			var imgID = 1;
			html[html.length] = '<table cellpadding="0" cellspacing="0" class="riseToolbarOuterTable">';
			html[html.length] = '<tr class="riseToolbarOuterRow">';
			html[html.length] = '<td class="riseToolbarOuterCell">';
			html[html.length] = '<table cellpadding="0" cellspacing="0" class="riseToolbarInnerTable">';
			html[html.length] = '<tr class="riseToolbarInnerRow">';
			html[html.length] = '<td class="riseToolbarInnerLeftCell"></td>';
			for(var b=0; b<this.imageBlocks.length; b++) {
			    for(var i=0; i<this.imageBlocks[b].length; i++){
				    this.imageBlocks[b][i]["id"] = this.fldToID((imgID++).toString());
				    html[html.length] = '<td class="riseToolbarImageCell">';
				    html[html.length] = '<img id="' + this.imageBlocks[b][i]["id"] + '" class="riseToolbarImage" src="' + (this.imageBlocks[b][i]["src"] || "") + '" width="' + (this.imageBlocks[b][i]["width"] || this.imageWidth.toString()) +'" height="' + (this.imageBlocks[b][i]["height"] || this.imageHeight.toString()) +'" alt="' + (this.imageBlocks[b][i]["alt"] || "") + '" title="' + (this.imageBlocks[b][i]["title"] || "") + '"  style="' + (this.imageBlocks[b][i]["style"] || "") + '" />';
				    html[html.length] = '</td>';
			    }
			    if(b != this.imageBlocks.length-1){
				    html[html.length] = '<td class="riseToolbarDelimiterCell"><div class="riseToolbarDelimiter" style="height: ' + this.imageHeight.toString() + 'px;"></div></td>';
			    }
			}
			html[html.length] = '<td class="riseToolbarInnerRightCell"></td>';
			html[html.length] = '</tr>';
			html[html.length] = '</table>';
			html[html.length] = '</td>';
			if(this.rightBlocks.length > 0){
			    html[html.length] = '<td class="riseToolbarShiftCell"></td><td class="riseToolbarRightOuterCell">';
			    html[html.length] = '<table cellpadding="0" cellspacing="0" class="riseToolbarInnerTable">';
			    html[html.length] = '<tr class="riseToolbarInnerRow">';
			    html[html.length] = '<td class="riseToolbarInnerLeftCell"></td>';
			    for(var b=0; b<this.rightBlocks.length; b++) {
			        for(var i=0; i<this.rightBlocks[b].length; i++){
				        this.rightBlocks[b][i]["id"] = this.fldToID((imgID++).toString());
				        html[html.length] = '<td class="riseToolbarImageCell">';
				        html[html.length] = '<img id="' + this.rightBlocks[b][i]["id"] + '" class="riseToolbarImage" src="' + (this.rightBlocks[b][i]["src"] || "") + '" width="' + (this.rightBlocks[b][i]["width"] || this.imageWidth.toString()) +'" height="' + (this.rightBlocks[b][i]["height"] || this.imageHeight.toString()) +'" alt="' + (this.rightBlocks[b][i]["alt"] || "") + '" title="' + (this.rightBlocks[b][i]["title"] || "") + '"  style="' + (this.rightBlocks[b][i]["style"] || "") + '" />';
				        html[html.length] = '</td>';
			        }
			        if(b != this.rightBlocks.length-1){
				        html[html.length] = '<td class="riseToolbarDelimiterCell"><div class="riseToolbarDelimiter" style="height: ' + this.imageHeight.toString() + 'px;"></div></td>';
			        }
			    }
			    html[html.length] = '<td class="riseToolbarInnerRightCell"></td>';
			    html[html.length] = '</tr>';
			    html[html.length] = '</table>';
			    html[html.length] = '</td>';
			}
			html[html.length] = '</tr>';
			html[html.length] = '</table>';
			this.domEl.innerHTML = html.join("");
			
			var cbClick = {};
			var cbMouseOver = {};
			var cbMouseOut = {};
			
			for(var b=0; b<this.imageBlocks.length; b++) {
				for(var i=0; i<this.imageBlocks[b].length; i++){
					var el = document.getElementById(this.imageBlocks[b][i]["id"]);
					if(el){
						var self = this;
						if(self.imageBlocks[b][i]["onclick"]){
							cbClick[el.id] = { cb: self.imageBlocks[b][i]["onclick"], cbc: self.imageBlocks[b][i]["cbContext"] || null };
							el.onclick = function(ev) {
								var evt = ev || window.event;
								if(cbClick[this.id]["cbc"]) cbClick[this.id]["cb"].call(cbClick[this.id]["cbc"], this, evt);
								else cbClick[this.id]["cb"](this, evt);
							};
						}
						if(self.imageBlocks[b][i]["onmouseover"]){
							cbMouseOver[el.id] = { cb: self.imageBlocks[b][i]["onmouseover"], cbc: self.imageBlocks[b][i]["cbContext"] || null };
							el.onmouseover = function(ev) {
								var evt = ev || window.event;
								if(cbMouseOver[this.id]["cbc"]) cbMouseOver[this.id]["cb"].call(cbMouseOver[this.id]["cbc"], this, evt);
								else cbMouseOver[this.id]["cb"](this, evt);
							};
						}
						if(self.imageBlocks[b][i]["onmouseout"]){
							cbMouseOut[el.id] = { cb: self.imageBlocks[b][i]["onmouseout"], cbc: self.imageBlocks[b][i]["cbContext"] || null };
							el.onmouseout = function(ev) {
								var evt = ev || window.event;
								if(cbMouseOut[this.id]["cbc"]) cbMouseOut[this.id]["cb"].call(cbMouseOut[this.id]["cbc"], this, evt);
								else cbMouseOut[this.id]["cb"](this, evt);
							};
						}
					}
				}
			}
			for(var b=0; b<this.rightBlocks.length; b++) {
				for(var i=0; i<this.rightBlocks[b].length; i++){
					var el = document.getElementById(this.rightBlocks[b][i]["id"]);
					if(el){
						var self = this;
						if(self.rightBlocks[b][i]["onclick"]){
							cbClick[el.id] = { cb: self.rightBlocks[b][i]["onclick"], cbc: self.rightBlocks[b][i]["cbContext"] || null };
							el.onclick = function(ev) {
								var evt = ev || window.event;
								if(cbClick[this.id]["cbc"]) cbClick[this.id]["cb"].call(cbClick[this.id]["cbc"], this, evt);
								else cbClick[this.id]["cb"](this, evt);
							};
						}
						if(self.rightBlocks[b][i]["onmouseover"]){
							cbMouseOver[el.id] = { cb: self.rightBlocks[b][i]["onmouseover"], cbc: self.rightBlocks[b][i]["cbContext"] || null };
							el.onmouseover = function(ev) {
								var evt = ev || window.event;
								if(cbMouseOver[this.id]["cbc"]) cbMouseOver[this.id]["cb"].call(cbMouseOver[this.id]["cbc"], this, evt);
								else cbMouseOver[this.id]["cb"](this, evt);
							};
						}
						if(self.rightBlocks[b][i]["onmouseout"]){
							cbMouseOut[el.id] = { cb: self.rightBlocks[b][i]["onmouseout"], cbc: self.rightBlocks[b][i]["cbContext"] || null };
							el.onmouseout = function(ev) {
								var evt = ev || window.event;
								if(cbMouseOut[this.id]["cbc"]) cbMouseOut[this.id]["cb"].call(cbMouseOut[this.id]["cbc"], this, evt);
								else cbMouseOut[this.id]["cb"](this, evt);
							};
						}
					}
				}
			}
		}
	}
};
