﻿/**
 * CMSImage CMSImage.js file.
 * Developer: RISE to Bloome Software
 */

function CMSImage(editor)
{
    var cfg = editor.config;
    
	cfg.registerButton({
		id        : "cmsimage",
		tooltip   : Xinha._lc("Select CMS Image",'CMSImage'),
		image     : Xinha.getPluginDir('CMSImage') + '/img/CMSImage.png',
		textMode  : false,
		action    : function(editor) { editor._selectCMSImage(); }
	});
	cfg.addToolbarElement("cmsimage", "insertimage", 1);
}

CMSImage._pluginInfo = {
    name          : "CMSImage",
    version       : "1.0",
    developer     : "RISE to Bloome Software",
    developer_url : "http://www.risetobloome.com"
};

Xinha.Config.prototype.CMSImage =
{
	"thumbnail" : "thumbnail.aspx?content=", 
	"image": "display.aspx?content=", 
	"width": 660, 
	"height": 490
};

Xinha.prototype._selectCMSImage = function(content) {
	var self = this;
	if(!this.cmsImageDialog){
		var htm = '<h1>' + Xinha._lc("Select Image",'CMSImage') + '</h1><div style=\"padding: 10px;\"><table><tr><td>' + Xinha._lc("Search",'CMSImage') + '</td><td>&nbsp;</td><td><input id="cmsImageQryTxt" type="text" value="" style="width:300px;" /></td><td>&nbsp;</td><td><input id="cmsImageSearchButton" type="button" value="' + Xinha._lc("Search",'CMSImage') + '" /></td></tr></table><div id=\"cmsImageResultsContainer\" style="margin-top: 10px; height: ' + (self.config.CMSImage.height - 80) + 'px; width:100%; overflow:auto;"><div id="cmsImageResults"></div></div></div>';
		this.cmsImageDialog = new Xinha.Dialog(this, htm, 'Xinha',{width: self.config.CMSImage.width, height: self.config.CMSImage.height});
		this.cmsImageDialog.getElementById('cmsImageResults').onclick = function(evt) {
			evt = evt || window.event;
			if(evt) {
				var el = evt.target || evt.srcElement;
				if(el && el.tagName.toLowerCase() == 'img' && el.name){
					IEdit.GetContentDetails(					
						{"ticket": null, "ContentID": el.name},
						function(result, args){
							self.cmsImageDialog.hide();
							// result contains: ContentID (int), ContentSUID (string), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), ContentAbstract (text_or_null), EditedDate (datetime), EditedBy (string), SiteID (int), SiteName (string), ParentID (int_or_null), friendlyName (string), hasArticle (bool), ArticleID (int), ArticleEditor (string_or_null), ArticleData (text_or_null), ArticleHint (string_or_null), hasDocument (bool), DocumentID (int), DocumentMimeType (string), hasImage (bool), ImageID (int), ImageMimeType (string), ImageWidth (int), ImageHeight (int), ImageAlternative (string_or_null), hasLink (bool), LinkID (int), LinkTargetURI (string_or_null), LinkTargetURL (string_or_null), hasMessage (bool), MessageID (int), MessageSource (string_or_null), MessageData (text_or_null)
							var s = [];

							if (Xinha.is_ie) {
								var sel = self.getSelection();
								var range = self.createRange(sel);
								if(sel.type == "Control"){
								    var curparent = range.item(0).parentNode;
								    var oldChildren = [];
								    for(var i=0; i<curparent.childNodes.length;i++){
								        oldChildren[i] = curparent.childNodes[i];
								    }
								    self._doc.execCommand("insertimage", false, self.config.CMSImage.image + result["ContentID"]);
								    var isOld = function(domEl){
								        for(var i=0; i<oldChildren.length; i++){
								            if(oldChildren[i] === domEl)
								                return true;
								        }
								        return false;
								    };
								    var img = null;
								    for(var i=0; i<curparent.childNodes.length;i++){
								        if(!isOld(curparent.childNodes[i])) {
								            img = ((curparent.childNodes[i].tagName.toLowerCase() == 'img') ? curparent.childNodes[i]:null);
								            break;
								        }
								    }
								    if(img){
								        if(result["ImageWidth"])
									        img.width = result["ImageWidth"];
								        if(result["ImageHeight"])
									        img.height = result["ImageHeight"];
								        img.alt = result["ImageAlternative"] || "";
								    }
								} else {
								    var range = self.createRange(sel);
								    self._doc.execCommand("insertimage", false, self.config.CMSImage.image + result["ContentID"]);
								    var img = range.parentElement();
								    if(result["ImageWidth"])
									    img.width = result["ImageWidth"];
								    if(result["ImageHeight"])
									    img.height = result["ImageHeight"];
								    img.alt = result["ImageAlternative"] || "";
								}
							} else {
								var img = document.createElement('img');
								img.src = self.config.CMSImage.image + result["ContentID"];
								if(result["ImageWidth"])
									img.width = result["ImageWidth"];
								if(result["ImageHeight"])
									img.height = result["ImageHeight"];
								img.alt = result["ImageAlternative"] || "";
								self.insertNodeAtSelection(img);
							}
						},
						function(x, msg, args){
						},
						function(args){
						}
					);
				}
			}
		};
		this.cmsImageDialog.getElementById('cmsImageSearchButton').onclick = function(evt) { 
			var qryStrEl = document.getElementById("cmsImageQryTxt");
			if(qryStrEl){
				IEdit.SearchImageByTitle(
					{"maxRowsToReturn": 100, "ticket": null, "siteID": null, "titleLike": "%" + qryStrEl.value + "%"},
					function(results, args){
					    // results contains: ContentID (int), ContentSUID (string), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), SiteID (int), SiteName (string), SiteRecycleBin (bool), ParentID (int_or_null), ContentAbstract (text_or_null), ImageID (int), ImageMimeType (string), ImageWidth (int), ImageHeight (int), ImageAlternative (string_or_null)
					    var s = [];
						for (var i=0; i<results.length; i++) {
							if(!results[i]["SiteRecycleBin"]){
								s[s.length] = "<div style=\"width: 94px; height: 100px; padding: 4px; float:left; text-align: center;\">";
								s[s.length] = "<div>";
								s[s.length] = "<img name=\"" + results[i]["ContentID"] + "\" src=\"";
								s[s.length] = self.config.CMSImage.thumbnail;
								s[s.length] = results[i]["ContentID"];
								s[s.length] = "\" width=\"64\" height=\"64\""
								s[s.length] = " alt=\"";
								s[s.length] = results[i]["ImageAlternative"] || results[i]["ContentTitle"] || "";
								s[s.length] = " (";
								s[s.length] = results[i]["SiteName"];
								s[s.length] = ")";
								s[s.length] = "\" title=\"";
								s[s.length] = results[i]["ImageAlternative"] || results[i]["ContentTitle"] || "";
								s[s.length] = " (";
								s[s.length] = results[i]["SiteName"];
								s[s.length] = ")";
								s[s.length] = "\" />";
								s[s.length] = "</div>";
								s[s.length] = "<div>";
								if(results[i]["ImageWidth"] && results[i]["ImageWidth"]){
									s[s.length] = results[i]["ImageWidth"];
									s[s.length] = " x ";
									s[s.length] = results[i]["ImageHeight"]; 
								} else { 
									s[s.length] = "&nbsp;";
								}
								s[s.length] = "</div>";
								s[s.length] = "<div style=\"width:100%; text-overflow: ellipsis; overflow: hidden; white-space: nowrap;\">";
								s[s.length] = results[i]["ContentTitle"] || "&nbsp;";
								s[s.length] = "</div></div>";
							}
						}
						if(s.length == 0){
							s[s.length] = Xinha._lc("No images found",'CMSImage');
						}
						document.getElementById("cmsImageResults").innerHTML = s.join("");
					},
					function(x, msg, args){
					},
					function(args){
					}
				);
			}
		};
		this.cmsImageDialog.onresize = function () {
			var resultEl = document.getElementById("cmsImageResultsContainer");
			if(resultEl){
				var newHeight = parseInt(this.height,10) - 80;
				if(newHeight > 0){
					resultEl.style.height = newHeight + "px";
				}
			}
		};
	}
	this.cmsImageDialog.show();
};
