﻿/**
 * CMSLink CMSLink.js file.
 * Developer: RISE to Bloome Software
 */

function CMSLink(editor)
{
    var cfg = editor.config;
    
	cfg.registerButton({
		id        : "cmslink",
		tooltip   : Xinha._lc("Link CMS Content",'CMSLink'),
		image     : Xinha.getPluginDir('CMSLink') + '/img/CMSLink.png',
		textMode  : false,
		action    : function(editor) { editor._selectCMSLink(); }
	});
	cfg.addToolbarElement("cmslink", "createlink", 1);
}

CMSLink._pluginInfo = {
    name          : "CMSLink",
    version       : "1.0",
    developer     : "RISE to Bloome Software",
    developer_url : "http://www.risetobloome.com"
};

Xinha.Config.prototype.CMSLink =
{
	"link": "display.aspx?content=",
	"width": 660, 
	"height": 490
};

Xinha.prototype._selectCMSLink = function(content) {
	var self = this;
	
	var sel = self.getSelection();
	var range = self.createRange(sel);
	var compare = 0;
	if (Xinha.is_ie) {
		compare = ((sel.type == "Control") ? range.length : range.compareEndPoints("StartToEnd", range));
	} else {
		compare = range.compareBoundaryPoints(range.START_TO_END, range);
	}
	if (compare == 0) {
		alert(Xinha._lc("You must select some text, or an image, before making a new link.", 'CMSLink'));
	} else {
		if(!this.cmsLinkDialog){
			var htm = '<h1>' + Xinha._lc("Link CMS Content",'CMSLink') + '</h1><div style=\"padding: 10px;\"><table><tr><td>' + Xinha._lc("Search",'CMSLink') + '</td><td>&nbsp;</td><td><input id="cmsLinkQryTxt" type="text" value="" style="width:300px;" /></td><td>&nbsp;</td><td><input id="cmsLinkSearchButton" type="button" value="' + Xinha._lc("Search",'CMSLink') + '" /></td></tr></table><div id=\"cmsLinkResultsContainer\" style="margin-top: 10px; height: ' + (self.config.CMSLink.height - 80) + 'px; width:100%; overflow:auto;"><div id="cmsLinkResults"></div></div></div>';
			this.cmsLinkDialog = new Xinha.Dialog(this, htm, 'Xinha', {width: self.config.CMSLink.width, height: self.config.CMSLink.height});
			this.cmsLinkDialog.getElementById('cmsLinkResults').onclick = function(evt) {
				evt = evt || window.event;
				if(evt) {
					var el = evt.target || evt.srcElement;
					while(el && el.tagName.toLowerCase() != 'tr'){
						el = el.parentNode;
					}
					if(el && el.tagName.toLowerCase() == 'tr') {
						var contentID = RISE.DataTable.prototype.rowMarkupIDToRowID(el.id);
						if(contentID){
							IEdit.GetContentDetails(
								{"ticket": null, "ContentID": contentID},
								function(result, args){
									self.cmsLinkDialog.hide();
									// result contains: ContentID (int), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), ContentAbstract (text_or_null), EditedDate (datetime), EditedBy (string), SiteID (int), SiteName (string), ParentID (int_or_null), friendlyName (string), hasArticle (bool), ArticleID (int), ArticleEditor (string_or_null), ArticleData (text_or_null), ArticleHint (string_or_null), hasDocument (bool), DocumentID (int), DocumentMimeType (string), hasImage (bool), ImageID (int), ImageMimeType (string), ImageWidth (int), ImageHeight (int), hasLink (bool), LinkID (int), LinkTargetURI (string_or_null), LinkTargetURL (string_or_null), hasMessage (bool), MessageID (int), MessageSource (string_or_null), MessageData (text_or_null)
									try {
										self._doc.execCommand("createlink", false, self.config.CMSLink.link + result["friendlyName"]);
									} catch(e) {}
								},
								function(x, msg, args){
								},
								function(args){
								}
							);					
						}
					}
				}
			};
			this.cmsLinkDialog.getElementById('cmsLinkSearchButton').onclick = function(evt) { 
				var qryStrEl = document.getElementById("cmsLinkQryTxt");
				if(qryStrEl) {
					IEdit.SearchByTitleType(
						{"maxRowsToReturn": 100, "ticket": null, "siteID": null, "titleLike": "%" + qryStrEl.value + "%", "typeLike": "%"},
						function(results, args){
							// results contains: ContentID (int), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), ContentAbstract (text_or_null), SiteID (int), SiteName (string), ParentID (int_or_null)
							var r = [];
							for(var i=0; i<results.length; i++){
								if(!results[i]["SiteRecycleBin"])
									r[r.length] = results[i];
							}
							results = r;
							var dtConfig = {
								rowID: "ContentID", 
								columns: []
							};
							dtConfig.columns[dtConfig.columns.length] = {
								name: "ContentType", 
								label: "", 
								columnType: RISE.DataTable.prototype.columnType.image, 
								style: "width: 20px;"
							}
							dtConfig.columns[dtConfig.columns.length] = {
								name: "SiteName", 
								label: Xinha._lc("Site",'CMSLink'), 
								columnType: RISE.DataTable.prototype.columnType.label
							}
							dtConfig.columns[dtConfig.columns.length] = {
								name: "ContentTitle", 
								label: Xinha._lc("Title",'CMSLink'), 
								columnType: RISE.DataTable.prototype.columnType.label
							}
							var imgDir = Xinha.getPluginDir('CMSLink') + "/img/";
							var dt = new RISE.DataTable(dtConfig);
							var span = dt.span(results);
							for(var r in span){
								if(r != "_span"){
									span[r]["ContentType"]["width"] = "16px";
									span[r]["ContentType"]["height"] = "16px";
									switch(span[r]["ContentType"]["value"]){
										case "None":
											span[r]["ContentType"]["src"] = imgDir + "icon_folder.png";
											span[r]["ContentType"]["alt"] = Xinha._lc("Folder",'CMSLink');
											span[r]["ContentType"]["title"] = Xinha._lc("Folder",'CMSLink');
											break;
										case "Link":
											span[r]["ContentType"]["src"] = imgDir + "icon_link.png";
											span[r]["ContentType"]["alt"] = Xinha._lc("Link",'CMSLink');
											span[r]["ContentType"]["title"] = Xinha._lc("Link",'CMSLink');
											break;
										case "Document":
											span[r]["ContentType"]["src"] = imgDir + "icon_doc.png";
											span[r]["ContentType"]["alt"] = Xinha._lc("Document",'CMSLink');
											span[r]["ContentType"]["title"] = Xinha._lc("Document",'CMSLink');
											break;
										case "Image":
											span[r]["ContentType"]["src"] = imgDir + "icon_image.png";
											span[r]["ContentType"]["alt"] = Xinha._lc("Image",'CMSLink');
											span[r]["ContentType"]["title"] = Xinha._lc("Image",'CMSLink');
											break;
										case "Article":
											span[r]["ContentType"]["src"] = imgDir + "icon_article.png";
											span[r]["ContentType"]["alt"] = Xinha._lc("Article",'CMSLink');
											span[r]["ContentType"]["title"] = Xinha._lc("Article",'CMSLink');
											break;
										case "Message":
											span[r]["ContentType"]["src"] = imgDir + "icon_message.png";
											span[r]["ContentType"]["alt"] = Xinha._lc("Message",'CMSLink');
											span[r]["ContentType"]["title"] = Xinha._lc("Message",'CMSLink');
											break;
									}
									span[r]["ContentType"]["style"] = "cursor: default;";
									span[r]["SiteName"]["style"] = "cursor: default;";
									span[r]["ContentTitle"]["style"] = "cursor: default;";
								}
							}
							document.getElementById("cmsLinkResults").innerHTML = dt.render(span);
						},
						function(x, msg, args){
						},
						function(args){
						}
					);
				}
			};
			this.cmsLinkDialog.onresize = function () {
				var resultEl = document.getElementById("cmsLinkResultsContainer");
				if(resultEl){
					var newHeight = parseInt(this.height,10) - 80;
					if(newHeight > 0) {
						resultEl.style.height = newHeight + "px";
					}
				}
			};
		}
		this.cmsLinkDialog.show();
	}
};
