/*------------------------------------------*\
CMSSubmit for Xinha
____________________

\*------------------------------------------*/

function CMSSubmit(editor) {
	this.editor = editor;
	this.changed = false;
	var self = this;
	var cfg = editor.config;
	this.textarea = this.editor._textArea;

	cfg.registerIcon('cmssubmitchanged', Xinha.getPluginDir("CMSSubmit")+"/img/ed_save_red.gif");
	cfg.registerIcon('cmssubmitunchanged', Xinha.getPluginDir("CMSSubmit")+"/img/ed_save_green.gif");

	cfg.registerButton({
	id       : "cmssubmit",
	tooltip  : self._lc("Save"),
	image    : cfg.iconList.cmssubmitunchanged,
	textMode : false,
	action   :  function() {
			self.save();
		}
	});
	cfg.addToolbarElement("cmssubmit", "popupeditor", -1);
}

CMSSubmit.prototype._lc = function(string) {
    return Xinha._lc(string, 'CMSSubmit');
}

CMSSubmit._pluginInfo = {
  name          : "CMSSubmit",
  version       : "1.0",
  developer     : "",
  developer_url : "http://www.risetobloome.com",
  c_owner       : "RISE to Bloome Software",
  sponsor       : "",
  sponsor_url   : "",
  license       : "htmlArea"
}

CMSSubmit.prototype.onKeyPress = function(ev) {
	if ( ev.ctrlKey && this.editor.getKey(ev) == 's') {
			this.save(this.editor);
			Xinha._stopEvent(ev);
			return true;
	}
	else {
		if (!this.changed) {
			if (this.getChanged()) this.setChanged();
			return false;
		}
	}
}
CMSSubmit.prototype.onExecCommand = function (cmd) {
	if (this.changed && cmd == 'undo') { 
		if (this.initial_html == this.editor.getInnerHTML()) this.setUnChanged();
		return false;
	}
}
CMSSubmit.prototype.onUpdateToolbar = function () {
  if (!this.initial_html) this.initial_html = this.editor.getInnerHTML();
	if (!this.changed) {
		if (this.getChanged()) this.setChanged();
		return false;
	}	
}
CMSSubmit.prototype.getChanged = function() {
	if (this.initial_html === null) this.initial_html = this.editor.getInnerHTML();
	if (this.initial_html != this.editor.getInnerHTML() && this.changed == false) {
		this.changed = true;
		return true;
	}
	else return false;
}
CMSSubmit.prototype.setChanged = function() {
	this.editor._toolbarObjects.cmssubmit.swapImage(this.editor.config.iconList.cmssubmitchanged);
	this.editor.updateToolbar();
}
CMSSubmit.prototype.setUnChanged = function() {
	this.changed = false;
	this.editor._toolbarObjects.cmssubmit.swapImage(this.editor.config.iconList.cmssubmitunchanged);
}
CMSSubmit.prototype.changedReset = function() {
	this.initial_html = null;
	this.setUnChanged();
}
CMSSubmit.prototype.save =  function() {
	CMS.articleEditor.save(this);
	return;
}