﻿if ((typeof(CMS) !== "undefined") && (typeof(CMS.admin) !== "undefined")) {
	CMS.admin.language = {
		userLanguage: null, 
		defaultLanguage: "en",
		languages: [{ISO: "en", Name: "English"}, {ISO: "sv", Name: "Svenska"}], 
		validLanguage: function(lang) {
			if(lang) {
				for(var i=0; i<CMS.admin.language.languages.length; i++) {
					if(CMS.admin.language.languages[i]["ISO"] == lang) return true;
				}
			}
			return false;
		}, 
		sv: {
		    loginForm: {
		        "header": "Logga in i RISE.CMS", 
		        "userID": "Användarnamn:&nbsp;", 
		        "password": "Lösenord:&nbsp;", 
		        "loginButtonText": "Logga in", 
		        "msgLoggingIn": "Loggar in...", 
		        "msgLoginFailed": "Inloggningen misslyckades", 
		        "msgErrorLoadingSession": "Error loading session information"
		    }, 
			toolbar: {
				"refreshTooltip": "Uppdatera Sajter och Användare", 
				"logOut": "Logga ut"
			}, 
			left: {
				"title": "Sajter och Användare", 
				"contextMenuAddNew": "Ny", 
				"contextMenuDelete": "Ta bort", 
				"sitesNode" : "Sajter", 
				"usersNode": "Användare", 
				"newSiteName": "Ny Sajt", 
				"confirmDeleteSiteStart": "Vill du ta bort sajten \"", 
				"confirmDeleteSiteEnd": "\"?", 
				"alertFailedToDeleteSite": "Sajten kunde inte tas bort.", 
				"alertFailedToAddSite": "Sajten kunde inte skapas", 
				"alertFailedToLoadSites": "Sajterna kunde inte laddas", 
				"newUserName": "Ny Användare", 
				"newUserLogin": "ny_användare", 
				"confirmDeleteUserStart": "Vill du ta bort användaren \"", 
				"confirmDeleteUserEnd": "\"?", 
				"alertFailedToDeleteUser": "Användaren kunde inte tas bort", 
				"alertFailedToAddUser": "Användaren kunde inte skapas", 
				"alertFailedToLoadUsers": "Användarna kunde inte laddas"
			}, 
			center: {
				"groupSite": "Sajt", 
				"propSiteName": "Namn", 
				"propSiteMembersOnly": "Endat Medlemmar", 
				
				"groupUser": "Användare", 
				"propName": "Namn", 
				"propLogin": "Användarid", 
				"propPassword": "Lösenord", 
				"propAdministrator": "Administrator", 
				"pickCaseTypeTitle": "Välj ur lista", 
				
				"alertFailedToSaveSite": "Sajten kunde inte sparas", 
				"alertFailedToSaveUser": "Användaren kunde inte sparas.", 
				"alertSiteNameMustNotBeEmpty": "Sajten måste ha ett namn", 
				"alertUserNameMustNotBeEmpty": "Användaren måste ha ett namn", 
				
				"toolbarTitleSite": "Sajt", 
				"toolbarTitleUser": "Användare", 
				"toolbarTitleSites": "Sajter", 
				"toolbarTitleUsers": "Användare", 
				
				"toolbarOpNewSite": "Ny Sajt", 
				"toolbarOpDeleteSite": "Kasta Sajt", 
				"toolbarOpNewSiteUser": "Koppla användare till sajt", 
				"toolbarOpNewUser": "Ny Användare", 
				"toolbarOpDeleteUser": "Kasta Användare", 
				"toolbarOpNewUserSite": "Koppla sajt till användare", 
				
				"dtCSColumnRevokeLabel": "", 
				"dtCSColumnSiteNameLabel": "Medlem i", 
				"dtCSColumnIsEditorLabel": "Får Editera", 
				"dtCSColumnSiteMembersOnlyLabel": "Endat Medlemmar", 
				"dtCSCellRevokeTooltip": "Ta bort medlemskap", 
	
				"dtSCColumnRevokeLabel": "", 
				"dtSCColumnUserNameLabel": "Sajtmedlem", 
				"dtSCColumnMemberEditLabel": "Får Editera",
				"dtSCCellRevokeTooltip": "Ta bort medlemskap"
			}, 
			userSites: {
				"panelHeader": "Lägg till Sajter", 
				"colCheckLabel": "", 
				"colNameLabel": "Sajt", 
				"filterLabelText": "Filter:&nbsp;", 
				"searchButtonText": "Sök", 
				"saveButtonText": "Spara"
			}, 
			siteUsers: {
				"panelHeader": "Lägg till Användare", 
				"colCheckLabel": "", 
				"colNameLabel": "Namn", 
				"filterLabelText": "Filter:&nbsp;", 
				"searchButtonText": "Sök", 
				"saveButtonText": "Spara"
			}
		}, 
		en: {
		    loginForm: {
		        "header": "Log in to RISE.CMS", 
		        "userID": "User id:&nbsp;", 
		        "password": "Password:&nbsp;", 
		        "loginButtonText": "Log in", 
		        "msgLoggingIn": "Logging in...", 
		        "msgLoginFailed": "Log in failed", 
		        "msgErrorLoadingSession": "Error loading session information"
		    }, 
			toolbar: {
				"refreshTooltip": "Refresh Sites and Users", 
				"logOut": "Log Out"
			}, 
			left: {
				"title": "Sites and Users", 
				"contextMenuAddNew": "Add New", 
				"contextMenuDelete": "Delete", 
				"sitesNode" : "Sites", 
				"usersNode": "Users", 
				"newSiteName": "New Site",
				"confirmDeleteSiteStart": "Do you want to delete the site \"", 
				"confirmDeleteSiteEnd": "\"?", 
				"alertFailedToDeleteSite": "The Site could not be deleted.", 
				"alertFailedToAddSite": "The Site could not be created", 
				"alertFailedToLoadSites": "The Sites could not be loaded", 
				"newUserName": "New User", 
				"newUserLogin": "new_user", 
				"confirmDeleteUserStart": "Do you want to delete the User \"", 
				"confirmDeleteUserEnd": "\"?", 
				"alertFailedToDeleteUser": "The User could not be deleted", 
				"alertFailedToAddUser": "The User could not be created", 
				"alertFailedToLoadUsers": "Failed to load Users"
			}, 
			center: {
				"groupSite": "Site", 
				"propSiteName": "Name", 
				"propSiteMembersOnly": "Members Only", 
				
				"groupUser": "User", 
				"propName": "Name", 
				"propLogin": "User id", 
				"propPassword": "Password", 
				"propAdministrator": "Administrator", 
				
				"alertFailedToSaveSite": "The site could not be saved", 
				"alertFailedToSaveUser": "Failed to save user.", 
				"alertSiteNameMustNotBeEmpty": "The site must have a name", 
				"alertUserNameMustNotBeEmpty": "The user must have a name", 
				
				"toolbarTitleSite": "Site", 
				"toolbarTitleUser": "User", 
				"toolbarTitleSites": "Sites", 
				"toolbarTitleUsers": "Users", 
				
				"toolbarOpNewSite": "New Site", 
				"toolbarOpDeleteSite": "Delete Site", 
				"toolbarOpNewSiteUser": "Add User to Site", 
				"toolbarOpNewUser": "New User", 
				"toolbarOpDeleteUser": "Delete User", 
				"toolbarOpNewUserSite": "Add Site to User", 
				
				"dtCSColumnRevokeLabel": "", 
				"dtCSColumnSiteNameLabel": "Member of", 
				"dtCSColumnIsEditorLabel": "May Edit", 
				"dtCSColumnSiteMembersOnlyLabel": "Members Only", 
				"dtCSCellRevokeTooltip": "Revoke membership", 
	
				"dtSCColumnRevokeLabel": "", 
				"dtSCColumnUserNameLabel": "Site members", 
				"dtSCColumnMemberEditLabel": "May Edit", 
				"dtSCCellRevokeTooltip": "Revoke membership"
			}, 
			userSites: {
				"panelHeader": "Add Sites", 
				"colCheckLabel": "", 
				"colNameLabel": "Site", 
				"filterLabelText": "Filter:&nbsp;", 
				"searchButtonText": "Search", 
				"saveButtonText": "Save"
			}, 
			siteUsers: {
				"panelHeader": "Add Users", 
				"colCheckLabel": "", 
				"colNameLabel": "Name", 
				"filterLabelText": "Filter:&nbsp;", 
				"searchButtonText": "Search", 
				"saveButtonText": "Save"
			}
		}, 	
		setUserLanguage: function() {
			try {
				var language = (navigator.language ? navigator.language : ( navigator.browserLanguage ? navigator.browserLanguage : null));
				if(language) {
					if (language.indexOf('en') > -1)
						CMS.admin.language.userLanguage = "en";
					else if (language.indexOf('sv') > -1)
						CMS.admin.language.userLanguage = "sv";
					else if(typeof(CMS.admin.language[language]) !== "undefined")
						CMS.admin.language.userLanguage = language;
				}
			} catch(ex) {}
			if(!CMS.admin.language.userLanguage) {
				CMS.admin.language.userLanguage = CMS.admin.language.defaultLanguage;
			}
		}, 
		defaultPhrase: function(context, item) {
			try {
				if(typeof(CMS.admin.language[CMS.admin.language.defaultLanguage][context][item]) !== "undefined")
					return CMS.admin.language[CMS.admin.language.defaultLanguage][context][item];
			} catch(ex) { }
			return (item || "Undefined phrase");
		}, 
		phrase: function(context, item) {
			var lang = CMS.admin.language;
			if(!lang.userLanguage) {
				lang.setUserLanguage();
			}
			try {
				if(typeof(lang[lang.userLanguage]) !== "undefined" && typeof(lang[lang.userLanguage][context]) !== "undefined" && typeof(lang[lang.userLanguage][context][item]) !== "undefined")
					return lang[lang.userLanguage][context][item];
			} catch(ex) { }
			return lang.defaultPhrase(context, item);
		}
	};
} else {
	alert("CMSAdminLanguage: missing dependencies");
}