﻿if (CMS && CMS.admin && IAdmin) {
	CMS.admin.nodeProperties = {
		markup: {
			propertyContainer: "propertyContainer", 
			propertyTitle: "propertyTitle", 
			propertyToolbar: "propertyToolbar", 
			propertyDetails: "propertyDetails", 
			propertyDataTable: "propertyDataTable"
		}, 
		_dummyPassword: "123 Nyfiken i en strut 321",
		oTreeNode: null, 
		propertyGrid: new RISE.PropertyGrid(), 
		resize: function(width) {
			var el = document.getElementById(CMS.editor.nodeProperties.markup["propertyContainer"]);
			if(el) {
				el.style.width = ((width-2) + "px");
			}
		}, 
		display: function(){
			if(CMS.admin.nodeProperties.markup["propertyDetails"]){
				var el = document.getElementById(CMS.admin.nodeProperties.markup["propertyDetails"]);
				if(el){
					el.innerHTML = CMS.admin.nodeProperties.propertyGrid.render();
					CMS.admin.nodeProperties._setToolbar();
					if(CMS.admin.nodeProperties.oTreeNode.cmsSite){
						CMS.admin.nodeProperties._setPropertyTitle(CMS.admin.nodeProperties.getPhrase("toolbarTitleSite") + " :: " + CMS.admin.nodeProperties.oTreeNode.cmsSite["Name"]);
						CMS.admin.nodeProperties._listSiteUsers();
					} else if(CMS.admin.nodeProperties.oTreeNode.cmsUser) {
						CMS.admin.nodeProperties._setPropertyTitle(CMS.admin.nodeProperties.getPhrase("toolbarTitleUser") + " :: " + CMS.admin.nodeProperties.oTreeNode.cmsUser["Name"]);
						CMS.admin.nodeProperties._loadUserSites();
					} else if(CMS.admin.nodeProperties.oTreeNode.cmsSitesTop){
						CMS.admin.nodeProperties._setPropertyTitle(CMS.admin.nodeProperties.getPhrase("toolbarTitleSites"));
					} else if(CMS.admin.nodeProperties.oTreeNode.cmsUsersTop){
						CMS.admin.nodeProperties._setPropertyTitle(CMS.admin.nodeProperties.getPhrase("toolbarTitleUsers"));
					}
				}
			}
			document.getElementById(CMS.admin.nodeProperties.markup["propertyContainer"]).style.display = "block";
		}, 
		hide: function(){
			document.getElementById(CMS.admin.nodeProperties.markup["propertyContainer"]).style.display = "none";
		}, 
		getPhrase: function(item){
			return CMS.admin.language.phrase("center", item);
		}, 
		load: function(treeNode){
			var phrase = function(phrase){ return CMS.admin.language.phrase("center", phrase); }
			document.getElementById(CMS.admin.nodeProperties.markup["propertyDataTable"]).innerHTML = "";
			if(treeNode){
				CMS.admin.nodeProperties.oTreeNode = treeNode;
				CMS.admin.nodeProperties.propertyGrid.init();
				if(CMS.admin.nodeProperties.oTreeNode.cmsSite){
					// cmsSite contains: ID (int), Name (string), MembersOnly (bool), RecycleBin (bool)
					CMS.admin.nodeProperties.propertyGrid.addProperty(phrase("groupSite"), { name: "Name", label: phrase("propSiteName"), value: CMS.admin.nodeProperties.oTreeNode.cmsSite["Name"], type: "textBox", callback: "CMS.admin.nodeProperties._onBlur", callbackArgs: { Fld: "Name" } });
					CMS.admin.nodeProperties.propertyGrid.addProperty(phrase("groupSite"), { name: "MembersOnly", label: phrase("propSiteMembersOnly"), value: CMS.admin.nodeProperties.oTreeNode.cmsSite["MembersOnly"], type: "checkBox", callback: "CMS.admin.nodeProperties._onBlur", callbackArgs: { Fld: "MembersOnly" } });
					CMS.admin.nodeProperties.display();
				} else if(CMS.admin.nodeProperties.oTreeNode.cmsUser){
					// cmsUser contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string)
					CMS.admin.nodeProperties.propertyGrid.addProperty(phrase("groupUser"), { name: "Name", label: phrase("propName"), value: CMS.admin.nodeProperties.oTreeNode.cmsUser["Name"], type: "textBox", callback: "CMS.admin.nodeProperties._onBlur", callbackArgs: { Fld: "Name" } });
					CMS.admin.nodeProperties.propertyGrid.addProperty(phrase("groupUser"), { name: "Login", label: phrase("propLogin"), value: CMS.admin.nodeProperties.oTreeNode.cmsUser["Login"], type: "textBox", callback: "CMS.admin.nodeProperties._onBlur", callbackArgs: { Fld: "Login" } });
					CMS.admin.nodeProperties.propertyGrid.addProperty(phrase("groupUser"), { name: "Password", label: phrase("propPassword"), value: CMS.admin.nodeProperties._dummyPassword, type: "password", callback: "CMS.admin.nodeProperties._onBlur", callbackArgs: { Fld: "Password" } });
					CMS.admin.nodeProperties.propertyGrid.addProperty(phrase("groupUser"), { name: "Administrator", label: phrase("propAdministrator"), value: CMS.admin.nodeProperties.oTreeNode.cmsUser["Administrator"], type: "checkBox", callback: "CMS.admin.nodeProperties._onBlur", callbackArgs: { Fld: "Administrator" } });
					CMS.admin.nodeProperties.display();
				} else if(CMS.admin.nodeProperties.oTreeNode.cmsSitesTop){
					CMS.admin.nodeProperties.display();
				} else if(CMS.admin.nodeProperties.oTreeNode.cmsUsersTop){
					CMS.admin.nodeProperties.display();
				} else {
					CMS.admin.nodeProperties.hide();
				}
			} else {
				CMS.admin.nodeProperties.hide();
			}
		}, 
		save: function(recovery){
			var phrase = function(phrase){ return CMS.admin.language.phrase("center", phrase); }
			if(CMS.admin.nodeProperties.oTreeNode){
				if(CMS.admin.nodeProperties.oTreeNode.cmsSite){
					// cmsSite contains: ID (int), Name (string), MembersOnly (bool)
					var si = CMS.admin.nodeProperties.oTreeNode.cmsSite;
					IAdmin.SaveSite(
						{"ticket": null, "ID": si["ID"], "MembersOnly": si["MembersOnly"], "Name": si["Name"]},
						function(result, args){
							CMS.admin.nodeProperties.oTreeNode.setHtml(CMS.admin.tree._siteNodeHTML(si["ID"], si["Name"], si["MembersOnly"]));
						},
						function(x, msg, args){
							if(recovery){
								for (var name in recovery) {
									si[name] = recovery[name];
								}
							}
							alert(phrase("alertFailedToSaveSite"));
						},
						function(args){
						}
					);
				} else if(CMS.admin.nodeProperties.oTreeNode.cmsUser){
					// cmsUser contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string)
					var cl = CMS.admin.nodeProperties.oTreeNode.cmsUser;
					IAdmin.SaveUser(
						{"ticket": null, "ID": cl["ID"], "GUID": cl["GUID"], "Login": cl["Login"], "Name": cl["Name"], "Administrator": cl["Administrator"], "Password": cl["Password"]},
						function(result, args){
							var yourVariable1 = result["ID"]; 
							CMS.admin.nodeProperties.oTreeNode.setHtml(CMS.admin.tree._userNodeHTML(cl["ID"], cl["Name"], cl["Administrator"]));
						},
						function(x, msg, args){
							if(recovery){
								try {
									cl[recovery["fld"]] = recovery["value"];
									recovery["domEl"].value = (((recovery["fld"] == "Password")) ? CMS.admin.nodeProperties._dummyPassword : recovery["value"]);
								} catch(ex) {}
							}
							alert(phrase("alertFailedToSaveUser"));
						},
						function(args){
						}
					);
				}
			}
		}, 
		_onBlur: function(domEl, custArgs){
			if(CMS.admin.nodeProperties.oTreeNode && domEl && custArgs && custArgs["Fld"]){
				var phrase = function(phrase){ return CMS.admin.language.phrase("center", phrase); }
				
				if(domEl){
					var recovery = {};
					if(CMS.admin.nodeProperties.oTreeNode.cmsSite){
						// cmsSite contains: ID (int), Name (string), MembersOnly (bool)
						switch(custArgs["Fld"]){
							case "Name":
								if(CMS.admin.nodeProperties.oTreeNode.cmsSite["Name"] != domEl.value){
									if(domEl.value){
										recovery = { domEl: domEl, fld: custArgs["Fld"], value: CMS.admin.nodeProperties.oTreeNode.cmsSite["Name"] };
										CMS.admin.nodeProperties.oTreeNode.cmsSite["Name"] = domEl.value;
										CMS.admin.nodeProperties.save(recovery);
									} else {
										domEl.value = CMS.admin.nodeProperties.oTreeNode.cmsSite["Name"];
										alert(phrase("alertSiteNameMustNotBeEmpty"));
									}
								}
							break;

							case "MembersOnly":
								if(CMS.admin.nodeProperties.oTreeNode.cmsSite["MembersOnly"] != domEl.checked){
									recovery = { domEl: domEl, fld: custArgs["Fld"], value: CMS.admin.nodeProperties.oTreeNode.cmsSite["MembersOnly"] };
									CMS.admin.nodeProperties.oTreeNode.cmsSite["MembersOnly"] = domEl.checked;
									CMS.admin.nodeProperties.save(recovery);
								}
							break;
						}
					} else if(CMS.admin.nodeProperties.oTreeNode.cmsUser){
						// cmsUser contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string)
						switch(custArgs["Fld"]){
							case "Name":
								if(CMS.admin.nodeProperties.oTreeNode.cmsUser["Name"] != domEl.value){
									if(domEl.value){
										recovery = { domEl: domEl, fld: custArgs["Fld"], value: CMS.admin.nodeProperties.oTreeNode.cmsUser["Name"] };
										CMS.admin.nodeProperties.oTreeNode.cmsUser["Name"] = domEl.value;
										CMS.admin.nodeProperties.save(recovery);
									} else {
										domEl.value = CMS.admin.nodeProperties.oTreeNode.cmsUser["Name"];
										alert(phrase("alertUserNameMustNotBeEmpty"));
									}
								}
							break;

							case "Login":
								if(CMS.admin.nodeProperties.oTreeNode.cmsUser["Login"] != domEl.value){
									if(domEl.value){
										recovery = { domEl: domEl, fld: custArgs["Fld"], value: CMS.admin.nodeProperties.oTreeNode.cmsUser["Login"] };
										CMS.admin.nodeProperties.oTreeNode.cmsUser["Login"] = domEl.value;
										CMS.admin.nodeProperties.save(recovery);
									} else {
										domEl.value = CMS.admin.nodeProperties.oTreeNode.cmsUser["Login"];
										alert(phrase("alertUserNameMustNotBeEmpty"));
									}
								}
							break;
							
							case "Password":
								if(CMS.admin.nodeProperties._dummyPassword != domEl.value){
									if(domEl.value){
										recovery = { domEl: domEl, fld: custArgs["Fld"], value: null };
										CMS.admin.nodeProperties.oTreeNode.cmsUser["Password"] = domEl.value;
										CMS.admin.nodeProperties.save(recovery);
									} else {
										domEl.value = CMS.admin.nodeProperties._dummyPassword;
										alert(phrase("alertUserNameMustNotBeEmpty"));
									}
								}
							break;

							case "Administrator":
								if(CMS.admin.nodeProperties.oTreeNode.cmsUser["Administrator"] != domEl.checked){
									recovery = { domEl: domEl, fld: custArgs["Fld"], value: CMS.admin.nodeProperties.oTreeNode.cmsUser["Administrator"] };
									CMS.admin.nodeProperties.oTreeNode.cmsUser["Administrator"] = domEl.checked;
									CMS.admin.nodeProperties.save(recovery);
								}
							break;
						}
					}
				}
			}
		}, 
		_toolbarForSites: function(toolbarEl){
			if(toolbarEl) {
				var toolbarImages = [];
				var group = [];
				group[group.length] = {
					src:"images/icon_site_add.png", 
					alt: CMS.admin.language.phrase("center", "toolbarOpNewSite"), 
					title: CMS.admin.language.phrase("center", "toolbarOpNewSite"), 
					onclick: function(ev){ 
						CMS.admin.tree._newSite();
					}
				};
				if(group.length > 0) toolbarImages[toolbarImages.length] = group;
				new RISE.Toolbar(toolbarEl, {imageWidth: 16, imageHeight: 16, imageBlocks: toolbarImages}).render();
			}
		},
		_toolbarForSite: function(toolbarEl){
			if(toolbarEl) {
				var toolbarImages = [];
				var group = [];
				group[group.length] = {
					src:"images/icon_delete.png", 
					alt: CMS.admin.language.phrase("center", "toolbarOpDeleteSite"), 
					title: CMS.admin.language.phrase("center", "toolbarOpDeleteSite"), 
					onclick: function(ev){ 
						CMS.admin.tree._deleteSite(CMS.admin.nodeProperties.oTreeNode);
					}
				};
				if(group.length > 0) toolbarImages[toolbarImages.length] = group;
				group = [];
				group[group.length] = {
					src:"images/icon_member_add.png", 
					alt: CMS.admin.language.phrase("center", "toolbarOpNewSiteUser"), 
					title: CMS.admin.language.phrase("center", "toolbarOpNewSiteUser"), 
					onclick: function(ev){ 
						CMS.admin.siteUsers.render(CMS.admin.nodeProperties.oTreeNode.cmsSite["ID"], function() { CMS.admin.nodeProperties.load(CMS.admin.nodeProperties.oTreeNode); });
					}
				};
				if(group.length > 0) toolbarImages[toolbarImages.length] = group;
				new RISE.Toolbar(toolbarEl, {imageWidth: 16, imageHeight: 16, imageBlocks: toolbarImages}).render();
			}
		},
		_toolbarForUsers: function(toolbarEl){
			if(toolbarEl) {
				var toolbarImages = [];
				var group = [];
				group[group.length] = {
					src:"images/icon_users_add.png", 
					alt: CMS.admin.language.phrase("center", "toolbarOpNewUser"), 
					title: CMS.admin.language.phrase("center", "toolbarOpNewUser"), 
					onclick: function(ev){ 
						CMS.admin.tree._newUser();
					}
				};
				if(group.length > 0) toolbarImages[toolbarImages.length] = group;
				new RISE.Toolbar(toolbarEl, {imageWidth: 16, imageHeight: 16, imageBlocks: toolbarImages}).render();
			}
		},
		_toolbarForUser: function(toolbarEl){
			if(toolbarEl) {
				var toolbarImages = [];
				var group = [];
				group[group.length] = {
					src:"images/icon_delete.png", 
					alt: CMS.admin.language.phrase("center", "toolbarOpDeleteUser"), 
					title: CMS.admin.language.phrase("center", "toolbarOpDeleteUser"), 
					onclick: function(ev){ 
						CMS.admin.tree._deleteUser(CMS.admin.nodeProperties.oTreeNode);
					}
				};
				if(group.length > 0) toolbarImages[toolbarImages.length] = group;
				group = [];
				group[group.length] = {
					src:"images/icon_member_add.png", 
					alt: CMS.admin.language.phrase("center", "toolbarOpNewUserSite"), 
					title: CMS.admin.language.phrase("center", "toolbarOpNewUserSite"), 
					onclick: function(ev){ 
						CMS.admin.userSites.render(CMS.admin.nodeProperties.oTreeNode.cmsUser["ID"], function() { CMS.admin.nodeProperties.load(CMS.admin.nodeProperties.oTreeNode); });
					}
				};
				if(group.length > 0) toolbarImages[toolbarImages.length] = group;
				new RISE.Toolbar(toolbarEl, {imageWidth: 16, imageHeight: 16, imageBlocks: toolbarImages}).render();
			}
		},
		_setToolbar: function(){
			if(CMS.admin.nodeProperties.markup["propertyToolbar"]){
				var toolbarEl = document.getElementById(CMS.admin.nodeProperties.markup["propertyToolbar"]);
				if(toolbarEl){
					if(CMS.admin.nodeProperties.oTreeNode.cmsSite){
						CMS.admin.nodeProperties._toolbarForSite(toolbarEl);
					} else if(CMS.admin.nodeProperties.oTreeNode.cmsUser) {
						CMS.admin.nodeProperties._toolbarForUser(toolbarEl);
					} else if(CMS.admin.nodeProperties.oTreeNode.cmsSitesTop){
						CMS.admin.nodeProperties._toolbarForSites(toolbarEl);
					} else if(CMS.admin.nodeProperties.oTreeNode.cmsUsersTop){
						CMS.admin.nodeProperties._toolbarForUsers(toolbarEl);
					}
				}
			}
		}, 
		_setPropertyTitle: function (title){
			if(CMS.admin.nodeProperties.markup["propertyTitle"]){
				var el = document.getElementById(CMS.admin.nodeProperties.markup["propertyTitle"]);
				if(el){
					el.innerHTML = title;
				}
			}
		}, 
		_loadUserSites: function(){
			if(CMS.admin.nodeProperties.oTreeNode.cmsUser){
				var phrase = function(phrase){ return CMS.admin.language.phrase("center", phrase); }
				IAdmin.ListUserSites(
					{"maxRowsToReturn": null, "ticket": null, "UserID": CMS.admin.nodeProperties.oTreeNode.cmsUser["ID"]},
					function(results, args){
						// results contains: ID (int), Name (string), MembersOnly (bool), RecycleBin (bool), IsEditor (bool)
						var config = {
							rowID: "ID", 
							columns: []
						};
						config.columns[config.columns.length] = {
							name: "ID", 
							label: phrase("dtCSColumnRevokeLabel"), 
							columnType: RISE.DataTable.prototype.columnType.image, 
							style: "width: 20px", 
							opCallback: "CMS.admin.nodeProperties._revokeMembership"
						}
						config.columns[config.columns.length] = {
							name: "Name", 
							label: phrase("dtCSColumnSiteNameLabel"), 
							columnType: RISE.DataTable.prototype.columnType.label
						}
						config.columns[config.columns.length] = {
							name: "IsEditor", 
							label: phrase("dtCSColumnIsEditorLabel"), 
							opCallback: "CMS.admin.nodeProperties._saveMembership", 
							columnType: RISE.DataTable.prototype.columnType.checkBox, 
							style: "width: 100px"
						}
						config.columns[config.columns.length] = {
							name: "MembersOnly", 
							label: phrase("dtCSColumnSiteMembersOnlyLabel"), 
							columnType: RISE.DataTable.prototype.columnType.checkBox, 
							style: "width: 150px"							
						}
						var dt = new RISE.DataTable(config);						
						var span = dt.span(results);
						for(var r in span){
							if(r != "_span"){
								span[r]["ID"]["width"] = "16px";
								span[r]["ID"]["height"] = "16px";
								span[r]["ID"]["src"] = "Images/icon_member_delete.png";
								span[r]["ID"]["alt"] = phrase("dtCSCellRevokeTooltip");
								span[r]["ID"]["title"] = phrase("dtCSCellRevokeTooltip");
								span[r]["ID"]["callbackArgs"] = { SiteID: r, UserID: CMS.admin.nodeProperties.oTreeNode.cmsUser["ID"] }
								span[r]["IsEditor"]["callbackArgs"] = { SiteID: r, UserID: CMS.admin.nodeProperties.oTreeNode.cmsUser["ID"] }
							}
						}
						document.getElementById(CMS.admin.nodeProperties.markup["propertyDataTable"]).innerHTML = dt.render(span);
					},
					function(x, msg, args){
					},
					function(args){
					}
				);
			}
		}, 
		_listSiteUsers: function(){
			if(CMS.admin.nodeProperties.oTreeNode.cmsSite){
				var phrase = function(phrase){ return CMS.admin.language.phrase("center", phrase); }
				IAdmin.ListSiteUsers(
					{"maxRowsToReturn": null, "ticket": null, "SiteID": CMS.admin.nodeProperties.oTreeNode.cmsSite["ID"]},
					function(results, args){
						// results contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string), IsEditor (bool)
						var config = {
							rowID: "ID", 
							columns: []
						};
						config.columns[config.columns.length] = {
							name: "ID", 
							label: phrase("dtSCColumnRevokeLabel"), 
							columnType: RISE.DataTable.prototype.columnType.image, 
							style: "width: 20px", 
							opCallback: "CMS.admin.nodeProperties._revokeMembership"
						}
						config.columns[config.columns.length] = {
							name: "Name", 
							label: phrase("dtSCColumnUserNameLabel"), 
							columnType: RISE.DataTable.prototype.columnType.label
						}
						config.columns[config.columns.length] = {
							name: "IsEditor", 
							label: phrase("dtSCColumnMemberEditLabel"), 
							opCallback: "CMS.admin.nodeProperties._saveMembership", 
							columnType: RISE.DataTable.prototype.columnType.checkBox, 
							style: "width: 100px"
						}
						var dt = new RISE.DataTable(config);
						var span = dt.span(results);
						for(var r in span){
							if(r != "_span"){
								span[r]["ID"]["width"] = "16px";
								span[r]["ID"]["height"] = "16px";
								span[r]["ID"]["src"] = "Images/icon_member_delete.png";
								span[r]["ID"]["alt"] = span[r]["ID"]["title"] = phrase("dtSCCellRevokeTooltip");
								span[r]["ID"]["callbackArgs"] = { SiteID: CMS.admin.nodeProperties.oTreeNode.cmsSite["ID"], UserID: r }
								span[r]["IsEditor"]["callbackArgs"] = { SiteID: CMS.admin.nodeProperties.oTreeNode.cmsSite["ID"], UserID: r }
							}
						}
						document.getElementById(CMS.admin.nodeProperties.markup["propertyDataTable"]).innerHTML = dt.render(span);
					},
					function(x, msg, args){
					},
					function(args){
					}
				);
			}
		}, 
		_revokeMembership: function(domEl, custArgs) {
			if(domEl && custArgs && custArgs["SiteID"] && custArgs["UserID"]) {
				IAdmin.RevokeMembership(
					{"ticket": null, "UserID": custArgs["UserID"], "SiteID": custArgs["SiteID"]},
					function(args){
						CMS.admin.nodeProperties.load(CMS.admin.nodeProperties.oTreeNode);
					},
					function(x, msg, args){
					},
					function(args){
					}
				);
			}
		}, 
		_saveMembership: function(domEl, custArgs) {
			if(domEl && custArgs && custArgs["SiteID"] && custArgs["UserID"]) {
				IAdmin.SaveMembership(
					{"ticket": null, "UserID": custArgs["UserID"], "SiteID": custArgs["SiteID"], "IsEditor": domEl.checked},
					function(args){
					},
					function(x, msg, args){
					},
					function(args){
					}
				);
			}
		}
	};
} else {
	alert("CMSAdminNodeProperties: missing dependencies");
}