﻿if (CMS && CMS.admin && IAdmin) {
	CMS.admin.siteUsers = {
		oPanel: null, 
		markupIds: {
			panel: "siteUsersPanel",
			filter: "siteUsersFilter", 
			body: "siteUsersBody", 
			error: "siteUsersError"
		}, 
		users: {},
		siteID: null, 
		onCompleted: null, 
		onCompletedContext: null, 
		_header: function() {
			return CMS.admin.language.phrase("siteUsers", "panelHeader");
		}, 
		_body: function() {
			var s = [];
			s[s.length] = '<div style="width: 100%;">';
			s[s.length] = '    <table cellpadding="0" cellspacing="0">';
			s[s.length] = '        <tr>';
			s[s.length] = '            <td>' + CMS.admin.language.phrase("siteUsers", "filterLabelText") + '</td>';
			s[s.length] = '            <td><input id="' + CMS.admin.siteUsers.markupIds["filter"] + '" type="text" /></td>';
			s[s.length] = '            <td>&nbsp;</td>';
			s[s.length] = '            <td><input type="button" value="' + CMS.admin.language.phrase("siteUsers", "searchButtonText") + '" onclick="CMS.admin.siteUsers._search();" /></td>';
			s[s.length] = '            <td>&nbsp;</td>';
			s[s.length] = '            <td><input type="button" value="' + CMS.admin.language.phrase("siteUsers", "saveButtonText") + '" onclick="this.disabled = true; CMS.admin.siteUsers._save();" /></td>';
			s[s.length] = '        </tr>';
			s[s.length] = '    </table>';
			s[s.length] = '</div>';
			s[s.length] = '<div style="padding: 4px">&nbsp;</div>';
			s[s.length] = '<div id="';
			s[s.length] = CMS.admin.siteUsers.markupIds["body"];
			s[s.length] = '" style="width: 100%;">';
			s[s.length] = '</div>';
			return s.join("");
		}, 
		_footer: function() {
			return "";
		}, 
		_displayPanel: function(header, body, footer) {
			if(!CMS.admin.siteUsers.oPanel) {
				CMS.admin.siteUsers.oPanel = new YAHOO.widget.Panel(CMS.admin.siteUsers.markupIds["panel"], {
					draggable: true,
					dragOnly: true, 
					x: 100, 
					y: 100, 
					close: true, 
					modal: true, 
					width: "500px",
					height: "465px",
					constraintoviewport: true, 
					visible: false
				});
				CMS.admin.siteUsers.oPanel.subscribe("hide", function() {
				});
				CMS.admin.siteUsers.oPanel.subscribe("render", function() {
				});
				CMS.admin.siteUsers.oPanel.subscribe("show", function() {
				});
				CMS.admin.siteUsers.oPanel.render();
			}
			CMS.admin.siteUsers.oPanel.setHeader(header ? header : "");
			CMS.admin.siteUsers.oPanel.setBody(body ? body : "");
			CMS.admin.siteUsers.oPanel.setFooter(footer ? footer : "");
			CMS.admin.siteUsers.oPanel.show();
		}, 
		_search: function() {
			var el = document.getElementById(CMS.admin.siteUsers.markupIds["body"]);
			var filterEl = document.getElementById(CMS.admin.siteUsers.markupIds["filter"]);
			if(el && filterEl) {
				CMS.admin.siteUsers.users = {};

				IAdmin.ListSiteUsers(
					{"maxRowsToReturn": null, "ticket": null, "SiteID": CMS.admin.siteUsers.siteID},
					function(results, args){
						// results contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string), IsEditor (bool)
						var siteUsers = results;
						var isSiteUser = function(id) {
							for(var i=0; i<siteUsers.length; i++) {
								if(siteUsers[i]["ID"] == id) return true;
							}
							return false;
						};

						IAdmin.ListUsers(
							{"maxRowsToReturn": null, "ticket": null, "NameLike": ((filterEl.value) ? "%" + filterEl.value + "%" : "%" )},
							function(results, args){
								// results contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string)
								var users = [];
								for (var i=0; i<results.length; i++) {
									if(!isSiteUser(results[i]["ID"])) {
										users[users.length] = results[i];
									}
								}
								
								var config = {
									rowID: "ID", 
									columns: []
								};
								config.columns[config.columns.length] = {
									name: "Check", 
									label: CMS.admin.language.phrase("siteUsers", "colCheckLabel"), 
									columnType: RISE.DataTable.prototype.columnType.checkBox, 
									style: "width: 20px", 
									opCallback: "CMS.admin.siteUsers._updateList"
								}
								config.columns[config.columns.length] = {
									name: "Name", 
									label: CMS.admin.language.phrase("siteUsers", "colNameLabel"), 
									columnType: RISE.DataTable.prototype.columnType.label
								}
								var dt = new RISE.DataTable(config);						
								var span = dt.span(users);
								for(var r in span){
									if(r != "_span"){
										span[r]["Check"]["callbackArgs"] = { ID: r }
									}
								}
								el.innerHTML = dt.render(span);								
							},
							function(x, msg, args){
							},
							function(args){
							}
						);
					},
					function(x, msg, args){
					},
					function(args){
					}
				);
			}
		}, 
		_updateList: function(domEl, custArgs) {
			if(domEl && custArgs && custArgs["ID"]) {
				CMS.admin.siteUsers.users[custArgs["ID"]] = domEl.checked;
			}
		}, 
		_save: function() {
			var users = CMS.admin.siteUsers.users;
			var cursor = 0;
			for(var s in users){
				if(users[s]){
					cursor++;
					IAdmin.SaveMembership(
						{"ticket": null, "UserID": s, "SiteID": CMS.admin.siteUsers.siteID, "IsEditor": false},
						function(args){
						},
						function(x, msg, args){
						},
						function(args){
							cursor--;
							if(cursor == 0) {
								if(CMS.admin.siteUsers.onCompleted){
									if(CMS.admin.siteUsers.onCompletedContext) CMS.admin.siteUsers.onCompleted.call(CMS.admin.siteUsers.onCompletedContext);
									else CMS.admin.siteUsers.onCompleted();
								}
							}
						}
					);
				}
			}
			CMS.admin.siteUsers.oPanel.hide();
		}, 
		_error: function(msg) {
			var errorEl = document.getElementById(CMS.admin.siteUsers.markupIds["error"]);
			if(errorEl){
				errorEl.innerHTML = msg;
			}
		}, 
		render: function(siteID, onCompleted, onCompletedContext) {
			if(siteID) {
				CMS.admin.siteUsers.users = {};
				CMS.admin.siteUsers.siteID = siteID;
				CMS.admin.siteUsers.onCompleted = onCompleted || null;
				CMS.admin.siteUsers.onCompletedContext = onCompletedContext || null;
				
				CMS.admin.siteUsers._displayPanel(CMS.admin.siteUsers._header(), CMS.admin.siteUsers._body(), CMS.admin.siteUsers._footer());
			}
		}
	};
} else {
	alert("CMS.admin.siteUsers: missing dependencies");
}
