﻿if (CMS && CMS.admin && IAdmin) {
	CMS.admin.tree = {
		markupIDs: {
			treeDiv: "structureTree",
			dragContainer: "dragDropContainer"
		},
		oTree: null, 
		oSitesRoot: null, 
		oUsersRoot: null, 
		contextTreeNode: null, 
		_loadDepth: 0,
		
		load: function() {
			CMS.admin.tree.contextTreeNode = null;
			if(CMS.admin.nodeProperties) CMS.admin.nodeProperties.load(null);
			var phrase = function(phrase){ return CMS.admin.language.phrase("left", phrase); }
			CMS.admin.tree.oTree = new YAHOO.widget.TreeView(CMS.admin.tree.markupIDs["treeDiv"]);
			CMS.admin.tree._loadSiteRoots();
			CMS.admin.tree.oTree.subscribe('clickEvent', CMS.admin.tree._nodeClick);
			CMS.admin.tree.oTree.subscribe('focusChanged', CMS.admin.tree._nodeFocus);
			
			var oContextMenu = new YAHOO.widget.ContextMenu(
				"cmsadmintreecontextmenu",
				{
					trigger: CMS.admin.tree.markupIDs["treeDiv"],
					lazyload: true,
					itemdata: [[
						{ text: phrase("contextMenuAddNew"), onclick: { fn: CMS.admin.tree._newNode } },
						{ text: phrase("contextMenuDelete"), onclick: { fn: CMS.admin.tree._deleteNode } }
					]]
				}
			);
			oContextMenu.subscribe("triggerContextMenu", CMS.admin.tree._onTriggerContextMenu);								
			oContextMenu.subscribe("show", CMS.admin.tree._onShowContextMenu);
		}, 
		_sitesNodeHTML: function(){
			var rc = [];
			rc[rc.length] = "<table><tr><td style=\"padding-right: 4px;\"><img src=\"images/icon_sites.png\" width=\"16px\" height=\"16px\" /></td><td><div>";
			rc[rc.length] = CMS.admin.language.phrase("left", "sitesNode");
			rc[rc.length] = "</div></td></tr></table>";
			return rc.join("");
		}, 		
		_siteNodeHTML: function(siteID, siteName, membersOnly){
			var rc = [];
			rc[rc.length] = "<table><tr><td style=\"padding-right: 4px;\"><img src=\"images/";
			rc[rc.length] = ((membersOnly) ? "icon_site_mo.png" : "icon_site.png");
			rc[rc.length] = "\" width=\"16px\" height=\"16px\" /></td><td><div>";
			rc[rc.length] = siteName;
			rc[rc.length] = "</div></td></tr></table>";
			return rc.join("");
		}, 		
		_usersNodeHTML: function(){
			var rc = [];
			rc[rc.length] = "<table><tr><td style=\"padding-right: 4px;\"><img src=\"images/icon_users.png\" width=\"16px\" height=\"16px\" /></td><td><div>";
			rc[rc.length] = CMS.admin.language.phrase("left", "usersNode");;
			rc[rc.length] = "</div></td></tr></table>";
			return rc.join("");
		}, 		
		_userNodeHTML: function(userID, userName, isAdmin){
			var rc = [];
			rc[rc.length] = "<table><tr><td style=\"padding-right: 4px;\"><img src=\"images/";
			rc[rc.length] = ((isAdmin) ? "icon_user_admin.png" : "icon_user.png");
			rc[rc.length] = "\" width=\"16px\" height=\"16px\" /></td><td><div>";
			rc[rc.length] = userName;
			rc[rc.length] = "</div></td></tr></table>";
			return rc.join("");
		}, 		
		_loadSiteRoots: function(){
			CMS.admin.tree.oSitesRoot = new YAHOO.widget.HTMLNode(CMS.admin.tree._sitesNodeHTML(), CMS.admin.tree.oTree.getRoot(), true, true); 
			CMS.admin.tree.oSitesRoot.cmsSitesTop = true;
			
			CMS.admin.tree.oUsersRoot = new YAHOO.widget.HTMLNode(CMS.admin.tree._usersNodeHTML(), CMS.admin.tree.oTree.getRoot(), true, true); 
			CMS.admin.tree.oUsersRoot.cmsUsersTop = true;

			CMS.admin.tree._loadDepth = 1;
			CMS.admin.tree._loadSites(CMS.admin.tree.oSitesRoot);
			CMS.admin.tree._loadUsers(CMS.admin.tree.oUsersRoot);
		}, 
		_loadSites: function(oParentTreeNode){
			if(oParentTreeNode){
				IAdmin.ListSites(
					{"maxRowsToReturn": null, "ticket": null},
					function(results, args){
						// results contains: ID (int), Name (string), MembersOnly (bool), RecycleBin (bool)
						for (var i=0; i<results.length; i++) {
							if(!results[i]["RecycleBin"]){
								var node = new YAHOO.widget.HTMLNode(CMS.admin.tree._siteNodeHTML(results[i]["ID"], results[i]["Name"], results[i]["MembersOnly"]), oParentTreeNode, false, true); 
								node.cmsSite = results[i];
							}
						}
					},
					function(x, msg, args){
						alert(CMS.admin.language.phrase("left", "alertFailedToLoadSites"));
					},
					function(args){
						CMS.admin.tree._loadDepth--;
						if(CMS.admin.tree._loadDepth == 0){
							CMS.admin.tree.oTree.draw();
						}
					}
				);
			}
		}, 
		_loadUsers: function(oParentTreeNode){
			if(oParentTreeNode){
				CMS.admin.tree._loadDepth++;

				IAdmin.ListUsers(
					{"maxRowsToReturn": null, "ticket": null},
					function(results, args){
						// results contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string)
						for (var i=0; i<results.length; i++) {
							var node = new YAHOO.widget.HTMLNode(CMS.admin.tree._userNodeHTML(results[i]["ID"], results[i]["Name"], results[i]["Administrator"]), oParentTreeNode, false, true); 
							node.cmsUser = results[i];
						}
					},
					function(x, msg, args){
						alert(CMS.admin.language.phrase("left", "alertFailedToLoadUsers"));
					},
					function(args){
						CMS.admin.tree._loadDepth--;
						if(CMS.admin.tree._loadDepth == 0){
							CMS.admin.tree.oTree.draw();
						}
					}
				);
			}
		}, 
		_nodeClick: function (oArgs){
			try { if(oArgs.node.children.length > 0) oArgs.node.collapse(); } catch(ex){}
		},
		_nodeFocus: function (oArgs){
			CMS.admin.tree.contextTreeNode = null;
			if(oArgs.newNode){
				if(CMS.admin.nodeProperties) CMS.admin.nodeProperties.load(oArgs.newNode);
			}
		}, 
		_onShowContextMenu: function(p_oEvent){
			if(CMS.admin.tree.contextTreeNode){
				var tn = CMS.admin.tree.contextTreeNode;
				if(tn.cmsSite){
					this.getItem(0).cfg.setProperty("disabled", true);
					this.getItem(1).cfg.setProperty("disabled", false);
				} else if(tn.cmsUser){
					this.getItem(0).cfg.setProperty("disabled", true);
					this.getItem(1).cfg.setProperty("disabled", false);
				} else if(tn.cmsSitesTop){
					this.getItem(0).cfg.setProperty("disabled", false);
					this.getItem(1).cfg.setProperty("disabled", true);
				} else if(tn.cmsUsersTop){
					this.getItem(0).cfg.setProperty("disabled", false);
					this.getItem(1).cfg.setProperty("disabled", true);
				}
			}
		}, 
		_newSite: function(){
			if(CMS.admin.tree.oSitesRoot){
				IAdmin.SaveSite(
					{"ticket": null, "ID": null, "MembersOnly": false, "Name": CMS.admin.language.phrase("left", "newSiteName") },
					function(result, args){
						// result contains: ID (int)
						var yourVariable1 = result["ID"]; 
						IAdmin.GetSite(
							{"ticket": null, "ID": result["ID"]},
							function(result, args){
								// result contains: ID (int), Name (string), MembersOnly (bool), RecycleBin (bool)
								var node = new YAHOO.widget.HTMLNode(CMS.admin.tree._siteNodeHTML(result["ID"], result["Name"], result["MembersOnly"]), CMS.admin.tree.oSitesRoot, false, true); 
								node.cmsSite = result;
								CMS.admin.tree.oTree.draw();
								node.focus();
							},
							function(x, msg, args){
							},
							function(args){
							}
						);
					},
					function(x, msg, args){
						alert(CMS.admin.language.phrase("left", "alertFailedToAddSite"));
					},
					function(args){
					}
				);
			}
		}, 
		_newUser: function(){
			if(CMS.admin.tree.oUsersRoot){
				IAdmin.SaveUser(
					{"ticket": null, "ID": null, "Login": CMS.admin.language.phrase("left", "newUserLogin"), "Name": CMS.admin.language.phrase("left", "newUserName"), "Administrator": false, "Password": null},
					function(result, args){
						// result contains: ID (int)
						IAdmin.GetUser(
							{"ticket": null, "ID": result["ID"]},
							function(result, args){
								// result contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string)
								var node = new YAHOO.widget.HTMLNode(CMS.admin.tree._userNodeHTML(result["ID"], result["Name"], result["Administrator"]), CMS.admin.tree.oUsersRoot, false, true); 
								node.cmsUser = result;
								CMS.admin.tree.oTree.draw();
								node.focus();
							},
							function(x, msg, args){
							},
							function(args){
							}
						);
					},
					function(x, msg, args){
						alert(CMS.admin.language.phrase("left", "alertFailedToAddUser"));
					},
					function(args){
					}
				);
			}
		}, 
		_deleteSite: function(oTreeNode){
			if(oTreeNode && oTreeNode.cmsSite && oTreeNode.cmsSite["ID"]){
				if(confirm(CMS.admin.language.phrase("left", "confirmDeleteSiteStart") + oTreeNode.cmsSite["Name"] + CMS.admin.language.phrase("left", "confirmDeleteSiteEnd"))){ 
					IAdmin.DeleteSite(
						{"ticket": null, "ID": oTreeNode.cmsSite["ID"]},
						function(args){
							CMS.admin.tree.oTree.removeNode(oTreeNode);  
							CMS.admin.tree.contextTreeNode = null;
							CMS.admin.tree.oTree.draw();
							if(CMS.admin.nodeProperties) CMS.admin.nodeProperties.load(null);						
						},
						function(x, msg, args){
							alert(CMS.admin.language.phrase("left", "alertFailedToDeleteSite"));
						},
						function(args){
						}
					);
				}
			}
		}, 
		_deleteUser: function(oTreeNode){
			if(oTreeNode && oTreeNode.cmsUser && oTreeNode.cmsUser["ID"]){
				if(confirm(CMS.admin.language.phrase("left", "confirmDeleteUserStart") + oTreeNode.cmsUser["Name"] + CMS.admin.language.phrase("left", "confirmDeleteUserEnd"))){
					IAdmin.DeleteUser(
						{"ticket": null, "ID": oTreeNode.cmsUser["ID"]},
						function(args){
							CMS.admin.tree.oTree.removeNode(oTreeNode);  
							CMS.admin.tree.contextTreeNode = null;
							CMS.admin.tree.oTree.draw();
							if(CMS.admin.nodeProperties) CMS.admin.nodeProperties.load(null);						
						},
						function(x, msg, args){
							alert(CMS.admin.language.phrase("left", "alertFailedToDeleteUser"));
						},
						function(args){
						}
					);
				}
			}
		}, 
		_onTriggerContextMenu: function(p_oEvent) {
			var oTarget = this.contextEventTarget;
			CMS.admin.tree.contextTreeNode = CMS.admin.tree.oTree.getNodeByElement(oTarget);
			if (!CMS.admin.tree.contextTreeNode) {
				this.cancel();
			}
		}, 
		_newNode: function() {
			if(CMS.admin.tree.contextTreeNode){
				if(CMS.admin.tree.contextTreeNode.cmsSite){
					// Do nothing
				} else if(CMS.admin.tree.contextTreeNode.cmsUser){
					// Do nothing
				} else if(CMS.admin.tree.contextTreeNode.cmsSitesTop){
					CMS.admin.tree._newSite();
				} else if(CMS.admin.tree.contextTreeNode.cmsUsersTop){
					CMS.admin.tree._newUser();
				}
			}
		},
		_deleteNode: function() {
			if(CMS.admin.tree.contextTreeNode){
				if(CMS.admin.tree.contextTreeNode.cmsSite){
					CMS.admin.tree._deleteSite(CMS.admin.tree.contextTreeNode);
				} else if(CMS.admin.tree.contextTreeNode.cmsUser){
					CMS.admin.tree._deleteUser(CMS.admin.tree.contextTreeNode);
				} else if(CMS.admin.tree.contextTreeNode.cmsSitesTop){
					// Do nothing
				} else if(CMS.admin.tree.contextTreeNode.cmsUsersTop){
					// Do nothing
				}
			}
		}		
	};
	
} else {
	alert("CMSAdminTree: missing dependencies");
}