﻿if (CMS && CMS.admin && IAdmin) {
	CMS.admin.userSites = {
		oPanel: null, 
		markupIds: {
			panel: "userSitesPanel",
			filter: "userSitesFilter", 
			body: "userSitesBody", 
			error: "userSitesError"
		}, 
		sites: {},
		userID: null, 
		onCompleted: null, 
		onCompletedContext: null, 
		_header: function() {
			return CMS.admin.language.phrase("userSites", "panelHeader");
		}, 
		_body: function() {
			var s = [];
			s[s.length] = '<div style="width: 100%;">';
			s[s.length] = '    <table cellpadding="0" cellspacing="0">';
			s[s.length] = '        <tr>';
			s[s.length] = '            <td>' + CMS.admin.language.phrase("userSites", "filterLabelText") + '</td>';
			s[s.length] = '            <td><input id="' + CMS.admin.userSites.markupIds["filter"] + '" type="text" /></td>';
			s[s.length] = '            <td>&nbsp;</td>';
			s[s.length] = '            <td><input type="button" value="' + CMS.admin.language.phrase("userSites", "searchButtonText") + '" onclick="CMS.admin.userSites._search();" /></td>';
			s[s.length] = '            <td>&nbsp;</td>';
			s[s.length] = '            <td><input type="button" value="' + CMS.admin.language.phrase("userSites", "saveButtonText") + '" onclick="this.disabled = true; CMS.admin.userSites._save();" /></td>';
			s[s.length] = '        </tr>';
			s[s.length] = '    </table>';
			s[s.length] = '</div>';
			s[s.length] = '<div style="padding: 4px">&nbsp;</div>';
			s[s.length] = '<div id="';
			s[s.length] = CMS.admin.userSites.markupIds["body"];
			s[s.length] = '" style="width: 100%;">';
			s[s.length] = '</div>';
			return s.join("");
		}, 
		_footer: function() {
			return "";
		}, 
		_displayPanel: function(header, body, footer) {
			if(!CMS.admin.userSites.oPanel) {
				CMS.admin.userSites.oPanel = new YAHOO.widget.Panel(CMS.admin.userSites.markupIds["panel"], {
					draggable: true,
					dragOnly: true, 
					x: 100, 
					y: 100, 
					close: true, 
					modal: true, 
					width: "500px",
					height: "465px",
					constraintoviewport: true, 
					visible: false
				});
				CMS.admin.userSites.oPanel.subscribe("hide", function() {
				});
				CMS.admin.userSites.oPanel.subscribe("render", function() {
				});
				CMS.admin.userSites.oPanel.subscribe("show", function() {
				});
				CMS.admin.userSites.oPanel.render();
			}
			CMS.admin.userSites.oPanel.setHeader(header ? header : "");
			CMS.admin.userSites.oPanel.setBody(body ? body : "");
			CMS.admin.userSites.oPanel.setFooter(footer ? footer : "");
			CMS.admin.userSites.oPanel.show();
		}, 
		_search: function() {
			var el = document.getElementById(CMS.admin.userSites.markupIds["body"]);
			var filterEl = document.getElementById(CMS.admin.userSites.markupIds["filter"]);
			if(el && filterEl) {
				CMS.admin.userSites.sites = {};

				IAdmin.ListUserSites(
					{"maxRowsToReturn": null, "ticket": null, "UserID": CMS.admin.userSites.userID},
					function(results, args){
						// results contains: ID (int), Name (string), MembersOnly (bool), RecycleBin (bool), IsEditor (bool)
						var userSites = results;
						var isUserSite = function(id) {
							for(var i=0; i< userSites.length; i++) {
								if(userSites[i]["ID"] == id || userSites[i]["RecycleBin"]) return true;
							}
							return false;
						};
						IAdmin.ListSites(
							{"maxRowsToReturn": null, "ticket": null, "NameLike": ((filterEl.value) ? "%" + filterEl.value + "%" : "%" )},
							function(results, args){
								// results contains: ID (int), Name (string), MembersOnly (bool), RecycleBin (bool)
								var sites = [];
								for (var i=0; i<results.length; i++) {
									if(!results[i]["RecycleBin"] && !isUserSite(results[i]["ID"])) {
										sites[sites.length] = results[i];
									}
								}
								var config = {
									rowID: "ID", 
									columns: []
								};
								config.columns[config.columns.length] = {
									name: "Check", 
									label: CMS.admin.language.phrase("userSites", "colCheckLabel"), 
									columnType: RISE.DataTable.prototype.columnType.checkBox, 
									style: "width: 20px", 
									opCallback: "CMS.admin.userSites._updateList"
								}
								config.columns[config.columns.length] = {
									name: "Name", 
									label: CMS.admin.language.phrase("userSites", "colNameLabel"), 
									columnType: RISE.DataTable.prototype.columnType.label
								}
								var dt = new RISE.DataTable(config);						
								var span = dt.span(sites);
								for(var r in span){
									if(r != "_span"){
										span[r]["Check"]["callbackArgs"] = { ID: r }
									}
								}
								el.innerHTML = dt.render(span);
							},
							function(x, msg, args){
							},
							function(args){
							}
						);
					},
					function(x, msg, args){
					},
					function(args){
					}
				);
			}
		}, 
		_updateList: function(domEl, custArgs) {
			if(domEl && custArgs && custArgs["ID"]) {
				CMS.admin.userSites.sites[custArgs["ID"]] = domEl.checked;
			}
		}, 
		_save: function() {
			var sites = CMS.admin.userSites.sites;
			var cursor = 0;
			for(var s in sites){
				if(sites[s]){
					cursor++;
					IAdmin.SaveMembership(
						{"ticket": null, "UserID": CMS.admin.userSites.userID, "SiteID": s, "IsEditor": false},
						function(args){
						},
						function(x, msg, args){
						},
						function(args){
							cursor--;
							if(cursor == 0) {
								if(CMS.admin.userSites.onCompleted){
									if(CMS.admin.userSites.onCompletedContext) CMS.admin.userSites.onCompleted.call(CMS.admin.userSites.onCompletedContext);
									else CMS.admin.userSites.onCompleted();
								}
							}
						}
					);
				}
			}
			CMS.admin.userSites.oPanel.hide();
		}, 
		_error: function(msg) {
			var errorEl = document.getElementById(CMS.admin.userSites.markupIds["error"]);
			if(errorEl){
				errorEl.innerHTML = msg;
			}
		}, 
		render: function(userID, onCompleted, onCompletedContext) {
			if(userID) {
				CMS.admin.userSites.sites = {};
				CMS.admin.userSites.userID = userID;
				CMS.admin.userSites.onCompleted = onCompleted || null;
				CMS.admin.userSites.onCompletedContext = onCompletedContext || null;
				
				CMS.admin.userSites._displayPanel(CMS.admin.userSites._header(), CMS.admin.userSites._body(), CMS.admin.userSites._footer());
			}
		}
	};
} else {
	alert("CMS.admin.userSites: missing dependencies");
}
