﻿if (CMS && CMS.editor && CMS.session) {
	CMS.editor.layout = {
		markupIDs: {
			top: "topPanel", 
			left: "leftPanel", 
			center: "centerPanel"
		}, 
		oLayout: null,
		centerWidth: 0, 
		defaultTopHeader: "CMS", 
		
		load: function(){
			CMS.editor.layout.oLayout = new YAHOO.widget.Layout({
				units: [
					{ position: 'top', body: CMS.editor.layout.markupIDs["top"], header: CMS.editor.layout.defaultTopHeader, height: 70, gutter: '0 0 5px 0'},
					{ position: 'left', body: CMS.editor.layout.markupIDs["left"], header: CMS.editor.language.phrase("left", "title"), width: 300, resize: true, gutter: '0 5px 0 0', collapse: true, close: false, collapseSize: 50, scroll: true, animate: true },
					{ position: 'center', body: CMS.editor.layout.markupIDs["center"], scroll: true }
				]
			});
			CMS.editor.layout.oLayout.on('render', function() {
				CMS.editor.layout.oLayout.subscribe("resize", CMS.editor.layout._onResize);
				if(CMS.editor.nodeProperties){
					CMS.editor.nodeProperties.resize(CMS.editor.layout.oLayout.getSizes()["center"].w);
				}
			});			
			CMS.editor.layout.oLayout.render();
		}, 
		setTopHeader: function(header) {
			if(CMS.editor.layout.oLayout){
				CMS.editor.layout.oLayout.getUnitByPosition("top").header.innerHTML = CMS.editor.layout.oLayout.getUnitByPosition("top").header.innerHTML.replace(CMS.editor.layout.defaultTopHeader, header);
			}
		}, 
		_onResize: function(oArgs) {
			if(CMS.editor.layout.centerWidth != CMS.editor.layout.oLayout.getSizes()["center"].w){
				CMS.editor.layout.centerWidth = CMS.editor.layout.oLayout.getSizes()["center"].w;
				if(CMS.editor.nodeProperties){
					CMS.editor.nodeProperties.resize(CMS.editor.layout.centerWidth);
				}
			}
		}
	};
} else {
	alert("CMSLayout: missing dependencies");
}