﻿if (CMS && CMS.editor && IEdit) {
	CMS.editor.nodeProperties = {
		markup: {
			propertyContainer: "propertyContainer", 
			propertyTitle: "propertyTitle", 
			propertyToolbar: "propertyToolbar", 
			propertyDetails: "propertyDetails"}, 
		oTreeNode: null, 
		contentDetails: null, 
		propertyGrid: new RISE.PropertyGrid(), 
		resize: function(width) {
			var el = document.getElementById(CMS.editor.nodeProperties.markup["propertyContainer"]);
			if(el) {
				el.style.width = ((width-2) + "px");
			}
		}, 
		display: function(){
			document.getElementById(CMS.editor.nodeProperties.markup["propertyContainer"]).style.display = "block";
		}, 
		hide: function(){
			document.getElementById(CMS.editor.nodeProperties.markup["propertyContainer"]).style.display = "none";
		}, 
		getPhrase: function(item){
			return CMS.editor.language.phrase("center", item);
		}, 
		refresh: function(contentID){
		    if(CMS.editor.nodeProperties.oTreeNode && (!contentID || CMS.editor.nodeProperties.contentDetails && CMS.editor.nodeProperties.contentDetails["ContentID"] == contentID)) {
		        CMS.editor.nodeProperties.load(CMS.editor.nodeProperties.oTreeNode);
		    }
		}, 
		load: function(treeNode){
			var phrase = CMS.editor.nodeProperties.getPhrase;
			if(treeNode && treeNode.cmsData && treeNode.cmsData.type && treeNode.cmsData.id){
				CMS.editor.nodeProperties.oTreeNode = treeNode;
				CMS.editor.nodeProperties.contentDetails = null;
				if(treeNode.cmsData.type == "Content"){
					CMS.editor.nodeProperties.propertyGrid.init();					
					IEdit.GetContentDetails(
						{"ticket": CMS.session.ticket, "ContentID": treeNode.cmsData.id},
						function(result, args){
							// result contains: ContentID (int), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), SiteID (int), ParentID (int_or_null), friendlyName (string), hasArticle (bool), ArticleID (int), ArticleEditor (string_or_null), ArticleData (text_or_null), hasDocument (bool), DocumentID (int), DocumentMimeType (string), hasImage (bool), ImageID (int), ImageMimeType (string), ImageWidth (int), ImageHeight (int), hasLink (bool), LinkID (int), LinkTargetURI (string_or_null), LinkTargetURL (string_or_null), hasMessage (bool), MessageID (int), MessageSource (string_or_null), MessageData (text_or_null)
							CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "friendlyName", label: phrase("propContentFriendlyName"), value: result["friendlyName"], type: "label" });
							CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "ContentTitle", label: phrase("propContentTitle"), value: result["ContentTitle"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur" });
							CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "ContentAbstract", label: phrase("propContentAbstract"), value: result["ContentAbstract"], type: "textArea", callback: "CMS.editor.nodeProperties._onBlur", callbackArgs: {ContentID: result["ContentID"]}, style: "height: 54px;" });
							CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "ContentSortOrder", label: phrase("propContentSortOrder"), value: result["ContentSortOrder"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur" });
							CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "ContentCustom", label: phrase("propContentCustom"), value: result["ContentCustom"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur" });
							CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "ContentSUID", label: phrase("propContentSUID"), value: result["ContentSUID"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur" });
							CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "ContentType", label: phrase("propContentType"), value: result["ContentType"], type: "label" });
							//CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "ContentID", label: phrase("propContentID"), value: result["ContentID"], type: "label" });
							CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "ContentPublished", label: phrase("propContentPublished"), value: result["ContentPublished"], type: "checkBox", callback: "CMS.editor.nodeProperties._onBlur" });
							CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupBasic"), { name: "ContentAllowMessages", label: phrase("propContentAllowMessages"), value: result["ContentAllowMessages"], type: "checkBox", callback: "CMS.editor.nodeProperties._onBlur" });

							if(result["hasArticle"]){
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupArticle"), { name: "ArticleEditor", label: phrase("propArticleEditor"), value: result["ArticleEditor"], type: "dropdown", callback: "CMS.editor.nodeProperties._onBlur", options: CMS.config.articleEditors, style: "width: 150px;" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupArticle"), { name: "ArticleData", label: phrase("propArticleData"), value: ((result["ArticleData"])?result["ArticleData"].length.toString():"0"), type: "label" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupArticle"), { name: "EditArticle", label: phrase("propEditArticle"), value: phrase("articleEditLinkLabel"), type: "link", callback: "CMS.editor.nodeProperties._opEditArticle", callbackArgs: {ContentID: result["ContentID"]} });
								if(CMS.editor.siteTree && CMS.editor.siteTree.siteHints && CMS.editor.siteTree.siteHints[result["SiteID"]] && CMS.editor.siteTree.siteHints[result["SiteID"]].length > 1) {
									CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupArticle"), { name: "ArticleHint", label: phrase("propArticleHint"), value: result["ArticleHint"], type: "dropdown", callback: "CMS.editor.nodeProperties._onBlur", options: CMS.editor.siteTree.siteHints[result["SiteID"]] });
								}
							}
							if(result["hasDocument"]){
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupDocument"), { name: "DocumentMimeType", label: phrase("propDocumentMimeType"), value: result["DocumentMimeType"], type: "label" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupDocument"), { name: "DocumentDownload", label: phrase("propDocumentDownload"), value: phrase("documentDownloadLinkLabel"), type: "link", callback: "CMS.editor.nodeProperties._opDownload", target: "_blank", callbackArgs: {s:"str", b:true, i:32} });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupDocument"), { name: "DocumentUpload", label: phrase("propDocumentUpload"), value: "", type: "fileUpload", callback: "CMS.editor.nodeProperties._opUpload", action: CMS.config.upload, target: "formTarget", uploadTicket: CMS.session.ticket, uploadContentID: result["ContentID"], uploadCallback: "parent.CMS.editor.nodeProperties._opUploadComplete" });
							}
							if(result["hasImage"]){
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupImage"), { name: "ImageMimeType", label: phrase("propImageMimeType"), value: result["ImageMimeType"], type: "label" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupImage"), { name: "ImageSize", label: phrase("propImageSize"), value: ((result["ImageWidth"] == 0 || result["ImageHeight"] == 0) ? "" : result["ImageWidth"] + " x " + result["ImageHeight"] + " px"), type: "label" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupImage"), { name: "ImageDownload", label: phrase("propImageDownload"), value: phrase("imageDownloadLinkLabel"), type: "link", callback: "CMS.editor.nodeProperties._opDownload", target: "_blank" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupImage"), { name: "ImageUpload", label: phrase("propImageUpload"), value: "", type: "fileUpload", callback: "CMS.editor.nodeProperties._opUpload", action: CMS.config.upload, target: "formTarget", uploadTicket: CMS.session.ticket, uploadContentID: result["ContentID"], uploadCallback: "parent.CMS.editor.nodeProperties._opUploadComplete" });								
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupImage"), { name: "ImageAlternative", label: phrase("propImageAlternative"), value: result["ImageAlternative"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupImage"), { name: "ImageThumb", label: phrase("propImageThumb"), value: "", type: "image", src: CMS.config.thumbnail + "?ticket=" + CMS.session.ticket + "&content=" + result["ContentID"].toString() + "&rnd=" + new Date().getTime().toString()});
							}
							if(result["hasLink"]){
								var uriEl = "<table><tr><td><input id=\"" + CMS.editor.nodeProperties.propertyGrid._makeID("LinkTargetURI") + "\" onblur=\"CMS.editor.nodeProperties._onBlur(this);\" type=\"text\" value=\"" + ((result["LinkTargetURI"]) ? CMS.editor.nodeProperties.propertyGrid.htmlEncode(result["LinkTargetURI"]) : "") + "\" /></td><td>&nbsp;</td><td><a href=\"\" onclick=\"CMS.editor.nodeProperties._onFindTargetURI('" + CMS.editor.nodeProperties.propertyGrid._makeID("LinkTargetURI") + "'); return false;\">" + phrase("propLinkTargetURIFind") + "</a></td></tr></table>"
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupLink"), { name: "LinkTargetURI", label: phrase("propLinkTargetURI"), value: uriEl, type: "custom" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupLink"), { name: "LinkTargetURL", label: phrase("propLinkTargetURL"), value: result["LinkTargetURL"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur", title: phrase("propLinkTargetURLTooltip") });
							}
							if(result["hasMessage"]){
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupMessage"), { name: "MessageSource", label: phrase("propMessageSource"), value: result["MessageSource"], type: "label" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupMessage"), { name: "MessageData", label: phrase("propMessageData"), value: result["MessageData"], type: "textArea", callback: "CMS.editor.nodeProperties._onBlur", callbackArgs: {ContentID: result["ContentID"]}, style: "height: 54px;" });
							}
							if(result["ContentType"] != "None"){
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupMetaTags"), { name: "ContentKeywords", label: phrase("propContentKeywords"), value: result["ContentKeywords"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupMetaTags"), { name: "ContentDescription", label: phrase("propContentDescription"), value: result["ContentDescription"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupMetaTags"), { name: "ContentRobots", label: phrase("propContentRobots"), value: result["ContentRobots"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur" });
								CMS.editor.nodeProperties.propertyGrid.addProperty(phrase("groupMetaTags"), { name: "ContentLanguage", label: phrase("propContentLanguage"), value: result["ContentLanguage"], type: "textBox", callback: "CMS.editor.nodeProperties._onBlur" });
							}
							CMS.editor.nodeProperties.contentDetails = result;
							CMS.editor.nodeProperties.oTreeNode.setHtml(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(CMS.editor.nodeProperties.contentDetails["ContentType"], CMS.editor.nodeProperties.contentDetails["ContentPublished"]), CMS.editor.nodeProperties.contentDetails["ContentTitle"], CMS.editor.nodeProperties.contentDetails["ContentID"]));
						},
						function(x, msg, args){
							CMS.editor.nodeProperties.contentDetails = null;
							CMS.editor.nodeProperties.hide();
							alert(phrase("alertErrorLoadingContent"));
						},
						function(args){
							CMS.editor.nodeProperties._setPropertyTitle(CMS.editor.nodeProperties.contentDetails["ContentType"], CMS.editor.nodeProperties.contentDetails["friendlyName"]);
							if(CMS.editor.nodeProperties.markup["propertyDetails"]){
								var el = document.getElementById(CMS.editor.nodeProperties.markup["propertyDetails"]);
								if(el){
									el.innerHTML = CMS.editor.nodeProperties.propertyGrid.render();
								}
							}
							if(CMS.editor.nodeProperties.markup["propertyToolbar"]){
								var el = document.getElementById(CMS.editor.nodeProperties.markup["propertyToolbar"]);
								if(el){
									CMS.editor.nodeProperties._toolbarForContent(el);
								}
							}
							CMS.editor.nodeProperties.display();
						}
					);
				} else if (treeNode.cmsData.type == "Site") {
					CMS.editor.nodeProperties._setPropertyTitle("Site", treeNode.cmsData.name);
					if(CMS.editor.nodeProperties.markup["propertyDetails"]){
						var el = document.getElementById(CMS.editor.nodeProperties.markup["propertyDetails"]);
						if(el){
							el.innerHTML = "";
						}
					}
					if(CMS.editor.nodeProperties.markup["propertyToolbar"]){
						var el = document.getElementById(CMS.editor.nodeProperties.markup["propertyToolbar"]);
						if(el){
							CMS.editor.nodeProperties._toolbarForSite(el);
						}
					}					
					CMS.editor.nodeProperties.display();
				}
			} else {
				CMS.editor.nodeProperties.hide();
			}
		}, 
		save: function(){
			var phrase = CMS.editor.nodeProperties.getPhrase;
			if(CMS.editor.nodeProperties.contentDetails){
				switch(CMS.editor.nodeProperties.contentDetails["ContentType"]){
					case "None":
						IEdit.SaveNone(
							{"ticket": CMS.session.ticket, 
								"ContentID": CMS.editor.nodeProperties.contentDetails["ContentID"], 
								"ContentTitle": CMS.editor.nodeProperties.contentDetails["ContentTitle"], 
								"ContentSortOrder": CMS.editor.nodeProperties.contentDetails["ContentSortOrder"], 
								"SiteID": CMS.editor.nodeProperties.contentDetails["SiteID"], 
								"ContentPublished": CMS.editor.nodeProperties.contentDetails["ContentPublished"], 
								"ContentKeywords": CMS.editor.nodeProperties.contentDetails["ContentKeywords"], 
								"ContentDescription": CMS.editor.nodeProperties.contentDetails["ContentDescription"], 
								"ContentRobots": CMS.editor.nodeProperties.contentDetails["ContentRobots"], 
								"ContentLanguage": CMS.editor.nodeProperties.contentDetails["ContentLanguage"], 
								"ContentCustom": CMS.editor.nodeProperties.contentDetails["ContentCustom"], 
								"ContentSUID": CMS.editor.nodeProperties.contentDetails["ContentSUID"], 
								"ContentAllowMessages": CMS.editor.nodeProperties.contentDetails["ContentAllowMessages"], 
								"ContentAbstract": CMS.editor.nodeProperties.contentDetails["ContentAbstract"], 
								"ParentID": CMS.editor.nodeProperties.contentDetails["ParentID"]},
							function(result, args){
							},
							function(x, msg, args){
								alert(phrase("alertErrorSavingFolder"));
							},
							function(args){
							}
						);
					break;

					case "Link":
						IEdit.SaveLink(
							{"ticket": CMS.session.ticket, 
								"LinkID": CMS.editor.nodeProperties.contentDetails["LinkID"], 
								"ContentID": CMS.editor.nodeProperties.contentDetails["ContentID"], 
								"ContentTitle": CMS.editor.nodeProperties.contentDetails["ContentTitle"], 
								"ContentSortOrder": CMS.editor.nodeProperties.contentDetails["ContentSortOrder"], 
								"SiteID": CMS.editor.nodeProperties.contentDetails["SiteID"], 
								"ContentPublished": CMS.editor.nodeProperties.contentDetails["ContentPublished"], 
								"ContentKeywords": CMS.editor.nodeProperties.contentDetails["ContentKeywords"], 
								"ContentDescription": CMS.editor.nodeProperties.contentDetails["ContentDescription"], 
								"ContentRobots": CMS.editor.nodeProperties.contentDetails["ContentRobots"], 
								"ContentLanguage": CMS.editor.nodeProperties.contentDetails["ContentLanguage"], 
								"ContentCustom": CMS.editor.nodeProperties.contentDetails["ContentCustom"], 
								"ContentSUID": CMS.editor.nodeProperties.contentDetails["ContentSUID"], 
								"ContentAllowMessages": CMS.editor.nodeProperties.contentDetails["ContentAllowMessages"], 
								"ContentAbstract": CMS.editor.nodeProperties.contentDetails["ContentAbstract"], 
								"ParentID": CMS.editor.nodeProperties.contentDetails["ParentID"], 
								"LinkTargetURI": CMS.editor.nodeProperties.contentDetails["LinkTargetURI"], 
								"LinkTargetURL": CMS.editor.nodeProperties.contentDetails["LinkTargetURL"]},
							function(result, args){
							},
							function(x, msg, args){
								alert(phrase("alertErrorSavingLink"));
							},
							function(args){
							}
						);					
					break;

					case "Document":
						IEdit.SaveDocument(
							{"ticket": CMS.session.ticket, 
								"DocumentID": CMS.editor.nodeProperties.contentDetails["DocumentID"], 
								"DocumentMimeType": CMS.editor.nodeProperties.contentDetails["DocumentMimeType"], 
								"ContentID": CMS.editor.nodeProperties.contentDetails["ContentID"], 
								"ContentTitle": CMS.editor.nodeProperties.contentDetails["ContentTitle"], 
								"ContentSortOrder": CMS.editor.nodeProperties.contentDetails["ContentSortOrder"], 
								"SiteID": CMS.editor.nodeProperties.contentDetails["SiteID"], 
								"ContentPublished": CMS.editor.nodeProperties.contentDetails["ContentPublished"], 
								"ContentKeywords": CMS.editor.nodeProperties.contentDetails["ContentKeywords"], 
								"ContentDescription": CMS.editor.nodeProperties.contentDetails["ContentDescription"], 
								"ContentRobots": CMS.editor.nodeProperties.contentDetails["ContentRobots"], 
								"ContentLanguage": CMS.editor.nodeProperties.contentDetails["ContentLanguage"], 
								"ContentCustom": CMS.editor.nodeProperties.contentDetails["ContentCustom"], 
								"ContentSUID": CMS.editor.nodeProperties.contentDetails["ContentSUID"], 
								"ContentAllowMessages": CMS.editor.nodeProperties.contentDetails["ContentAllowMessages"], 
								"ContentAbstract": CMS.editor.nodeProperties.contentDetails["ContentAbstract"], 
								"ParentID": CMS.editor.nodeProperties.contentDetails["ParentID"]},
							function(result, args){
							},
							function(x, msg, args){
								alert(phrase("alertErrorSavingDocument"));
							},
							function(args){
							}
						);
					break;

					case "Image":
						IEdit.SaveImage(
							{"ticket": CMS.session.ticket, 
								"ImageID": CMS.editor.nodeProperties.contentDetails["ImageID"], 
								"ImageMimeType": CMS.editor.nodeProperties.contentDetails["ImageMimeType"], 
								"ImageWidth": CMS.editor.nodeProperties.contentDetails["ImageWidth"], 
								"ImageHeight": CMS.editor.nodeProperties.contentDetails["ImageHeight"], 
								"ImageAlternative": CMS.editor.nodeProperties.contentDetails["ImageAlternative"], 
								"ContentID": CMS.editor.nodeProperties.contentDetails["ContentID"], 
								"ContentTitle": CMS.editor.nodeProperties.contentDetails["ContentTitle"], 
								"ContentSortOrder": CMS.editor.nodeProperties.contentDetails["ContentSortOrder"], 
								"SiteID": CMS.editor.nodeProperties.contentDetails["SiteID"], 
								"ContentPublished": CMS.editor.nodeProperties.contentDetails["ContentPublished"], 
								"ContentKeywords": CMS.editor.nodeProperties.contentDetails["ContentKeywords"], 
								"ContentDescription": CMS.editor.nodeProperties.contentDetails["ContentDescription"], 
								"ContentRobots": CMS.editor.nodeProperties.contentDetails["ContentRobots"], 
								"ContentLanguage": CMS.editor.nodeProperties.contentDetails["ContentLanguage"], 
								"ContentCustom": CMS.editor.nodeProperties.contentDetails["ContentCustom"], 
								"ContentSUID": CMS.editor.nodeProperties.contentDetails["ContentSUID"], 
								"ContentAllowMessages": CMS.editor.nodeProperties.contentDetails["ContentAllowMessages"], 
								"ContentAbstract": CMS.editor.nodeProperties.contentDetails["ContentAbstract"], 
								"ParentID": CMS.editor.nodeProperties.contentDetails["ParentID"]},
							function(result, args){
							},
							function(x, msg, args){
								alert(phrase("alertErrorSavingImage"));
							},
							function(args){
							}
						);
					break;

					case "Article":
						IEdit.SaveArticle(
							{"ticket": CMS.session.ticket, 
								"ArticleID": CMS.editor.nodeProperties.contentDetails["ArticleID"], 
								"ArticleEditor": CMS.editor.nodeProperties.contentDetails["ArticleEditor"], 
								"ArticleData": CMS.editor.nodeProperties.contentDetails["ArticleData"], 
								"ContentID": CMS.editor.nodeProperties.contentDetails["ContentID"], 
								"ContentTitle": CMS.editor.nodeProperties.contentDetails["ContentTitle"], 
								"ContentSortOrder": CMS.editor.nodeProperties.contentDetails["ContentSortOrder"], 
								"SiteID": CMS.editor.nodeProperties.contentDetails["SiteID"], 
								"ContentPublished": CMS.editor.nodeProperties.contentDetails["ContentPublished"], 
								"ContentKeywords": CMS.editor.nodeProperties.contentDetails["ContentKeywords"], 
								"ContentDescription": CMS.editor.nodeProperties.contentDetails["ContentDescription"], 
								"ContentRobots": CMS.editor.nodeProperties.contentDetails["ContentRobots"], 
								"ContentLanguage": CMS.editor.nodeProperties.contentDetails["ContentLanguage"], 
								"ContentCustom": CMS.editor.nodeProperties.contentDetails["ContentCustom"], 
								"ContentSUID": CMS.editor.nodeProperties.contentDetails["ContentSUID"], 
								"ContentAllowMessages": CMS.editor.nodeProperties.contentDetails["ContentAllowMessages"], 
								"ContentAbstract": CMS.editor.nodeProperties.contentDetails["ContentAbstract"], 
								"ArticleHint": CMS.editor.nodeProperties.contentDetails["ArticleHint"], 
								"ParentID": CMS.editor.nodeProperties.contentDetails["ParentID"]},
							function(result, args){
							},
							function(x, msg, args){
								alert(phrase("alertErrorSavingArticle"));
							},
							function(args){
							}
						);
					break;

					case "Message":
						IEdit.SaveMessage(
							{"ticket": CMS.session.ticket, 
								"MessageID": CMS.editor.nodeProperties.contentDetails["MessageID"], 
								"MessageSource": CMS.editor.nodeProperties.contentDetails["MessageSource"], 
								"MessageData": CMS.editor.nodeProperties.contentDetails["MessageData"], 
								"ContentID": CMS.editor.nodeProperties.contentDetails["ContentID"], 
								"ContentTitle": CMS.editor.nodeProperties.contentDetails["ContentTitle"], 
								"ContentSortOrder": CMS.editor.nodeProperties.contentDetails["ContentSortOrder"], 
								"SiteID": CMS.editor.nodeProperties.contentDetails["SiteID"], 
								"ContentPublished": CMS.editor.nodeProperties.contentDetails["ContentPublished"], 
								"ContentKeywords": CMS.editor.nodeProperties.contentDetails["ContentKeywords"], 
								"ContentDescription": CMS.editor.nodeProperties.contentDetails["ContentDescription"], 
								"ContentRobots": CMS.editor.nodeProperties.contentDetails["ContentRobots"], 
								"ContentLanguage": CMS.editor.nodeProperties.contentDetails["ContentLanguage"], 
								"ContentCustom": CMS.editor.nodeProperties.contentDetails["ContentCustom"], 
								"ContentSUID": CMS.editor.nodeProperties.contentDetails["ContentSUID"], 
								"ContentAllowMessages": CMS.editor.nodeProperties.contentDetails["ContentAllowMessages"], 
								"ContentAbstract": CMS.editor.nodeProperties.contentDetails["ContentAbstract"], 
								"ParentID": CMS.editor.nodeProperties.contentDetails["ParentID"]},
							function(result, args){
							},
							function(x, msg, args){
								alert(phrase("alertErrorSavingMessage"));
							},
							function(args){
							}
						);
					break;
				}
			}
		}, 
		_onBlur: function(domEl){
			var phrase = CMS.editor.nodeProperties.getPhrase;
			if(domEl){
				if(!CMS.editor.nodeProperties.contentDetails)
					alert(phrase("alertContentDataMissing"));
				else {
					switch(CMS.editor.nodeProperties.propertyGrid.MarkupIDToPropertyName(domEl.id)){
						case "ContentTitle":
							if(CMS.editor.nodeProperties.contentDetails["ContentTitle"] != domEl.value){
								if(domEl.value == null || domEl.value.toString() == ""){
									alert(phrase("alertContentMustHaveTitle"));
									domEl.value = CMS.editor.nodeProperties.contentDetails["ContentTitle"];
								} else {
									CMS.editor.nodeProperties.contentDetails["ContentTitle"] = domEl.value;
									CMS.editor.nodeProperties.save();
									CMS.editor.nodeProperties.oTreeNode.setHtml(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(CMS.editor.nodeProperties.contentDetails["ContentType"], CMS.editor.nodeProperties.contentDetails["ContentPublished"]), CMS.editor.nodeProperties.contentDetails["ContentTitle"], CMS.editor.nodeProperties.contentDetails["ContentID"]));
								}
							}
						break;
						
						case "ContentSortOrder":
							if(CMS.editor.nodeProperties.contentDetails["ContentSortOrder"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ContentSortOrder"] = ((domEl.value) ? domEl.value:null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ContentCustom":
							if(CMS.editor.nodeProperties.contentDetails["ContentCustom"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ContentCustom"] = ((domEl.value) ? domEl.value:null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ContentSUID":
							if(CMS.editor.nodeProperties.contentDetails["ContentSUID"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ContentSUID"] = ((domEl.value) ? domEl.value:null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ContentPublished":
							if(CMS.editor.nodeProperties.contentDetails["ContentPublished"] != domEl.checked){
								CMS.editor.nodeProperties.contentDetails["ContentPublished"] = domEl.checked;
								CMS.editor.nodeProperties.save();
								CMS.editor.nodeProperties.oTreeNode.setHtml(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(CMS.editor.nodeProperties.contentDetails["ContentType"], CMS.editor.nodeProperties.contentDetails["ContentPublished"]), CMS.editor.nodeProperties.contentDetails["ContentTitle"], CMS.editor.nodeProperties.contentDetails["ContentID"]));
							}
						break;
						
						case "ContentAllowMessages":
							if(CMS.editor.nodeProperties.contentDetails["ContentAllowMessages"] != domEl.checked){
								CMS.editor.nodeProperties.contentDetails["ContentAllowMessages"] = domEl.checked;
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ContentKeywords":
							if(CMS.editor.nodeProperties.contentDetails["ContentKeywords"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ContentKeywords"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ContentDescription":
							if(CMS.editor.nodeProperties.contentDetails["ContentDescription"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ContentDescription"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ContentRobots":
							if(CMS.editor.nodeProperties.contentDetails["ContentRobots"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ContentRobots"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ContentLanguage":
							if(CMS.editor.nodeProperties.contentDetails["ContentLanguage"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ContentLanguage"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;
												
						case "MessageData":
							if(CMS.editor.nodeProperties.contentDetails["MessageData"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["MessageData"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "LinkTargetURI":
							if(CMS.editor.nodeProperties.contentDetails["LinkTargetURI"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["LinkTargetURI"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "LinkTargetURL":
							if(CMS.editor.nodeProperties.contentDetails["LinkTargetURL"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["LinkTargetURL"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ImageAlternative":
							if(CMS.editor.nodeProperties.contentDetails["ImageAlternative"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ImageAlternative"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ContentAbstract":
							if(CMS.editor.nodeProperties.contentDetails["ContentAbstract"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ContentAbstract"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						case "ArticleHint":
							if(CMS.editor.nodeProperties.contentDetails["ArticleHint"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ArticleHint"] = ((domEl.value) ? domEl.value.toString():null);
								CMS.editor.nodeProperties.save();
							}
						break;

						case "ArticleEditor":
							if(domEl.value && CMS.editor.nodeProperties.contentDetails["ArticleEditor"] != domEl.value){
								CMS.editor.nodeProperties.contentDetails["ArticleEditor"] = ((domEl.value) ? domEl.value.toString() : null);
								CMS.editor.nodeProperties.save();
							}
						break;
						
						default:
							alert(phrase("alertUnknownData"));
						break;
					}
				}
			}
		}, 
		_onFindTargetURI: function(domElId){
			CMS.editor.search.byTitle(document.getElementById(domElId).value, CMS.editor.nodeProperties._onFindCallback, null, { "domElId": domElId });
		}, 
		_onFindCallback: function(data, customData){
			if(data && data["ContentID"] && customData && customData["domElId"]){
				document.getElementById(customData["domElId"]).value = data["ContentID"].toString();
				CMS.editor.nodeProperties.contentDetails["LinkTargetURI"] = data["ContentID"].toString();
				CMS.editor.nodeProperties.save();
				return true;
			}
			return false;
		}, 
		_toolbarForSite: function(toolbarEl){
			if(toolbarEl) {
				var toolbarImages = [];
				var group = [];
				group[group.length] = { src:"images/icon_folder_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddFolder"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddFolder"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "None"); } };
				group[group.length] = { src:"images/icon_link_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddLink"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddLink"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Link"); } };
				group[group.length] = { src:"images/icon_doc_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddDocument"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddDocument"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Document"); } };
				group[group.length] = { src:"images/icon_image_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddImage"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddImage"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Image"); } };
				group[group.length] = { src:"images/icon_article_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddArticle"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddArticle"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Article"); } };
				group[group.length] = { src:"images/icon_message_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddMessage"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddMessage"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Message"); } };
				if(group.length > 0) toolbarImages[toolbarImages.length] = group;
				new RISE.Toolbar(toolbarEl, {imageWidth: 16, imageHeight: 16, imageBlocks: toolbarImages}).render();				
			}
		},
		_toolbarForContent: function(toolbarEl){
			if(toolbarEl) {
				var toolbarImages = [];
				var group = [];
				group[group.length] = { src:"images/icon_delete.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarDeleteNode"), title: CMS.editor.nodeProperties.getPhrase("toolbarDeleteNode"), onclick: function(ev){ CMS.editor.siteTree._deleteContentNode(CMS.editor.nodeProperties.oTreeNode); } };
				toolbarImages[toolbarImages.length] = group;
				group = [];

				group[group.length] = { src:"images/icon_folder_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddFolder"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddFolder"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "None"); } };
				group[group.length] = { src:"images/icon_link_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddLink"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddLink"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Link"); } };
				group[group.length] = { src:"images/icon_doc_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddDocument"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddDocument"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Document"); } };
				group[group.length] = { src:"images/icon_image_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddImage"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddImage"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Image"); } };
				group[group.length] = { src:"images/icon_article_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddArticle"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddArticle"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Article"); } };
				group[group.length] = { src:"images/icon_message_add.png", alt: CMS.editor.nodeProperties.getPhrase("toolbarAddMessage"), title: CMS.editor.nodeProperties.getPhrase("toolbarAddMessage"), onclick: function(ev){ CMS.editor.siteTree._addContent(CMS.editor.nodeProperties.oTreeNode, "Message"); } };
				toolbarImages[toolbarImages.length] = group;
				new RISE.Toolbar(toolbarEl, {imageWidth: 16, imageHeight: 16, imageBlocks: toolbarImages}).render();				
			}
		}, 
		_opDownload: function(el, customArgs){
			document.getElementById("frmDownloadTicket").value = CMS.session.ticket;
			document.getElementById("frmDownloadContent").value = CMS.editor.nodeProperties.contentDetails["ContentID"];
			document.getElementById("frmDownload").submit();
			return false;
		}, 
		_opOpen: function(){
			document.getElementById("frmOpenTicket").value = CMS.session.ticket;
			document.getElementById("frmOpenContent").value = CMS.editor.nodeProperties.contentDetails["ContentID"];
			document.getElementById("frmOpen").submit();
			return false;
		}, 
		_opUpload: function(el, formID, progressID, customArgs){
			try{
				document.getElementById(progressID).innerHTML = "<img src=\"images/status_anim.gif\" />";
				document.getElementById(formID).submit();
			} catch(ex){}
			return false;
		}, 
		_opUploadComplete: function(o, progressID){
			try{
				document.getElementById(progressID).innerHTML = "";
				CMS.editor.nodeProperties.load(CMS.editor.nodeProperties.oTreeNode);
				document.getElementById("formTarget").src = "";
			} catch(ex){}
			return false;
		}, 
		_opEditArticle: function(el, customArgs){
			if(customArgs && customArgs["ContentID"]){
				if(CMS.editor.nodeProperties.contentDetails["ArticleEditor"] == "Xinha")
					window.open("CMSArticleEditor.htm?contentID=" + customArgs["ContentID"], "ArticleEditor");
				else window.open("CMSArticleTextEditor.htm?contentID=" + customArgs["ContentID"], "ArticleEditor");
			}
			return false;
		}, 
		_opEditMessage: function(){
			alert("Edit Message");
			return false;
		},
		_opEditLink: function(){
			alert("Edit Link");
			return false;
		}, 
		_getPropertyTitle: function (type){
			var phrase = CMS.editor.nodeProperties.getPhrase;
			switch(type){
				case "Site":
					return phrase("typeSite");
				break;
				
				case "None":
					return phrase("typeFolder");
				break;

				case "Link":
					return phrase("typeLink");
				break;

				case "Document":
					return phrase("typeDocument");
				break;

				case "Image":
					return phrase("typeImage");
				break;

				case "Article":
					return phrase("typeArticke");
				break;

				case "Message":
					return phrase("typeMessage");
				break;
			}
			return "&nbsp;"
		}, 
		_setPropertyTitle: function (type, friendlyName){
			if(CMS.editor.nodeProperties.markup["propertyTitle"]){
				var el = document.getElementById(CMS.editor.nodeProperties.markup["propertyTitle"]);
				if(el){
					el.innerHTML = CMS.editor.nodeProperties._getPropertyTitle(type) + ((friendlyName)? " :: " + friendlyName : "");
				}
			}
		}
	};
} else {
	alert(CMS.editor.language.phrase("center", "alertMissingDependencies"));
}