﻿if (CMS && CMS.editor && IEdit) {
	CMS.editor.search = {
		oPanel: null, 
		markupIds: {
			container: "searchContainer",
			panel: "searchPanel", 
			results: "searchResults", 
			filter: "searchFilter"
		}, 
		_columnDefs: [
            {key: "Type", label: CMS.editor.language.phrase("search", "columnType"), className:"searchColumn", width: 32, formatter: "typeFormatter", sortable:true, sortOptions:{defaultDir:YAHOO.widget.DataTable.CLASS_DESC}},
            {key: "Site", label: CMS.editor.language.phrase("search", "columnSite"), className:"searchColumn", width: 180, sortable:true, sortOptions:{defaultDir:YAHOO.widget.DataTable.CLASS_DESC}},
            {key: "Title", label: CMS.editor.language.phrase("search", "columnTitle"), className:"searchColumn", width: 330, sortable:true, sortOptions:{defaultDir:YAHOO.widget.DataTable.CLASS_DESC}}
        ], 
		_responseSchema: {
            fields: ["Type", "Site", "Title", "SiteID", "ContentID"]
        },
		_dataSource: null,
		_dataTable: null,
		_rowClickCB: null, 
		_rowDblClickCB: null, 
		_callbackArgs: null, 
		
		getPhrase: function(item){
			return CMS.editor.language.phrase("search", item);
		}, 
		byTitle: function(filter, rowClickCB, rowDblClickCB, callbackArgs){
			var phrase = CMS.editor.search.getPhrase;
			CMS.editor.search._rowClickCB = rowClickCB || null;
			CMS.editor.search._rowDblClickCB = rowDblClickCB || null;
			CMS.editor.search._callbackArgs = callbackArgs || null;
			CMS.editor.search._displayPanel(phrase("byTitleHeader"), "<table><tr><td>" + phrase("byTitleFilterLabel") + "</td><td>&nbsp;</td><td><input id=\"" + CMS.editor.search.markupIds["filter"] + "\" type=\"text\" value=\"" + ((filter && typeof(filter) === "string") ? filter : "") + "\" style=\"width:300px\" /></td><td>&nbsp;</td><td><input type=\"button\" value=\"" + phrase("byTitleButtonText") + "\" onclick=\"CMS.editor.search._findContentByTitle()\" /></td></tr></table><div style=\"margin-top: 10px; height: 390px; width:620px; overflow:auto;\"><div id=\"" + CMS.editor.search.markupIds["results"] + "\"></div></div>", "");
			if(filter && typeof(filter) === "string")
				CMS.editor.search._getContentById();
		}, 
		byArticleText: function(filter, rowClickCB, rowDblClickCB, callbackArgs){
			var phrase = CMS.editor.search.getPhrase;
			CMS.editor.search._rowClickCB = rowClickCB || null;
			CMS.editor.search._rowDblClickCB = rowDblClickCB || null;
			CMS.editor.search._callbackArgs = callbackArgs || null;
			CMS.editor.search._displayPanel(phrase("byArticleTextHeader"), "<table><tr><td>" + phrase("byArticleTextFilterLabel") + "</td><td>&nbsp;</td><td><input id=\"" + CMS.editor.search.markupIds["filter"] + "\" type=\"text\" value=\"" + ((filter && typeof(filter) === "string") ? filter : "") + "\" style=\"width:300px\" /></td><td>&nbsp;</td><td><input type=\"button\" value=\"" + phrase("byArticleTextButtonText") + "\" onclick=\"CMS.editor.search._findContentByArticleText()\" /></td></tr></table><div style=\"margin-top: 10px; height: 390px; width:620px; overflow:auto;\"><div id=\"" + CMS.editor.search.markupIds["results"] + "\"></div></div>", "");
			if(filter && typeof(filter) === "string")
				CMS.editor.search._findContentByArticleText();
		}, 
		byTargetUri: function(filter, rowClickCB, rowDblClickCB, callbackArgs){
			var phrase = CMS.editor.search.getPhrase;
			CMS.editor.search._rowClickCB = rowClickCB || null;
			CMS.editor.search._rowDblClickCB = rowDblClickCB || null;
			CMS.editor.search._callbackArgs = callbackArgs || null;
			CMS.editor.search._displayPanel(phrase("byTargetURIHeader"), "<table><tr><td>" + phrase("byTargetURIFilterLabel") + "</td><td>&nbsp;</td><td><input id=\"" + CMS.editor.search.markupIds["filter"] + "\" type=\"text\" value=\"" + ((filter && typeof(filter) === "string") ? filter : "") + "\" style=\"width:300px\" /></td><td>&nbsp;</td><td><input type=\"button\" value=\"" + phrase("byTargetURIButtonText") + "\" onclick=\"CMS.editor.search._findContentByLinkTargetURI()\" /></td></tr></table><div style=\"margin-top: 10px; height: 390px; width:620px; overflow:auto;\"><div id=\"" + CMS.editor.search.markupIds["results"] + "\"></div></div>", "");
			if(filter && typeof(filter) === "string")
				CMS.editor.search._findContentByLinkTargetURI();
		}, 
		hide: function(){
			if(CMS.editor.search.oPanel)
				CMS.editor.search.oPanel.hide();
		}, 
		_displayPanel: function(header, body, footer){
			if(!CMS.editor.search.oPanel){
				CMS.editor.search.oPanel = new YAHOO.widget.Panel(CMS.editor.search.markupIds["panel"], {
					draggable: true,
					dragOnly: true, 
					x: 100, 
					y: 100, 
					close: true, 
					//modal: true, 
					width: "640px",
					height: "480px",
					constraintoviewport:true
				});
			}
			CMS.editor.search.oPanel.setHeader(header ? header : "");
			CMS.editor.search.oPanel.setBody(body ? body : "");
			CMS.editor.search.oPanel.setFooter(footer ? footer : "");
			CMS.editor.search.oPanel.render();
			CMS.editor.search.oPanel.show();
			CMS.editor.search._dataSource = null;
			CMS.editor.search._dataTable = null;
			document.getElementById(CMS.editor.search.markupIds["filter"]).select();
			document.getElementById(CMS.editor.search.markupIds["filter"]).focus();
		}, 
		_getContentById: function(){
			var filterEl = document.getElementById(CMS.editor.search.markupIds["filter"]);
			IEdit.GetContentDetails(
				{"ticket": CMS.session.ticket, "ContentID": (filterEl.value ? filterEl.value : "")},
				function(result, args){
					// result contains: ContentID (int), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), EditedDate (datetime), EditedBy (string), SiteID (int), ParentID (int_or_null), friendlyName (string), hasArticle (bool), ArticleID (int), ArticleEditor (string_or_null), ArticleData (text_or_null), hasDocument (bool), DocumentID (int), DocumentMimeType (string), hasImage (bool), ImageID (int), ImageMimeType (string), ImageWidth (int), ImageHeight (int), hasLink (bool), LinkID (int), LinkTargetURI (string_or_null), LinkTargetURL (string_or_null), hasMessage (bool), MessageID (int), MessageSource (string_or_null), MessageData (text_or_null)
					var ds = [];
					ds[ds.length] = { "Type": result["ContentType"], "Site": result["SiteName"], "Title": result["ContentTitle"], "SiteID": result["SiteID"], "ContentID": result["ContentID"] };
					CMS.editor.search._dataSource = new YAHOO.util.DataSource(ds);
					YAHOO.widget.DataTable.Formatter.typeFormatter = CMS.editor.search._typeFormatter;
					CMS.editor.search._dataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
					CMS.editor.search._dataSource.responseSchema = CMS.editor.search._responseSchema;
					if(CMS.editor.search._dataTable) CMS.editor.search._dataTable.destroy();
					CMS.editor.search._dataTable = new YAHOO.widget.DataTable(CMS.editor.search.markupIds["results"], CMS.editor.search._columnDefs, CMS.editor.search._dataSource);
					CMS.editor.search._dataTable.subscribe("rowClickEvent", CMS.editor.search._onRowClick);
					CMS.editor.search._dataTable.subscribe("rowDblclickEvent", CMS.editor.search._onRowDblClick);
					filterEl.value = "";
				},
				function(x, msg, args){
					CMS.editor.search._findContentByTitle();
				},
				function(args){
				}
			);
		}, 
		_findContentByTitle: function(){
			var filterEl = document.getElementById(CMS.editor.search.markupIds["filter"]);
			if(filterEl){
				IEdit.SearchByTitleType(
					{"maxRowsToReturn": 1000, "ticket": CMS.session.ticket, "siteID": null, "titleLike": "%" + (filterEl.value ? filterEl.value : "") + "%", "typeLike": "%"},
					function(results, args){
						// results contains: ContentID (int), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), SiteID (int), SiteName (string), ParentID (int_or_null)
						var ds = [];
						for (var i=0; i<results.length; i++) {
							ds[ds.length] = { "Type": results[i]["ContentType"], "Site": results[i]["SiteName"], "Title": results[i]["ContentTitle"], "SiteID": results[i]["SiteID"], "ContentID": results[i]["ContentID"] };
						}
						CMS.editor.search._dataSource = new YAHOO.util.DataSource(ds);
						YAHOO.widget.DataTable.Formatter.typeFormatter = CMS.editor.search._typeFormatter;
						CMS.editor.search._dataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
						CMS.editor.search._dataSource.responseSchema = CMS.editor.search._responseSchema;
					},
					function(x, msg, args){
						CMS.editor.search._dataSource = null;
					},
					function(args){
						if(CMS.editor.search._dataSource){
							if(CMS.editor.search._dataTable) CMS.editor.search._dataTable.destroy();
							CMS.editor.search._dataTable = new YAHOO.widget.DataTable(CMS.editor.search.markupIds["results"], CMS.editor.search._columnDefs, CMS.editor.search._dataSource);
							CMS.editor.search._dataTable.subscribe("rowClickEvent", CMS.editor.search._onRowClick);
							CMS.editor.search._dataTable.subscribe("rowDblclickEvent", CMS.editor.search._onRowDblClick);
						}
					}
				);
			}
		}, 
		_findContentByArticleText: function(){
			var filterEl = document.getElementById(CMS.editor.search.markupIds["filter"]);
			if(filterEl){
				IEdit.SearchByArticleText(
					{"maxRowsToReturn": 1000, "ticket": CMS.session.ticket, "dataLike": "%" + (filterEl.value ? filterEl.value : "") + "%"},
					function(results, args){
						// results contains: ContentID (int), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), SiteID (int), ParentID (int_or_null), ContentType (string), ArticleID (int), ArticleEditor (string_or_null), ArticleData (text_or_null)
						var ds = [];
						for (var i=0; i<results.length; i++) {
							ds[ds.length] = { "Type": results[i]["ContentType"], "Site": results[i]["SiteName"], "Title": results[i]["ContentTitle"], "SiteID": results[i]["SiteID"], "ContentID": results[i]["ContentID"] };
						}
						CMS.editor.search._dataSource = new YAHOO.util.DataSource(ds);
						YAHOO.widget.DataTable.Formatter.typeFormatter = CMS.editor.search._typeFormatter;
						CMS.editor.search._dataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
						CMS.editor.search._dataSource.responseSchema = CMS.editor.search._responseSchema;
					},
					function(x, msg, args){
						CMS.editor.search._dataSource = null;
					},
					function(args){
						if(CMS.editor.search._dataSource){
							if(CMS.editor.search._dataTable) CMS.editor.search._dataTable.destroy();
							CMS.editor.search._dataTable = new YAHOO.widget.DataTable(CMS.editor.search.markupIds["results"], CMS.editor.search._columnDefs, CMS.editor.search._dataSource);
							CMS.editor.search._dataTable.subscribe("rowClickEvent", CMS.editor.search._onRowClick);
							CMS.editor.search._dataTable.subscribe("rowDblclickEvent", CMS.editor.search._onRowDblClick);
						}
					}
				);
			}
		}, 
		_findContentByLinkTargetURI: function(){
			var filterEl = document.getElementById(CMS.editor.search.markupIds["filter"]);
			if(filterEl){
				IEdit.SearchByLinkTargetURI(
					{"maxRowsToReturn": 1000, "ticket": CMS.session.ticket, "targetURI": (filterEl.value ? filterEl.value : "")},
					function(results, args){
						// results contains: ContentID (int), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), SiteID (int), ParentID (int_or_null), ContentType (string), LinkID (int), LinkTargetURI (string_or_null), LinkTargetURL (string_or_null)
						var ds = [];
						for (var i=0; i<results.length; i++) {
							ds[ds.length] = { "Type": results[i]["ContentType"], "Site": results[i]["SiteName"], "Title": results[i]["ContentTitle"], "SiteID": results[i]["SiteID"], "ContentID": results[i]["ContentID"] };
						}
						CMS.editor.search._dataSource = new YAHOO.util.DataSource(ds);
						YAHOO.widget.DataTable.Formatter.typeFormatter = CMS.editor.search._typeFormatter;
						CMS.editor.search._dataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
						CMS.editor.search._dataSource.responseSchema = CMS.editor.search._responseSchema;
					},
					function(x, msg, args){
						CMS.editor.search._dataSource = null;
					},
					function(args){
						if(CMS.editor.search._dataSource){
							if(CMS.editor.search._dataTable) CMS.editor.search._dataTable.destroy();
							CMS.editor.search._dataTable = new YAHOO.widget.DataTable(CMS.editor.search.markupIds["results"], CMS.editor.search._columnDefs, CMS.editor.search._dataSource);
							CMS.editor.search._dataTable.subscribe("rowClickEvent", CMS.editor.search._onRowClick);
							CMS.editor.search._dataTable.subscribe("rowDblclickEvent", CMS.editor.search._onRowDblClick);
						}
					}
				);
			}
		}, 
		_typeFormatter: function(elLiner, oRecord, oColumn, oData){
			var phrase = CMS.editor.search.getPhrase;
			switch(oData) {
				case "None":
					elLiner.innerHTML = "<img src=\"images/icon_folder.png\" alt=\"" + phrase("typeFolderTooltip") + "\" title=\"" + phrase("typeFolderTooltip") + "\" />";
				break;
				
				case "Link":
					elLiner.innerHTML = "<img src=\"images/icon_link.png\" alt=\"" + phrase("typeLinkTooltip") + "\" title=\"" + phrase("typeLinkTooltip") + "\" />";
				break;
				
				case "Document":
					elLiner.innerHTML = "<img src=\"images/icon_doc.png\" alt=\"" + phrase("typeDocumentTooltip") + "\" title=\"" + phrase("typeDocumentTooltip") + "\" />";
				break;
				
				case "Image":
					elLiner.innerHTML = "<img src=\"images/icon_image.png\" alt=\"" + phrase("typeImageTooltip") + "\" title=\"" + phrase("typeImageTooltip") + "\" />";
				break;
				
				case "Article":
					elLiner.innerHTML = "<img src=\"images/icon_article.png\" alt=\"" + phrase("typeArticleTooltip") + "\" title=\"" + phrase("typeArticleTooltip") + "\" />";
				break;
				
				case "Message":
					elLiner.innerHTML = "<img src=\"images/icon_message.png\" alt=\"" + phrase("typeMessageTooltip") + "\" title=\"" + phrase("typeMessageTooltip") + "\" />";
				break;
				
				default: 
					elLiner.innerHTML = "<img src=\"images/icon_file_warning.png\" alt=\"" + phrase("typeUnknownTooltip") + "\" title=\"" + phrase("typeUnknownTooltip") + "\" />";
				break;
			}
		}, 
		_onRowClick: function(oArgs) {
			if(CMS.editor.search._rowClickCB){
				if(CMS.editor.search._rowClickCB(CMS.editor.search._dataTable.getRecord(oArgs.target).getData(), CMS.editor.search._callbackArgs))
					CMS.editor.search.oPanel.hide();
			}
		}, 
		_onRowDblClick: function(oArgs) {
			if(CMS.editor.search._rowDblClickCB){
				if(CMS.editor.search._rowDblClickCB(CMS.editor.search._dataTable.getRecord(oArgs.target).getData(), CMS.editor.search._callbackArgs))
					CMS.editor.search.oPanel.hide();
			}
		}
	};
} else {
	alert("CMSSearch: missing dependencies");
}
