﻿if (CMS && ISession) {
	CMS.session = {
		isAuthenticated: false, 
		userID: null, 
		userLogin: null, 
		userAdministrator: false, 
		userName: null, 
		ticket: null, 
		
		load: function(onSucess, onError, onComplete){
			ISession.Info(
				{"ticket": null},
				function(result, args){
					// result contains: IsAuthenticated (bool), UserID (int), UserLogin (string), UserAdministrator (bool), UserName (string_or_null), Ticket (string)
					CMS.session.isAuthenticated = result["IsAuthenticated"];
					CMS.session.userID = result["UserID"];
					CMS.session.userLogin = result["UserLogin"];
					CMS.session.userAdministrator = result["UserAdministrator"];
					CMS.session.userName = result["UserName"];
					CMS.session.ticket = result["Ticket"];
					if(onSucess){
						onSucess(result);
					}
				},
				function(x, msg, args){
					CMS.session.reset();
					if(onError){
						onError();
					}
				},
				function(args){
					if(onComplete){
						onComplete();
					}
				}
			);
		}, 
		login: function(uid, psw, onSucess, onError, onComplete) {
			CMS.session.reset();
			ISession.Start(
				{"login": uid, "password": psw, "persistent": CMS.config.persistentCookies},
				function(result, args){
					// result contains: ticket (string), UserID (int), UserLogin (string), UserAdministrator (bool)
					if(onSucess){
						onSucess(result);
					}
				},
				function(x, msg, args){
					CMS.session.reset();
					if(onError){
						onError();
					}
				},
				function(args){
					if(onComplete){
						onComplete();
					}
				}
			);
		}, 
		logout: function(onSucess, onError, onComplete) {
			CMS.session.reset();
			ISession.End(
				{"ticket": null},
				function(args){
					if(onSucess){ onSucess(); }
				},
				function(x, msg, args){
					if(onError){ onError(); }
				},
				function(args){
					if(onComplete){ onComplete(); }
				}
			);
		}, 
		reset: function(){
			CMS.session.isAuthenticated = false;
			CMS.session.userID = null;
			CMS.session.userLogin = null;
			CMS.session.userAdministrator = false;
			CMS.session.userName = null;
			CMS.session.ticket = null;
		}
	};
} else {
	alert("CMSSession: missing dependencies");
}