﻿if (CMS && CMS.editor && IEdit) {
	CMS.editor.siteTree = {
		markupIDs: {
			siteTreeDiv: "siteTree",
			dragContainer: "dragDropContainer"
		},
		oSiteTree: null, 
		oContextMenu: null,
		contextTreeNode: null, 
		depth: 0,
		loading: false, 
		siteHints: {},
		
		getPhrase: function(item){
			return CMS.editor.language.phrase("left", item);
		}, 
		load: function(){
			CMS.editor.siteTree.contextTreeNode = null;
			CMS.editor.siteTree.loading = false;
			if(CMS.editor.nodeProperties) CMS.editor.nodeProperties.load(null);
			var phrase = CMS.editor.siteTree.getPhrase;
			if(CMS.editor.siteTree.oSiteTree){
				CMS.editor.siteTree.oSiteTree.destroy();
				CMS.editor.siteTree.oSiteTree = null;
			}
			CMS.editor.siteTree.oSiteTree = new YAHOO.widget.TreeView(CMS.editor.siteTree.markupIDs["siteTreeDiv"]);
			CMS.editor.siteTree.oSiteTree.setDynamicLoad(CMS.editor.siteTree._loadSite, 0);
			DragTreeNode.init(CMS.editor.siteTree.oSiteTree, CMS.editor.siteTree.markupIDs["siteTreeDiv"], CMS.editor.siteTree.markupIDs["dragContainer"], CMS.editor.siteTree._moveContent);
			CMS.editor.siteTree._loadSiteRoots();
			CMS.editor.siteTree.oSiteTree.subscribe('clickEvent', CMS.editor.siteTree._nodeClick);
			CMS.editor.siteTree.oSiteTree.subscribe('focusChanged', CMS.editor.siteTree._nodeFocus);
			
			if(!CMS.editor.siteTree.oContextMenu){
				CMS.editor.siteTree.oContextMenu = new YAHOO.widget.ContextMenu(
					"cmstreecontextmenu",
					{
						trigger: CMS.editor.siteTree.markupIDs["siteTreeDiv"],
						lazyload: true,
						itemdata: [[
							{ text: phrase("contextMenuAddFolder"), onclick: { fn: CMS.editor.siteTree._addFolder } },
							{ text: phrase("contextMenuAddLink"), onclick: { fn: CMS.editor.siteTree._addLink } },
							{ text: phrase("contextMenuAddDocument"), onclick: { fn: CMS.editor.siteTree._addDocument } },
							{ text: phrase("contextMenuAddImage"), onclick: { fn: CMS.editor.siteTree._addImage } },
							{ text: phrase("contextMenuAddArticle"), onclick: { fn: CMS.editor.siteTree._addArticle } },
							{ text: phrase("contextMenuAddMessage"), onclick: { fn: CMS.editor.siteTree._addMessage } }
						], [
							{ text: phrase("contextMenuDeleteNode"), onclick: { fn: CMS.editor.siteTree._deleteNode } }
						]]
					}
				);
				CMS.editor.siteTree.oContextMenu.subscribe("triggerContextMenu", CMS.editor.siteTree._onTriggerContextMenu);								
				CMS.editor.siteTree.oContextMenu.subscribe("show", CMS.editor.siteTree._onShowContextMenu);
			}
		}, 
		selectNode: function(siteID, siteName, contentID) {
			if(CMS.editor.siteTree.oSiteTree) {
				var drill = function (node) {
					var rc = null;
					if(node.cmsData && node.cmsData["type"] == "Content" && node.cmsData["id"] == contentID) {
						rc = node;
						if(CMS.editor.nodeProperties) CMS.editor.nodeProperties.load(node);
						while(node.parent){
							if(!node.parent.expanded)
								node.parent.expand();
							node = node.parent;
						}
						rc.focus();
					}
					for(var i=0; i<node.children.length && !rc; i++){
						rc = drill(node.children[i]);
					}
					return rc;
				}

				var root = CMS.editor.siteTree.oSiteTree.getRoot();
				for (var i=0; i<root.children.length; i++) {
					if(root.children[i] && root.children[i].cmsData && root.children[i].cmsData["type"] == "Site" && root.children[i].cmsData["id"] == siteID) {
						if(root.children[i].dynamicLoadComplete){
							if(drill(root.children[i]))
								return true;
						} else {
							var phrase = CMS.editor.siteTree.getPhrase;
							if(confirm(phrase("confirmLoadSiteStart") + siteName + phrase("confirmLoadSiteEnd"))) {
								var cb = function(){
									var node = drill(root.children[i]);
									if(node) {
										CMS.editor.siteTree.oSiteTree.draw();
										node.focus();
									}
								}
								CMS.editor.siteTree._loadSite(root.children[i], cb);
								return true;
							}
						}
					}
				}
			}
			return false;
		}, 
		_loadSiteRoots: function() {
			IEdit.ListSites(
				{"maxRowsToReturn": null, "ticket": CMS.session.ticket},
				function(results, args){
					// results contains: SiteID (int), SiteName (string), SiteMembersOnly (bool), SiteRecycleBin (bool_or_null)
					for (var i=0; i<results.length; i++) {
						var oHTMLNode = new YAHOO.widget.HTMLNode(CMS.editor.siteTree.siteNodeHTML(CMS.editor.siteTree.siteImage(results[i]["SiteRecycleBin"], results[i]["SiteMembersOnly"]), results[i]["SiteName"], results[i]["SiteID"], results[i]["SiteRecycleBin"]), CMS.editor.siteTree.oSiteTree.getRoot(), false, true); 
						oHTMLNode.cmsData = {"type": "Site", "id": results[i]["SiteID"], "name": results[i]["SiteName"]};
						oHTMLNode._isNotDraggable = true;
						CMS.editor.siteTree._listSiteArticleHints(oHTMLNode);
					}
				},
				function(x, msg, args){
					alert(CMS.editor.siteTree.getPhrase("alertErrorLoadingSites"));
				},
				function(args){
					CMS.editor.siteTree.oSiteTree.draw();
				}
			);
		}, 
		_loadSite: function(oParentTreeNode, fnLoadComplete){
			if(!CMS.editor.siteTree.loading && oParentTreeNode && oParentTreeNode.cmsData && oParentTreeNode.cmsData.type && oParentTreeNode.cmsData.type == "Site" && oParentTreeNode.cmsData.id){
				CMS.editor.siteTree.depth = 1;
				CMS.editor.siteTree.loading = true;
				if(oParentTreeNode.hasChildren(false))
				    CMS.editor.siteTree.oSiteTree.removeChildren(oParentTreeNode);
				oParentTreeNode.dynamicLoadComplete = true;
				oParentTreeNode.setDynamicLoad(null, 1);
				IEdit.ListRootContent(
					{"maxRowsToReturn": null, "ticket": CMS.session.ticket, "siteID": oParentTreeNode.cmsData.id},
					function(results, args){
						// results contains: ContentID (int), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), SiteID (int), ParentID (int_or_null), ContentType (string), friendlyName (string)
						for (var i=0; i<results.length; i++) {
							var oHTMLNode = new YAHOO.widget.HTMLNode(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(results[i]["ContentType"], results[i]["ContentPublished"]), results[i]["ContentTitle"], results[i]["ContentID"]), oParentTreeNode, false, true); 
							oHTMLNode.cmsData = {"type": "Content", "id": results[i]["ContentID"], "siteID": results[i]["SiteID"], "sortOrder": results[i]["ContentSortOrder"]};
							oHTMLNode.setDynamicLoad(null, 1);
							oHTMLNode.dynamicLoadComplete = true;
							CMS.editor.siteTree._loadChildContent(oHTMLNode, fnLoadComplete);
						}
					},
					function(x, msg, args){
						if (fnLoadComplete) fnLoadComplete();
						else CMS.editor.siteTree.oSiteTree.draw();
						alert(CMS.editor.siteTree.getPhrase("alertErrorLoadingContentNodes"));
					},
					function(args){
						CMS.editor.siteTree.depth--;
						if(CMS.editor.siteTree.depth == 0) {
							CMS.editor.siteTree.loading = false;
							if (fnLoadComplete) fnLoadComplete();
							else CMS.editor.siteTree.oSiteTree.draw();
						}
					}
				);
			}
		}, 
		_loadChildContent: function(oParentTreeNode, fnLoadComplete){
			if(oParentTreeNode && oParentTreeNode.cmsData && oParentTreeNode.cmsData.type && oParentTreeNode.cmsData.type == "Content" && oParentTreeNode.cmsData.id){
				CMS.editor.siteTree.depth++;
				IEdit.ListChildContent(
					{"maxRowsToReturn": null, "ticket": CMS.session.ticket, "ContentID": oParentTreeNode.cmsData.id},
					function(results, args){
						// results contains: ContentID (int), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), SiteID (int), ParentID (int_or_null), ContentType (string), friendlyName (string)
						for (var i=0; i<results.length; i++) {
							var oHTMLNode = new YAHOO.widget.HTMLNode(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(results[i]["ContentType"], results[i]["ContentPublished"]), results[i]["ContentTitle"], results[i]["ContentID"]), oParentTreeNode, false, true); 
							oHTMLNode.cmsData = {"type": "Content", "id": results[i]["ContentID"], "siteID": results[i]["SiteID"], "sortOrder": results[i]["ContentSortOrder"]};
							oHTMLNode.setDynamicLoad(null, 1);
							oHTMLNode.dynamicLoadComplete = true;
							CMS.editor.siteTree._loadChildContent(oHTMLNode, fnLoadComplete);
						}
					},
					function(x, msg, args){
						if (fnLoadComplete) fnLoadComplete();
						else CMS.editor.siteTree.oSiteTree.draw();
						alert(CMS.editor.siteTree.getPhrase("alertErrorLoadingContentNodes"));
					},
					function(args){
						CMS.editor.siteTree.depth--;
						if(CMS.editor.siteTree.depth == 0) {
							CMS.editor.siteTree.loading = false;
							if (fnLoadComplete) fnLoadComplete();
							else CMS.editor.siteTree.oSiteTree.draw();
						}
					}
				);
			}
		}, 
		_listSiteArticleHints: function(oSiteTreeNode){
			if(oSiteTreeNode && oSiteTreeNode.cmsData && oSiteTreeNode.cmsData.type && oSiteTreeNode.cmsData.type == "Site" && oSiteTreeNode.cmsData.id) {
				IEdit.ListSiteArticleHints(
					{"maxRowsToReturn": null, "ticket": CMS.session.ticket, "siteID": oSiteTreeNode.cmsData.id},
					function(results, args){
						// results contains: ArticleHintID (int), ArticleHintName (string), SiteID (int)
						var hints = [];
						hints[hints.length] = { name: "", value: ""};
						for (var i=0; i<results.length; i++) {
							hints[hints.length] = { name: results[i]["ArticleHintName"], value: results[i]["ArticleHintName"]};
						}
						CMS.editor.siteTree.siteHints[oSiteTreeNode.cmsData.id] = hints;
					},
					function(x, msg, args){
						var hints = [];
						hints[hints.length] = { name: "", value: ""};
						CMS.editor.siteTree.siteHints[oSiteTreeNode.cmsData.id] = hints;
					},
					function(args){
					}
				);
			}
		}, 
		contentImage: function(contentType, published){
			if(contentType == "None")
				return ((typeof(published) === "undefined") ? "images/icon_folder.png" : ((published) ? "images/icon_folder_published.png":"images/icon_folder_unpublished.png"));
			if(contentType == "Link")
				return ((typeof(published) === "undefined") ? "images/icon_link.png" : ((published) ? "images/icon_link_published.png":"images/icon_link_unpublished.png"));
			if(contentType == "Document")
				return ((typeof(published) === "undefined") ? "images/icon_doc.png" : ((published) ? "images/icon_doc_published.png":"images/icon_doc_unpublished.png"));
			if(contentType == "Image")
				return ((typeof(published) === "undefined") ? "images/icon_image.png" : ((published) ? "images/icon_image_published.png":"images/icon_image_unpublished.png"));
			if(contentType == "Article")
				return ((typeof(published) === "undefined") ? "images/icon_article.png" : ((published) ? "images/icon_article_published.png":"images/icon_article_unpublished.png"));
			if(contentType == "Message")
				return ((typeof(published) === "undefined") ? "images/icon_message.png" : ((published) ? "images/icon_message_published.png":"images/icon_message_unpublished.png"));
			return ((typeof(published) === "undefined") ? "images/con_file_warning.png" : ((published) ? "images/con_file_warning_published.png":"images/con_file_warning_unpublished.png"));
		},
		suggestSortOrder: function(nChildren){
			if(nChildren > 1000) return nChildren.toString();
			if(nChildren > 100) return (nChildren.toString() + "0");
			if(nChildren > 10) return ("0" + nChildren.toString() + "0");
			return ("00" + nChildren.toString() + "0");
		}, 
		getContentNodeText: function(contentID){
			var el = document.getElementById(CMS.editor.siteTree.contentNodeTextID(contentID));
			return ((el && el.innerHTML) ? el.innerHTML : "");
		}, 
		getSiteNodeText: function(siteID){
			var el = document.getElementById(CMS.editor.siteTree.siteNodeTextID(siteID));
			return ((el && el.innerHTML) ? el.innerHTML : "");
		}, 
		setSiteNodeText: function(siteID, text){
			var el = document.getElementById(CMS.editor.siteTree.siteNodeTextID(siteID));
			if(el){
				el.innerHTML = text;
			}
		}, 
		contentNodeTextID: function(contentID){
			var rc = [];
			rc[rc.length] = "contentNodeLabel_";
			rc[rc.length] = contentID.toString();
			return rc.join("");		
		}, 
		siteNodeTextID: function(siteID){
			var rc = [];
			rc[rc.length] = "siteNodeLabel_";
			rc[rc.length] = siteID.toString();
			return rc.join("");		
		}, 
		contentNodeHTML: function(imageSrc, nodeTxt, contentID){
			var rc = [];
			rc[rc.length] = "<table><tr><td style=\"padding-right: 4px;\"><img src=\"";
			rc[rc.length] = imageSrc;
			rc[rc.length] = "\" width=\"16px\" height=\"16px\" /></td><td><div id=\"";
			rc[rc.length] = CMS.editor.siteTree.contentNodeTextID(contentID);
			rc[rc.length] = "\">";
			rc[rc.length] = nodeTxt;
			rc[rc.length] = "</div></td></tr></table>";
			return rc.join("");
		}, 
		siteImage: function(isRecycleBin, membersOnly){
			if(isRecycleBin)
				return "images/icon_garbage.png";
			return ((membersOnly) ? "images/icon_site_mo.png":"images/icon_site.png");
		}, 
		siteNodeHTML: function(imageSrc, nodeTxt, siteID, isRecycleBin){
			var rc = [];
			rc[rc.length] = "<table><tr><td style=\"padding-right: 4px;\"><img src=\"";
			rc[rc.length] = imageSrc;
			rc[rc.length] = "\" width=\"16px\" height=\"16px\" /></td><td><div id=\"";
			rc[rc.length] = CMS.editor.siteTree.siteNodeTextID(siteID);
			rc[rc.length] = "\">";
			rc[rc.length] = ((isRecycleBin)? CMS.editor.siteTree.getPhrase("recycleBin") : nodeTxt);
			rc[rc.length] = "</div></td></tr></table>";
			return rc.join("");
		}, 
		_nodeClick: function (oArgs){
			try { if(oArgs.node.children.length > 0) oArgs.node.collapse(); } catch(ex){}
		},
		_nodeFocus: function (oArgs){
			CMS.editor.siteTree.contextTreeNode = null;
			if(oArgs.newNode){
				if(CMS.editor.nodeProperties) CMS.editor.nodeProperties.load(oArgs.newNode);
			}
		}, 
		_addContent: function(oTreeNode, contentType) {
			var phrase = CMS.editor.siteTree.getPhrase;
			if(oTreeNode && oTreeNode.cmsData){
				if(oTreeNode.cmsData.type == "Content"){
					CMS.editor.siteTree._newContent(oTreeNode, contentType,  oTreeNode.cmsData.id, oTreeNode.cmsData.siteID);
				} if(oTreeNode.cmsData.type == "Site"){
					CMS.editor.siteTree._newContent(oTreeNode, contentType,  null, oTreeNode.cmsData.id);
				}
			}
		}, 
		_addFolder: function() {
			CMS.editor.siteTree._addContent(CMS.editor.siteTree.contextTreeNode, "None");
		},
		_addLink: function() {
			CMS.editor.siteTree._addContent(CMS.editor.siteTree.contextTreeNode, "Link");
		},
		_addDocument: function() {
			CMS.editor.siteTree._addContent(CMS.editor.siteTree.contextTreeNode, "Document");
		},
		_addImage: function() {
			CMS.editor.siteTree._addContent(CMS.editor.siteTree.contextTreeNode, "Image");
		},
		_addArticle: function() {
			CMS.editor.siteTree._addContent(CMS.editor.siteTree.contextTreeNode, "Article");
		},
		_addMessage: function() {
			CMS.editor.siteTree._addContent(CMS.editor.siteTree.contextTreeNode, "Message");
		},
		_deleteNode: function() {
			if(CMS.editor.siteTree.contextTreeNode && CMS.editor.siteTree.contextTreeNode.cmsData){
				if(CMS.editor.siteTree.contextTreeNode.cmsData.type == "Content"){
					CMS.editor.siteTree._deleteContentNode(CMS.editor.siteTree.contextTreeNode);
				} else if(CMS.editor.siteTree.contextTreeNode.cmsData.type == "Site"){
					alert(CMS.editor.siteTree.getPhrase("alertDeleteSiteInAdminGui"));
				}
			}
		},
		_deleteContentNode: function(oTreeNode) {
			if(oTreeNode && oTreeNode.cmsData){
				if(oTreeNode.cmsData.type == "Content"){
					var phrase = CMS.editor.siteTree.getPhrase;
					if(confirm(phrase("confirmDeleteContentStart") + CMS.editor.siteTree.getContentNodeText(oTreeNode.cmsData.id) + phrase("confirmDeleteContentEnd"))){
						CMS.editor.siteTree._deleteContent(oTreeNode, oTreeNode.cmsData.id);
					}
				}
			}
		}, 
		_onShowContextMenu: function(p_oEvent){
			if(CMS.editor.siteTree.contextTreeNode){
				var tn = CMS.editor.siteTree.contextTreeNode;
				if(tn.cmsData){
					if(tn.cmsData.type == "Site"){
						this.getItem(5).cfg.setProperty("disabled", false);
						this.getItem(0,1).cfg.setProperty("disabled", true);
					} else if( tn.cmsData.type == "Content") {
						this.getItem(5).cfg.setProperty("disabled", false);
						this.getItem(0,1).cfg.setProperty("disabled", false);
					}
				}
			}
		}, 
		_onTriggerContextMenu: function(p_oEvent) {
			var oTarget = this.contextEventTarget;
			CMS.editor.siteTree.contextTreeNode = CMS.editor.siteTree.oSiteTree.getNodeByElement(oTarget);
			if (!CMS.editor.siteTree.contextTreeNode) {
				this.cancel();
			}
		}, 
		_deleteContent: function(oTreeNode, contentID){
			if(oTreeNode && contentID && contentID > 0){
				IEdit.DeleteContent(
					{"ticket": CMS.session.ticket, "ContentID": contentID},
					function(args){
						CMS.editor.siteTree.oSiteTree.removeNode(oTreeNode);  
						CMS.editor.siteTree.contextTreeNode = null;
						if(CMS.editor.nodeProperties) CMS.editor.nodeProperties.load(null);
					},
					function(x, msg, args){
						alert(CMS.editor.siteTree.getPhrase("alertErrorDeletingContent"));
					},
					function(args){
						CMS.editor.siteTree.oSiteTree.draw();
					}
				);
			}
		}, 
		_newContent: function(oParentTreeNode, contentType, parentID, siteID){
			if(oParentTreeNode && contentType && siteID && siteID > 0){
				var phrase = CMS.editor.siteTree.getPhrase;
				var sortOrder =	CMS.editor.siteTree.suggestSortOrder(oParentTreeNode.children.length + 1);
				switch(contentType){
					case "None":
						IEdit.SaveNone(
							{"ticket": CMS.session.ticket, 
								"ContentID": null, 
								"ContentTitle": phrase("newFolderName"), 
								"SiteID": siteID, 
								"ContentSortOrder": sortOrder, 
								"ContentPublished": false, 
								"ContentKeywords": null, 
								"ContentDescription": null, 
								"ContentRobots": null, 
								"ContentLanguage": null, 
								"ContentCustom": null, 
								"ContentAllowMessages": false, 
								"ParentID": parentID},
							function(result, args){
								if(result["ContentID"] && result["ContentID"] > 0){
									var oHTMLNode = new YAHOO.widget.HTMLNode(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(contentType, false), phrase("newFolderName"), result["ContentID"]), oParentTreeNode, false, true); 
									oHTMLNode.cmsData = {"type": "Content", "id": result["ContentID"], "siteID": siteID, "sortOrder": sortOrder};
									oHTMLNode.setDynamicLoad(null, 1);
									oHTMLNode.dynamicLoadComplete = true;
									oParentTreeNode.expand();
									CMS.editor.siteTree.oSiteTree.draw();
									oHTMLNode.focus();
								}
							},
							function(x, msg, args){
								alert(phrase("alertErrorCreatingFolder"));
							},
							function(args){
							}
						);
					break;

					case "Link":
						IEdit.SaveLink(
							{"ticket": CMS.session.ticket, 
								"LinkID": null, 
								"ContentID": null, 
								"ContentTitle": phrase("newLinkName"), 
								"SiteID": siteID, 
								"ContentSortOrder": sortOrder, 
								"ContentPublished": false, 
								"ContentKeywords": null, 
								"ContentDescription": null, 
								"ContentRobots": null, 
								"ContentLanguage": null, 
								"ContentCustom": null, 
								"ContentAllowMessages": false, 
								"ParentID": parentID, 
								"LinkTargetURI": null, 
								"LinkTargetURL": null},
							function(result, args){
								if(result["ContentID"] && result["ContentID"] > 0){
									var oHTMLNode = new YAHOO.widget.HTMLNode(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(contentType, false), phrase("newLinkName"), result["ContentID"]), oParentTreeNode, false, true); 
									oHTMLNode.cmsData = {"type": "Content", "id": result["ContentID"], "siteID": siteID, "sortOrder": sortOrder};
									oHTMLNode.setDynamicLoad(null, 1);
									oHTMLNode.dynamicLoadComplete = true;
									oParentTreeNode.expand();
									CMS.editor.siteTree.oSiteTree.draw();
									oHTMLNode.focus();
								}
							},
							function(x, msg, args){
								alert(phrase("alertErrorCreatingLink"));
							},
							function(args){
							}
						);					
					break;

					case "Document":
						IEdit.SaveDocument(
							{"ticket": CMS.session.ticket, 
								"DocumentID": null, 
								"DocumentMimeType": "application/octet-stream", 
								"ContentID": null, 
								"ContentTitle": phrase("newDocumentName"), 
								"SiteID": siteID, 
								"ContentSortOrder": sortOrder, 
								"ContentPublished": false, 
								"ContentKeywords": null, 
								"ContentDescription": null, 
								"ContentRobots": null, 
								"ContentLanguage": null, 
								"ContentCustom": null, 
								"ContentAllowMessages": false, 
								"ParentID": parentID},
							function(result, args){
								if(result["ContentID"] && result["ContentID"] > 0){
									var oHTMLNode = new YAHOO.widget.HTMLNode(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(contentType, false), phrase("newDocumentName"), result["ContentID"]), oParentTreeNode, false, true); 
									oHTMLNode.cmsData = {"type": "Content", "id": result["ContentID"], "siteID": siteID, "sortOrder": sortOrder};
									oHTMLNode.setDynamicLoad(null, 1);
									oHTMLNode.dynamicLoadComplete = true;
									oParentTreeNode.expand();
									CMS.editor.siteTree.oSiteTree.draw();
									oHTMLNode.focus();
								}
							},
							function(x, msg, args){
								alert(phrase("alertErrorCreatingDocument"));
							},
							function(args){
							}
						);
					break;

					case "Image":
						IEdit.SaveImage(
							{"ticket": CMS.session.ticket, 
								"ImageID": null, 
								"ImageMimeType": "application/octet-stream", 
								"ImageWidth": 0, 
								"ImageHeight": 0, 
								"ContentID": null, 
								"ContentTitle": phrase("newImageName"), 
								"SiteID": siteID, 
								"ContentSortOrder": sortOrder, 
								"ContentPublished": false, 
								"ContentKeywords": null, 
								"ContentDescription": null, 
								"ContentRobots": null, 
								"ContentLanguage": null, 
								"ContentCustom": null, 
								"ContentAllowMessages": false, 
								"ParentID": parentID},
							function(result, args){
								if(result["ContentID"] && result["ContentID"] > 0){
									var oHTMLNode = new YAHOO.widget.HTMLNode(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(contentType, false), phrase("newImageName"), result["ContentID"]), oParentTreeNode, false, true); 
									oHTMLNode.cmsData = {"type": "Content", "id": result["ContentID"], "siteID": siteID, "sortOrder": sortOrder};
									oHTMLNode.setDynamicLoad(null, 1);
									oHTMLNode.dynamicLoadComplete = true;
									oParentTreeNode.expand();
									CMS.editor.siteTree.oSiteTree.draw();
									oHTMLNode.focus();
								}
							},
							function(x, msg, args){
								alert(phrase("alertErrorCreatingImage"));
							},
							function(args){
							}
						);
					break;

					case "Article":
						IEdit.SaveArticle(
							{"ticket": CMS.session.ticket, 
								"ArticleID": null, 
								"ArticleEditor": "Xinha", 
								"ArticleData": null, 
								"ContentID": null, 
								"ContentTitle": phrase("newArticleName"), 
								"SiteID": siteID, 
								"ContentSortOrder": sortOrder, 
								"ContentPublished": false, 
								"ContentKeywords": null, 
								"ContentDescription": null, 
								"ContentRobots": null, 
								"ContentLanguage": null, 
								"ContentCustom": null, 
								"ContentAllowMessages": false, 
								"ParentID": parentID},
							function(result, args){
								if(result["ContentID"] && result["ContentID"] > 0){
									var oHTMLNode = new YAHOO.widget.HTMLNode(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(contentType, false), phrase("newArticleName"), result["ContentID"]), oParentTreeNode, false, true); 
									oHTMLNode.cmsData = {"type": "Content", "id": result["ContentID"], "siteID": siteID, "sortOrder": sortOrder};
									oHTMLNode.setDynamicLoad(null, 1);
									oHTMLNode.dynamicLoadComplete = true;
									oParentTreeNode.expand();
									CMS.editor.siteTree.oSiteTree.draw();
									oHTMLNode.focus();
								}
							},
							function(x, msg, args){
								alert(phrase("alertErrorCreatingArticle"));
							},
							function(args){
							}
						);
					break;

					case "Message":
						IEdit.SaveMessage(
							{"ticket": CMS.session.ticket, 
								"MessageID": null, 
								"MessageSource": "CMS Editor", 
								"MessageData": null, 
								"ContentID": null, 
								"ContentTitle": phrase("newMessageName"), 
								"SiteID": siteID, 
								"ContentSortOrder": sortOrder, 
								"ContentPublished": false, 
								"ContentKeywords": null, 
								"ContentDescription": null, 
								"ContentRobots": null, 
								"ContentLanguage": null, 
								"ContentCustom": null, 
								"ContentAllowMessages": false, 
								"ParentID": parentID},
							function(result, args){
								if(result["ContentID"] && result["ContentID"] > 0){
									var oHTMLNode = new YAHOO.widget.HTMLNode(CMS.editor.siteTree.contentNodeHTML(CMS.editor.siteTree.contentImage(contentType, false), phrase("newMessageName"), result["ContentID"]), oParentTreeNode, false, true); 
									oHTMLNode.cmsData = {"type": "Content", "id": result["ContentID"], "siteID": siteID, "sortOrder": sortOrder};
									oHTMLNode.setDynamicLoad(null, 1);
									oHTMLNode.dynamicLoadComplete = true;
									oParentTreeNode.expand();
									CMS.editor.siteTree.oSiteTree.draw();
									oHTMLNode.focus();
								}
							},
							function(x, msg, args){
								alert(phrase("alertErrorCreatingMessage"));
							},
							function(args){
							}
						);
					break;
				}
			}
		}, 
		_moveContent: function(oDstNode, oSrcNode){
			try{
				if(oDstNode && oSrcNode){
					CMS.editor.siteTree.oSiteTree.popNode(oSrcNode);
					oSrcNode.appendTo(oDstNode);
					if(!oDstNode.expanded)
						oDstNode.expand();
					CMS.editor.siteTree.oSiteTree.draw();
				
					var contentID = oSrcNode.cmsData.id;
					var newParentID = ((oDstNode.cmsData.type == "Content") ? oDstNode.cmsData.id : null);
					var newSiteID = ((oDstNode.cmsData.type == "Site") ? oDstNode.cmsData.id : oDstNode.cmsData.siteID);
					var newSortOrder = CMS.editor.siteTree.suggestSortOrder(oDstNode.children.length);

					if(contentID && newSiteID && typeof(newParentID) !== "undefined") {
						IEdit.MoveContent(
							{"ticket": CMS.session.ticket, "ContentID": contentID, "newParentID": newParentID, "newSiteID": newSiteID, "newSortOrder": newSortOrder ? newSortOrder : null},
							function(args){
								oDstNode.cmsData["sortOrder"] = newSortOrder;
								oDstNode.cmsData["siteID"] = newSiteID;
							},
							function(x, msg, args){
								alert(CMS.editor.siteTree.getPhrase("alertErrorMovingContent"));
							},
							function(args){
							}
						);
					}
				}
			} catch(ex){
				alert(CMS.editor.siteTree.getPhrase("alertErrorMovingContent"));
			}
		}
	};
	
} else {
	alert(CMS.editor.siteTree.getPhrase("alertMissingDependencies"));
}