﻿if (CMS && CMS.editor) {
	CMS.editor.toolbar = {
		markupIDs: {
			container: "topToolbar"
		}, 
		load: function(){
			var toolbarEl = document.getElementById(CMS.editor.toolbar.markupIDs["container"]);
			if(toolbarEl) {
				var ph = function(phrase){ return CMS.editor.language.phrase("toolbar", phrase); }
				var toolbarImages = [];
				var group = [];
				
				group[group.length] = { src: "images/refreshSites.png", alt: ph("refreshTooltip"), title: ph("refreshTooltip"), onclick: function(ev){ CMS.editor.siteTree.load(); } };
				toolbarImages[toolbarImages.length] = group;

				group = [];
				group[group.length] = { src: "images/findByTitle.png", alt: ph("searchByTitleTooltip"), title: ph("searchByTitleTooltip"), onclick: function(ev){ CMS.editor.search.byTitle('', CMS.editor.toolbar._selectSearchResult); } };
				group[group.length] = { src: "images/findArticleByText.png", alt: ph("searchByArticleTextTooltip"), title: ph("searchByArticleTextTooltip"), onclick: function(ev){ CMS.editor.search.byArticleText('', CMS.editor.toolbar._selectSearchResult); } };
				group[group.length] = { src: "images/findByURI.png", alt: ph("searchByTargetURITooltip"), title: ph("searchByTargetURITooltip"), onclick: function(ev){ CMS.editor.search.byTargetUri('', CMS.editor.toolbar._selectSearchResult); } };
				toolbarImages[toolbarImages.length] = group;
				
				group = [];
				var rightImages = [];
				
				group[group.length] = { src: "Images/logout.png", alt: ph("logOut"), title: ph("logOut"), onclick: function(ev){ window.CMSLogout(); } };
				rightImages[rightImages.length] = group;
				group = [];
				
				group[group.length] = { src:"Images/OTR_BlueText.png", alt: "RISE to Bloome Software", title: "RISE to Bloome Software", width: "65px", height: "30px", onclick: function(ev){ window.open("http://www.risetobloome.com"); } };
				rightImages[rightImages.length] = group; 

				new RISE.Toolbar(toolbarEl, {imageWidth: 32, imageHeight: 32, imageBlocks: toolbarImages, rightBlocks: rightImages}).render();				
			}
		}, 
		_selectSearchResult: function(o) {
			if(o && o["SiteID"] && o["Site"] && o["ContentID"]){
				if(CMS.editor.siteTree.selectNode(o["SiteID"], o["Site"], o["ContentID"]))
					return true;
			}
			return false;
		}
	}
} else {
	alert("CMSToolbar: missing dependencies");
}