﻿var IAdmin = {

    wsuri: "cms.WS.IAdmin.asmx",        // You must enter the correct uri to your installed web service.
    wsenvironment: ".NET",               // Possible values are: null, ".NET", "PHP"

    /****************************************************************
        --- FUNCTION INDEX ---

        CopySiteArticleHints
        DeleteArticleHint
        DeleteSite
        DeleteUser
        GetSite
        GetUser
        ListSiteArticleHints
        ListSites
        ListSiteUsers
        ListUsers
        ListUserSessions
        ListUserSites
        RevokeMembership
        SaveMembership
        SaveSite
        SaveSiteArticleHint
        SaveUser

    ****************************************************************/

    /*
        // Description: Copy the hint list from one site to another
        // This code exemplifies how to call the generated function CopySiteArticleHints
        IAdmin.CopySiteArticleHints(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "fromSiteID": your_int, "toSiteID": your_int},
            function(results, args){
                // This function is called on success
                // results contains: AddedArticleHintID (int)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["AddedArticleHintID"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    CopySiteArticleHints: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/CopySiteArticleHints",
            data: IAdmin.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "fromSiteID": args["fromSiteID"], "toSiteID": args["toSiteID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Delete a hint from the site hint list
        // This code exemplifies how to call the generated function DeleteArticleHint
        IAdmin.DeleteArticleHint(
            {"ticket": your_string_or_null, "ID": your_int},
            function(args){
                // This function is called on success
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    DeleteArticleHint: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/DeleteArticleHint",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ID": args["ID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Delete a site
        // This code exemplifies how to call the generated function DeleteSite
        IAdmin.DeleteSite(
            {"ticket": your_string_or_null, "ID": your_int},
            function(args){
                // This function is called on success
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    DeleteSite: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/DeleteSite",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ID": args["ID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Deletes a user account (incl sessions and memberships)
        // This code exemplifies how to call the generated function DeleteUser
        IAdmin.DeleteUser(
            {"ticket": your_string_or_null, "ID": your_int},
            function(args){
                // This function is called on success
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    DeleteUser: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/DeleteUser",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ID": args["ID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // This code exemplifies how to call the generated function GetSite
        IAdmin.GetSite(
            {"ticket": your_string_or_null, "ID": your_int},
            function(result, args){
                // This function is called on success
                // result contains: ID (int), Name (string), MembersOnly (bool), RecycleBin (bool)
                // Example:
                var yourVariable1 = result["ID"]; 
                var yourVariable2 = result["Name"]; 
                var yourVariable3 = result["MembersOnly"]; 
                var yourVariable4 = result["RecycleBin"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    GetSite: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/GetSite",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ID": args["ID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // This code exemplifies how to call the generated function GetUser
        IAdmin.GetUser(
            {"ticket": your_string_or_null, "ID": your_int},
            function(result, args){
                // This function is called on success
                // result contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string)
                // Example:
                var yourVariable1 = result["ID"]; 
                var yourVariable2 = result["Login"]; 
                var yourVariable3 = result["Administrator"]; 
                var yourVariable4 = result["Name"]; 
                var yourVariable5 = result["GUID"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    GetUser: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/GetUser",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ID": args["ID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Lists all display hints for a site
        // This code exemplifies how to call the generated function ListSiteArticleHints
        IAdmin.ListSiteArticleHints(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "SiteID": your_int},
            function(results, args){
                // This function is called on success
                // results contains: ID (int), Name (string), SiteID (int)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["ID"]; 
                    var yourVariable2 = results[i]["Name"]; 
                    var yourVariable3 = results[i]["SiteID"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListSiteArticleHints: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/ListSiteArticleHints",
            data: IAdmin.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "SiteID": args["SiteID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: List all sites
        // This code exemplifies how to call the generated function ListSites
        IAdmin.ListSites(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "NameLike": your_string_or_null},
            function(results, args){
                // This function is called on success
                // results contains: ID (int), Name (string), MembersOnly (bool), RecycleBin (bool)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["ID"]; 
                    var yourVariable2 = results[i]["Name"]; 
                    var yourVariable3 = results[i]["MembersOnly"]; 
                    var yourVariable4 = results[i]["RecycleBin"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListSites: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/ListSites",
            data: IAdmin.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "NameLike": (typeof(args["NameLike"]) !== 'undefined' ? args["NameLike"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Lists all users that are members of the site
        // This code exemplifies how to call the generated function ListSiteUsers
        IAdmin.ListSiteUsers(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "SiteID": your_int},
            function(results, args){
                // This function is called on success
                // results contains: ID (int), Login (string), Administrator (bool), Name (string), GUID (string), IsEditor (bool)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["ID"]; 
                    var yourVariable2 = results[i]["Login"]; 
                    var yourVariable3 = results[i]["Administrator"]; 
                    var yourVariable4 = results[i]["Name"]; 
                    var yourVariable5 = results[i]["GUID"]; 
                    var yourVariable6 = results[i]["IsEditor"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListSiteUsers: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/ListSiteUsers",
            data: IAdmin.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "SiteID": args["SiteID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Lists all users
        // This code exemplifies how to call the generated function ListUsers
        IAdmin.ListUsers(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "NameLike": your_string_or_null},
            function(results, args){
                // This function is called on success
                // results contains: ID (int), GUID (string), Login (string), Name (string), Administrator (bool)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["ID"]; 
                    var yourVariable2 = results[i]["GUID"]; 
                    var yourVariable3 = results[i]["Login"]; 
                    var yourVariable4 = results[i]["Name"]; 
                    var yourVariable5 = results[i]["Administrator"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListUsers: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/ListUsers",
            data: IAdmin.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "NameLike": (typeof(args["NameLike"]) !== 'undefined' ? args["NameLike"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Lists all sessions for a specific user
        // This code exemplifies how to call the generated function ListUserSessions
        IAdmin.ListUserSessions(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "UserID": your_int},
            function(results, args){
                // This function is called on success
                // results contains: ID (int), StartDate (datetime), EndDate (datetime)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["ID"]; 
                    var yourVariable2 = results[i]["StartDate"]; 
                    var yourVariable3 = results[i]["EndDate"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListUserSessions: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/ListUserSessions",
            data: IAdmin.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "UserID": args["UserID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    for (var i = 0; i< results.length; i++) {
                        results[i]["StartDate"] = IAdmin.JSONHelper.StringToDate(results[i]["StartDate"]);
                        results[i]["EndDate"] = IAdmin.JSONHelper.StringToDate(results[i]["EndDate"]);
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Lists a all membership sites for a user
        // This code exemplifies how to call the generated function ListUserSites
        IAdmin.ListUserSites(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "UserID": your_int},
            function(results, args){
                // This function is called on success
                // results contains: ID (int), Name (string), MembersOnly (bool), RecycleBin (bool), IsEditor (bool)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["ID"]; 
                    var yourVariable2 = results[i]["Name"]; 
                    var yourVariable3 = results[i]["MembersOnly"]; 
                    var yourVariable4 = results[i]["RecycleBin"]; 
                    var yourVariable5 = results[i]["IsEditor"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListUserSites: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/ListUserSites",
            data: IAdmin.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "UserID": args["UserID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Revokes a user site membership
        // This code exemplifies how to call the generated function RevokeMembership
        IAdmin.RevokeMembership(
            {"ticket": your_string_or_null, "UserID": your_int, "SiteID": your_int},
            function(args){
                // This function is called on success
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    RevokeMembership: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/RevokeMembership",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "UserID": args["UserID"], "SiteID": args["SiteID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Creates or changes a user site membership.
        // This code exemplifies how to call the generated function SaveMembership
        IAdmin.SaveMembership(
            {"ticket": your_string_or_null, "UserID": your_int, "SiteID": your_int, "IsEditor": your_bool},
            function(args){
                // This function is called on success
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    SaveMembership: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/SaveMembership",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "UserID": args["UserID"], "SiteID": args["SiteID"], "IsEditor": args["IsEditor"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Creates or updates site info
        // This code exemplifies how to call the generated function SaveSite
        IAdmin.SaveSite(
            {"ticket": your_string_or_null, "ID": your_int_or_null, "MembersOnly": your_bool, "Name": your_string_or_null},
            function(result, args){
                // This function is called on success
                // result contains: ID (int)
                // Example:
                var yourVariable1 = result["ID"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    SaveSite: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/SaveSite",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ID": (typeof(args["ID"]) !== 'undefined' ? args["ID"] : null), "MembersOnly": args["MembersOnly"], "Name": (typeof(args["Name"]) !== 'undefined' ? args["Name"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Creates or updates a hint in the site hint list
        // This code exemplifies how to call the generated function SaveSiteArticleHint
        IAdmin.SaveSiteArticleHint(
            {"ticket": your_string_or_null, "ID": your_int_or_null, "Name": your_string, "SiteID": your_int},
            function(result, args){
                // This function is called on success
                // result contains: ID (int)
                // Example:
                var yourVariable1 = result["ID"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    SaveSiteArticleHint: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/SaveSiteArticleHint",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ID": (typeof(args["ID"]) !== 'undefined' ? args["ID"] : null), "Name": args["Name"], "SiteID": args["SiteID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Creates or update a user. If password is null the current password is kept.
        // This code exemplifies how to call the generated function SaveUser
        IAdmin.SaveUser(
            {"ticket": your_string_or_null, "ID": your_int_or_null, "Login": your_string, "Name": your_string, "Administrator": your_bool, "Password": your_string_or_null},
            function(result, args){
                // This function is called on success
                // result contains: ID (int)
                // Example:
                var yourVariable1 = result["ID"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    SaveUser: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IAdmin.wsuri + "/SaveUser",
            data: IAdmin.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ID": (typeof(args["ID"]) !== 'undefined' ? args["ID"] : null), "Login": args["Login"], "Name": args["Name"], "Administrator": args["Administrator"], "Password": (typeof(args["Password"]) !== 'undefined' ? args["Password"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IAdmin.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    JSONHelper: {
        SerializeArgs: function (args) {
            var s = [];
            if (args) for (var m in args) s[s.length] = '"' + m + '":' + (typeof(args[m]) == 'undefined' || args[m] == null ? 'null' : (typeof(args[m]) == 'string' ? '"' + args[m].replace(/\\/g,"\\\\").replace(/\"/g, "\\\"").replace(/\r/g,"\\r").replace(/\n/g,"\\n").replace(/\t/g,"\\t") + '"' : args[m].toString()));
            return '{' + s.join(',') + '}';
        },
        WSEnv: function () {
                return (IAdmin.wsenvironment && (IAdmin.wsenvironment == ".NET" || IAdmin.wsenvironment == "PHP") ? IAdmin.wsenvironment : (IAdmin.wsuri ? (IAdmin.wsuri.toLowerCase().match(".asmx$") == ".asmx" ? ".NET" : (IAdmin.wsuri.toLowerCase().match(".php$") == ".php" ? "PHP" : "UNKNOWN")) : "UNKNOWN"));
        },
        DateToString: function (date) {
            if(date){
                switch(IAdmin.JSONHelper.WSEnv()) {
                    case ".NET":
                    case "PHP": {
                        var pad = function (val) {
                            val = val.toString();
                            while (val.length < 2) val = "0" + val;
                            return val;
                        };
                        return (date ? date.getFullYear() + '-' + pad((date.getMonth()+1)) + '-' + pad(date.getDate()) + 'T' + pad(date.getHours()) + ':' + pad(date.getMinutes()) + ':' + pad(date.getSeconds()) : null);
                    }
                    default:
                        throw new Exception("Unknown target environment");
                }
            }
            return null;
        },
        StringToDate: function (datestring) {
            if(datestring){
                switch(IAdmin.JSONHelper.WSEnv()) {
                    case ".NET":
                        return eval('new '+ datestring.replace(/\//g,' '));
                    case "PHP": {
                        var num = function(val, fb) {
                            return (val && val!='' ? parseInt(val,10) : (fb ? fb : 0));
                        };
                        var m = datestring.match(/^\s*((\d\d\d\d)-(\d\d)-(\d\d))((\s|T)(\d\d)(:(\d\d)(:(\d\d))?)?)?\s*$/i);
                        return new Date(num(m[2]), num(m[3])-1, num(m[4]), num(m[7]), num(m[9]), num(m[11]));
                    }
                }
            }
            return null;
        }
    }
}

