﻿var IPublished = {

    wsuri: "cms.WS.IPublished.asmx",        // You must enter the correct uri to your installed web service.
    wsenvironment: ".NET",               // Possible values are: null, ".NET", "PHP"

    /****************************************************************
        --- FUNCTION INDEX ---

        AddMessage
        Download
        DownloadThumbnail
        GetContentDetails
        GetSiteID
        ListChildContent
        ListRootContent
        ListSiteContent
        ListSites
        LookupIDFromFriendlyName
        LookupIDFromSUID

    ****************************************************************/

    /*
        // Description: Creates a new message if allowed for the specified parent.
        // This code exemplifies how to call the generated function AddMessage
        IPublished.AddMessage(
            {"ticket": your_string_or_null, "ParentID": your_int, "MessageSource": your_string_or_null, "LogEditedBy": your_string, "MessageData": your_text_or_null, "ContentTitle": your_string, "ContentSortOrder": your_string_or_null, "ContentSUID": your_string_or_null},
            function(result, args){
                // This function is called on success
                // result contains: MessageID (int)
                // Example:
                var yourVariable1 = result["MessageID"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    AddMessage: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/AddMessage",
            data: IPublished.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ParentID": args["ParentID"], "MessageSource": (typeof(args["MessageSource"]) !== 'undefined' ? args["MessageSource"] : null), "LogEditedBy": args["LogEditedBy"], "MessageData": (typeof(args["MessageData"]) !== 'undefined' ? args["MessageData"] : null), "ContentTitle": args["ContentTitle"], "ContentSortOrder": (typeof(args["ContentSortOrder"]) !== 'undefined' ? args["ContentSortOrder"] : null), "ContentSUID": (typeof(args["ContentSUID"]) !== 'undefined' ? args["ContentSUID"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Download image or document file content
        // This code exemplifies how to call the generated function Download
        IPublished.Download(
            {"ticket": your_string_or_null, "contentID": your_int_or_null},
            function(result, args){
                // This function is called on success
                // result contains: Title (string), MimeType (string), bytes (blob)
                // Example:
                var yourVariable1 = result["Title"]; 
                var yourVariable2 = result["MimeType"]; 
                var yourVariable3 = result["bytes"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    Download: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/Download",
            data: IPublished.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "contentID": (typeof(args["contentID"]) !== 'undefined' ? args["contentID"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Download image thumbnail file content.
        // This code exemplifies how to call the generated function DownloadThumbnail
        IPublished.DownloadThumbnail(
            {"ticket": your_string_or_null, "contentID": your_int_or_null},
            function(result, args){
                // This function is called on success
                // result contains: MimeType (string), imageBytes (blob)
                // Example:
                var yourVariable1 = result["MimeType"]; 
                var yourVariable2 = result["imageBytes"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    DownloadThumbnail: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/DownloadThumbnail",
            data: IPublished.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "contentID": (typeof(args["contentID"]) !== 'undefined' ? args["contentID"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Returns content details for all types of content.
        // This code exemplifies how to call the generated function GetContentDetails
        IPublished.GetContentDetails(
            {"ticket": your_string_or_null, "ContentID": your_int},
            function(result, args){
                // This function is called on success
                // result contains: ContentID (int), ContentSUID (string), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), ContentAbstract (text_or_null), SiteID (int), SiteName (string), ParentID (int_or_null), friendlyName (string), hasArticle (bool), ArticleID (int), ArticleEditor (string_or_null), ArticleData (text_or_null), ArticleHint (string_or_null), hasDocument (bool), DocumentID (int), DocumentMimeType (string), hasImage (bool), ImageID (int), ImageMimeType (string), ImageWidth (int), ImageHeight (int), ImageAlternative (string_or_null), hasLink (bool), LinkID (int), LinkTargetURI (string_or_null), LinkTargetURL (string_or_null), hasMessage (bool), MessageID (int), MessageSource (string_or_null), MessageData (text_or_null)
                // Example:
                var yourVariable1 = result["ContentID"]; 
                var yourVariable2 = result["ContentSUID"]; 
                var yourVariable3 = result["ContentType"]; 
                var yourVariable4 = result["ContentTitle"]; 
                var yourVariable5 = result["ContentPublished"]; 
                var yourVariable6 = result["ContentSortOrder"]; 
                var yourVariable7 = result["ContentKeywords"]; 
                var yourVariable8 = result["ContentDescription"]; 
                var yourVariable9 = result["ContentRobots"]; 
                var yourVariable10 = result["ContentLanguage"]; 
                var yourVariable11 = result["ContentCustom"]; 
                var yourVariable12 = result["ContentAllowMessages"]; 
                var yourVariable13 = result["ContentAbstract"]; 
                var yourVariable14 = result["SiteID"]; 
                var yourVariable15 = result["SiteName"]; 
                var yourVariable16 = result["ParentID"]; 
                var yourVariable17 = result["friendlyName"]; 
                var yourVariable18 = result["hasArticle"]; 
                var yourVariable19 = result["ArticleID"]; 
                var yourVariable20 = result["ArticleEditor"]; 
                var yourVariable21 = result["ArticleData"]; 
                var yourVariable22 = result["ArticleHint"]; 
                var yourVariable23 = result["hasDocument"]; 
                var yourVariable24 = result["DocumentID"]; 
                var yourVariable25 = result["DocumentMimeType"]; 
                var yourVariable26 = result["hasImage"]; 
                var yourVariable27 = result["ImageID"]; 
                var yourVariable28 = result["ImageMimeType"]; 
                var yourVariable29 = result["ImageWidth"]; 
                var yourVariable30 = result["ImageHeight"]; 
                var yourVariable31 = result["ImageAlternative"]; 
                var yourVariable32 = result["hasLink"]; 
                var yourVariable33 = result["LinkID"]; 
                var yourVariable34 = result["LinkTargetURI"]; 
                var yourVariable35 = result["LinkTargetURL"]; 
                var yourVariable36 = result["hasMessage"]; 
                var yourVariable37 = result["MessageID"]; 
                var yourVariable38 = result["MessageSource"]; 
                var yourVariable39 = result["MessageData"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    GetContentDetails: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/GetContentDetails",
            data: IPublished.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ContentID": args["ContentID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Maps a site name to a site ID.
        // This code exemplifies how to call the generated function GetSiteID
        IPublished.GetSiteID(
            {"name": your_string},
            function(result, args){
                // This function is called on success
                // result contains: SiteID (int)
                // Example:
                var yourVariable1 = result["SiteID"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    GetSiteID: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/GetSiteID",
            data: IPublished.JSONHelper.SerializeArgs({ "name": args["name"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Lists all sub-content of a content node.
        // This code exemplifies how to call the generated function ListChildContent
        IPublished.ListChildContent(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "ContentID": your_int},
            function(results, args){
                // This function is called on success
                // results contains: ContentID (int), ContentSUID (string), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), ContentAbstract (text_or_null), SiteID (int), ParentID (int_or_null), friendlyName (string), hasLink (bool), LinkID (int), LinkTargetURI (string_or_null), LinkTargetURL (string_or_null)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["ContentID"]; 
                    var yourVariable2 = results[i]["ContentSUID"]; 
                    var yourVariable3 = results[i]["ContentType"]; 
                    var yourVariable4 = results[i]["ContentTitle"]; 
                    var yourVariable5 = results[i]["ContentPublished"]; 
                    var yourVariable6 = results[i]["ContentSortOrder"]; 
                    var yourVariable7 = results[i]["ContentKeywords"]; 
                    var yourVariable8 = results[i]["ContentDescription"]; 
                    var yourVariable9 = results[i]["ContentRobots"]; 
                    var yourVariable10 = results[i]["ContentLanguage"]; 
                    var yourVariable11 = results[i]["ContentCustom"]; 
                    var yourVariable12 = results[i]["ContentAllowMessages"]; 
                    var yourVariable13 = results[i]["ContentAbstract"]; 
                    var yourVariable14 = results[i]["SiteID"]; 
                    var yourVariable15 = results[i]["ParentID"]; 
                    var yourVariable16 = results[i]["friendlyName"]; 
                    var yourVariable17 = results[i]["hasLink"]; 
                    var yourVariable18 = results[i]["LinkID"]; 
                    var yourVariable19 = results[i]["LinkTargetURI"]; 
                    var yourVariable20 = results[i]["LinkTargetURL"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListChildContent: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/ListChildContent",
            data: IPublished.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "ContentID": args["ContentID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: List all root-level content of a site
        // This code exemplifies how to call the generated function ListRootContent
        IPublished.ListRootContent(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "SiteID": your_int},
            function(results, args){
                // This function is called on success
                // results contains: ContentID (int), ContentSUID (string), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), ContentAbstract (text_or_null), SiteID (int), ParentID (int_or_null), friendlyName (string), hasLink (bool), LinkID (int), LinkTargetURI (string_or_null), LinkTargetURL (string_or_null)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["ContentID"]; 
                    var yourVariable2 = results[i]["ContentSUID"]; 
                    var yourVariable3 = results[i]["ContentType"]; 
                    var yourVariable4 = results[i]["ContentTitle"]; 
                    var yourVariable5 = results[i]["ContentPublished"]; 
                    var yourVariable6 = results[i]["ContentSortOrder"]; 
                    var yourVariable7 = results[i]["ContentKeywords"]; 
                    var yourVariable8 = results[i]["ContentDescription"]; 
                    var yourVariable9 = results[i]["ContentRobots"]; 
                    var yourVariable10 = results[i]["ContentLanguage"]; 
                    var yourVariable11 = results[i]["ContentCustom"]; 
                    var yourVariable12 = results[i]["ContentAllowMessages"]; 
                    var yourVariable13 = results[i]["ContentAbstract"]; 
                    var yourVariable14 = results[i]["SiteID"]; 
                    var yourVariable15 = results[i]["ParentID"]; 
                    var yourVariable16 = results[i]["friendlyName"]; 
                    var yourVariable17 = results[i]["hasLink"]; 
                    var yourVariable18 = results[i]["LinkID"]; 
                    var yourVariable19 = results[i]["LinkTargetURI"]; 
                    var yourVariable20 = results[i]["LinkTargetURL"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListRootContent: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/ListRootContent",
            data: IPublished.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "SiteID": args["SiteID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Lists all site content
        // This code exemplifies how to call the generated function ListSiteContent
        IPublished.ListSiteContent(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null, "SiteID": your_int},
            function(results, args){
                // This function is called on success
                // results contains: ContentID (int), ContentSUID (string), ContentType (string), ContentTitle (string), ContentPublished (bool), ContentSortOrder (string_or_null), ContentKeywords (string_or_null), ContentDescription (string_or_null), ContentRobots (string_or_null), ContentLanguage (string_or_null), ContentCustom (string_or_null), ContentAllowMessages (bool), ContentAbstract (text_or_null), SiteID (int), ParentID (int_or_null), friendlyName (string)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["ContentID"]; 
                    var yourVariable2 = results[i]["ContentSUID"]; 
                    var yourVariable3 = results[i]["ContentType"]; 
                    var yourVariable4 = results[i]["ContentTitle"]; 
                    var yourVariable5 = results[i]["ContentPublished"]; 
                    var yourVariable6 = results[i]["ContentSortOrder"]; 
                    var yourVariable7 = results[i]["ContentKeywords"]; 
                    var yourVariable8 = results[i]["ContentDescription"]; 
                    var yourVariable9 = results[i]["ContentRobots"]; 
                    var yourVariable10 = results[i]["ContentLanguage"]; 
                    var yourVariable11 = results[i]["ContentCustom"]; 
                    var yourVariable12 = results[i]["ContentAllowMessages"]; 
                    var yourVariable13 = results[i]["ContentAbstract"]; 
                    var yourVariable14 = results[i]["SiteID"]; 
                    var yourVariable15 = results[i]["ParentID"]; 
                    var yourVariable16 = results[i]["friendlyName"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListSiteContent: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/ListSiteContent",
            data: IPublished.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "SiteID": args["SiteID"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Lists all sites
        // This code exemplifies how to call the generated function ListSites
        IPublished.ListSites(
            {"maxRowsToReturn": your_int_or_null, "ticket": your_string_or_null},
            function(results, args){
                // This function is called on success
                // results contains: SiteID (int), SiteName (string), SiteIsPublic (bool), SiteRecycleBin (bool)
                // Example:
                for (var i=0; i<results.length; i++) {
                    var yourVariable1 = results[i]["SiteID"]; 
                    var yourVariable2 = results[i]["SiteName"]; 
                    var yourVariable3 = results[i]["SiteIsPublic"]; 
                    var yourVariable4 = results[i]["SiteRecycleBin"]; 
                }
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ListSites: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/ListSites",
            data: IPublished.JSONHelper.SerializeArgs({ "maxRowsToReturn": args["maxRowsToReturn"] || null, "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var results = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            results = response.d;
                        break;
                        case "PHP":
                            results = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, results, args); else onsuccess(results, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // This code exemplifies how to call the generated function LookupIDFromFriendlyName
        IPublished.LookupIDFromFriendlyName(
            {"ticket": your_string_or_null, "friendlyName": your_string_or_null},
            function(result, args){
                // This function is called on success
                // result contains: ContentID (int)
                // Example:
                var yourVariable1 = result["ContentID"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    LookupIDFromFriendlyName: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/LookupIDFromFriendlyName",
            data: IPublished.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "friendlyName": (typeof(args["friendlyName"]) !== 'undefined' ? args["friendlyName"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Returns content details, for all types of content, based on the SUID or friendly name
        // This code exemplifies how to call the generated function LookupIDFromSUID
        IPublished.LookupIDFromSUID(
            {"ticket": your_string_or_null, "SUID": your_string_or_null},
            function(result, args){
                // This function is called on success
                // result contains: ContentID (int)
                // Example:
                var yourVariable1 = result["ContentID"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    LookupIDFromSUID: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: IPublished.wsuri + "/LookupIDFromSUID",
            data: IPublished.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "SUID": (typeof(args["SUID"]) !== 'undefined' ? args["SUID"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(IPublished.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    JSONHelper: {
        SerializeArgs: function (args) {
            var s = [];
            if (args) for (var m in args) s[s.length] = '"' + m + '":' + (typeof(args[m]) == 'undefined' || args[m] == null ? 'null' : (typeof(args[m]) == 'string' ? '"' + args[m].replace(/\\/g,"\\\\").replace(/\"/g, "\\\"").replace(/\r/g,"\\r").replace(/\n/g,"\\n").replace(/\t/g,"\\t") + '"' : args[m].toString()));
            return '{' + s.join(',') + '}';
        },
        WSEnv: function () {
                return (IPublished.wsenvironment && (IPublished.wsenvironment == ".NET" || IPublished.wsenvironment == "PHP") ? IPublished.wsenvironment : (IPublished.wsuri ? (IPublished.wsuri.toLowerCase().match(".asmx$") == ".asmx" ? ".NET" : (IPublished.wsuri.toLowerCase().match(".php$") == ".php" ? "PHP" : "UNKNOWN")) : "UNKNOWN"));
        },
        DateToString: function (date) {
            if(date){
                switch(IPublished.JSONHelper.WSEnv()) {
                    case ".NET":
                    case "PHP": {
                        var pad = function (val) {
                            val = val.toString();
                            while (val.length < 2) val = "0" + val;
                            return val;
                        };
                        return (date ? date.getFullYear() + '-' + pad((date.getMonth()+1)) + '-' + pad(date.getDate()) + 'T' + pad(date.getHours()) + ':' + pad(date.getMinutes()) + ':' + pad(date.getSeconds()) : null);
                    }
                    default:
                        throw new Exception("Unknown target environment");
                }
            }
            return null;
        },
        StringToDate: function (datestring) {
            if(datestring){
                switch(IPublished.JSONHelper.WSEnv()) {
                    case ".NET":
                        return eval('new '+ datestring.replace(/\//g,' '));
                    case "PHP": {
                        var num = function(val, fb) {
                            return (val && val!='' ? parseInt(val,10) : (fb ? fb : 0));
                        };
                        var m = datestring.match(/^\s*((\d\d\d\d)-(\d\d)-(\d\d))((\s|T)(\d\d)(:(\d\d)(:(\d\d))?)?)?\s*$/i);
                        return new Date(num(m[2]), num(m[3])-1, num(m[4]), num(m[7]), num(m[9]), num(m[11]));
                    }
                }
            }
            return null;
        }
    }
}

