﻿var ISession = {

    wsuri: "cms.WS.ISession.asmx",        // You must enter the correct uri to your installed web service.
    wsenvironment: ".NET",               // Possible values are: null, ".NET", "PHP"

    /****************************************************************
        --- FUNCTION INDEX ---

        ChangePassword
        End
        Info
        Start

    ****************************************************************/

    /*
        // Description: Changes the curre
        // This code exemplifies how to call the generated function ChangePassword
        ISession.ChangePassword(
            {"ticket": your_string_or_null, "oldPassword": your_string, "newPassword": your_string_or_null},
            function(args){
                // This function is called on success
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    ChangePassword: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: ISession.wsuri + "/ChangePassword",
            data: ISession.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null), "oldPassword": args["oldPassword"], "newPassword": (typeof(args["newPassword"]) !== 'undefined' ? args["newPassword"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(ISession.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Terminates a session by cancelling the session ticket
        // This code exemplifies how to call the generated function End
        ISession.End(
            {"ticket": your_string_or_null},
            function(args){
                // This function is called on success
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    End: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: ISession.wsuri + "/End",
            data: ISession.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(ISession.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Allows a user to retrieve his/her own user account info.
        // This code exemplifies how to call the generated function Info
        ISession.Info(
            {"ticket": your_string_or_null},
            function(result, args){
                // This function is called on success
                // result contains: IsAuthenticated (bool), UserGUID (string_or_null), UserID (int), UserLogin (string), UserAdministrator (bool), UserName (string_or_null), Ticket (string)
                // Example:
                var yourVariable1 = result["IsAuthenticated"]; 
                var yourVariable2 = result["UserGUID"]; 
                var yourVariable3 = result["UserID"]; 
                var yourVariable4 = result["UserLogin"]; 
                var yourVariable5 = result["UserAdministrator"]; 
                var yourVariable6 = result["UserName"]; 
                var yourVariable7 = result["Ticket"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    Info: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: ISession.wsuri + "/Info",
            data: ISession.JSONHelper.SerializeArgs({ "ticket": (typeof(args["ticket"]) !== 'undefined' ? args["ticket"] : null)}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(ISession.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    /*
        // Description: Starts a new session by allocating a ticket
        // This code exemplifies how to call the generated function Start
        ISession.Start(
            {"login": your_string, "password": your_string, "persistent": your_bool},
            function(result, args){
                // This function is called on success
                // result contains: ticket (string), UserID (int), UserLogin (string), UserAdministrator (bool), UserName (string_or_null)
                // Example:
                var yourVariable1 = result["ticket"]; 
                var yourVariable2 = result["UserID"]; 
                var yourVariable3 = result["UserLogin"]; 
                var yourVariable4 = result["UserAdministrator"]; 
                var yourVariable5 = result["UserName"]; 
            },
            function(x, msg, args){
                // This function is called on error
            },
            function(args){
                // This function is called after onsuccess/onerror
            }
        );
    */

    Start: function (args, onsuccess, onerror, oncomplete, context) {
        $.ajax({
            type: "POST",
            url: ISession.wsuri + "/Start",
            data: ISession.JSONHelper.SerializeArgs({ "login": args["login"], "password": args["password"], "persistent": args["persistent"]}),
            contentType: "application/json; charset=utf-8",
            dataType: "json",
            success: function(response) {
                if (onsuccess){
                    var result = null;
                    switch(ISession.JSONHelper.WSEnv()){
                        case ".NET":
                            result = response.d;
                        break;
                        case "PHP":
                            result = response;
                        break;
                        default:
                            throw new Exception("Unknown target environment");
                        break;
                    }
                    if(context) onsuccess.call(context, result, args); else onsuccess(result, args);
                }
            },
            error: function(x, msg) {
                if (onerror){
                    if (context) onerror.call(context, x, msg, args); else onerror(x, msg, args);
                }
            },
            complete: function() {
                if (oncomplete){
                    if (context) oncomplete.call(context, args); else oncomplete(args)
                }
            }
        });
    },

    JSONHelper: {
        SerializeArgs: function (args) {
            var s = [];
            if (args) for (var m in args) s[s.length] = '"' + m + '":' + (typeof(args[m]) == 'undefined' || args[m] == null ? 'null' : (typeof(args[m]) == 'string' ? '"' + args[m].replace(/\\/g,"\\\\").replace(/\"/g, "\\\"").replace(/\r/g,"\\r").replace(/\n/g,"\\n").replace(/\t/g,"\\t") + '"' : args[m].toString()));
            return '{' + s.join(',') + '}';
        },
        WSEnv: function () {
                return (ISession.wsenvironment && (ISession.wsenvironment == ".NET" || ISession.wsenvironment == "PHP") ? ISession.wsenvironment : (ISession.wsuri ? (ISession.wsuri.toLowerCase().match(".asmx$") == ".asmx" ? ".NET" : (ISession.wsuri.toLowerCase().match(".php$") == ".php" ? "PHP" : "UNKNOWN")) : "UNKNOWN"));
        },
        DateToString: function (date) {
            if(date){
                switch(ISession.JSONHelper.WSEnv()) {
                    case ".NET":
                    case "PHP": {
                        var pad = function (val) {
                            val = val.toString();
                            while (val.length < 2) val = "0" + val;
                            return val;
                        };
                        return (date ? date.getFullYear() + '-' + pad((date.getMonth()+1)) + '-' + pad(date.getDate()) + 'T' + pad(date.getHours()) + ':' + pad(date.getMinutes()) + ':' + pad(date.getSeconds()) : null);
                    }
                    default:
                        throw new Exception("Unknown target environment");
                }
            }
            return null;
        },
        StringToDate: function (datestring) {
            if(datestring){
                switch(ISession.JSONHelper.WSEnv()) {
                    case ".NET":
                        return eval('new '+ datestring.replace(/\//g,' '));
                    case "PHP": {
                        var num = function(val, fb) {
                            return (val && val!='' ? parseInt(val,10) : (fb ? fb : 0));
                        };
                        var m = datestring.match(/^\s*((\d\d\d\d)-(\d\d)-(\d\d))((\s|T)(\d\d)(:(\d\d)(:(\d\d))?)?)?\s*$/i);
                        return new Date(num(m[2]), num(m[3])-1, num(m[4]), num(m[7]), num(m[9]), num(m[11]));
                    }
                }
            }
            return null;
        }
    }
}

