﻿using System;
using System.Data;
using System.Web;
using System.Collections;
using System.Collections.Generic;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.ComponentModel;
using System.Data.Odbc;
using System.IO;
using cms.DB.IAdmin;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.WS.IAdmin
{
	/// <summary>
	/// Web service for publishing cms.DB.IAdmin.IAdmin
	/// </summary>
	[WebService(Namespace = "http://cms.WS.IAdmin/")]
	[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
	[ToolboxItem(false)]
	[System.Web.Script.Services.ScriptService]
	public class IAdmin : System.Web.Services.WebService
	{
		protected string GetConnectionString(string systemid)
		{
			return System.Configuration.ConfigurationManager.AppSettings[systemid];
		}
		protected void AssignTemporaryDirectory(cms.DB.IAdmin.IAdmin obj)
		{
			string wsAppData = HttpContext.Current.Server.MapPath(".") + "\\App_Data";
			if (!Directory.Exists(wsAppData))
				Directory.CreateDirectory(wsAppData);
			obj.TempDir = wsAppData;
		}
		/// <summary>
		/// Creates or updates site info
		/// Uses cms.DB.IAdmin.IAdmin.SaveSite to runs a sequence of connected methods: AbortIfNotAdministrator, IsRecycleBin, Constants, SaveSite.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <param name="MembersOnly"></param>
		/// <param name="Name"></param>
		/// <returns>returnSaveSite</returns>
		[WebMethod(Description="Creates or updates site info")]
		public returnSaveSite SaveSite(string ticket, long? ID, bool MembersOnly, string Name)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.SaveSite(ticket, ID, MembersOnly, Name);
		}
		/// <summary>
		/// Delete a site
		/// Uses cms.DB.IAdmin.IAdmin.DeleteSite to runs a sequence of connected methods: AbortIfNotAdministrator, IsRecycleBin, DeleteSiteEx.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnDeleteSite</returns>
		[WebMethod(Description="Delete a site")]
		public returnDeleteSite DeleteSite(string ticket, long ID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.DeleteSite(ticket, ID);
		}
		/// <summary>
		/// List all sites
		/// Uses cms.DB.IAdmin.IAdmin.ListSites to runs a sequence of connected methods: AbortIfNotAdministrator, ListSiteByNameLike.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="NameLike"></param>
		/// <returns>returnListSites[]</returns>
		[WebMethod(Description="List all sites")]
		public returnListSites[] ListSites(int? maxRowsToReturn, string ticket, string NameLike)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.ListSites(maxRowsToReturn, ticket, NameLike);
		}
		/// <summary>
		/// Lists all users
		/// Uses cms.DB.IAdmin.IAdmin.ListUsers to runs a sequence of connected methods: AbortIfNotAdministrator, ListUserByNameLike.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="NameLike"></param>
		/// <returns>returnListUsers[]</returns>
		[WebMethod(Description="Lists all users")]
		public returnListUsers[] ListUsers(int? maxRowsToReturn, string ticket, string NameLike)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.ListUsers(maxRowsToReturn, ticket, NameLike);
		}
		/// <summary>
		/// Lists all sessions for a specific user
		/// Uses cms.DB.IAdmin.IAdmin.ListUserSessions to runs a sequence of connected methods: AbortIfNotAdministrator, ListSessionByUser.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="UserID"></param>
		/// <returns>returnListUserSessions[]</returns>
		[WebMethod(Description="Lists all sessions for a specific user")]
		public returnListUserSessions[] ListUserSessions(int? maxRowsToReturn, string ticket, long UserID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.ListUserSessions(maxRowsToReturn, ticket, UserID);
		}
		/// <summary>
		/// Lists a all membership sites for a user
		/// Uses cms.DB.IAdmin.IAdmin.ListUserSites to runs a sequence of connected methods: AbortIfNotAdministrator, ListMemberByUser, GetSite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="UserID"></param>
		/// <returns>returnListUserSites[]</returns>
		[WebMethod(Description="Lists a all membership sites for a user")]
		public returnListUserSites[] ListUserSites(int? maxRowsToReturn, string ticket, long UserID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.ListUserSites(maxRowsToReturn, ticket, UserID);
		}
		/// <summary>
		/// Delete a hint from the site hint list
		/// Uses cms.DB.IAdmin.IAdmin.DeleteArticleHint to runs a sequence of connected methods: AbortIfNotAdministrator, DeleteArticleHint.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnDeleteArticleHint</returns>
		[WebMethod(Description="Delete a hint from the site hint list")]
		public returnDeleteArticleHint DeleteArticleHint(string ticket, long ID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.DeleteArticleHint(ticket, ID);
		}
		/// <summary>
		/// Lists all display hints for a site
		/// Uses cms.DB.IAdmin.IAdmin.ListSiteArticleHints to runs a sequence of connected methods: AbortIfNotAdministrator, ListArticleHintBySite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListSiteArticleHints[]</returns>
		[WebMethod(Description="Lists all display hints for a site")]
		public returnListSiteArticleHints[] ListSiteArticleHints(int? maxRowsToReturn, string ticket, long SiteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.ListSiteArticleHints(maxRowsToReturn, ticket, SiteID);
		}
		/// <summary>
		/// Creates or updates a hint in the site hint list
		/// Uses cms.DB.IAdmin.IAdmin.SaveSiteArticleHint to runs a sequence of connected methods: AbortIfNotAdministrator, SaveArticleHint.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <param name="Name"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnSaveSiteArticleHint</returns>
		[WebMethod(Description="Creates or updates a hint in the site hint list")]
		public returnSaveSiteArticleHint SaveSiteArticleHint(string ticket, long? ID, string Name, long SiteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.SaveSiteArticleHint(ticket, ID, Name, SiteID);
		}
		/// <summary>
		/// Copy the hint list from one site to another
		/// Uses cms.DB.IAdmin.IAdmin.CopySiteArticleHints to runs a sequence of connected methods: AbortIfNotAdministrator, ListArticleHintBySite, ListArticleHintByName, NewArticleHint.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="fromSiteID"></param>
		/// <param name="toSiteID"></param>
		/// <returns>returnCopySiteArticleHints[]</returns>
		[WebMethod(Description="Copy the hint list from one site to another")]
		public returnCopySiteArticleHints[] CopySiteArticleHints(int? maxRowsToReturn, string ticket, long fromSiteID, long toSiteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.CopySiteArticleHints(maxRowsToReturn, ticket, fromSiteID, toSiteID);
		}
		/// <summary>
		/// Uses cms.DB.IAdmin.IAdmin.GetSite to runs a sequence of connected methods: AbortIfNotAdministrator, GetSite.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnGetSite</returns>
		[WebMethod]
		public returnGetSite GetSite(string ticket, long ID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.GetSite(ticket, ID);
		}
		/// <summary>
		/// Lists all users that are members of the site
		/// Uses cms.DB.IAdmin.IAdmin.ListSiteUsers to runs a sequence of connected methods: AbortIfNotAdministrator, ListMemberBySite, GetUser.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListSiteUsers[]</returns>
		[WebMethod(Description="Lists all users that are members of the site")]
		public returnListSiteUsers[] ListSiteUsers(int? maxRowsToReturn, string ticket, long SiteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.ListSiteUsers(maxRowsToReturn, ticket, SiteID);
		}
		/// <summary>
		/// Creates or update a user. If password is null the current password is kept.
		/// Uses cms.DB.IAdmin.IAdmin.SaveUser to runs a sequence of connected methods: AbortIfNotAdministrator, SaveUser.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <param name="Login"></param>
		/// <param name="Name"></param>
		/// <param name="Administrator"></param>
		/// <param name="Password"></param>
		/// <returns>returnSaveUser</returns>
		[WebMethod(Description="Creates or update a user. If password is null the current password is kept.")]
		public returnSaveUser SaveUser(string ticket, long? ID, string Login, string Name, bool Administrator, string Password)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.SaveUser(ticket, ID, Login, Name, Administrator, Password);
		}
		/// <summary>
		/// Deletes a user account (incl sessions and memberships)
		/// Uses cms.DB.IAdmin.IAdmin.DeleteUser to runs a sequence of connected methods: AbortIfNotAdministrator, DeleteUserEx.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnDeleteUser</returns>
		[WebMethod(Description="Deletes a user account (incl sessions and memberships)")]
		public returnDeleteUser DeleteUser(string ticket, long ID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.DeleteUser(ticket, ID);
		}
		/// <summary>
		/// Uses cms.DB.IAdmin.IAdmin.GetUser to runs a sequence of connected methods: AbortIfNotAdministrator, GetUser.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ID"></param>
		/// <returns>returnGetUser</returns>
		[WebMethod]
		public returnGetUser GetUser(string ticket, long ID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.GetUser(ticket, ID);
		}
		/// <summary>
		/// Creates or changes a user site membership.
		/// Uses cms.DB.IAdmin.IAdmin.SaveMembership to runs a sequence of connected methods: AbortIfNotAdministrator, SaveMembership.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="UserID"></param>
		/// <param name="SiteID"></param>
		/// <param name="IsEditor"></param>
		/// <returns>returnSaveMembership</returns>
		[WebMethod(Description="Creates or changes a user site membership.")]
		public returnSaveMembership SaveMembership(string ticket, long UserID, long SiteID, bool IsEditor)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.SaveMembership(ticket, UserID, SiteID, IsEditor);
		}
		/// <summary>
		/// Revokes a user site membership
		/// Uses cms.DB.IAdmin.IAdmin.RevokeMembership to runs a sequence of connected methods: AbortIfNotAdministrator, RevokeMembership.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="UserID"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnRevokeMembership</returns>
		[WebMethod(Description="Revokes a user site membership")]
		public returnRevokeMembership RevokeMembership(string ticket, long UserID, long SiteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IAdmin.IAdmin obj = new cms.DB.IAdmin.IAdmin(dbconn);
			return obj.RevokeMembership(ticket, UserID, SiteID);
		}
	}
}
