﻿using System;
using System.Data;
using System.Web;
using System.Collections;
using System.Collections.Generic;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.ComponentModel;
using System.Data.Odbc;
using System.IO;
using cms.DB.IEdit;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.WS.IEdit
{
	/// <summary>
	/// Web service for publishing cms.DB.IEdit.IEdit
	/// </summary>
	[WebService(Namespace = "http://cms.WS.IEdit/")]
	[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
	[ToolboxItem(false)]
	[System.Web.Script.Services.ScriptService]
	public class IEdit : System.Web.Services.WebService
	{
		protected string GetConnectionString(string systemid)
		{
			return System.Configuration.ConfigurationManager.AppSettings[systemid];
		}
		protected void AssignTemporaryDirectory(cms.DB.IEdit.IEdit obj)
		{
			string wsAppData = HttpContext.Current.Server.MapPath(".") + "\\App_Data";
			if (!Directory.Exists(wsAppData))
				Directory.CreateDirectory(wsAppData);
			obj.TempDir = wsAppData;
		}
		/// <summary>
		/// Lists all content in a site.
		/// Uses cms.DB.IEdit.IEdit.ListSiteContent to runs a sequence of connected methods: MayEditSite, ListContentBySite, ComposeFriendlyName.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListSiteContent[]</returns>
		[WebMethod(Description="Lists all content in a site.")]
		public returnListSiteContent[] ListSiteContent(int? maxRowsToReturn, string ticket, long SiteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.ListSiteContent(maxRowsToReturn, ticket, SiteID);
		}
		/// <summary>
		/// Get content details for any kind of content
		/// Uses cms.DB.IEdit.IEdit.GetContentDetails to runs a sequence of connected methods: MayEditContent, GetContent, GetSite, ComposeFriendlyName, LatestLog, GetContentArticle, GetContentDocument, GetContentImage, GetContentLink, GetContentMessage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnGetContentDetails</returns>
		[WebMethod(Description="Get content details for any kind of content")]
		public returnGetContentDetails GetContentDetails(string ticket, long ContentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.GetContentDetails(ticket, ContentID);
		}
		/// <summary>
		/// Creates or update link content.
		/// Uses cms.DB.IEdit.IEdit.SaveLink to runs a sequence of connected methods: AbortIfSiteIsChanged, SaveLink.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="LinkID"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <param name="LinkTargetURI"></param>
		/// <param name="LinkTargetURL"></param>
		/// <returns>returnSaveLink</returns>
		[WebMethod(Description="Creates or update link content.")]
		public returnSaveLink SaveLink(string ticket, long? LinkID, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID, string LinkTargetURI, string LinkTargetURL)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SaveLink(ticket, LinkID, ContentID, ContentSUID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID, LinkTargetURI, LinkTargetURL);
		}
		/// <summary>
		/// Creates or updates document content excl the document file
		/// Uses cms.DB.IEdit.IEdit.SaveDocument to runs a sequence of connected methods: AbortIfSiteIsChanged, SaveDocument.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="DocumentID"></param>
		/// <param name="DocumentMimeType"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <returns>returnSaveDocument</returns>
		[WebMethod(Description="Creates or updates document content excl the document file")]
		public returnSaveDocument SaveDocument(string ticket, long? DocumentID, string DocumentMimeType, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SaveDocument(ticket, DocumentID, DocumentMimeType, ContentID, ContentSUID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID);
		}
		/// <summary>
		/// Creates or updates image content excl the image file
		/// Uses cms.DB.IEdit.IEdit.SaveImage to runs a sequence of connected methods: AbortIfSiteIsChanged, SaveImage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ImageID"></param>
		/// <param name="ImageMimeType"></param>
		/// <param name="ImageWidth"></param>
		/// <param name="ImageHeight"></param>
		/// <param name="ImageAlternative"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <returns>returnSaveImage</returns>
		[WebMethod(Description="Creates or updates image content excl the image file")]
		public returnSaveImage SaveImage(string ticket, long? ImageID, string ImageMimeType, long ImageWidth, long ImageHeight, string ImageAlternative, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SaveImage(ticket, ImageID, ImageMimeType, ImageWidth, ImageHeight, ImageAlternative, ContentID, ContentSUID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID);
		}
		/// <summary>
		/// Creates or updates article content
		/// Uses cms.DB.IEdit.IEdit.SaveArticle to runs a sequence of connected methods: AbortIfSiteIsChanged, SaveArticle.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ArticleID"></param>
		/// <param name="ArticleEditor"></param>
		/// <param name="ArticleData"></param>
		/// <param name="ArticleHint"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <param name="ContentSUID"></param>
		/// <returns>returnSaveArticle</returns>
		[WebMethod(Description="Creates or updates article content")]
		public returnSaveArticle SaveArticle(string ticket, long? ArticleID, string ArticleEditor, string ArticleData, string ArticleHint, long? ContentID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID, string ContentSUID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SaveArticle(ticket, ArticleID, ArticleEditor, ArticleData, ArticleHint, ContentID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID, ContentSUID);
		}
		/// <summary>
		/// Creates or update message content
		/// Uses cms.DB.IEdit.IEdit.SaveMessage to runs a sequence of connected methods: AbortIfSiteIsChanged, SaveMessage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="MessageID"></param>
		/// <param name="MessageSource"></param>
		/// <param name="MessageData"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <returns>returnSaveMessage</returns>
		[WebMethod(Description="Creates or update message content")]
		public returnSaveMessage SaveMessage(string ticket, long? MessageID, string MessageSource, string MessageData, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SaveMessage(ticket, MessageID, MessageSource, MessageData, ContentID, ContentSUID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID);
		}
		/// <summary>
		/// Delete content, e.g. an article, a document.
		/// Uses cms.DB.IEdit.IEdit.DeleteContent to runs a sequence of connected methods: MayEditContent, DeleteIfRecycleBinContent, GetRecycleBin, Constants, MoveContent.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnDeleteContent</returns>
		[WebMethod(Description="Delete content, e.g. an article, a document.")]
		public returnDeleteContent DeleteContent(string ticket, long ContentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.DeleteContent(ticket, ContentID);
		}
		/// <summary>
		/// Lists all sites you're allowed to edit.
		/// Uses cms.DB.IEdit.IEdit.ListSites to runs a sequence of connected methods: CurrentUser, ListSite, IsEditMemberOf, LogicalOr, GetSite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <returns>returnListSites[]</returns>
		[WebMethod(Description="Lists all sites you're allowed to edit.")]
		public returnListSites[] ListSites(int? maxRowsToReturn, string ticket)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.ListSites(maxRowsToReturn, ticket);
		}
		/// <summary>
		/// Move content in the content structure.
		/// Uses cms.DB.IEdit.IEdit.MoveContent to runs a sequence of connected methods: MayEditContent, MayEditSite, AbortIfContentNotInSite, MoveContent.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <param name="newParentID"></param>
		/// <param name="newSiteID"></param>
		/// <param name="newSortOrder"></param>
		/// <returns>returnMoveContent</returns>
		[WebMethod(Description="Move content in the content structure.")]
		public returnMoveContent MoveContent(string ticket, long ContentID, long? newParentID, long newSiteID, string newSortOrder)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.MoveContent(ticket, ContentID, newParentID, newSiteID, newSortOrder);
		}
		/// <summary>
		/// Updates the article text body.
		/// Uses cms.DB.IEdit.IEdit.SaveArticleText to runs a sequence of connected methods: MayEditContent, ContentTypes, GetContentArticle, GetContent, SaveArticle.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <param name="ArticleData"></param>
		/// <param name="ContentSUID"></param>
		/// <returns>returnSaveArticleText</returns>
		[WebMethod(Description="Updates the article text body.")]
		public returnSaveArticleText SaveArticleText(string ticket, long ContentID, string ArticleData, string ContentSUID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SaveArticleText(ticket, ContentID, ArticleData, ContentSUID);
		}
		/// <summary>
		/// Creates or updates unspecified content, i.e. a folder.
		/// Uses cms.DB.IEdit.IEdit.SaveNone to runs a sequence of connected methods: AbortIfSiteIsChanged, ContentTypes, SaveContent.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <param name="ContentSUID"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="SiteID"></param>
		/// <param name="ContentPublished"></param>
		/// <param name="ContentKeywords"></param>
		/// <param name="ContentDescription"></param>
		/// <param name="ContentRobots"></param>
		/// <param name="ContentLanguage"></param>
		/// <param name="ContentCustom"></param>
		/// <param name="ContentAllowMessages"></param>
		/// <param name="ContentAbstract"></param>
		/// <param name="ParentID"></param>
		/// <returns>returnSaveNone</returns>
		[WebMethod(Description="Creates or updates unspecified content, i.e. a folder.")]
		public returnSaveNone SaveNone(string ticket, long? ContentID, string ContentSUID, string ContentTitle, string ContentSortOrder, long SiteID, bool ContentPublished, string ContentKeywords, string ContentDescription, string ContentRobots, string ContentLanguage, string ContentCustom, bool ContentAllowMessages, string ContentAbstract, long? ParentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SaveNone(ticket, ContentID, ContentSUID, ContentTitle, ContentSortOrder, SiteID, ContentPublished, ContentKeywords, ContentDescription, ContentRobots, ContentLanguage, ContentCustom, ContentAllowMessages, ContentAbstract, ParentID);
		}
		/// <summary>
		/// Lists all sub-content of specified content.
		/// Uses cms.DB.IEdit.IEdit.ListChildContent to runs a sequence of connected methods: MayEditContent, ListContentByParent, ComposeFriendlyName.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnListChildContent[]</returns>
		[WebMethod(Description="Lists all sub-content of specified content.")]
		public returnListChildContent[] ListChildContent(int? maxRowsToReturn, string ticket, long? ContentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.ListChildContent(maxRowsToReturn, ticket, ContentID);
		}
		/// <summary>
		/// Lists all root-level content in a site
		/// Uses cms.DB.IEdit.IEdit.ListRootContent to runs a sequence of connected methods: MayEditSite, ListContentRoots, ComposeFriendlyName.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <returns>returnListRootContent[]</returns>
		[WebMethod(Description="Lists all root-level content in a site")]
		public returnListRootContent[] ListRootContent(int? maxRowsToReturn, string ticket, long siteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.ListRootContent(maxRowsToReturn, ticket, siteID);
		}
		/// <summary>
		/// Lists all content with a title matching the criteria.
		/// Uses cms.DB.IEdit.IEdit.SearchByTitleType to runs a sequence of connected methods: SearchSites, ListContentBySiteAndTitle, DefaultString, DefaultBool.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <param name="titleLike"></param>
		/// <param name="typeLike"></param>
		/// <returns>returnSearchByTitleType[]</returns>
		[WebMethod(Description="Lists all content with a title matching the criteria.")]
		public returnSearchByTitleType[] SearchByTitleType(int? maxRowsToReturn, string ticket, long? siteID, string titleLike, string typeLike)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SearchByTitleType(maxRowsToReturn, ticket, siteID, titleLike, typeLike);
		}
		/// <summary>
		/// Lists all articles matching the specified criteria.
		/// Uses cms.DB.IEdit.IEdit.SearchByArticleText to runs a sequence of connected methods: CurrentUser, ListArticleByData, MayEditContent, GetContent, GetSite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="dataLike"></param>
		/// <returns>returnSearchByArticleText[]</returns>
		[WebMethod(Description="Lists all articles matching the specified criteria.")]
		public returnSearchByArticleText[] SearchByArticleText(int? maxRowsToReturn, string ticket, string dataLike)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SearchByArticleText(maxRowsToReturn, ticket, dataLike);
		}
		/// <summary>
		/// Lists all links referring to the specified target.
		/// Uses cms.DB.IEdit.IEdit.SearchByLinkTargetURI to runs a sequence of connected methods: CurrentUser, ListLinkByTargetURI, MayEditContent, GetContent, GetSite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="targetURI"></param>
		/// <returns>returnSearchByLinkTargetURI[]</returns>
		[WebMethod(Description="Lists all links referring to the specified target.")]
		public returnSearchByLinkTargetURI[] SearchByLinkTargetURI(int? maxRowsToReturn, string ticket, string targetURI)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SearchByLinkTargetURI(maxRowsToReturn, ticket, targetURI);
		}
		/// <summary>
		/// Download image or document file content
		/// Uses cms.DB.IEdit.IEdit.Download to runs a sequence of connected methods: MayEditContent, Download.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="contentID"></param>
		/// <returns>returnDownload</returns>
		[WebMethod(Description="Download image or document file content")]
		public returnDownload Download(string ticket, long? contentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.Download(ticket, contentID);
		}
		/// <summary>
		/// Download image thumbnail file content
		/// Uses cms.DB.IEdit.IEdit.DownloadThumbnail to runs a sequence of connected methods: MayEditContent, DownloadThumbnail.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="contentID"></param>
		/// <returns>returnDownloadThumbnail</returns>
		[WebMethod(Description="Download image thumbnail file content")]
		public returnDownloadThumbnail DownloadThumbnail(string ticket, long? contentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.DownloadThumbnail(ticket, contentID);
		}
		/// <summary>
		/// Uploads document or image file. For images, a thumbnail file is automatically generated.
		/// Uses cms.DB.IEdit.IEdit.Upload to runs a sequence of connected methods: MayEditSite, Upload.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <param name="contentID"></param>
		/// <param name="parentID"></param>
		/// <param name="type"></param>
		/// <param name="fileName"></param>
		/// <param name="mimeType"></param>
		/// <param name="bytes"></param>
		/// <returns>returnUpload</returns>
		[WebMethod(Description="Uploads document or image file. For images, a thumbnail file is automatically generated.")]
		public returnUpload Upload(string ticket, long siteID, long? contentID, long? parentID, string type, string fileName, string mimeType, byte[] bytes)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.Upload(ticket, siteID, contentID, parentID, type, fileName, mimeType, bytes);
		}
		/// <summary>
		/// Lists the site hint list.
		/// Uses cms.DB.IEdit.IEdit.ListSiteArticleHints to runs a sequence of connected methods: MayEditSite, ListArticleHintBySite.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <returns>returnListSiteArticleHints[]</returns>
		[WebMethod(Description="Lists the site hint list.")]
		public returnListSiteArticleHints[] ListSiteArticleHints(int? maxRowsToReturn, string ticket, long siteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.ListSiteArticleHints(maxRowsToReturn, ticket, siteID);
		}
		/// <summary>
		/// Uses cms.DB.IEdit.IEdit.SearchImageByTitle to runs a sequence of connected methods: ContentTypes, SearchSites, ListContentBySiteAndTitle, DefaultString, DefaultBool, GetImageByContent.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="siteID"></param>
		/// <param name="titleLike"></param>
		/// <returns>returnSearchImageByTitle[]</returns>
		[WebMethod]
		public returnSearchImageByTitle[] SearchImageByTitle(int? maxRowsToReturn, string ticket, long? siteID, string titleLike)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.SearchImageByTitle(maxRowsToReturn, ticket, siteID, titleLike);
		}
		/// <summary>
		/// Uses cms.DB.IEdit.IEdit.LookupIDFromFriendlyName to runs a sequence of connected methods: FindIDByFriendlyName, MayEditContent, Constants, DefaultInt.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="friendlyName"></param>
		/// <returns>returnLookupIDFromFriendlyName</returns>
		[WebMethod]
		public returnLookupIDFromFriendlyName LookupIDFromFriendlyName(string ticket, string friendlyName)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IEdit.IEdit obj = new cms.DB.IEdit.IEdit(dbconn);
			return obj.LookupIDFromFriendlyName(ticket, friendlyName);
		}
	}
}
