﻿using System;
using System.Data;
using System.Web;
using System.Collections;
using System.Collections.Generic;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.ComponentModel;
using System.Data.Odbc;
using System.IO;
using cms.DB.IPublished;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.WS.IPublished
{
	/// <summary>
	/// Web service for publishing cms.DB.IPublished.IPublished
	/// </summary>
	[WebService(Namespace = "http://cms.WS.IPublished/")]
	[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
	[ToolboxItem(false)]
	[System.Web.Script.Services.ScriptService]
	public class IPublished : System.Web.Services.WebService
	{
		protected string GetConnectionString(string systemid)
		{
			return System.Configuration.ConfigurationManager.AppSettings[systemid];
		}
		protected void AssignTemporaryDirectory(cms.DB.IPublished.IPublished obj)
		{
			string wsAppData = HttpContext.Current.Server.MapPath(".") + "\\App_Data";
			if (!Directory.Exists(wsAppData))
				Directory.CreateDirectory(wsAppData);
			obj.TempDir = wsAppData;
		}
		/// <summary>
		/// Lists all site content
		/// Uses cms.DB.IPublished.IPublished.ListSiteContent to runs a sequence of connected methods: MayViewSite, ListPublishedContentAll, ComposeFriendlyName.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListSiteContent[]</returns>
		[WebMethod(Description="Lists all site content")]
		public returnListSiteContent[] ListSiteContent(int? maxRowsToReturn, string ticket, long SiteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.ListSiteContent(maxRowsToReturn, ticket, SiteID);
		}
		/// <summary>
		/// List all root-level content of a site
		/// Uses cms.DB.IPublished.IPublished.ListRootContent to runs a sequence of connected methods: MayViewSite, ListPublishedContentRoots, ComposeFriendlyName, GetContentLink.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="SiteID"></param>
		/// <returns>returnListRootContent[]</returns>
		[WebMethod(Description="List all root-level content of a site")]
		public returnListRootContent[] ListRootContent(int? maxRowsToReturn, string ticket, long SiteID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.ListRootContent(maxRowsToReturn, ticket, SiteID);
		}
		/// <summary>
		/// Lists all sub-content of a content node.
		/// Uses cms.DB.IPublished.IPublished.ListChildContent to runs a sequence of connected methods: MayViewContent, ListPublishedContentChildren, ComposeFriendlyName, GetContentLink.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnListChildContent[]</returns>
		[WebMethod(Description="Lists all sub-content of a content node.")]
		public returnListChildContent[] ListChildContent(int? maxRowsToReturn, string ticket, long ContentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.ListChildContent(maxRowsToReturn, ticket, ContentID);
		}
		/// <summary>
		/// Returns content details for all types of content.
		/// Uses cms.DB.IPublished.IPublished.GetContentDetails to runs a sequence of connected methods: MayViewContent, GetContent, GetSite, ComposeFriendlyName, GetContentArticle, GetContentDocument, GetContentImage, GetContentLink, GetContentMessage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ContentID"></param>
		/// <returns>returnGetContentDetails</returns>
		[WebMethod(Description="Returns content details for all types of content.")]
		public returnGetContentDetails GetContentDetails(string ticket, long ContentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.GetContentDetails(ticket, ContentID);
		}
		/// <summary>
		/// Maps a site name to a site ID.
		/// Uses cms.DB.IPublished.IPublished.GetSiteID to runs a sequence of connected methods: GetSiteByName.
		/// </summary>
		/// <param name="name"></param>
		/// <returns>returnGetSiteID</returns>
		[WebMethod(Description="Maps a site name to a site ID.")]
		public returnGetSiteID GetSiteID(string name)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.GetSiteID(name);
		}
		/// <summary>
		/// Creates a new message if allowed for the specified parent.
		/// Uses cms.DB.IPublished.IPublished.AddMessage to runs a sequence of connected methods: MayViewContent, GetContent, Constants, ContentTypes, SaveMessage.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="ParentID"></param>
		/// <param name="MessageSource"></param>
		/// <param name="LogEditedBy"></param>
		/// <param name="MessageData"></param>
		/// <param name="ContentTitle"></param>
		/// <param name="ContentSortOrder"></param>
		/// <param name="ContentSUID"></param>
		/// <returns>returnAddMessage</returns>
		[WebMethod(Description="Creates a new message if allowed for the specified parent.")]
		public returnAddMessage AddMessage(string ticket, long ParentID, string MessageSource, string LogEditedBy, string MessageData, string ContentTitle, string ContentSortOrder, string ContentSUID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.AddMessage(ticket, ParentID, MessageSource, LogEditedBy, MessageData, ContentTitle, ContentSortOrder, ContentSUID);
		}
		/// <summary>
		/// Returns content details, for all types of content, based on the SUID or friendly name
		/// Uses cms.DB.IPublished.IPublished.LookupIDFromSUID to runs a sequence of connected methods: FindIDBySUID, MayViewContent, Constants, DefaultInt.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="SUID"></param>
		/// <returns>returnLookupIDFromSUID</returns>
		[WebMethod(Description="Returns content details, for all types of content, based on the SUID or friendly name")]
		public returnLookupIDFromSUID LookupIDFromSUID(string ticket, string SUID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.LookupIDFromSUID(ticket, SUID);
		}
		/// <summary>
		/// Download image or document file content
		/// Uses cms.DB.IPublished.IPublished.Download to runs a sequence of connected methods: MayViewContent, Download.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="contentID"></param>
		/// <returns>returnDownload</returns>
		[WebMethod(Description="Download image or document file content")]
		public returnDownload Download(string ticket, long? contentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.Download(ticket, contentID);
		}
		/// <summary>
		/// Download image thumbnail file content.
		/// Uses cms.DB.IPublished.IPublished.DownloadThumbnail to runs a sequence of connected methods: MayViewContent, DownloadThumbnail.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="contentID"></param>
		/// <returns>returnDownloadThumbnail</returns>
		[WebMethod(Description="Download image thumbnail file content.")]
		public returnDownloadThumbnail DownloadThumbnail(string ticket, long? contentID)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.DownloadThumbnail(ticket, contentID);
		}
		/// <summary>
		/// Lists all sites
		/// Uses cms.DB.IPublished.IPublished.ListSites to runs a sequence of connected methods: Constants, ViewableSites, DefaultInt, DefaultString, DefaultBool, DefaultBool.
		/// </summary>
		/// <param name="maxRowsToReturn">Max number of rows to return. If null or 0 all rows are returned.</param>
		/// <param name="ticket"></param>
		/// <returns>returnListSites[]</returns>
		[WebMethod(Description="Lists all sites")]
		public returnListSites[] ListSites(int? maxRowsToReturn, string ticket)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.ListSites(maxRowsToReturn, ticket);
		}
		/// <summary>
		/// Uses cms.DB.IPublished.IPublished.LookupIDFromFriendlyName to runs a sequence of connected methods: FindIDByFriendlyName, MayViewContent, Constants, DefaultInt.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="friendlyName"></param>
		/// <returns>returnLookupIDFromFriendlyName</returns>
		[WebMethod]
		public returnLookupIDFromFriendlyName LookupIDFromFriendlyName(string ticket, string friendlyName)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.IPublished.IPublished obj = new cms.DB.IPublished.IPublished(dbconn);
			return obj.LookupIDFromFriendlyName(ticket, friendlyName);
		}
	}
}
