﻿using System;
using System.Data;
using System.Web;
using System.Collections;
using System.Collections.Generic;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.ComponentModel;
using System.Data.Odbc;
using System.IO;
using cms.DB.ISession;

//da6e583d-ae07-4955-956b-5fe205448f88
//
// CMS (cms)
// Version 1.0 (#33)
//
// RISE to Bloome Software AB
// RISE to Bloome Software AB, 2010-2011
//
//da6e583d-ae07-4955-956b-5fe205448f88

namespace cms.WS.ISession
{
	/// <summary>
	/// Web service for publishing cms.DB.ISession.ISession
	/// </summary>
	[WebService(Namespace = "http://cms.WS.ISession/")]
	[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
	[ToolboxItem(false)]
	[System.Web.Script.Services.ScriptService]
	public class ISession : System.Web.Services.WebService
	{
		protected string GetConnectionString(string systemid)
		{
			return System.Configuration.ConfigurationManager.AppSettings[systemid];
		}
		protected void AssignTemporaryDirectory(cms.DB.ISession.ISession obj)
		{
			string wsAppData = HttpContext.Current.Server.MapPath(".") + "\\App_Data";
			if (!Directory.Exists(wsAppData))
				Directory.CreateDirectory(wsAppData);
			obj.TempDir = wsAppData;
		}
		/// <summary>
		/// Starts a new session by allocating a ticket
		/// Uses cms.DB.ISession.ISession.Start to runs a sequence of connected methods: LoginPwd, CurrentUser.
		/// </summary>
		/// <param name="login"></param>
		/// <param name="password"></param>
		/// <param name="persistent"></param>
		/// <returns>returnStart</returns>
		[WebMethod(Description="Starts a new session by allocating a ticket")]
		public returnStart Start(string login, string password, bool persistent)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.ISession.ISession obj = new cms.DB.ISession.ISession(dbconn);
			return obj.Start(login, password, persistent);
		}
		/// <summary>
		/// Terminates a session by cancelling the session ticket
		/// Uses cms.DB.ISession.ISession.End to runs a sequence of connected methods: Logout.
		/// </summary>
		/// <param name="ticket"></param>
		/// <returns>returnEnd</returns>
		[WebMethod(Description="Terminates a session by cancelling the session ticket")]
		public returnEnd End(string ticket)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.ISession.ISession obj = new cms.DB.ISession.ISession(dbconn);
			return obj.End(ticket);
		}
		/// <summary>
		/// Allows a user to retrieve his/her own user account info.
		/// Uses cms.DB.ISession.ISession.Info to runs a sequence of connected methods: CurrentUser.
		/// </summary>
		/// <param name="ticket"></param>
		/// <returns>returnInfo</returns>
		[WebMethod(Description="Allows a user to retrieve his/her own user account info.")]
		public returnInfo Info(string ticket)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.ISession.ISession obj = new cms.DB.ISession.ISession(dbconn);
			return obj.Info(ticket);
		}
		/// <summary>
		/// Changes the curre
		/// Uses cms.DB.ISession.ISession.ChangePassword to runs a sequence of connected methods: CurrentUser, GetUser, PasswordEncode, IsEqualString, SaveUser.
		/// </summary>
		/// <param name="ticket"></param>
		/// <param name="oldPassword"></param>
		/// <param name="newPassword"></param>
		/// <returns>returnChangePassword</returns>
		[WebMethod(Description="Changes the curre")]
		public returnChangePassword ChangePassword(string ticket, string oldPassword, string newPassword)
		{
			OdbcConnection dbconn = new OdbcConnection(GetConnectionString("cms"));
			cms.DB.ISession.ISession obj = new cms.DB.ISession.ISession(dbconn);
			return obj.ChangePassword(ticket, oldPassword, newPassword);
		}
	}
}
