﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Text;
using cms.DB.IPublished;
using service.Utility;

namespace service
{
    public partial class display : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            string ticket = FormUtility.Ticket;
            long? contentID = FormUtility.ContentID;
            bool save = FormUtility.GetFlag("save");
            returnGetContentDetails content = new returnGetContentDetails();
            returnDownload rv = new returnDownload();

            if (contentID.HasValue)
            {
                try
                {
                    IPublished iPub = new IPublished(FormUtility.Connection);
                    content = iPub.GetContentDetails(ticket, contentID.Value);
                    if (content.hasDocument || content.hasImage)
                        rv = iPub.Download(ticket, contentID);
                }
                catch (Exception)
                {
                }
            }
            if (content.ContentID != 0)
            {
                string mimeType = (!string.IsNullOrEmpty(content.ImageMimeType) ? content.ImageMimeType :
                    (!string.IsNullOrEmpty(content.DocumentMimeType) ? content.DocumentMimeType : 
                    "text/html"));
                Response.Clear();
                Response.ContentType = mimeType;
                if (save)
                    Response.AddHeader("content-disposition", "attachment; filename=" + HttpUtility.UrlPathEncode(content.ContentTitle));
                if (rv.bytes != null && rv.bytes.Length > 0)
                    Response.BinaryWrite(rv.bytes);
                else if (!string.IsNullOrEmpty(content.ArticleData))
                    Response.BinaryWrite(new UTF8Encoding().GetBytes(content.ArticleData));
                else if (!string.IsNullOrEmpty(content.MessageData))
                    Response.BinaryWrite(new UTF8Encoding().GetBytes(content.MessageData));
                Response.End();
            }
        }
    }
}
